c-- sirpow                                                Release 93.05
      subroutine procdata(newf,ier)
c--
c     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c        routine for the command data  (input data)                 
c
c        version may   '90                university of bari
c     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c          struttura del buffer vet/ivet
c
c     h   k   l   fo  rho   id   fasi   e  e'/ed  e'p/ew  denor  sig
c     1   2   3   4    5     6    7     8    9      10     11    12
c----------------------------------------------------------------------
c   lista 7
c     h+k+l    e       fo   e'+e'p    phi'+phi+code punt+wei
c       1      2       3       4            5          6
c   scompattati in                       
c     h   k   l   e   fo    e'   e'p  fasi punt+wei
c     1   2   3   4    5     6    7     8     9
c----------------------------------------------------------------------
c
      character*80 fileh,formt,name
      character cff
c   implementation  common
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
c  partial structure procedure common
      common /frgmt/ mmold,mzold,ihmax(3),knowo,sumn,sumd,ntype(80)
c     erlangen
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
c     sapi
      common/rsc/ibgr,mg,mig(8),scl,bts(9),scsa(9),ip(8,3,5)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common /ureq1/ ncycl,nroset,nundset,alambda,nsec,machkl,uvwt(4),
     *               pfwhm
c     symmetry
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
cnew-------------------
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
c     scratch file reflexion arrays
      common /buffer/ vet(13,39),nrpb,dummb(7)
c     atomic scattering factors
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
c     known molecular (group) information
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
c     spherical scattering factors
      common/at/gis(142),giw(142)
c     miscellaneous
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
c     wilson plot parameters
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
c     work area common       (30000 integer words)
      common/xdata/ix(3000),ex(3000),fx(3000),iphi(3000),
     *             ewx(3000),edx(3000),jpunt(3000),nv(3000),
     *             we(3000),nvn(3000),
     *             IndHKL(3000,5),Mult(3000),SetFob(3000,4),
     *             TThet(3000),WHM(3000),dummx(54000),dummpc(124000)
c     sin/cos table
c     pseudotranslation information
      common /cpseud/ npseud,lpseuv(12),llpse
c
      write(cff,'(i1)') kff
      write(lo,10) cff,itle
   10 format(///,a1,120('+'),//,
     1 39h SIRPOW.92 : data routine              ,68x,14hRelease  93.05
     2 ,/,/,20x,20a4,/,1h ,120('+'),//)
c     set up initial values
      kuser = 15000
      nsym=0
      nref=0
      rhomax=0.0
      dtor=pi/180.0
      rtod=180.0/pi
      do 40 i=1,12
   40 lpseuv(i)=0
c     set up sin/cos table
      do 50 i=1,450
      sint(i)=sin(dtor*float(i-1))
   50 continue
      iflag=0
      itype=1
      iform=2
      kop=kopen(iscra,name,nlen,itype,ierr)
Corig call dirdat(newf,iequi,jump,bt,s3s2o,fileh,formt,iy,ier)
      call dirdat(newf,iequi,s3s2o,fileh,formt,iy,npc,ier)
      if (ier.lt.0) go to 900
      anat=float(nat)/(pts*float((icent+1)*nsym))
      aa=s3s2*s3s2*pts
c  s3s2p is related to the number of atoms in the primitive cell
      s3s2p=aa*sqrt(1.0/aa)
      s3s2=s3s2p
      is3s2=1./(s3s2p*s3s2p)+0.5
c
      a1=cos(cx(4)*pi/180.0)
      a2=cos(cx(5)*pi/180.0)
      a3=cos(cx(6)*pi/180.0)
      arg=1.0-a1*a1
     1       -a2*a2
     2       -a3*a3
     3       +a1*a2*a3*2.0
      v=cx(1)*cx(2)*cx(3)*sqrt(arg)
      atvol = v / float(nat)
c
      write(lo,370) anat,is3s2,atvol
  370 format(/,39x,'Number of atoms in asymmetric unit =',f6.2,/,
     1 31x,'Equivalent number of equal atoms in primitive cell =',i6,/,
     2 46x,'Volume per atom =',f7.2,/)
      nasu=int(anat+0.5)
c
c     calculate number of reflexions for (sem)invariant searching
      if (mm.gt.0) goto 400
      mn = int(4.0*anat+100.5)
      if (icent.eq.1) mn = mn + 50
      if (nsym.eq.1) mn = mn + 50
      mn = min0(mn,499)
      mm=mn+min0(499-mn,100)/2
  400 continue
c     read reflexion data from cards
           if (machkl.eq.0) then
                              call datain(fileh,formt,kuser,npc,ier)
      else if (machkl.eq.1) then
                              call machkls(fileh,formt,kuser,istop,ier)
                            endif
      if (ier.lt.0) go to 900
      call defovl
      call incrys
      if (iequi.eq.1) call noequi
c---------------------------
      if(iequi.eq.1) write(lo,368)
      if(iequi.eq.0) write(lo,369)
 368  format(//,'   The overall intensity for each group of ',
     *'overlapping reflections is equipartitioned (default)')
 369  format(//,'   The overall intensity for each group of ',
     *'overlapping reflections is not equipartitioned      ')
c---------------------------
c
      call preparel7
c ----
c ---- create list 7 ( sorted e's )
c ----
      call ysfr07(nref,npseud,iy)
c ----
      call xdump
  900 close(iscra)
      return
      end
c------------------------------------------------------------
      subroutine datain(fileh,formt,kuser,npc,ier)
c
c-- read reflections from card input
c
      character*80 fileh,formt
      character*80 line,buff
      character fname(9)*80,ext(9)*4
      common/dotdat/ fname,ext
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common /uno/ mxbg,indmb
      common/xdata/ibig(84000),
     *             IndHKL(3000,5),Mult(3000),SetFob(3000,4),
     *             TThet(3000),WHM(3000),dummpc(124000)
      common /neutro/ neutro,bmat(2,98),neuwei,vetint(200)
c  if ibig dimension has to be changed, alter mxbg accordingly
      dimension kh(12),kk(12),kl(12),f(12),phyr(12),
     *nover(12),jhkl(3),kv(3),i1(3)
      integer phy(12),vsym(24),ibrav(6,13)
      data phyr/12*0.0/
      data ibrav/4*1,3,1,0,3*1,0,-1,1,0,6*1,0,3*1,5*2,3,4*0,1,11*0,1,
     ,5*0,2,5*0,1,5*0,1,11*0,2,0/
c
c
c--
c
      fosog=-999.9
      mxbg=84000
      nex=0
c  ksym=number of translational matrices different from ( 0.0 0.0 0.0 )
      ksym=0
      do 20 i=2,nsym
      ifl=0
      do 10 j=1,3
      if (abs(ts(j,i)).gt.0.00001) ifl=1
   10 continue
      if (ifl.eq.0) go to 20
      ksym=ksym+1
      vsym(ksym)=i
   20 continue
      klatt=latt-1
      if (jfile.lt.0) go to 7034
      if (jfile.ne.ln) then
                         itype=2
                         iform=1
                         if (jopen(jfile,fileh,nlen,itype,iform,ios)
     *                             .lt.0) go to 9000
                    
c-- reflections are in the direct access file
          endif
 7034 continue
      if (jfile.eq.ln) go to 6000
      jfile=iabs(jfile)
      nref=0
      nrefp=0
      do 7035 i=1,3
 7035 ihx(i)=-100
      nn=iabs(npc)
      nrec=0
      nnn=0
      nuobs=0
      nrmax=0
      rhm =-99.9
      rhmi= 99.9
c
      neuwei=0
      istop=0
c
      read(jfile,'(a80)',end=7000) line
      buff=line
      call shift(buff,nchar)
      if (buff(1:1).eq.'>') go to 30
      if (knw.eq.0) read(line,formt,end=60,err=8000,iostat=ios)
     *                  (kh(i),kk(i),kl(i), f(i),
     *                   nover(i),i=1,nn)
      if (knw.eq.1) read(line,formt,end=60,err=8000,iostat=ios)
     *                  (kh(i),kk(i),kl(i), f(i),phyr(i),
     *                   nover(i),i=1,nn)
      go to 32
   30 if (knw.eq.0) read(jfile,formt,end=60,err=8000,iostat=ios)
     *                  (kh(i),kk(i),kl(i), f(i),
     *                   nover(i),i=1,nn)
      if (knw.eq.1) read(jfile,formt,end=60,err=8000,iostat=ios)
     *                  (kh(i),kk(i),kl(i), f(i),phyr(i),
     *                   nover(i),i=1,nn)
   32 continue
      do 50 i=1,nn
      phy(i)=phyr(i)
      if(f(i).lt.0.0) go to 60
      if (kh(i).eq.0.and.kk(i).eq.0.and.kl(i).eq.0) go to 60
      if(nover(i).gt.8) then
                          write(lo,33) nover(i)
   33 format(//,
     * '  *** error *** too many reflections in overlappig (',i3,')',/,
     * '                max. allowed = 8 ')
                          ier=-1
                          return
                        endif
      nref=nref+1
      call extin(jex,kh(i),kk(i),kl(i),ibrav,klatt,ksym,vsym)
      if (jex.eq.1) then
               nex=nex+1
               write(lo,35) kh(i),kk(i),kl(i),nover(i)
   35 format(' systematically absent :',3i4,' overlapping code :',i3)
               if (nover(i).ne.1) istop=1 
        else
          call geneq(1,kh(i),kk(i),kl(i),idelt,jcode,isgnn,id1,rho)
          ireje=0
          if (rho.gt.th) then
                           ireje=1
                           nrmax=nrmax+1
                         endif
          if (ireje.eq.0) then
                            sig=1.0
                            if (rho.gt.rhm) rhm=rho   
                            if (rho.lt.rhmi) rhmi=rho   
                            nrefp=nrefp+1
ccccccccccccccccccccccccccccccccc
      if (nrefp.gt.3000) then         
      nnn=3000
      write(6,325) nnn
  325 format(10x,'number of independent input reflections larger than
     & permitted number of input reflections',i5)
      stop 
      end if
                            nnn=nnn+1
                            if (knw.eq.0) go to 40
                               phy(i)=phy(i)+idelt
                               phy(i)=phy(i)*isgnn
                               phy(i)=mod(phy(i),360)
                               if(phy(i).le.0) phy(i)=phy(i)+360
   40                       continue
                            phy(i)=phy(i)*32+jcode
                            jhkl(1) = kh(i)
                            jhkl(2) = kk(i)
                            jhkl(3) = kl(i)
CNEW ------------------------------------------
                            i1(1)=jhkl(1)
                            i1(2)=jhkl(2)
                            i1(3)=jhkl(3)
                            call cmult(i1,eps,multi)
                            IndHKL(nrefp,1) = kh(i)
                            IndHKL(nrefp,2) = kk(i)
                            IndHKL(nrefp,3) = kl(i)
                            IndHKL(nrefp,4) = nover(i)
CNEW                        IndHKL(nrefp,5) = jcode
                            IndHKL(nrefp,5)=phy(i)
                            SetFob(nrefp,1) = 0
                            SetFob(nrefp,2) = 0
                            SetFob(nrefp,3) = 0
                            SetFob(nrefp,4) = f(i)*f(i)
                            WHM(nrefp)=-1.0
                            TThet(nrefp)    = ctheta(rho)
                            Mult(nrefp)     = multi
                            if (f(i).gt.fosog) fosog=f(i)
                          endif
                        endif
   50 continue
      go to 30
   60 continue
c
c-- check for equivalent reflections
c
      call checkeq(kv,rhm,rhmi,nrmax,nrefp,nex,istop,ier)
      if (ier.lt.0) return
c
c-- check for correctness of overlapping code
c
      ii=1
      do 80 i=1,nrefp
      nov=IndHKL(ii,4)
      if(ii.eq.nrefp.and.nov.eq.1) go to 299
      if(nov.gt.1) then
                    if((ii+nov-1).gt.nrefp) then
                                   write(lo,217)(IndHKL(ii,ia),ia=1,4)
                                   ier=-1
                                   return
                                        endif
                    do 70 j=ii+1,ii+nov-1
                    if(IndHKL(j,4).ne.0) then   
                                   write(lo,217) (IndHKL(j,ia),ia=1,4)
                                   ier=-1
                                   return
                                        endif
   70               continue
                  else 
                     if(nov.eq.0) then
                                   write(lo,217)(IndHKL(ii,ia),ia=1,4)
                                   ier=-1
                                   return
                               endif
                 endif
      if((ii+nov-1).eq.nrefp) go to 299
      ii=ii+nov
   80 continue                          
  299 continue
  217 format(/,
     * '   *** error *** reflection  ',3i3,/,
     * '  incorrect overlapping code ',i3,/)
c
c-- check for unobserved reflections
c
      call obsin(kv,ibrav,klatt,ksym,vsym)
c
      if (jfile.ne.ln) close(jfile)
      if (nref.gt.kuser) go to 350
      return
  350 write(lo,360) kuser
  360 format(//,' ***  error  *** too many reflections  ',/,
     *' increase  kuser  value and dimensions in common /xdata/ in norma
     *l modul',/,' actually kuser = ',i5)
      ier=-1
      return
 6000 continue
      write(lo,6010)
 6010 format(/,' *** error ***  no reflections supplied')
      ier=-1
      return
 7000 continue
      write(lo,7010) jfile
 7010 format(/,' *** error ***  eof on channel ',i2)
      go to 9020
 8000 write(lo,8010) jfile,ios
 8010 format(/,' *** error ***  read error on channel ',i2,' code =',i5)
      go to 9020
 9000 write(lo,9010) ios,fileh
 9010 format(/,' *** error ***  open error, code =',i5,' file is ',a)
 9020 write(lo,9030)
 9030 format(  '                reflections expected')
      ier=-1
      return
      end
c--------------------------------------------------------------
Corig subroutine dirdat(newf,iequi,jump,bt,s3s2o,fileh,formt,iy,ier)
      subroutine dirdat(newf,iequi,s3s2o,fileh,formt,iy,npc,ier)
      character fname(9)*80,ext(9)*4
      common/dotdat/ fname,ext
      character line*80,dire*80,diret*80,fileh*80,formt*80
      character blank,digit*12,card(100)*80,ffile*80
      character ibl2*2,specie(8)*2
c     common /comdir/ icomq(20,2),idirq(100),ipcom,ipdir,icomat
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /chara/ blank,digit,card,ffile
      common /erl/ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      common /frgmt/ mmold,mzold,ihmax(3),knowo,sumn,sumd,n(80)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common /ureq1/ ncycl,nroset,nundset,alambda,nsec,machkl,uvwt(4),
     *               pfwhm
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common/gpt/nanew(8),naold(8),sn,sq
      common/at/gis(142),giw(142)
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common /cpseud/ npseud,lpseuv(12),llpse
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /neutro/ neutro,bmat(2,98),neuwei,vetint(200)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      dimension na(8),vet(40),ivet(40),kshif(3),kistp(8)
     *,vistp(8)
      common/genob/irho,rhomax3
      data ibl2 /'  '/
c
c set default values
      none=0
      neutro=0
      nistp=0
      iequi=1
      neuwei=0
      iy=67543
      iprin=0
      jj=0
      do 10 i=1,19,2
      jj=jj+1
      nag(jj)=0
      ninf(jj)=0
      j=i+20
      formt(i:i+1)='  '
   10 formt(j:j+1)='  '
      formt(1:13)='(3i4,f8.2,i2)'
      ishif=0
      juvwt=0
      alambda=-1.0
c     pfwhm=0.6
c NEW  NEW  NEW
      pfwhm=0.1
c NEW  NEW  NEW
      do 20 i=1,3
   20 kshif(i)=0
      bt=0.0
      sc=-99.9
      knw=0
      mm=0
      mz=166
      th=1.0
      rhomin=0.0
      en=1.0
      er=0.3
      ngp=0
      jpart=0
      jtran=0
c     nonos=0
      npseud=0
      llpse=0
      npc=1
      jjfile=ln
      machkl=0
      do 30 i=1,200
      x(4,i)=1.0
      read(ibl2,'(a2)') nz(i)
      do 30 j=1,3
   30 x(j,i)=0.0
      lix1=0
      lix2=0
      lix3=0
      lix7=0
      if (newf.eq.1) go to 50
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c-- already exists a direct access file containing
c-- information concerning the structure
c
      iln=1
      call srlin (iln,lsn,lix1,ljxx,lkxx,llxx)
      if(lix1.gt.0) call yfl01
      iln=2
      call srlin (iln,lsn,lix2,ljxx,lkxx,llxx)
      if(lix2.gt.0) call yfl02
      iln=3
      call srlin (iln,lsn,lix3,ljxx,lkxx,llxx)
      if(lix3.gt.0) then
                      call yfl03
                      lix3=1
                    endif
c
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c---------------------------------------------------------------------
c  irho = 1 genera i riflessi dello shell esterno
c  irho = 0 genera i riflessi non osservati fino al (sin theta)/lambda
c         max degli osservati  
c  irho =-1 controlla l'esistenza di riflessi non-obs senza memorizzarli
c         sul file ad accesso diretto (default)
c---------------------------------------------------------------------
   50 irho=-1
      ic=0
      icmax=icomq(icomat,2)
c
  100 continue
      ic=ic+1
      if (ic.gt.icmax) go to 8200
      ipdir=ipdir+1
      line=card(ipdir)
      diret=line
      call cutst(line,lenp,dire,lend)
      call lcase(dire)
c-- directives with alphanumeric parameters
      if (dire(1:4).eq.'spac') then
          if (lenp.le.1) go to 8000
          call lcase(line)
          call onebl(line,lenp,ier)
          read(line,'(16a1)') nt
          lix2=1
          go to 100
          endif
      if (dire(1:4).eq.'cont') then
          call lcase(line)
          call getcon(line,dire,nw,nalf,nk)
          if (nk.le.0) go to 8000
          lix3=2
          go to 100
          endif
      if (dire(1:4).eq.'ref1') then
          read(line,'(a)') fileh
          if (fileh(1:4).ne.'foll') then
                                      jjfile=jfile
                                    else 
                                      jjfile=-ln
                                    endif
          go to 100
          endif
      if (dire(1:4).eq.'ref2' ) then
          machkl=1
          read(line,'(a)') fileh
          if (fileh(1:4).ne.'foll') then
                                      jjfile=jfile
                                    else 
                                      jjfile=-ln
                                    endif
          go to 100
          endif
      if (dire(1:4).eq.'form') then
          k=index(diret,'(')
          if (k.eq.0) go to 8000
          formt=diret(k:k+39)
          go to 100
          endif
      if (dire(1:4).eq.'isot') then
                                  nistp=nistp+1
                                  call cutst(line,lenp,dire,lend)
                                  call lcase(dire)
                                  read(dire(1:2),'(a2)') kistp(nistp)
                                  iopt=0
                                  call getnum(line,vet,ivet,iv,iopt)
                                  if (iopt.eq.-1) go to 8000
                                  if (iv.ne.1) go to 8000
                                  vistp(nistp)=vet(1)
                                  lix3=2
                                  go to 100
                                endif
      if (dire(1:4).eq.'know') then
          knw=1
          if (lenp.gt.0) read(line,'(a)') fname(8)
          go to 100
          endif
Corig if (dire(1:4).eq.'gene') then
Corig                             irho=0
Corig                             go to 100
Corig                           endif
      if (dire(1:4).eq.'weig') then
                                 neuwei=1
                                 goto 100
                               endif
      if (dire(1:4).eq.'neut') then
                                 neutro=1
                                 goto 100
                               endif
c     if (dire(1:4).eq.'port') then
      if (dire(1:4).eq.'nopo') then
          iequi=0
          goto 100
      endif
c-- directives with numeric parameters
      iopt=0
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 8000
      if (dire(1:4).eq.'expa') then
                                 if(lenp.lt.0) go to 8000
                                 if (iv.ne.1) go to 8000
                                 rhomax3=vet(1)
                                 irho=1
                                 go to 100
                               endif
      if (dire(1:4).eq.'uvwt') then
          if (iv.ne.4) go to 8000
          do 190 i=1,4
  190     uvwt(i)=vet(i)
          juvwt=1
          go to 100
          endif
      if (dire(1:4).eq.'wave') then
          if (iv.ne.1) go to 8000
          alambda=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'fwhm') then
          if (iv.ne.1) go to 8000
          pfwhm=vet(1)
          if(pfwhm.lt.0.0.or.pfwhm.gt.1.0) go to 8000
          go to 100
          endif
      if (dire(1:4).eq.'cell') then
          if (iv.ne.6) go to 8000
          do 200 i=1,6
  200     cx(i)=vet(i)
          lix1=1
          call frm01(cx)
          go to 100
          endif
      if (dire(1:4).eq.'shif') then
          if (iv.ne.3) go to 8000
          ishif=1
          do 250 i=1,3
          ksh=ivet(i)
          if (ksh.ne.0) then
              if (mod(24,ksh).ne.0) then
                                      write(lo,230)
                                      go to 8000
                                    endif
                        endif
          kshif(i)=ksh
  250     continue
          go to 100
          endif
  230   format(///' origin shift components must be integral multiples',
     * ' of 1/24 ')
      if (dire(1:4).eq.'rhom') then
          if (iv.ne.1) go to 8000
          th=vet(1)
          if (th.lt.0.0.or.th.gt.1.0) go to 8000
          go to 100
          endif
      if (dire(1:4).eq.'prin') then
          if (iv.ne.1) go to 8000
          iprin=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'reco') then
          if (iv.ne.1) go to 8000
          npc=ivet(1)
          go to 100
          endif
      write(lo,6000) diret
 6000 format(' wrong directive on following line:',/a)
      ier=-1
      return
 8000 continue
      ier=-1
      write(lo,'(22h error in directive : ,a80)') diret
      return
 8200 continue
      jfile=jjfile
      if (lix1.le.0) then
                       write(lo,8220)
 8220 format(/,' *** error *** no cell parameters supplied')
                       ier=-1
                     else
      call yfl01
      write(lo,8230) (cx(i),i=1,6),p
 8230 format(/,11hDirect cell,9x,3ha =,f8.3,4x,3hb =,f8.3,4x,
     1 3hc =,f8.3,4x,7halpha =,f7.2,4x,6hbeta =,f7.2,4x,7hgamma =,f7.2,/
     2 ,     12h s2 = s**2 =,f9.6,9h * h**2 +,f9.6,9h * k**2 +,f9.6,
     39h * l**2 +,f9.6,10h * h * k +,f9.6,10h * h * l +,f9.6,8h * k * l)
                     endif
      if (lix2.le.0) then
                       write(lo,8240)
 8240 format(/,' *** error *** no space group symbol supplied')
                       ier=-1
                     else
      call insym(ishif,kshif)
      pop=pts*(float((icent+1)*nsym))
      call yfrm02
      call yfl02
                     endif
c ---
c --- read scattering factors
c ---
      if (lix3.le.0) then
                       write(lo,8250)
 8250 format(/,' *** error *** no cell content supplied')
                       ier=-1
                     else
      if (lix3.eq.2) then
                       call yfrm03(ier)
                       if (ier.ge.0) call yfl03
                     endif
                     endif
      call xdump
      if (machkl.eq.2.and.juvwt.eq.0) then
                                        write(lo,8260)
                                        ier=-1
                                      endif
      if (machkl.eq.2.and.alambda.lt.0.0) then
                                            write(lo,8270)
                                            ier=-1
                                          endif
 8260 format(/,' *** error *** no u,v,w,t values supplied')
 8270 format(/,' *** error *** no wavelenght value supplied')
      if (alambda.lt.0.0) then
                            write(lo,8225)
 8225 format(/,' *** error *** no wavelenght supplied')
                       ier=-1
                     endif
      if (ier.lt.0) return
      if (neutro.eq.1.and.nistp.gt.0) then
                         do 9005 j=1,nistp
                         do 9003 i=1,nk
                         if (nalf(i).eq.kistp(j)) then
                                                    l=no(i)
                                                    bmat(1,l)=vistp(j)
                                                    go to 9005
                                                  endif
 9003                    continue
                         write(lo,9007) kistp(j)
 9007 format(' *** error ***  atom type ',a2,' not expected', / ,
     *       '               check isotope directive ')
                         ier=-1
                         return
 9005                    continue
                       endif
      if (neutro.eq.0) then
                         do 9010 i=1,nk
                         write(specie(i),'(a2)') nalf(i)
                         call ucase(specie(i)(1:1))
 9010                    continue
                         write(lo,9020) (specie(i),nw(i),no(i),
     1                   (al(ii,i),bs(ii,i),ii=1,4),cl(i),i=1,nk)
                       else
                         if (lix3.eq.2) then
                                          do 9030 i=1,nk
                                          do 9030 j=1,2
 9030                                     bs(j,i)=bmat(j,no(i))
                                          bs(2,i)=0.0
                                          call upd03
                                        endif
                         call yfl03
                         do 9035 i=1,nk
                         write(specie(i),'(a2)') nalf(i)
                         call ucase(specie(i)(1:1))
 9035                    continue
                         write(lo,9040) (specie(i),nw(i),no(i),
     1                    bs(1 ,i),i=1,nk)
                       endif
 9020 format(/,15x,'Unit cell contents and scattering factor constants
     1     f = sum (  a(i) * exp(-b(i)*s2)  )  i=1,4 + c ',//,
     2 1h ,4hatom,4x,14hnumber in cell,4x,13hatomic number,5x,
     3 'a(1)',5x,'b(1)',5x,'a(2)',5x,'b(2)',5x,'a(3)',5x,'b(3)',5x,
     4 'a(4)',5x,'b(4)',5x,' c',/,(1h ,1x,a2,i14,i17,6x,9f9.3))
 9040 format(/,15x,'unit cell contents and scattering factor constants
     1',//,
c    1     f = sqrt(  b(real)**2 + b(imag)**2 ) )',//,
     2 1h ,19x,4hatom,4x,14hnumber in cell,4x,13hatomic number,8x,
c    3 'b(real)',5x,'b(imag)',/,
     3 '   f   ',/,
c    4 (1h ,1x,19x,a2,i14,i17,6x,2f12.3))
     4 (1h ,1x,19x,a2,i14,i17,6x,f12.3))
      s3=0
      s2=0
      do 9059 i=1,nk
 9059 na(i)=nw(i)
      do 9060 i=1,nk
      if (neutro.eq.0) then
         ss=float(na(i))*no(i)*no(i)
         s2=s2+ss
         s3=s3+ss*no(i)
      else
c        bi=sqrt(bs(1,i)*bs(1,i)+bs(2,i)*bs(2,i))
         bi=bs(1,i)
         ss=float(na(i))*bi*bi      
         s2=s2+ss
         s3=s3+ss*bi
      endif
 9060 continue
      s3s2=s3/sqrt(s2**3)
      if (s3s2.lt.0.0001) then
                            ier=-1
                            write(lo,9063) s3s2
                            return
                          endif
 9063 format(//,' *** error ***  sigma(3) / sigma(2)**1.5 = ',f10.3,
     *        /,'                Program stops')
      do 9070 i=1,142
      gis(i)=0.0
 9070 continue
c     calculate wilson (giw) and debye (gis) scattering factors
      do 9230 i=1,142
      t=0.01*float(i-1)
      tt=t*t
      giw(i)=0.0
      do 9220 j=1,nk
      if (neutro.eq.0) then
                         fz = cl(j)
                         do 9210 jj=1,4
                         bst=bs(jj,j)*tt
                         if(bst.le.60.)  fz=fz+al(jj,j)*exp(-bst)
 9210                    continue
                       else
                         fz=sqrt(bs(1,j)*bs(1,j)+bs(2,j)*bs(2,j))
                       endif
      gis(i)=gis(i)+fz*fz*float(na(j))
      fnw=float(nw(j))
      giw(i)=giw(i)+fz*fz*fnw
 9220 continue
 9230 continue
      pop=pts*(float((icent+1)*nsym))
      return
      end
c     ------------------------------------------------------------------
c     prepare  list 7               
      subroutine preparel7
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common/xdata/ix(3000),ex(3000),fx(3000),iphi(3000),
     *             ewx(3000),edx(3000),jpunt(3000),nv(3000),
     *             we(3000),nvn(3000),dummy(54000),
     *             IndHKL(3000,5),Mult(3000),SetFob(3000,4),
     *             TThet(3000),WHM(3000),dummpc(124000)
      common/gpt/nanew(8),naold(8),sn,sq
      common /neutro/ neutro,bmat(2,98),neuwei,vetint(200)
c     pseudotranslation informations
      common /cpseud/ npseud,lpseuv(12),llpse
c
c
      nc=0
      do 5 i=1,nref
      nc=nc+1
      nv(nc)=IndHKL(i,4)
   5  continue
c
      bt2=2.*bt
c     set initial values
      nc=0
      nr=0
      do 240 i=1,nref
      nr=nr+1
      lh   =IndHKL(i,1)
      lk   =IndHKL(i,2)
      ll   =IndHKL(i,3)
      nov  =IndHKL(i,4)
      jcode=IndHKL(i,5)
      icobs=1
c     icobs  =  0 if reflexion is unobserved
c            =  1 if reflexion is observed
c     inp=65536*lh+256*(lk+128)+ll+128
      inp=(icobs*128*128+(lh+64)*128+(lk+64))*128+ll+64
      f2=SetFob(i,4)
      sigf2=SetFob(i,2)
      fo=sqrt(f2)
      if (fo.le.0.0001) then
                          fo=0.0 
                          sigmaf=0.0
                        else
      if (f2.ge.sigf2) then
                         sigmaf=0.5*sigf2/fo
                       else
                         sigmaf=0.5*sqrt(sigf2)
                       endif
                       endif
c
c--  ed = FWHM
c--  ew = sigma(F)
c
      ed= WHM(i) * 10.0
      ew=sigmaf
      nc=nc+1
      ix(nc)=inp
      ex(nc)=0.0
      fx(nc)=fo
      iphi(nc)=jcode
      ewx(nc)=ew
      edx(nc)=ed
      we(nc)=1.0
  240 continue
c
      if (neuwei.eq.0) then
                         do 574 i=1,nc
                         if (nv(i).ge.0) then
                                 if (nv(i).gt.0) over=nv(i)
                                 we(i)=1.0/sqrt(over)
                               endif
  574                    continue
                       endif
c
      ind=0
      do 575 i=1,nref
           if (nv(i).eq.1) then
                             nvn(i)=0
                             if (ind.gt.0) nvn(ind)=i-1
                             ind=0
      else if (nv(i).gt.1) then
                             if (ind.gt.0) nvn(ind)=i-1
                             ind=i
      else if (nv(i).eq.0) then
                             nvn(i)=i-1
                           else
                             if (ind.gt.0) nvn(ind)=i-1
                             ind=0
                             nvn(i)=-1
                             we (i)=0.0
                           endif
  575 continue
      if (ind.gt.0) nvn(ind)=nref
      do 589 i=1,nref
  589 nv(i)=nvn(i)*1024+int(we(i)*1000)
      return
      end
c ------------------------------------------------------------------
      subroutine noequi
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/xdata/ix(3000),ex(3000),fx(3000),iphi(3000),
     *             ewx(3000),edx(3000),jpunt(3000),nv(3000),
     *             we(3000),nvn(3000),dummy(54000),
     *             IndHKL(3000,5),Mult(3000),SetFob(3000,4),
     *             TThet(3000),WHM(3000),dummpc(124000)
      dimension i1(3)
c
c
c-- modify F's accordingly to epsilon and multeplicity
c
      nc=0
      sum=0.0
      tot=0.0
      do 1020 i=1,nref
      nc=nc+1
      i1(1)=IndHKL(i,1)
      i1(2)=IndHKL(i,2)
      i1(3)=IndHKL(i,3)
      jovr =IndHKL(i,4)
      call cmult(i1,eps,multi)
      dummy(i)=eps
      if(jovr.lt.0) jovr=-jovr         
      if (jovr.ne.0.and.jovr.ne.1)then
      mmm=0
      novr=jovr-1
      do 10 j=0,novr   
      i1(1)=IndHKL(i+j,1)
      i1(2)=IndHKL(i+j,2)
      i1(3)=IndHKL(i+j,3)
      call cmult(i1,eps,multi)
      dummy(i+j)=eps
      mmm=mmm+Mult(i+j)*dummy(i+j)
  10  continue
      do 15 j=0,novr    
      SetFob(i+j,4)=dummy(i+j)*SetFob(i,1)/mmm
  15  continue
      end if
1020  continue
      return
      end
c ------------------------------------------------------------------
      subroutine incrys
c
c-- prepare reflections input file for INCRYS or CRYPOW
c-- file content :  h  k  l  over I(obs) sigma sin(theta)/lambda
c-- where I(obs) = sum ( F(o)**2 * mult )
c
      character fname(9)*80,ext(9)*4
      common/dotdat/ fname,ext
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /ureq1/ ncycl,nroset,nundset,alambda,nsec,machkl,uvwt(4),
     *               pfwhm
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/xdata/ix(3000),ex(3000),fx(3000),iphi(3000),
     *             ewx(3000),edx(3000),jpunt(3000),nv(3000),
     *             we(3000),nvn(3000),dummy(54000),
     *             IndHKL(3000,5),Mult(3000),SetFob(3000,4),
     *             TThet(3000),WHM(3000),dummpc(124000)
c
      itype=0
      iform=1
      if (jopen(kform,fname(7),nlen,itype,iform,ios).lt.0) go to 9100
c
c-- output reflections
c
      do 1060 i=1,nref
      arg = 0.5 * TThet(i) * pi/180.0
      sintl=sin(arg)/alambda
      count=SetFob(i,1)
      jovr =IndHKL(i,4)
CNEW  if (jovr.eq.0) count=100.0
      if (jovr.eq.0) count=0.0
      write(kform,1040) (IndHKL(i,j),j=1,4),count,SetFob(i,2),
     *                  sintl,
     *SetFob(i,4),WHM(i),TThet(i),Mult(i)
c
      if (jovr.lt.0.and.machkl.eq.1) IndHKL(i,4) = -jovr
c
 1040 format(4i4,2f15.3,f8.5,f15.3,2f15.5,i4)
 1060 continue
      close (kform)
      return
 9100 write(lo,9010) ios,fname(7)
 9010 format(' *** error ***  open error, code =',i5,' file is ',a)
      ier=-1
      return
      end
c---------------------------------------------------------------------
      subroutine cmult(i1,eps,mult)
c
c     compute epsilon and multiplicity by generating equivalent
c     reflexions
c     epsylon = number of times same reflexion appears in list
c     multiplicity = number different reflexions in list
c
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      dimension i1(3),i2(3)
c
      eps=1.0
      mult=1
c     in triclinic space groups eps = 1.0 and mult = 1
      if(nsym.eq.1) go to 600
      k1=65536*i1(1)+256*(i1(2)+128)+i1(3)+128
      ik1=65792-k1
      do 500 j=2,nsym
      do 100 l=1,3
  100 i2(l)=0
      do 400 l=1,3
      do 300 k=1,2
      m=iabs(is(k,l,j))
      if(m.gt.0) i2(m)=i2(m)+i1(l)*isign(1,is(k,l,j))
  300 continue
  400 continue
      k2=65536*i2(1)+256*(i2(2)+128)+i2(3)+128
      if(k2.eq.k1) eps=eps+1.0
      if(icent.ne.0.and.k2.eq.ik1) eps=eps+1.0
      if(k2.eq.k1.or.k2.eq.ik1) mult=mult+1
  500 continue
  600 continue
      mult=2*nsym/mult
      return
      end
c---------------------------------------------------------------------
      subroutine checkeq(kv,rhm,rhmi,nrmax,nrefp,nex,istop,ier)
c
c-- at this point the allowed reflections are available
c-- it is possible to eliminate symmetry equivalents 
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common /ureq1/ ncycl,nroset,nundset,alambda,nsec,machkl,uvwt(4),
     *               pfwhm
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common /uno/ mxbg,indmb
      common/xdata/ibig(84000),
     *             IndHKL(3000,5),Mult(3000),SetFob(3000,4),
     *             TThet(3000),WHM(3000),dummpc(124000)
      common /neutro/ neutro,bmat(2,98),neuwei,vetint(200)
      integer ib(3),jnbl(128),knbl(128)
      dimension kv(3)
c
c        set values for some constants
c
      nob=0
      neq=0
      npq=0
      nobi=0
      nnob=0
      lag=0
      ib(1)=1
      ib(2)=2**2
      ib(3)=2**12
      do 65 i=1,128
      knbl(i)=-1
   65 jnbl(i)=-1
      kv(2)=2*ihx(3)+1
      kv(3)=ihx(2)*kv(2)+ihx(3)
      kv(1)=kv(2)*(2*ihx(2)+1)
      indmb=ihx(1)*kv(1) + ihx(2)*kv(2) + ihx(3) + kv(3)
      if(indmb.gt.mxbg) then
           write(lo,70) jrel,indmb,mxbg
70         format(' available memory too small, a scratch file',/,
     *            ' on channel ',i3,' will be used temporarely.',/,
     *            ' required =',i5,'  available =',i5)
           itype=1
           iform=2
           jop=jopen(jrel,fileh,nlen,itype,iform,ier)
         endif
      do 80 i=1,mxbg
 80    ibig(i)=0
      do 230 i=1,nrefp
      lh = IndHKL(i,1)
      lk = IndHKL(i,2)
      ll = IndHKL(i,3)
c-- index of relection in big list
      inbl= lh*kv(1) + lk*kv(2) + ll + kv(3)
      if(inbl.le.mxbg) go to 170
      if (nob.eq.0) go to 160
      do 120 j=1,nobi
      if (inbl.eq.jnbl(j)) go to 210
120   continue
      if (nnob.eq.0) go to 160
      rewind jrel
      do 140 k=1,nnob
      read(jrel) knbl
      do 140 j=1,128
      if (inbl.eq.knbl(j)) then
                             lag=1
                             go to 210
                           endif
140   continue
160   continue
      jbig=1
      if (nobi.lt.128) go to 166
      write(jrel) jnbl
      nobi=0
      nnob=nnob+1
      do 165 j=1,128
165   jnbl(j)=-1
166   nob=nob+1
      nobi=nobi+1
      jnbl(nobi)=inbl
      go to 230
170   lag=ibig(inbl)
210   continue
c
c        lag=0 if ibig(inbl) is empty,
c        lag=1 if ibig(inbl) was filled up
c
      if (lag.ne.1) then
                      ibig(inbl)=1
                      npq=npq+1
                      IndHKL(npq,1) = IndHKL(i,1)
                      IndHKL(npq,2) = IndHKL(i,2)
                      IndHKL(npq,3) = IndHKL(i,3)
                      IndHKL(npq,4) = IndHKL(i,4)
                      SetFob(npq,4) = SetFob(i,4)
                      TThet(npq)    = TThet(i)   
                    else
                      neq=neq+1
                      if(machkl.eq.0) then
                      write(lo,215) lh,lk,ll,IndHKL(i,4)
                                       else
                      write(lo,216) lh,lk,ll
                                       endif
                      if (IndHKL(i,4).ne.1.and.IndHKL(i,4).ne.-1)
     *                istop=2
                    endif
  230 continue
  215 format('   symmetry equivalent :',3i4,' overlapping code :',i3)
  216 format('   symmetry equivalent :',3i4)
      write(lo,305) nref
      if (nrmax.gt.0) write(lo,311) nrmax,th
      write(lo,320) npq,nex,neq,ihx,rhmi,rhm
  305 format(/,10x,i5,'  input reflections')
  311 format(10x,i5,'  rejected reflections with s**2 .gt. ',f6.3)
  320 format(  10x,i5, '  independent input reflections',
     *       /,10x,i5, '  systematically absent reflections rejected',
     *       /,10x,i5, '  symmetry equivalent reflections rejected',
     *       /, 3x,3i4,'  maximum  h,k,l  values',
     *       /,8x,f7.4,'  minimum s**2 = (sin(theta)/lambda)**2',
     *       /,8x,f7.4,'  maximum s**2 = (sin(theta)/lambda)**2',/)
c
c-- check reflections against cell parameters
c
      check=sqrt(rhm)*alambda
      if (check.gt.1.0) then
                          write(lo,324) 
                          ier=-1
                          return
                        endif
  324 format(/,'   *** error *** inconsistence between cell constants',
     */,'                 and reflections. Program stops',/)
      if (istop.eq.1) then
                        write(lo,325)
                         ier=-1
                         return
                       endif
      if (istop.eq.2) then
                        write(lo,326)
                         ier=-1
                         return
                       endif
  325 format(/,'   *** error *** sistematically absent reflection',/,
     *           '      with overlapping code  > 1. Program stops',/)
  326 format(/,'   *** error *** simmetry equivalent reflection',/,
     *           '    with overlapping code  > 1. Program stops',/)
      nref=npq
      rhomax=rhm
      rhomin=rhmi
      return
      end
c---------------------------------------------------------------------
      function ctheta(rho)
c
c-- compute 2-Theta value from ( sin(theta)/lambda ) ** 2
      common /ureq1/ ncycl,nroset,nundset,alambda,nsec,machkl,uvwt(4),
     *               pfwhm
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      theta=sqrt(rho)*alambda
      theta=asin(theta)*180.0/pi
      ctheta=2.0*theta
      return
      end
c---------------------------------------------------------------------
code for upd03
      subroutine upd03
c--update list 3, ( for neutron data )
c
c  l3  location of the information for the first form factor
c  n3  number of form factors
c
c--
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common /neutro/ neutro,bmat(2,98),neuwei,vetint(200)
      common/xlimi/ nfl,idummy(5),nfls
      common /data/ store(5000)
      dimension  istore(5000)
      dimension vet(8),ivet(8),nwn(8),non(8),rad1(8),rad2(8)
      equivalence(store,istore)
c--
      nfl=nfls
      call sldl(3,ly,l3g,lz)
      n3=     store(l3g+5)
      l3=     store(l3g+6) +l3g
      md3=    store(l3g+7)
      l=lz-1
      call xsac(3,ly,li,l)
c
c-- sort values respect to neutron scattering factor
c
      m3=l3
      do 500 i=1,n3
      ivet(i)=i
      vet (i)=abs(bs(1,i))
      rad1(i)=store(m3+15)
      m3=m3+md3
  500 continue
      n=n3
      call sortco (vet,ivet,n)
      do 600 i=1,n3
      j=ivet(i)
      ivet(i)=nalf(j)
      nwn(i)=nw(j)
      non(i)=no(j)
      vet(i)=bs(1,j)
      rad2(i)=rad1(j)
  600 continue
      do 700 i=1,n3
      nalf(i)=ivet(i)
      nw  (i)=nwn(i)
      no  (i)=non(i)
      bs(1,i)=vet(i)
  700 continue
      nk=n3
      m3=l3
      nat=0
      do 1000 i=1,n3
      istore(m3   )=nalf(i)
       store(m3+12)=nw(i)
       store(m3+13)=no(i)
       store(m3 +2) = 0.0
      m3i=m3+3
      do 1100 j=1,4
      store(m3i  ) = 0.0
      if (j.eq.1) then
                    store(m3i+1) = bs(1,i)
                  else
                    store(m3i+1) = 0.0
                  endif
      m3i=m3i+2
1100  continue
      store(m3+15)=rad2(i)
      m3=m3+md3
1000  continue
      lz=12+1+n3*md3
      n=lz-nfl
      call sfrml(3,n)
      return
      end
c------------------------------------------------------------
      subroutine onebl(string,lenstr,ier)
      character blank,string*(*),buff*16,poss*22
      dimension in(7)
c
      ier=0
      poss='pabcifrmabcnd-123456/ '
      blank=poss(22:22)
      k=len(string)
c
c-- check the number of blanks between items in space
c-- group symbol ( max one blank allowed )
c
      do 5 i=1,16
    5 buff(i:i)=blank
      ic=0
      j=1
      do 10 i=1,k
      if (string(i:i).ne.blank) then
                                  buff(j:j)=string(i:i)
                                  j=j+1
                                  if (j.gt.16) go to 15
                                  ic=0
                                else 
                                  if (ic.eq.0) then
                                      ic=ic+1
                                      buff(j:j)=string(i:i)
                                      j=j+1
                                      if (j.gt.16) go to 15
                                    endif
                                endif
   10 continue
   15 do 20 i=1,16
   20 string(i:i)=buff(i:i)
c
c-- now check the correctness of the space group symbol 
c
c     poss='pabcifrmabcnd-123456/ '
c                  123456789012345
c-- ifoll = possible following character
c         = 0   initial state ( actual char = blank )
c         = 1   only numbers < 7 ( not 5 )
c         = 2   only numbers < actual number or / or blank
c         = 3   only letters
c         = 4   only blank
      if (string(2:2).ne.blank) go to 800
      n=0
      k=0
      iz=0
      nbr=0
      do 99 i=1,7
      in(i)=0
  99  if (string(1:1).eq.poss(i:i)) nbr=i
      if(nbr.eq.0) go to 800
      do 100 i=2,lenstr
      if(string(i:i).ne.blank) go to 101
      minus=1
      num=0
      ifoll=0
      k=k+1
      go to 100
 101  m=0
      do 102 j=1,14
 102  if(string(i:i).eq.poss(j+7:j+7)) m=j
      if(m.eq.0.or.k.gt.3) go to 800
c     poss='pabcifrmabcnd-123456/ '
c                  123456789012345
           if (m.ge.1.and.m.le.6.and.ifoll.eq.3) then
                                        ifoll=4
      else if (m.ge.1.and.m.le.6.and.ifoll.eq.0) then
                                        ifoll=4
      else if (m.eq.7.and.ifoll.eq.0) then
                                        ifoll=1
                                        minus=-1
                                        num=num+1
      else if (m.ge.8.and.m.le.13.and.ifoll.le.1) then
                                        ifoll=2
                                        iold=m-7
                                        if (iold.eq.5) go to 800
                                        num=num+1
                                        if (num.gt.2) go to 800
      else if (m.ge.8.and.m.le.13.and.ifoll.eq.2) then
                                        inew=m-7
                                        if (inew.ge.iold) go to 800
                                        num=num+1
                                        if (num.gt.2) go to 800
                                        ifoll=2
      else if (m.eq.14.and.ifoll.eq.2) then
                                        ifoll=3
                                      else
                                        go to 800
                                      endif
 100  continue
      if (minus.lt.0.and.num.eq.1) go to 800
c
c-- space group symbol ok
c
      return
c
c-- error
c
  800 continue
      ier=-1
      return
      end
c------------------------------------------------------------
      subroutine machkls(fileh,formt,kuser,istop,ier)
c
c-- read reflections from card input
c
      character*80 fileh,formt
      character*80 line
      character fname(9)*80,ext(9)*4
      common/dotdat/ fname,ext
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common /uno/ mxbg,indmb
c  if ibig dimension has to be changed, alter mxbg accordingly
      common/xdata/ibig(84000),
     *             IndHKL(3000,5),Mult(3000),SetFob(3000,4),
     *             TThet(3000),WHM(3000),dummpc(124000)
      common /neutro/ neutro,bmat(2,98),neuwei,vetint(200)
      dimension abig(120000)
      equivalence (ibig(1),abig(1))
      integer ph,vsym(24),ibrav(6,13)
      dimension kv(3),i1(3)
      data ibrav/4*1,3,1,0,3*1,0,-1,1,0,6*1,0,3*1,5*2,3,4*0,1,11*0,1,
     ,5*0,2,5*0,1,5*0,1,11*0,2,0/
c
c--
c
      fosog=-999.9
      mxbg=84000
      nex=0
c  ksym=number of translational matrices different from ( 0.0 0.0 0.0 )
      ksym=0
      do 20 i=2,nsym
      ifl=0
      do 10 j=1,3
      if (abs(ts(j,i)).gt.0.00001) ifl=1
   10 continue
      if (ifl.eq.0) go to 20
      ksym=ksym+1
      vsym(ksym)=i
   20 continue
      klatt=latt-1
      kfasi=36
      if (jfile.lt.0) go to 7034
      if (jfile.ne.ln) then
                         itype=2
                         iform=1
                         if (jopen(jfile,fileh,nlen,itype,iform,ios)
     *                             .lt.0) go to 9000
                    
c-- reflections are in the direct access file
          endif
 7034 continue
      if (jfile.eq.ln) go to 6000
      jfile=iabs(jfile)
      nref=0
      nrefp=0
      do 7035 i=1,3
 7035 ihx(i)=-100
      nrec=0
      nnn=0
      nuobs=0
      nrmax=0
      rhm =-99.9
      rhmi= 99.9
c
      if(knw.eq.1) open (unit=kfasi,file=fname(8),
     *                   status='old')
      read(jfile,'(a80)',end=7000) line
      read(jfile,'(a80)',end=7000) line
      formt='(3i4,i8,f10.5,2f10.4,f10.0,f10.1)'
   30 read(jfile,formt,end=60,err=8000,iostat=ios)
     *     lh,lk,ll,multi,sintl,twot,fwhm,f2,sigf2
      if(knw.eq.1) read(kfasi,37)aph
      ph=aph
   37 format(28x,f8.2)  
c  37 format(28x,i5)  
**************************************************************************
**********                                                  **************
**********  Quando si prepara il file per il raffinamento   **************
**********  questo deve contenere I=sum( m F**2 )           **************
**********  e sigma(i)=sigma( F**2 ) * m                    **************
**********                                                  **************
**********  SetFob(JR,2) = SetFob(JR,2)*FLOAT(Mult(JR))*2.  **************
**********                                                  **************
**************************************************************************
      nref=nref+1
      call extin(jex,lh,lk,ll,ibrav,klatt,ksym,vsym)
      if (jex.eq.1) then
          nex=nex+1
          write(lo,35) lh,lk,ll
   35     format(' systematically absent :',3i4)
        else
          call geneq(1,lh,lk,ll,idelt,jcode,isgnn,id1,rho)
          ireje=0
          if (rho.gt.th) then
                           ireje=1
                           nrmax=nrmax+1
                         endif
          if (ireje.eq.0) then
                            sig=1.0
                            if (rho.gt.rhm) rhm=rho   
                            if (rho.lt.rhmi) rhmi=rho   
                            nrefp=nrefp+1
ccccccccccccccccccccccccccccccccc
      if (nrefp.gt.3000) then         
      nnn=3000
      write(6,325) nnn
  325 format(10x,'number of independent input reflections larger than
     & permitted number of input reflections',i5)
      stop 
      end if
                            nnn=nnn+1
                            if (f2.lt.0.0) f2=0.0
                            f=sqrt(f2)
                            if (f.gt.fosog) fosog=f
CNEW ---------------------------------
                            if (knw.eq.0) then    
                                            ph=0
                                          else
                                            ph=ph+idelt
                                            ph=ph*isgnn
                                            ph=mod(ph,360)
                                            if(ph.le.0)ph=ph+360
                                          endif
                            ph=ph*32+jcode
CNEW ---------------------------------
                            IndHKL(nrefp,1) = lh
                            ibig(12*(nrefp-1)+1)=lh
                            IndHKL(nrefp,2) = lk
                            ibig(12*(nrefp-1)+2)=lk
                            IndHKL(nrefp,3) = ll
                            ibig(12*(nrefp-1)+3)=ll
CNEW -----------------------
                            i1(1)=lh
                            i1(2)=lk
                            i1(3)=ll
                            call cmult(i1,eps,multi)
                            IndHKL(nrefp,4) = -1
                            ibig(12*(nrefp-1)+4)=-1
CNEW                        IndHKL(nrefp,5) = jcode
                            IndHKL(nrefp,5) = ph
                            ibig(12*(nrefp-1)+5)=ph
                            SetFob(nrefp,1) = 0
                            ibig(12*(nrefp-1)+6)=0 
                            SetFob(nrefp,2) = sigf2
                            abig(12*(nrefp-1)+7)=sigf2
                            SetFob(nrefp,3) = 0
                            ibig(12*(nrefp-1)+8)=0     
                            SetFob(nrefp,4) = f2
                            abig(12*(nrefp-1)+9)=f2
                            TThet(nrefp)    = twot
                            abig(12*(nrefp-1)+10)=twot
                            Mult(nrefp)     = multi
                            abig(12*(nrefp-1)+11)=multi
                            WHM(nrefp)      = fwhm
                            abig(12*(nrefp-1)+12)=fwhm  
                            if (f.gt.fosog) fosog=f
                          endif
                        endif
      go to 30
   60 continue
CNEW -----------
      k1=1
      jump=10
      call sortz(k1,nrefp,12,jump)
      do 61 i=1,nrefp
      IndHKL(i,1)=ibig(12*(i-1)+1)
      IndHKL(i,2)=ibig(12*(i-1)+2)
      IndHKL(i,3)=ibig(12*(i-1)+3)
      IndHKL(i,4)= -1
      IndHKL(i,5)=ibig(12*(i-1)+5)
      SetFob(i,1)= 0
      SetFob(i,2)=abig(12*(i-1)+7)
      SetFob(i,3) = 0
      SetFob(i,4)=abig(12*(i-1)+9)
      TThet(i)=abig(12*(i-1)+10)
      Mult(i)=abig(12*(i-1)+11)
      WHM(i)=abig(12*(i-1)+12) 
 61   continue
c
c-- check for equivalent reflections
c
      call checkeq(kv,rhm,rhmi,nrmax,nrefp,nex,istop,ier)
      if (ier.lt.0) return
c
c-- check for unobserved reflections
c
      call obsin(kv,ibrav,klatt,ksym,vsym)
c
      if (jfile.ne.ln) close(jfile)
      if(knw.eq.1) close (kfasi)
      if (nref.gt.kuser) go to 350
      return
  350 write(lo,360) kuser
  360 format(//,' ***  error  *** too many reflections  ',/,
     *' increase  kuser  value and dimensions in common /xdata/ in norma
     *l modul',/,' actually kuser = ',i5)
      ier=-1
      return
 6000 continue
      write(lo,6010)
 6010 format(/,' *** warning ***  no reflections supplied')
      go to 9040
 7000 continue
      write(lo,7010) jfile
 7010 format(/,' *** error ***  eof on channel ',i2)
      go to 9020
 8000 write(lo,8010) jfile,ios
 8010 format(/,' *** error ***  read error on channel ',i2,' code =',i5)
      go to 9020
 9000 write(lo,9010) ios,fileh
 9010 format(/,' *** error ***  open error, code =',i5,' file is ',a)
 9020 write(lo,9030)
 9030 format(  '                reflections expected')
      ier=-1
      if(knw.eq.1) close(kfasi)
 9040 return
      end
c------------------------------------------------------------
c     define overlapping            
      subroutine defovl
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common /ureq1/ ncycl,nroset,nundset,alambda,nsec,machkl,uvwt(4),
     *               pfwhm
      common/xdata/ix(3000),ex(3000),fx(3000),iphi(3000),
     *             ewx(3000),edx(3000),jpunt(3000),nv(3000),
     *             we(3000),nvn(3000),dummx(54000),
     *             IndHKL(3000,5),Mult(3000),SetFob(3000,4),
     *             TThet(3000),WHM(3000),dummpc(124000)
C
C --- Construct of overlapping groups of reflections;
C
      if(WHM(1).lt.0.0) then
      do 10 i=1,nref
      SetFob(i,1)=0.0
      do 15 j=1,IndHKL(i,4)
      SetFob(i,1)=SetFob(i,1)+Mult(i+j-1)*SetFob(i+j-1,4)
  15  continue
  10  continue
      go to 295
      end if
      EPS    = 0.001
      THG    = pfwhm
      Fmax   = 0.
      NumOvG = 0
      NumRjR = 0
      NumRjG = 0
      jr     = nref
      DO 230 JS=1,JR-1
         NgF = 0
         If(IndHKL(JS,4).EQ.0) GO TO 227
            SetFob(JS,1) = SetFob(JS,4)*FLOAT(Mult(JS))
            IF(SetFob(JS,4).LT.EPS) NgF    = -1
            IndHKL(JS,4) = 1
            NumOvG       =NumOvG+1
            DO 220 JG=JS+1,JR
               IFL = 0
               IF(ABS(Tthet(JG)-Tthet(JS)).LE.THG*WHM(JS)) THEN
                  SetFob(JG,1) = SetFob(JG,4)*FLOAT(Mult(JG))   
                  If(SetFob(JG,4).LT.EPS) NgF    = -1
                  SetFob(JS,1) = SetFob(JS,1)+SetFob(JG,1)
                  IndHKL(JS,4) = IndHKL(JS,4)+1
                  IndHKL(JG,4) = 0
                  IFL = 1
               END IF
               IF(IFL.EQ.0) GO TO 225
 220        CONTINUE
 225        CONTINUE
            IF((JG.GE.JR).AND.(IFL.EQ.0)) THEN
               SetFob(JR,1) = SetFob(JR,4)*FLOAT(Mult(JR))    
               IndHKL(JR,4) = 1
               NumOvG       = NumOvG+1
               IF(Fmax.LT.SetFob(JR,1)) Fmax = SetFob(JR,1)
               IF(SetFob(JR,4).LT.EPS) THEN
                  IndHKL(JR,4) = -1
                  NumRjG = NumRjG+1
                  NumRjR = NumRjR+1
               END IF
            END IF
 227     CONTINUE
      IF(Fmax.LT.SetFob(JS,1)) Fmax = SetFob(JS,1)
      IF(NgF.LT.0) THEN
         NumRjG = NumRjG+1
         NumRjR = NumRjR+IndHKL(JS,4)
         IndHKL(JS,4) = -IndHKL(JS,4)
      END IF
 230  CONTINUE
      ngroup=0
      Do 270 JJ=1,JR
         If (IndHKL(JJ,4).EQ.0) then
            SetFob(JJ,1) = 0.
                                else
            ngroup=ngroup+1
                                endif 
 270  CONTINUE
 295  continue
      return
      end
c-----------------------------------------------------------------------
      subroutine genaeq(lty,ih,kk,il,lvet,vetaeq,kv)
      integer  vetaeq(48)
      dimension i1(3),i2(3)
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      dimension kv(2)
c
c--- la procedura genaeq  riempie il vettore
c--- vetaeq con i superindici degli equivalenti per simmetria 
c--- al riflesso (ih,kk,il)          
c---
c
      do 70 i=1,48             
70    vetaeq(i)=0
      lvet=0
      jj=0
c ---
      i1(1)=ih
      i1(2)=kk
      i1(3)=il
      jcode=13
      do 250 j=1,nsym
      do 200 i=1,3
      i2(i)=0
  200 continue
      do 220 i=1,3
      do 210 k=1,2
      m=iabs(is(k,i,j))
      if(m.gt.0) i2(m)=i2(m)+i1(i)*isign(1,is(k,i,j))
  210 continue
  220 continue
c--
      lvet=lvet+1
      inbl=i2(1)*kv(1) + i2(2)*kv(2) + i2(3) 
      inbl=iabs(inbl)
      vetaeq(lvet)=inbl
c--
      if (lty.eq.1) then
                      if(ihx(1).lt.iabs(i2(1))) ihx(1)=iabs(i2(1))
                      if(ihx(2).lt.iabs(i2(2))) ihx(2)=iabs(i2(2))
                      if(ihx(3).lt.iabs(i2(3))) ihx(3)=iabs(i2(3))
                    endif
  250 continue
c--
      return
      end
c------------------------------------------------------------
      subroutine indmm(hmin,hmax,kmin,kmax,lmin,lmax)
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      integer  hmin,hmax,kmin,kmax,lmin,lmax                  
      character ntc*16
c
      write(ntc,'(16a1)') nt
c --
c --   calcolo hmin e hmax , kmin e kmax , lmin e lmax                  
c --
        hmin=-ihx(1)
        hmax=ihx(1)
        kmin=-ihx(2)
        kmax=ihx(2)
        lmin=-ihx(3)
        lmax=ihx(3)
c --
c -- TRICLINO
c --
      if (lsys.eq.1) then
        hmin=0
c --
c -- MONOCLINO
c --
      else if (lsys.eq.2) then
       if (ntc(3:3).eq.'1') then
        if (ntc(5:5).eq.'1') then
c -- 2||c
            hmin=0
            lmin=0         
        else 
c -- 2||b
            hmin=0
            kmin=0         
        endif      
       else
        if (ntc(4:4).eq.'1') then
         if (ntc(6:6).eq.'1') then
c -- 2||a
            hmin=0
            kmin=0
         else
c -- 2||b
            hmin=0
            kmin=0         
         endif
        else
         if(ntc(5:5).eq.'1') then
c -- 2||a
            kmin=0
            hmin=0
         else
c -- 2||b
            hmin=0
            kmin=0         
         endif
        endif
       endif
c --
c -- ORTOROMBICO
c --
      else if (lsys.eq.3) then
          hmin=0
          kmin=0
          lmin=0
c --
c -- TETRAGONALE : 
c -- 
      else if (lsys.eq.4) then
          hmin=0
          kmin=0
          lmin=0
c --
c -- ESAGONALE E TRIGONALE : 
c -- 
      else if (lsys.eq.5) then
            hmin=0
            lmin=0
c --
c -- CUBICO :  va' considerata la condizione aggiuntiva h<=k<=l
c -- 
      else if (lsys.eq.6) then
           hmin=0
           kmin=0
           lmin=0
      endif
      return
      end
c-----------------------------------------------------------------
c     read reflexions from list 7      
      subroutine obsin(kv,ibrav,klatt,ksym,vsym)
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/xdata/ibig(84000),
     *             IndHKL(3000,5),Mult(3000),SetFob(3000,4),
     *             TThet(3000),WHM(3000),dummpc(124000)
      common/genob/irho,rhomax3
c---
      integer  hmin,hmax,kmin,kmax,lmin,lmax                  
      integer  vetaeq(48),ibrav(6,13),vsym(24)
      dimension kv(3)
c---
      nhmax=0
      nkmax=0
      nlmax=0
      rhomax1=rhomax
      if (irho.gt.0) then
                       thmin=rhomax
                       thmax=rhomax3
                       write(lo,7031)
                       write(lo,7032)thmin,thmax    
                       if(nref.eq.1)then 
                                     ihx(1)=20
                                     ihx(2)=20
                                     ihx(3)=20
                                   else
                                     ihx(1)=2*ihx(1)
                                     ihx(2)=2*ihx(2)
                                     ihx(3)=2*ihx(3)
                                   endif
                     endif
 7031 format('Intervallo di rho in cui sono generati i riflessi ',/)
 7032 format(' rhomin = ',f6.5,' rhomax = ',f6.5)
c
c-- at this point the allowed reflections are in memory
c-- it is possible to add (optionally) unobserved reflections
c
      nru=0
      nr=nref
c--
      call indmm(hmin,hmax,kmin,kmax,lmin,lmax)
c--
      nhmax=hmin
      nkmax=kmin
      nlmax=lmin
c--
      do 800 indh=hmin,hmax
      do 700 indk=kmin,kmax
      do 600 indl=lmin,lmax
c---
c---  vedere se il nuovo riflesso generato e' equivalente
c---  ad uno gia' considerato, in questo caso :
c---
      if (indh.eq.0.and.indk.eq.0.and.indl.eq.0) go to 600
c   
c    TRIGONALE : va' considerata la condizione aggiuntiva |h|>|k|
c                nel caso (+-+)
c               
      if (lsys.eq.5.and.indk.lt.0.
     *and.iabs(indh).lt.iabs(indk)) goto 600
c   
c    CUBICO :  va' considerata la condizione aggiuntiva h<=k<=l
c    
      if(lsys.eq.6.and.(indk.lt.indh.and.indk.gt.indl)) goto 600
c
      indh1=indh
      indk1=indk
      indl1=indl
      call extin(jex,indh1,indk1,indl1,ibrav,klatt,ksym,vsym)
      if (jex.eq.1) goto 600
      call geneq(1,indh1,indk1,indl1,idelt,jcode,isgnn,id1,rho)
      inbl=indh1*kv(1) + indk1*kv(2) + indl1 + kv(3) 
c-- in data il superindice e' calcolato come:
c     inbl= lh*kv(1) + lk*kv(2) + ll + kv(3)
      inbl=iabs(inbl)
      if (ibig(inbl).ne.0) go to 600
      rhomax=rhomax1
      if (irho.eq.1) then
        if (rho.lt.rhomax1.or.rho.gt.rhomax3) then
                                              goto 600
                                             else
                             if(indh1.gt.nhmax) nhmax=indh1
                             if(indk1.gt.nkmax) nkmax=indk1
                             if(indl1.gt.nlmax) nlmax=indl1
                                              endif
                      else
                       if (rho.gt.rhomax1.or.rho.lt.rhomin) go to 600
                      endif 
c --
c -- ibig e' riempito con il riflesso non osservato
c --
      ibig(inbl)=1
      if (irho.lt.0) then
                       nru=nru+1
                       write(lo,7040) indh1,indk1,indl1,ctheta(rho)
 7040     format(' not measured reflection :',3i4,'  2-Theta = ',f10.4)
                       go to 600
                     endif
      nr=nr+1
c -- si tratta di un riflesso non osservato e di cio' si tiene 
c -- conto settando ivet(13,i) = -1        
      twot = ctheta(rho)
      write(lo,7050) indh1,indk1,indl1,twot
 7050 format('    generated reflection :',3i4,f10.4)
      IndHKL(nr,1) = indh1
      IndHKL(nr,2) = indk1
      IndHKL(nr,3) = indl1
      IndHKL(nr,4) = -1
      IndHKL(nr,5) = 0
      SetFob(nr,1) = 0
      SetFob(nr,2) = 0
      SetFob(nr,3) = 0
      SetFob(nr,4) = 0.0001
      TThet(nr)    = twot
  600 continue
  700 continue
  800 continue
c
      if (irho.ge.0) then
                     numobs=nref
                     nref=nr
                     nrug=nr-numobs
                     write(lo,900) nrug
                   else
                     if (nru.gt.0) write(lo,910) nru
                   endif
  900 format(10x,i5, '  generated reflections ')
  910 format(/,10x,i5, '  not measured reflections in data')
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c calcolo gli indici max tra i riflessi generati dello shell esterno
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      if(irho.eq.1) then
                      ihx(1)=0
                      ihx(2)=0
                      ihx(3)=0
                      call genaeq(1,nhmax,nkmax,nlmax,lvet,vetaeq,kv)
                     endif
      return
      end
c-----------------------------------------------------------------------
      subroutine unpack (index,ih,kk,il)
      ih = index/262144
      is = index - 262144*ih
      kk = is/512-256
      il = is-512*(kk+256)-256
      return
      end
c ----------------------------------------------------------------------
c
      subroutine symm(ncwu,ishif,kshif)
      character oshift*33,oshp*5,texc(6)*12,buffer(24)*60
      character space*16
      common /erl/ r,tmat(48,3),nt,isys,ngen,ngt,svet(10),jvet(8)
     *            ,dum(7)
      integer  svet,kshif(3)
      integer sys,nt(16),ges(3,3,36),net(3),in(3,4),is(3),get(3,34),
     *ntex(42),hbr(9),hs(15),ll(2,3,2),iss(59),lsh(2,78),s(3),lgt(
     *48),mst1(3,6),mst2(3,6),lf(216),q(3,4,5),txa(3,11),nsm(45),sem(3,3
     *,18),sc(3,3),lgn(3,45),atx(18),txb(5,7),tx(2,6,3),teb(2,9),t(48,3)
     *,ngt(48,48),r(48,3,3)
      equivalence (j2,in(2,2)),(j3,in(2,3)),(k2,in(3,2)),(k3,in(3,3)),
     *(i3,in(1,3)),(i2,in(1,2)),(i1,in(1,1)),(j1,in(2,1)),(k1,in(3,1))
     *,(i4,in(1,4)),(j4,in(2,4)),(k4,in(3,4))
      data sem/1,3*0,1,3*0,1,96,3*0,1,3*0,1,1,3*0,96,3*0,1,1,3*0,1,3*0,9
     *6,1,3*0,96,3*0,2*96,3*0,1,3*0,2*96,3*0,96,3*0,1,96,3*0,96,3*0,3*96
     *,3*0,1,3*0,2*96,3*0,96,5*0,96,6*0,3*96,8*0,1,6*0,64,128,32,6*0,128
     *,64,3*0,1,3*0,128,64,3*0,96,3*0,3*48,96,3*0,96,0,2*96,2*0,96,48,2*
     *0,96/,nsm/1,2,3,4,5,6,7,5,6,7,8,10,9,9,10,10,10,15,15,13,11,16,16,
     *13,13,16,11,11,12,12,12,8,8,8,8,8,11,10,10,11,11,11,11,12,12/,
     *q/4*0,2*12,9*0,12,0,12,9*0,2*12,11*0,3*12,0,3*12,4*0,3*12,6*0/
      data lsh/2,26,6,11,5,15,7,26,435,28,603,26,453,28,645,15,747,26,
     *771,15,2287,30,2383,32,2299,31,1622,11,899,9,1319,10,1209,10,1749,
     *11,954,9,1601,11,898,9,1221,10,1770,11,955,9,1307,10,2401,13,2547,
     *13,2421,13,5105,16,7303,15,7205,15,29187,12,29687,12,31662,12,1372
     *1,21,13202,11,13210,21,13691,22,17219,21,17221,15,17223,23,17227,
     *13,17229,15,17231,24,17721,24,14137,21,14147,11,14164,21,14170,
     *21,14638,3,14689,25,14692,26,15183,15,15160,21,15185,13,16229,15,
     *16228,11,16230,12,16729,15,15708,34,17122,3,17149,3,17102,21,171
     *29,21,17120,11,17148,11,17155,3,17132,3,17135,21,17112,11,17153,11
     *,17131,11,17603,3,17659,29,17662,15,5204,14,5104,14,5205,16/
      data mst1/3*1,0,2,2,3,0,3,4,4,0,5,6,7,9,10,11/,mst2/3*1,2,0,0,3,3,
     *0,0,4,4,7,5,8,11,0,12/,sys/2/,n,net,is,k/8*1/,id,il,lt,nrt/4
     **0/
      data lgn/1,0,0,2,0,0,2,0,0,2,0,0,2,0,0,2,0,0,2,0,0,3,4,0,3,4,0,
     *3,4,0,3,4,0,3,0,0,3,0,0,5,7,0,5,3,0,5,3,0,3,5,0,2,0,0,4,2,0,4,2,0,
     *4,2,0,4,2,0,5,0,0,5,0,0,7,10,0,7,4,0,7,4,0,7,10,0,2,5,0,5,14,0,
     *5,14,0,2,0,0,4,2,0,4,2,0,4,2,0,7,8,6,5,0,0,6,3,0,10,11,13,10,8,0,
     *10,8,0,14,19,22,8,5,0,26,37,5,14,5,0/,mcc,ngo,ncs,s,in,lgt/66*0/
      data lf/1,1,-2,1,-3,1,-4,1,2,1,3,1,4,1,2,-3,-4,1,3,-2,-4,1,4,-2,-3
     *,1,4,2,3,1,4,-15,-14,1,4,15,14,1,4,15,14,-2,-3,-13,-16,1,4,2,3,-13
     *,-16,-14,-15,1,4,13,16,-2,-3,-14,-15,1,4,2,3,13,16,14,15,1,3,5,1,3
     *,5,-9,-11,-7,1,3,5,-10,-8,-12,1,3,5,9,11,7,1,3,5,10,8,12,1,3,5,-4,
     *-2,-6,1,4,3,5,2,6,1,4,3,5,2,6,-9,-11,-7,-10,-8,-12,1,3,5,10,8,12,-
     *9,-11,-7,-4,-2,-6,1,3,5,9,11,7,-10,-8,-12,-4,-2,-6,1,4,3,5,2,6,9,1
     *1,7,10,8,12,1,4,2,3,5,9,7,12,8,10,6,11,1,4,2,3,5,9,7,12,8,10,6,11,
     *-13,-16,-14,-15,-17,-21,-19,-24,-20,-22,-18,-23,1,4,2,3,5,9,7,12,8
     *,10,6,11,13,16,14,15,17,21,19,24,20,22,18,23/,t  /144*0/
      data ges/1,3*0,1,3*0,1,1,3*0,-1,3*0,2*-1,3*0,1,3*0,2*-1,3*0,
     *-1,3*0,1,0,1,3*0,1,1,3*0,1,3*0,2*-1,3*0,-1,3*0,1,-1,3*0,-1,3*0,-1,
     *1,4*0,1,1,3*0,1,3*0,1,-1,3*0,-1,3*0,-1,1,3*0,-1,3*0,2*-1,3*0,
     *1,2*0,-1,0,-1,4*0,-1,0,-1,0,1,4*0,1,0,1,0,-1,4*0,1,0,1,0,1,4*0,
     *2*-1,4*0,-1,0,-1,0,-1,4*0,1,0,1,0,1,4*0,-1,0,1,0,1,4*0,1,0,-1,
     *3*0,-1,0,-1,0,-1,4*0,-1,0,1,0,1,4*0,1,0,-1,0,1,4*0,1,0,1,0,-1,0,0,
     *1,3*0,1,3*0,1,1,1,0,-1,4*0,1,0,1,0,2*-1,3*0,1,-1,3*0,-1,3*0,1,2*-1
     *,0,1,4*0,1,0,-1,0,1,1,3*0,1,0,1,0,1,4*0,-1,1,1,0,0,-1,3*0,-1,1,0,
     *0,2*-1,3*0,-1,0,-1,0,-1,4*0,3*-1,0,0,1,3*0,2*-1,0,0,1,1,3*0,-1/
      data iss/111,711,171,117,211,121,112,277,727,772,222,-389,411,477,
     *-373,-328,422,311,371,317,321,312,-589,611,677,-528,-573,622,231,-
     *363,432,-89,218,128,119,777,-289,418,484,-229,-283,684,618,737,731
     *,1,5,6,7,11,18,13,17,21,22,28,24,31,29/
      data texc/'triclinic   ','monoclinic  ','orthorhombic',
     *'tetragonal  ','hexagonal   ','cubic       '/
      data hbr/1hp,1ha,1hb,1hc,1hf,1hi,1hr,1hy,1h /
     *,hs/1hm,1ha,1hb,1hc,1hn,1hd,1h-,1h0,1h1,1h2,1h3,1h4,1h5,1h6,1h//
      data ntex/2h  ,2h  ,4*0,2h+1,2h/8,2h+1,2h/6,2*0,2h+1,2h/4,2*0,2h+1
     *,2h/3,2h+3,2h/8,4*0,2h+1,2h/2,6*0,2h+2,2h/3,2*0,2h+3,2h/4,2*0,2h+5
     *,2h/6/,teb/2h  ,2h-z,2h  ,2h-y,2h x,2h-y,2h  ,2h-x,0,0,2h  ,2h x,
     *2h y,2h-x,2h  ,2h y,2h  ,2h z/,txa/3*2h 0,2h g,3*2h 0,2h g,3*2h 0,
     *2
     *h g,2h 0,3*2h g,2h 0,3*2h g,2h 0,3*2h g,2h h,2h k,2h 0,2h h,2h k,2
     *h g,2h h,2h k,2h l/,txb/5*2h  ,2hh+,2hk=,2h2n,2*2h  ,2hh+,2hk+,2hl
     *=
     *,2h2n,2h  ,2h2h,2h+4,2hk+,2hg=,2h6n,2h2h,2h+k,2h=3,2hn ,2h  ,2hh+,
     *2hk+,2hl=,2h4n,2h  ,2h2h,2h+2,2hk+,2hg=,2h4n/,atx/11,21,31,41,51,6
     *1
     *,71,81,92,102,101,113,91,104,95,105,86,107/,get/3*0,12,3*0,12,3*0,
     *1
     *2,0,3*12,0,3*12,0,3*12,0,3*6,0,3*6,0,3*6,18,2*6,0,0,4,0,0,6,0,0,8,
     *0,0,12,0,0,16,0,0,18,0,0,20,18,6,0,18,12,6,18,6,3,18,6,9,0,18,0,0,
     *6,0,0,6,3,6,0,0,0,12,6,9,9,0,9,0,9,0,9,9,6,18,18,0,18,9/
      data oshift /'                                 '/
c--
c  13 format(2(i3,')',2(4a2,','),4a2))
   13 format(2(1h ,i3,2(4a2,','),4a2))
   15 format(//,' Seminvariant condition : ',3a2,4x,5a2)
   19 format (/,' Crystal family',29x,':  ',a12)
   20 format (/,' Space group (centrosymmetric)',14x,':  ',a16,a33)
   21 format (/,' Space group (noncentrosymmetric)',11x,':  ',a16,a33)
   27 format(/,' Symmetry-operations'/)
   31 format(2a60)
c     read the symbol,determine bravais lattice and crystal family.
      i=hbr(8)
      do 99 i=1,7
   99 if(nt(1).eq.hbr(i)) nbr=i
c     standardization of the symbol
      do 100 i=3,16
      if(nt(i).ne.hbr(9)) goto 95
      k=0
      n=n+1
      goto 100
   95 if(nt(i).eq.hs(11).or.nt(i).eq.hs(14))sys=5
      do 96 j=1,15
   96 if(nt(i).eq.hs(j)) in(n,k)=j-8
  100 k=k+1
      if(i1.eq.4.or.i1.eq.-1.and.i2.eq.4) sys=4
      if(j1.eq.3) sys=6
      if(j1.eq.0.and.i1.eq.1.or.i1.eq.-1.and.i2.eq.1)sys=1
      if(sys.eq.2.and.j1.eq.0)goto 105
      if(sys.eq.2.and.i1.ne.1.and.j1.ne.1.and.k1.ne.1)sys=3
      goto 107
  105 do 106 i=1,4
      in(2,i)=in(1,i)
  106 in(1,i)=0
      i1=1
      k1=1
c     determination of code no. ngc for the point group
  107 do 97 i=1,3
      if(in(i,1).ne.0) is(i)=in(i,1)
      if(is(i).eq.-1) is(i)=-in(i,2)
      if(in(i,1).lt.-1) is(i)=7
      if(in(i,1).gt.-2) goto 94
      in(i,4)=in(i,1)
      in(i,1)=1
   94 if(in(i,2).ne.7) goto 97
      in(i,4)=in(i,3)
      in(i,3)=7
      in(i,2)=0
   97 continue
      if(k1.eq.2.and.(j1.eq.2.or.j1.eq.3))nrt=1
      m=100*is(1)+10*is(2)+is(3)+i3+j3+k3
      do 109 i=1,45
  109 if(m.eq.iss(i)) ngc=i
c     fix code no. ncs for centrosymmetry
      if(ngc.le.31) ncs=1
      nd=ngc
      if(nd.gt.31) nd=iss(ngc+14)
c     rotation parts
      do 110 i=1,216
      if(lf(i).eq.1) id=id+1
      if(id-nd) 110,112,120
  112 m=lf(i)*isign(1,lf(i))+24*(5/sys)*(sys/5)
      ngo=ngo+1
      do 111 k=1,3
      do 111 l=1,3
  111 r(ngo,k,l)=ges(k,l,m)*isign(1,lf(i))
  110 continue
c     multiplcation table
  120 do 90 i=1,ngo
      do 124 j=1,3
      do 124 k=1,3
  124 if(ncs.eq.0) r(ngo+i,j,k)=-r(i,j,k)
      do 90 j=1,ngo
      do 91 k=1,3
      do 91 l=1,3
   91 sc(k,l)=0
      do 92 k=1,3
      do 92 l=1,3
      do 92 m=1,3
   92 sc(k,l)=sc(k,l)+r(i,k,m)*r(j,m,l)
      do 93 k=1,ngo
      do 89 l=1,3
      do 89 m=1,3
      if(sc(l,m).ne.r(k,l,m)) goto 93
   89 continue
      ngt(i,j)=k
      if(ncs.eq.0)ngt(ngo+i,j)=k+ngo
      if(ncs.eq.0)ngt(i,ngo+j)=k+ngo
      if(ncs.eq.0)ngt(ngo+i,ngo+j)=k
      goto 90
   93 continue
   90 continue
      if(ncs.eq.0)ngo=ngo+ngo
c     select translation parts for generators
      if(ngc.eq.30.or.ngc.eq.31) il=1
      if(sys.eq.3) mcc=400*nbr+i4*49+j4*7+k4+399
      if(sys.ge.4)mcc=1000*nd+100*nbr+25*((k4+7)/2)+5*i4+j4+42+4*i2+j2*2
      if(sys.eq.5)mcc=3000+100*ngc+i2+j1+k1
      if(ngc.eq.11) mcc=i2*4+j2*2+k2
      do 122 i=1,3
      l=in(i,4)+8
      if(l.ge.7) goto 122
      il=il+1
      net(il)=mst1(i,l)
      if(sys.gt.3) net(il)=mst2(i,l)
  122 continue
      if(ngc.eq.30.and.k4.eq.-2) net(il)=13
      if(il.ge.2) goto 130
      do 123 i=1,3
      if(in(i,1).ne.2) goto 123
      il=il+1
      net(il)=1+i*in(i,2)
      if(sys.gt.3.and.in(i,1).ne.-1) net(il)=1+in(i,2)
      if(sys.eq.6) net(il)=1+5*in(i,2)
  123 continue
      if(i1.lt.3.or.i1.gt.6.or.i2.eq.0) goto 130
      il=il+1
      net(il)=13+(10*i2)/i1-(i2+i2)/i1
  130 n=net(3)
      if(ngc.eq.31)n=1+7*(i2/2)+i2/3+i2*(10*i2*i2-42*i2+43+mod(nbr,5))
      do 129 i=1,3
      m=net(i)
      id=lgn(i,ngc)
      if(id.eq.0) goto 128
      do 129 j=1,3
      t(id,j)=get(j,m)-nrt*(i/2)*(2/i)*(1-2*(sys/6))*get(j,n)
  129 if(nrt.eq.0.and.sys.lt.4.and.nbr.ne.5) s(j)=get(j,m)/2+s(j)
c     complete translation parts
  128 do 131 i=1,3
      if(lgn(i,ngc).eq.0) goto 131
      lt=lt+1
      lgt(lt)=lgn(i,ngc)
  131 continue
  135 if(lt.eq.ngo) goto 200
      n=0
      do 132 i=1,lt
      do 132 j=1,lt
      il=lgt(i)
      jl=lgt(j)
      kl=ngt(il,jl)
      do 133 m=1,ngo
      if(lgt(m).eq.kl) goto 132
  133 continue
      do 136 k=1,3
      do 134 l=1,3
  134 t(kl,k)=t(kl,k)+r(il,k,l)*t(jl,l)
      t(kl,k)=t(kl,k)+t(il,k)+48
  136 t(kl,k)=mod(t(kl,k),24)
      n=n+1
      lgt(lt+n)=kl
  132 continue
      lt=lt+n
      goto 135
c     selection of origin
  200 continue
      l=ishif+1
      if (l.eq.1) go to 219
      do 218 l=1,3
  218 s(l)=kshif(l)
      oshift(1:16)='( origin shift ='
      oshift(33:33)=')'
      iniz=18
      do 6923 l=1,3
         if (kshif(l).eq.0) then
                              oshp='  0  '
                            else
                              kk=24/kshif(l)
                              if (kk.le.9) then
                                             write(oshp,1000) kk
                                           else
                                             write(oshp,1100) kk
                                           endif
                            endif
         oshift(iniz:iniz+4)=oshp
         iniz=iniz+5
 6923  continue
 1000 format('1/',i1,'  ')
 1100 format('1/',i2,' ')
  219 n=0
      do 201 i=1,78
  201 if(mcc.eq.lsh(1,i)) n=lsh(2,i)
      if(n.eq.0) goto 210
      do 202 i=1,3
  202 s(i)=s(i)+get(i,n)
  210 do 211 i=1,ngo
      do 216 j=1,3
      t(i,j)=t(i,j)+r(i,j,1)*s(1)+r(i,j,2)*s(2)+r(i,j,3)*s(3)-s(j)+48
  216 t(i,j)=mod(t(i,j),24)
      if(nbr.eq.1.or.nbr.eq.7) goto 211
      nd=72
      do 214 l=1,4
      ne=0
      do 212 k=1,3
      is(k)=t(i,k)+q(k,l,nbr-1)
  212 ne=ne+mod(is(k),24)
      if(nd.le.ne) goto 214
      nd=ne
      do 213 k=1,3
  213 t(i,k)=mod(is(k),24)
  214 continue
  211 continue
      write(ncwu,19) texc(sys)
      write(space,'(16a1)') nt
      call ucase(space(1:1))
      if(ncs.eq.0) write(ncwu,20) space,oshift
      if(ncs.eq.1) write(ncwu,21) space,oshift
      write(ncwu,27)
      ne=(ngo+1)/2
      do 423 n=1,60
  423 buffer(ne)(n:n)=' '
      do 424 n=1,ne
      id=2-(n+n-1)/ngo
      do 425 l=1,2
      is(l)=l+(n-1)*2
      i=is(l)
      do 425 j=1,3
      nd=r(i,j,1)+r(i,j,2)*3+r(i,j,3)*4+5
      tx(1,j,l)=teb(1,nd)
      tx(2,j,l)=teb(2,nd)
      do 425 k=1,2
      m=t(i,j)*2+k
  425 ll(k,j,l)=ntex(m)
      write(buffer(n),13)(is(m),(tx(1,j,m),tx(2,j,m),ll(1,j,m),ll(2,j,m)
     *,j=1,3),m=1,id)
  424 continue
      write(ncwu,31) (buffer(m),m=1,ne)
c     seminvariants
      nse=nsm(ngc)
      if(sys.eq.6.and.nbr.eq.5) nse=8
      if(nbr.eq.5.and.(ngc.eq.11.or.ngc.eq.29.or.ngc.eq.30)) nse=17
      if(nbr.eq.6.and.(ngc.eq.12.or.ngc.eq.16)) nse=18
      if(nbr.eq.7.and.(ngc.eq.37.or.ngc.eq.21.or.ngc.eq.40)) nse=14
      m=atx(nse)/10
      n=atx(nse)-10*m
      write(ncwu,15)(txa(i,m),i=1,3),(txb(j,n),j=1,5)
      do 426 jj=1,3
  426 jvet(jj)=txa(jj,m)
      do 427 jj=1,5
  427 jvet(jj+3)=txb(jj,n)
      isys=sys
      isv=1
      do 503 i=1,3
      do 503 j=1,3
      jsem=sem(i,j,nse)
      svet(isv)=jsem
      isv=isv+1
  503 continue
      svet(10)=3
      ngen=0
      do 504 i=1,3
      if (lgn(i,ngc).eq.0) go to 504
      ngen=ngen+1
  504 continue
c ---------------
c -------   calcola tmat
c
      do 505 i=1,ngo
      do 505 j=1,3
      tmat(i,j)=0.0
      if(t(i,j).eq.0) goto 505
      tmat(i,j)=float(t(i,j))/24.
  505 continue
      call modif(r,tmat,ngo,ncs,nt)
      call calmod(ngc,nbr,ncs,sem,nse)
      return
      end
c------------------------------------------------------------
      function rhof(p,jh,jk,jl)
      dimension p(6)
c
      rho2=p(1)*float(jh*jh)+p(2)*float(jk*jk)
     1 +p(3)*float(jl*jl)+p(4)*float(jh*jk)
     2 +p(5)*float(jh*jl)+p(6)*float(jk*jl)
      rhof=sqrt(rho2)
      return
      end
c-----------------------------------------------------------------------
      subroutine calmod(ngc,nbr,ncs,sem,nse)
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen,
     * irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      integer jmat(3,3),norv(3),sem(3,3,18)
      data jmat,norv/12*0/
c
      do 5 j=1,3
      nss(j)=0
      modul(j)=256
    5  continue
      do 10 j=1,3
      do 10 i=1,3
      isem=sem(i,j,nse)
      norv(j)=norv(j)+isem
      if(isem.lt.modul(j).and.isem.gt.1) modul(j)=isem
      jmat(i,j)=isem
   10 continue
      do 50 j=1,3
      if(modul(j).eq.0) goto 50
      do 40 i=1,3
   40 jmat(i,j)=jmat(i,j)/modul(j)
      modul(j)=192/modul(j)
   50 continue
      nori=3
      do 60 i=1,3
      j=3-i+1
      if(norv(j).gt.0) goto 70
      nori=nori-1
   60 continue
   70 continue
      do 80 i=1,3
      do 75 j=1,3
      if(sem(i,j,nse).ne.1) goto 75
      jmat(i,j)=1
   75 continue
      do 80 j=1,3
   80 nss(i)=nss(i)+jmat(i,j)
c --     nbr is the lattice code  p=1, a=2, b=3, c=4, f=5, i=6, r=7
      goto(100,600,1000,600,500,600,700),nbr
  100 if(ncs.eq.0) goto 1000
      if(ngc.ne.22.and.ngc.ne.23.and.ngc.ne.26) goto 1000
      nori=1
      nss(2)=4
      nss(3)=3
      modul(1)=6
      modul(2)=0
      goto 1000
  500 nori=1
      modul(2)=0
      modul(3)=0
      if(ngc.eq.10) goto 550
      nss(1)=1
      nss(2)=1
      modul(1)=2
      if(ncs.eq.1) modul(1)=4
      goto 1000
  550 nss(1)=0
      nss(2)=0
      modul(1)=0
      goto 1000
  600 nori=nori-1
      if(nori.gt.0) goto 620
      do 610 k=1,3
  610 modul(k)=1
      goto 1000
  620 continue
      do 630 k=1,2
      j1=2-k+1
      j2=j1
      if(nbr.eq.6.and.nori.eq.2) j1=k
      if(modul(j1).eq.0) goto 630
      nss(j1)=0
      modul(j2)=0
      goto 640
  630 continue
  640 if(nbr.eq.4) goto 650
      if(nbr.ne.6) goto 1000
      if(ngc.ne.12.and.ngc.ne.16) goto 650
      nori=1
      nss(1)=0
      nss(2)=2
      nss(3)=-1
      modul(1)=4
      modul(2)=0
      modul(3)=0
      goto 1000
  650 if(nori.eq.1) goto 680
      modul(2)=modul(3)
      modul(3)=0
      goto 1000
  680 nss(1)=0
      nss(2)=0
      goto 1000
  700 if(ncs.eq.0) goto 1000
      if(ngc.ne.18.and.ngc.ne.19) goto 1000
      nori=1
      nss(3)=0
 1000 return
      end
c-----------------------------------------------------------------------
      subroutine modif(r,tmat,ngo,ncs,nt)
      common/sym/isba(2,3,24),tsba(3,24),nsym,dummy(2),icent,latt,s3s2,e
     *          ,s3s2p
      integer nt(16),r(48,3,3)
      dimension tmat(48,3)
      icent=1-ncs
      nsym=ngo
      if (icent.eq.1) nsym=nsym/2
      latt=nt(1)
      call musym(r,tmat,nsym,isba,tsba)
      return
      end
c-----------------------------------------------------------------------
      subroutine musym(smat,tmat,n2,is,ts)
      integer is(2,3,24),smat(48,3,3)
      dimension ts(3,24),tmat(48,3)
c
c-----------------------------------------------------------------------
c
c     purpose
c             conversion of matricies in multan notation
c
c     usage
c             call musym(smat,tmat,n2,is,ts)
c
c     description of parameters
c
c             smat - 3-dimensionale array containing the rotational
c                    matricies computed by subroutine symm
c             tmat - bidimensional array containing the traslational
c                    matricies computed by subroutine symm
c             n2   - number of symmetry operators not related by
c                    a centre of symmetry
c             is   - 3-dimensional array containing the rotational
c                    matricies in multan notation
c             ts   - bidimensional array containing the traslational
c                    matricies in multan notation
c
c-----------------------------------------------------------------------
c
      do 10  j=1,2
      do 10 ja=1,3
      do 10 jb=1,n2
      is(j,ja,jb)=0
      ts(  ja,jb)=0
   10 continue
      do 50 jc=1,n2
      do 30  l=1,3
      m=1
      do 20  i=1,3
      if (smat(jc,l,i).eq.0) go to 20
      is(m,l,jc)=smat(jc,l,i)*i
      m=2
   20 continue
   30 continue
      do 40 ja=1,3
      ts(ja,jc)=tmat(jc,ja)
   40 continue
   50 continue
      return
      end
c-----------------------------------------------------------------------
