c-- sir code for seminvariants                   Release 93.05
        subroutine seminv(ier)
c----------------------------------------------------------------------
c         sir -  seminvariant  routine
c----------------------------------------------------------------------
      character cff
      common /dirg/ jss1,jopt,jss2
      common /dir1/ jboth,jrepr,jeli1,jenu1,jknum,soge1,sogk
      common /dir2/ jenu2,glim,soge2,eplim,nca(2)
      common /ss2c/ ip,ku(3),eu,kva(3),ev,kn,epsu,epsv,nsem2,nsem2g
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common /inp/  natom,fnat,satm,dumy
      common /inv/  invma(96,3,3),idivv(48)
      common /cost/ pi2,jxa,jxb,jxx,nk1,lfl,nrif,mult,nsem,itype,ang(24)
      common /choi/ mm,iimax,jmax,nsj,jtable(8,16),invet(48)
      common /pro/  jvarma(3,3),kx(3),idoub,kkk,sump(2),icros,
     * jhkl(3),e,scr2(2),ns,sr2(2),jhimrn(3,3),nsemc,nsemg
      common/xdata/isr(100000),matse(350,3),little(350,24,3),limi(9001),
     1 idopp(1000),iel(350),phive(350),list1(1000,2),list2(1000,5),nlis,
     2 gq(8000),gv(8000),idummy(48),itab(8000),itab1(8000),isig(3,8000),
     3 lim0(9001),dummpc(34999)
      common /temp/ ifinv(100,2),hkrj(100,4,24)
      common /sig2/ gs,n8
      common/tst/nt8,ar(26),nn(11,26,3),pp(11,26,3)
      common /nctst/ nt9,br(15),nb(11,15,3),fnb(11,15,3),bcm(11,15,3),
     *                        acm(11,15,3)
      integer dmat(3,500)
      character rescha(2)*32,line(2)*8
      integer result(2,2)
      data rescha/
     *            '     one-phase seminvariants    ',
     *            '     two-phase seminvariants    '/
c
      write(cff,'(i1)') kff
      if(ipripe.gt.0) write(lo,10) cff,itle
   10 format(///,a1 ,120('+'),//,
     1 39h SIRPOW.92 : Seminvariants routine     ,68x,14hRelease  93.05
     2 ,//,20x,20a4,/,1h ,120('+'),//)
c-- read directives
      ier=0
      call dirsem(ier)
      if (ier.lt.0)  return
      call initps(ier)
      if (ier.ne.0)  return
Corig call histor(4,1,ier)
Corig if (ier.ne.0)  return
      call wrcon
      if (iprin.eq.0) go to 201
      write(lo,19) nrif,ihx
   19 format(/5x,'the number of reflexions is',i6,'   with   ',
     * 'h(max) =',i4,3x,'k(max) =',i4,3x,'l(max) =',i4)
      write(lo,20) natom
   20 format(/5x,'the number of atoms in primitive cell is ',i5)
  201 if(ipripe.gt.0) write(lo,21)
   21 format(/,' The following routines will be executed:')
      if(jss1.eq.1.and.ipripe.gt.0) write(lo,22)
   22 format(41x,'>One-phase seminvariants routine')
      if(jss2.eq.1.and.ipripe.gt.0) write(lo,24)
   24 format(41x,'>Two-phase seminvariants routine')
      if (jss1.eq.0) go to 100
      call ss1(result)
      if (nsem.eq.0) then
                       write(lo,90) 
                       return
                     endif
   90 format(//5x,'**** warning ****  no seminvariants have been estimat
     *ed . Sorry.',//)
  100 continue
      if (jss2.eq.0) go to 1000
      call ss2(dmat,result)
 1000 continue
      if(ipripe.gt.0) write(lo,1100)
 1100 format(//,120('+'),//,40x,'***   output   section   ***',//)
      if(ipripe.gt.0) write(lo,1500)
 1500 format(/,10x,31x,'number of relationships',/,
     *         10x,32x,' calculated   stored   ',/)
      do 2000 i=1,2
      do 1800 j=1,2
      if (result(i,j).eq.0) then
                              write(line(j),1600)
                            else
                              write(line(j),1700) result(i,j)
                            endif
 1600 format('       -')
 1700 format(i8)
 1800 continue
      if(ipripe.gt.0) write(lo,2100) rescha(i),(line(j),j=1,2)
 2100 format(/, 9x,a32,a8,3x,a8)
 2000 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine initps(ier)
c
c---- initialization subroutine
c
      common /dirg/ jss1,jopt,jss2
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,dumy
      common /cost/ pi2,jxa,jxb,jxx,nk1,lfl,nrif,mult,nsem,itype,ang(24)
      common/xdata/isr(100000),matse(350,3),little(350,24,3),limi(9001),
     1 idopp(1000),iel(350),phive(350),list1(1000,2),list2(1000,5),nlis,
     2 gq(8000),gv(8000),idummy(48),dummpc(84000)
c
c-- set some values
      lfl=100000
      nk1=350
      pi2=8*atan(1.0)
      do 1 i=1,24
    1 ang( i)=0.0
      ang( 3)=pi2/12
      ang( 4)=pi2/8.0
      ang( 5)=2.0*ang(3)
      ang( 7)=2.0*ang(4)
      ang( 9)=2.0*ang(5)
      ang(10)=3.0*ang(4)
      ang(11)=5.0*ang(3)
c-----------------------------------------------------------
c
c     itype =  1    any phase
c     itype =  3    phase  30,210   degree
c     itype =  4    phase  45,225   degree
c     itype =  5    phase  60,240   degree
c     itype =  7    phase  90,270   degree
c     itype =  9    phase 120,300   degree
c     itype = 10    phase 135,315   degree
c     itype = 11    phase 150,330   degree
c     itype = 13    phase   0,180   degree
c
c-----------------------------------------------------------
c
      do 2 i=1,350
      do 2 j=1,3
    2 matse(i,j)=0
c-- reading of normal file
      call inpts(ier)
      if (ier.ne.0) return
      if (jss2.ne.0) call sigma2
c-- set up reciprocal space for seminvariants
      call fillr
      return
      end
c-----------------------------------------------------------------------
      subroutine inpts(ier)
c---- reading of normal file
      common /dirg/ jss1,jopt,jss2
      common /dir1/ jboth,jrepr,jeli1,jenu1,jknum,soge1,sogk
      common /dir2/ jenu2,glim,soge2,eplim,nca(2)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
      common/sym /jdummy(216),jssn,kdu1,kdu2,jssi,kdu3,ssss,ssssm,ssssp
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,dumy
      common /inv/  invma(96,3,3),idivv(48)
      common /cost/ pi2,jxa,jxb,jxx,nk1,lfl,nrif,mult,nsem,itype,ang(24)
      common /choi/ mm,iimax,jmax,nsj,jtable(8,16),invet(48)
      common /pro/  jvarma(3,3),kx(3),idoub,kkk,sump(2),icros,
     * jhkl(3),e,scr2(2),ns,sr2(2),jhimrn(3,3),nsemc,nsemg
      common/xdata/isr(100000),matse(350,3),little(350,24,3),limi(9001),
     1 idopp(1000),iel(350),phive(350),list1(1000,2),list2(1000,5),nlis,
     2 gq(8000),gv(8000),idummy(48),dummpc(84000)
      integer hkl(3)
      dimension ivet(12),vet(12)
      equivalence (vet(1),ivet(1))
c
      nsem=0
      nlis=0
      iphiv=0
c -----
c     call  sub.  per  lettura  lista  2  :  simmetria
c -----
      call yfl02
c -----
c     call  sub.  per  lettura  preambolo  lista  7
c -----
      call ysfl07(nrif,nstron,nweak,npseud,iy)
      s3s2=ssss
      nsym=jssn
      icc =jssi
      if(npseud.eq.0) go to 20
      write(lo,15)
   15 format(//5x,'**** warning ****  no seminvariants are estimated whe
     *n sir handles pseudotranslations',/)
      ier = 1
      return
   20 continue
c---- check if the space group is ' p 1 '
      icent=icc+1
      msym=nsym*icent
      nsym2=(3-icent)*msym
      if (msym.eq.1) then
                     write(lo,1040)
 1040 format(//5x,'**** warning ****  no seminvariants are estimated whe
     *n the space group is p 1',/)
                     ier = 1
                     return
                     endif
      fnat=(1.0/s3s2)**2.0
      natom=int(fnat+0.05)
      satm=sqrt(fnat)
      do 1050 k=1,nsym
      do 1050 i=1,3
      do 1050 j=1,3
 1050 ksmat(k+nsym,i,j)=-ksmat(k,i,j)
      do 1060 k=1,nsym
      do 1060 i=1,3
 1060 tmat(k+nsym,i)=-tmat(k,i)
c---- compute the number of free vectors used in the 2nd representation
      knum=natom/msym+40
      if (knum.gt.100) knum=100
      if (jenu1.eq.0.and.soge1.eq.0.0) jenu1=nstron
      if (jknum.ne.0.and.jknum.gt.100)jknum=100
      jxa=(2*ihx(2)+1)*(2*ihx(3)+1)
      jxb=2*ihx(3)+1
      jxx=jxa*ihx(1)+jxb*ihx(2)+ihx(3)
      if (jxx.le.lfl) go to 90
      write(lo,1300) ihx,jxa,jxb,jxx,lfl
 1300 format(1x,'maximum value for   h k l   = ',3i5,
     *//,1x,'costants value to compute the addres=',2i8,//
     *  ,1x,'value for the maximum addres   =',i10,
     *//,1x,'maximum allowed value  = ',i6,
     *//,1x,'change the dimension of isr vector',
     *   1x,'and the corrispondent value of lfl',
     *//,1x,'seminvariants cannot be estimated.')
      ier=1
      return
   90 continue
c-- calculation of inverse matricies
      call invers
c-- calculation of generalized inverse matricies
      call geninv
c-- set up the working table
      call choice
c-- set up multiplication matrix
      call mltply(ksmat,nsym2,irot)
c---- reads in reflections from normal file
      if (jeli1.eq.1) write(lo,905)
  905 format(///,22x,'list of reflection to search seminvariant',/,
     1           22x,'-----------------------------------------',//)
      irec=0
      ifin=1000
c -----
c     call  sub.  per  lettura  lista  7  :  riflessi ordinati
c -----
      do 800 i=1,nrif
      call snr07(vet)
      hkl(1)=ivet(1)
      hkl(2)=ivet(2)
      hkl(3)=ivet(3)
      e=vet(4)
      if(e.eq.0.0) e=0.01
      if(e.eq.1.0) e=0.999
      iphi8=mod(ivet(8),2**15)
      iphi=iphi8/32
      itype=mod(iphi8,32)
c-- store reflexion in list1 (only if first rank seminvariant)
      nmat=0
      if (jss2.eq.0) ifin=nsem
      if (nlis.lt.ifin) call fillis(hkl,i,nmat,iphi)
      if (irec.eq.1) go to 1085
      if (i.gt.nk1) irec=1
      if (irec.eq.1) go to 1085
      if (iphi.ge.360) iphi=iphi-360
      if (knw.eq.0) iphi=360
      if (jenu1.eq.0.and.e.ge.soge1) jlim =i
      if (jenu1.ne.0.and.i.eq.jenu1) soge1=e
      if(jeli1.eq.0.or.e.lt.soge1) go to 180
      kmod=mod(i,3)
      if (kmod.eq.1) write(lo,910) i,hkl,e,iphi,itype
  910 format(1h ,i5,1h),2x,3i4,f8.3,i5,i3)
      if (kmod.eq.2) write(lo,920) i,hkl,e,iphi,itype
  920 format(1h+,40x,i5,1h),2x,3i4,f8.3,i5,i3)
      if (kmod.eq.0) write(lo,930) i,hkl,e,iphi,itype
  930 format(1h+,80x,i5,1h),2x,3i4,f8.3,i5,i3)
      if(e.eq.soge1) jeli1=0
  180 if(e.lt.soge1) goto 1085
c---- if reflection is a seminvariant we compute the threshold
      if (nmat.eq.0) goto 1085
      nsem=nsem+1
      matse(nsem,1)=i
      matse(nsem,2)=i
      sop1=e
 1085 call fill(hkl,e,itype,iphi,i,irec)
  800 continue
      if (jeli1.eq.1) write(lo,940)
  940 format(//)
      if (jknum.eq.0) jknum=knum
      if (jenu1.eq.0) jenu1=jlim
      if (jknum.le.0) go to 9000
      if (jenu1.eq.0) soge1=sop1
      if (jenu1.gt.nk1) jenu1=nk1
      if (jenu1.le.nk1) soge1=abs(float(iel(jenu1)))/1000.0
      if (sogk.ne.0.0) go to 899
      sogk=iel(jknum)
      sogk=abs(sogk)/1000.0
  899 continue
 9000 continue
      if(iprin.ne.0) write(lo,9010) nlis,nsem
 9010 format('  number of first rank seminvariants recognized  =',i5,
     *     /,'  number of first rank seminvariants to estimate =',i5)
      return
      end
c----------------------------------------------------------------------
      subroutine invers
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
c
      common /choi/ mm,iimax,jmax,nsj,jtable(8,16),invet(48)
      integer v(3,3)
c
      invet(1)=1
      do 30 i=2,msym
      call invs(i,v)
      do 20 j=1,msym
      do  10 k=1,3
      do  10 l=1,3
      if (ksmat(j,k,l).ne.v(k,l)) go to 20
   10 continue
      invet(i)=j
      go to 30
   20 continue
   30 continue
      return
      end
c---------------------------------------------------------------------
      subroutine invs(j,v)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
c
      integer v(3,3),a(3,3)
c
      do 1 i1=1,3
      do 1 j1=1,3
    1 a(i1,j1)=ksmat(j,i1,j1)
c
c---- calcola v, la inversa di a
c
      call inv3(a,idet,v)
      if (idet.eq.0) then
                       write(lo,100) j
                       write(lo,*) '****  programming  error  ****'
                       write(lo,*) ' sir ends in error'
                       stop 1234
                      endif
  100 format(1x,'error computing invers no.',i2,' - det.=0  ')
      return
      end
c----------------------------------------------------------------------
      subroutine inv3(a,det,v)
c
c---- calcola l'inversa della matrice a e la
c---- memorizza in v.
c---- a deve essere una matrice  3*3 non-singolare
c---- alfa e' la matrice aggiunta
c
      integer a(3,3),v(3,3),det,alfa(3,3)
c
      alfa(1,1)=a(2,2)*a(3,3)-a(2,3)*a(3,2)
      alfa(1,2)=-1*(a(2,1)*a(3,3)-a(2,3)*a(3,1))
      alfa(1,3)=a(2,1)*a(3,2)-a(2,2)*a(3,1)
      alfa(2,1)=-1*(a(1,2)*a(3,3)-a(1,3)*a(3,2))
      alfa(2,2)=a(1,1)*a(3,3)-a(1,3)*a(3,1)
      alfa(2,3)=-1*(a(1,1)*a(3,2)-a(1,2)*a(3,1))
      alfa(3,1)=a(1,2)*a(2,3)-a(1,3)*a(2,2)
      alfa(3,2)=-1*(a(1,1)*a(2,3)-a(1,3)*a(2,1))
      alfa(3,3)=a(1,1)*a(2,2)-a(1,2)*a(2,1)
      det=a(1,1)*alfa(1,1)+a(1,2)*alfa(1,2)+a(1,3)*alfa(1,3)
      if (det.ne.0) goto 200
      do  5 i=1,3
   5  write(6,6) (a(i,j),j=1,3)
      do 66 i=1,3
  66  write(6,6) (alfa(i,j),j=1,3)
   6  format(5x,3i8)
 200  do 10 i=1,3
      do 10 j=1,3
   10 v(i,j)=alfa(j,i)/det
      return
      end
c-----------------------------------------------------------------------
      subroutine geninv
c
c-- calcola le generalizzate inverse
c-- memorizzandole in 'invma' ed in 'idivv'
c
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
c
      common /inv/  invma(96,3,3),idivv(48)
      integer a(3,3),v(3,3),va(3,3)
c
      lo=6
      do 50 k=1,nsym2
c
c---- calcola la inversa generalizzata   v  della matrice  a
c---- dove  a  e' uguale alla matrice unita' meno la
c---- trasposta della k-esima matrice di rotazione
c
      if (k.eq.1) go to 50
      do 20 i=1,3
      do 10 j=1,3
   10 a(i,j)=-ksmat(k,j,i)
      a(i,i)=1+a(i,i)
   20 continue
      call g12sp(a,v,idiv)
c
c---- calcola  va = v * a
c
      do 30 i=1,3
      do 30 j=1,3
      va(i,j)=0
      do 30 l=1,3
   30 va(i,j)=va(i,j)+v(i,l)*a(l,j)
c
c---- memorizza  v  ed  va  in invma
c
      do 40 i=1,3
      do 40 j=1,3
      invma(k+48,i,j)=va(i,j)
   40 invma(k   ,i,j)= v(i,j)
      idivv(k)=idiv
c
   50 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine g12sp(a,v,idiv)
      integer s(3,3),com(3,3),v(3,3),hold(3,3)
      integer a(3,3),p(3,3),q(3,3)
      do 2 i=1,3
      do 1 j=1,3
      p(i,j)=0
      q(i,j)=0
      s(i,j)=0
    1 hold(i,j)=a(i,j)
      p(i,i)=1
    2 q(i,i)=1
      do 14 ir=1,3
      irr=ir
c
c---- trova il minimo elemento diverso da zero
c
      ip=0
      jp=0
      imin=999
      do 3 i=ir,3
      do 3 j=ir,3
      int=iabs(hold(i,j))
      if (int.eq.0.or.int.ge.imin) go to 3
      imin=int
      ip=i
      jp=j
    3 continue
      if (ir-ip) 4,5,5
c
c---- scambia le righe
c
    4 call rowop(hold,ip,ir,ih,p,1)
    5 if (ir-jp) 6,7,7
c
c---- scambia le colonne
c
    6 call colop(hold,jp,ir,ih,q,1)
    7 iflo=hold(ir,ir)
      if (iflo.eq.0) go to 14
c
c---- azzera la colonna
c
      ip=ir+1
      if (ip-3) 8,8,10
    8 continue
      do 9 i=ip,3
      if (hold(i,ir).eq.0) go to 9
      ih=-1*hold(i,ir)/iflo
      call rowop(hold,i,ir,ih,p,2)
    9 continue
c
c---- azzera la riga
c
   10 jp=ir+1
      if (jp-3) 11,11,13
   11 continue
      do 12 j=jp,3
      if (hold(ir,j).eq.0) go to 12
      ih=-1*hold(ir,j)/iflo
      call colop(hold,j,ir,ih,q,2)
   12 continue
   13 continue
   14 continue
      ir=irr
      ia=hold(irr,irr)
      if (ia) 100,110,100
  100 irr1=irr-1
      ib=hold(irr1,irr1)
      iflo=mod(ia,ib)
      if (iflo) 105,110,105
  105 call colop(hold,irr,irr,ib,q,2)
  110 continue
   22 idiv=hold(ir,ir)
      if (idiv) 21,20,21
   20 ir=ir-1
      if (ir) 22,23,22
   21 continue
      i=ir
   15 i=i-1
      if (i) 16,17,16
   16 s(i,i)=idiv/hold(i,i)
      go to 15
   17 s(ir,ir)=1
      do 18 i=1,3
      do 18 j=1,3
      com(i,j)=0
      do 18 l=1,3
   18 com(i,j)=com(i,j)+q(i,l)*s(l,j)
      do 19 i=1,3
      do 19 j=1,3
      v(i,j)=0
      do 19 l=1,3
   19 v(i,j)=v(i,j)+com(i,l)*p(l,j)
   23 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine colop(a,il,ir,ii,q,ind)
      integer a(3,3),q(3,3),r(3,3),com(3,3),temp(3,3)
      do 1 i=1,3
      do 1 j=1,3
    1 r(i,j)=0
      if (ind-1) 2,2,3
    2 i=6-1*(il+ir)
      r(i,i)=1
      r(il,ir)=1
      r(ir,il)=1
      go to 5
    3 do 4 i=1,3
    4 r(i,i)=1
      r(ir,il)=ii
    5 continue
      do 6 i=1,3
      do 6 j=1,3
      com(i,j)=0
      temp(i,j)=0
      do 6 l=1,3
      temp(i,j)=temp(i,j)+q(i,l)*r(l,j)
    6 com(i,j)=com(i,j)+a(i,l)*r(l,j)
      do 7 i=1,3
      do 7 j=1,3
      q(i,j)=temp(i,j)
    7 a(i,j)=com(i,j)
      return
      end
c-----------------------------------------------------------------------
      subroutine rowop(a,il,ir,ii,p,ind)
      integer a(3,3),p(3,3),r(3,3),com(3,3),temp(3,3)
      do 1 i=1,3
      do 1 j=1,3
    1 r(i,j)=0
      if (ind-1) 2,2,3
    2 i=6-1*(ir+il)
      r(i,i)=1
      r(il,ir)=1
      r(ir,il)=1
      go to 5
    3 do 4 i=1,3
    4 r(i,i)=1
      r(il,ir)=ii
    5 continue
      do 6 i=1,3
      do 6 j=1,3
      com(i,j)=0
      temp(i,j)=0
      do 6 l=1,3
      temp(i,j)=temp(i,j)+r(i,l)*p(l,j)
    6 com(i,j)=com(i,j)+r(i,l)*a(l,j)
      do 7 i=1,3
      do 7 j=1,3
      p(i,j)=temp(i,j)
    7 a(i,j)=com(i,j)
      return
      end
c-----------------------------------------------------------------------
      subroutine choice
c
c-- calcola la 'working table' memorizzandola in 'jtable'
c
      common /dirg/ jss1,jopt,jss2
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inv/  invma(96,3,3),idivv(48)
      common /choi/ mm,iimax,jmax,nsj,jtable(8,16),invet(48)
      integer v(3,3),vscar(48),mscar(48,3),jrot(48,48)
      data vscar/48*-1/
      data mscar/144*-1/
c
      do 5 i=1,48
      do 5 j=1,48
    5 jrot(i,j)=0
      maxi=1
      ima=1
      jmax=0
      if (ngen.eq.1.and.iprin.gt.2) write(lo,3000)
      if (icent.eq.1.and.iprin.gt.2) write(lo,9002)
      if (icent.eq.2.and.iprin.gt.2) write(lo,9000)
c
c---- elimina la matrice unita'
c
      do 10 i=2,msym
      vscar(i)=i
      mscar(i,1)=i
   10 continue
      if (iprin.gt.2) write(lo,113)
      vscar(1)=-1
c
c---- stiamo trattando un gruppo spaziale fino all'ortorombico ?
c
      if (jsys.le.3) go to 500
c
c---- poiche' e' un gruppo spaziale con simmetria superiore
c---- all'ortorombico ci chiediamo se e' abeliano
c
      if (ngen.eq.1) go to 700
c
c---- non essendo abeliano isoliamo la matrice  -i (se esiste)
c---- memorizzando la sua posizione (*-1) in  nsy
c
      if (icent.eq.1) go to 61
      nsy=msym/2+1
      if (iprin.gt.2) write(lo,9001) nsy
      vscar(nsy)=0
      nsy=-nsy
   61 continue
c
c---- eliminiamo le matrici inverse e le matrici  rj (?)
c----
c----              -1
c----             rj * ri * rj     (k=j+1,m)
c----
      m1m=msym-1
      do 99 i=2,msym
      iflag=0
      do 100 j=2,msym
      if (i.eq.j) go to 100
      iflag=0
c
c---- controlla che la matrice   ri  sia
c---- diversa dalla inversa di  rj .
c
      call invs(j,v)
      do  97 k=1,3
      do  97 l=1,3
      if (ksmat(i,k,l).ne.v(k,l)) iflag=1
   97 continue
      if (iflag.ne.0) go to 100
      mscar(i,2)=j
      if (iprin.gt.2) write(lo,112) j,i
      go to 99
  100 continue
   99 continue
      do 854 i=2,msym
      do 853 j=2  ,msym
      if (i.eq.j) go to 853
      call invs(j,v)
c
c---- elimina le matrici equivalenti
c
      call prodm(i,j,v)
      j1p=j+1
      do 852 jj=2  ,msym
      if (jj.eq.i.or.jj.eq.j) go to 852
      do 851 k=1,3
      do 851 l=1,3
      if (ksmat(jj,k,l).ne.v(k,l)) go to 852
  851 continue
      if (iprin.gt.2) write(lo,204) jj,i,j
      jrot(j,jj)=i
  852 continue
  853 continue
  854 continue
      do 860 j=2,msym
      jrot(1,j)=j
  860 continue
      do 855 j=2,msym
      do 856 i=1,msym
      jj=jrot(i,j)
      if (jj.eq.0) go to 856
      if (jj.eq.j) go to 856
      iflag=0
      jrot(1,jj)=0
      do 857 k=2,msym
      if (jrot(k,jj).eq.0) go to 857
      iflag=1
      jrot(k,jj)=0
  857 continue
      if (iflag.eq.0) jrot(i,j)=0
  856 continue
  855 continue
      jmax=0
      ima =0
      do 861 j=2,msym
      iflag=0
      do 862 i=1,msym
      jj=jrot(i,j)
      if (jj.eq.0) go to 862
      if (mscar(jj,1).eq.0) go to 862
      if (iflag.eq.1) go to 863
      iflag=1
      jmax=jmax+1
      ima =0
  863 continue
      ima=ima+1
      if (ima.gt.maxi) maxi=ima
      jtable(ima,jmax)=jj
      jj=mscar(jj,2)
      if (jj.lt.0) go to 862
      mscar(jj,1)=0
  862 continue
  861 continue
      go to 600
  700 continue
c
c---- essendo un gruppo abeliano deve solo eliminare le inverse
c
      if (iprin.gt.2) write(lo,4000)
      m1m=msym-1
      do 50 i=1,m1m
      if (vscar(i).le.0) go to 50
      iflag=0
      i1p=i+1
      do 45 j=i1p,msym
      if (vscar(j).le.0) go to 45
      call invs(j,v)
      do 40 k=1,3
      do 40 l=1,3
      if (ksmat(i,k,l).ne.v(k,l)) iflag=1
   40 continue
      if (iflag.eq.0) go to 44
      iflag=0
      go to 45
   44 continue
      vscar(j)=0
      if (iprin.gt.2) write(lo,112) j,i
      go to 50
   45 continue
   50 continue
  500 continue
      do 505 i=1,msym
      if (vscar(i).le.0) go to 505
      jmax=jmax+1
      jtable(1,jmax)=vscar(i)
  505 continue
      go to 605
  600 continue
      if (icent.eq.1) go to 605
      if (ngen.gt.1.and.jsys.gt.3) go to 605
      jmax=jmax+1
      jtable(1,jmax)=iabs(nsy)
      nsy=0
  605 continue
      mm=jmax
      if (iprin.lt.2) go to 225
      write(lo,221)
      do 222 i=1,maxi
  222 write(lo,223) (jtable(i,jj),jj=1,jmax)
      write(lo,224)
      write(lo,9004) mm
  225 continue
      if (nsy.lt.0) nsy=0
c &&&&&&&&&&&&&&&&&&&&&&&
c &&&&&&&&&   questa istruzione serve ad evitare l'errore
c &&&&&&&&&   in compilazione - il 2000 non e' riferito
c &&&&&&&&&&&&&&&&&&&&&&&
      ihdgtd=0
      if(ihdgtd.eq.2323) goto 2000
      go to 9900
 2000 continue
      mm=-1
 9900 continue
      iimax=maxi
      ns=nsy
      return
  221 format(///,  5x,'  kk     w o r k i n g     t a b l e',/,
     *           5x,'==kk===========================================',/
     *            ,5x,'  kk')
  223 format(5x,'  kk     ',16i3)
  224 format(5x,'  kk',
     *     /,5x,    '==kk===========================================',/
     *        ,5x,'  kk',//)
  204 format(1x,'matrix # ',i2,' has been eliminated being equivalent to
     * matrix # ',i2,'  j=',i2)
  112 format(1x,'matrix # ',i2,' has been eliminated being the inverse o
     *f matrix # ',i2)
  113 format(1x,'matrix # 1 has been eliminated being the unitary one')
 3000 format(1x,'this is an abelian space group      ')
 4000 format(1x,'space group above orthorombic')
 9000 format(1x,'centrosimmetric space group')
 9002 format(1x,'non-centrosimmetric space group')
 9001 format(1x,'matrix number ',i2,'  is equal to  -i   ')
 9004 format(1x,'..... therefore we get ',i2,' different classes',//)
      end
c-----------------------------------------------------------------------
      subroutine prodm(ind1,ind2,v)
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
c
      integer v(3,3),com1(3,3),com2(3,3)
c
      do 1 i=1,3
      do 1 j=1,3
      com1(i,j)=0
      do 1 l=1,3
    1 com1(i,j)=com1(i,j)+v(i,l)*ksmat(ind1,l,j)
      do 2 i=1,3
      do 2 j=1,3
      com2(i,j)=0
      do 2 l=1,3
    2 com2(i,j)=com2(i,j)+com1(i,l)*ksmat(ind2,l,j)
      do 3 i=1,3
      do 3 j=1,3
    3 v(i,j)=com2(i,j)
      return
      end
c---------------------------------------------------------------------
      subroutine mltply(ksmat,nsym2,irot)
c
c-- set up 'irot', the multiplication matrix
c
      dimension ksmat(48,3,3),iv(3,3),irot(48,48)
c
      do 30 i=1,nsym2
      do 30 j=1,nsym2
      call prod1(ksmat,i,j,iv)
      do 20 n=1,nsym2
      do 10 k=1,3
      do 10 l=1,3
      if (ksmat(n,k,l).ne.iv(k,l)) go to 20
   10 continue
      irot(i,j)=n
      go to 30
   20 continue
   30 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine prod1(ksmat,i1,i2,iv)
      dimension iv(3,3),ksmat(48,3,3)
c
      do 10 i=1,3
      do 10 j=1,3
      iv(i,j)=0
      do 10 k=1,3
   10 iv(i,j)=iv(i,j)+ksmat(i1,i,k)*ksmat(i2,k,j)
      return
      end
c----------------------------------------------------------------------
      subroutine fillis(hkl,nord,nmat,iphi)
c-- store reflexions in list1 & list2 (only if first rank seminvariant)
      common /dirg/ jss1,jopt,jss2
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inv/  invma(96,3,3),idivv(48)
      common /cost/ pi2,jxa,jxb,jxx,nk1,lfl,nrif,mult,nsem,itype,ang(24)
      common /choi/ mm,iimax,jmax,nsj,jtable(8,16),invet(48)
      common /pro/  jvarma(3,3),kx(3),idoub,kkk,sump(2),icros,
     * jhkl(3),e,scr2(2),ns,sr2(2),jhimrn(3,3),nsemc,nsemg
      common/xdata/isr(100000),matse(350,3),little(350,24,3),limi(9001),
     1 idopp(1000),iel(350),phive(350),list1(1000,2),list2(1000,5),nlis,
     2 gq(8000),gv(8000),idummy(48),dummpc(84000)
      integer hkl(3),imat(5)
      integer balfa(3),h(3,3),congr(16)
      dimension blv(3),sign(3),alf(3)
c  
      k=modulo_sir(hkl)
      if (modulo_sir(hkl).ne.0) return
      do 10 i=1,3
   10 jhkl(i)=hkl(i)
c---- by means of the working table ( jtable ) consider only
c---- indipendent symmetry operators.
      do 70 j=1,jmax
      do 60 i=1,iimax
      kkk=jtable(i,j)
      if (kkk.eq.0) go to 60
c---- compute the matrix  h = ( i - rs )  where  s = jtable(i,j)
      do 40 i1=1,3
      do 30 j1=1,3
   30 h(i1,j1)=-ksmat(kkk,j1,i1)
   40 h(i1,i1)=h(i1,i1)+1
c---- compute the first rank seminvariant vector
c---- by means of 'cong4' (for print only).
      if (iprin.gt.2) call cong4(ksmat,msym,kkk,congr)
c---- compute the solutions of the diophantine system
c---- if idiof = 1  we do not get integer solutions.
      call diof(h,idiof,balfa,sign,alf,blv)
      if (idiof.ne.0) go to 60
      if (iprin.gt.2.and.nord.le.nk1) write(lo,50) nord,jhkl,kkk,congr
     *, balfa
     1, (kx(i1),i1=1,3)
     2, (sign(i1),alf(i1),blv(i1),i1=1,3),nlis
   50 format(1h ,i3,1h),3i4,3h - ,
     *           'mat. ',i2,2x,10a1,' congruent to 0 mod. (',6a1,
     *  2x,'h = (',2(i3,1h,),i3,1h),
     1  2x,6h x = (,i3,2(1h,,i3),1h),
     2  2x,' + (',3a1,2(1h,,3a1),1h),i5)
      nmat=nmat+1
      if (nmat.le.5) go to 55
      write(lo,1100) jhkl,nord,(imat(i1),i1=1,5)
 1100 format(' seminvariant ',3i4,'  code = ',i4,' uses more than 5 matr
     *ices. (',i3,4(',',i3),' ). they are enough.')
      nmat=5
      go to 75
   55 imat(nmat)=kkk
   60 continue
   70 continue
   75 continue
      if (nmat.eq.0) return
c---- reflection jhkl is a first rank seminvariant
c---- we store in list1 all the information concerned
c---- with this seminvariant
      nlis=nlis+1
      j=0
      do 80 i=1,nmat
   80 j=j+imat(i)*64**(i-1)
      list1(nlis,1)=nord*10+nmat
      list1(nlis,2)=j
      do 90 i=1,3
   90 list2(nlis,i)=hkl(i)
      list2(nlis,4)=int(e*1000.0)
      list2(nlis,5)=itype*1000+iphi
      return
      end
c-----------------------------------------------------------------------
      subroutine cong4(ksmat,m,k,congr)
      dimension ksmat(48,3,3)
      integer sb(3,3),sum(3),syco,congr(16)
c
      do 10 i=1,3
      do 10 j=1,3
   10 sb(i,j)=ksmat(k,i,j)+1
      do 20 i=1,3
      sum(i)=0
      do 20 j=1,3
   20 sum(i)=sum(i)+sb(i,j)*4**(3-j)
      syco=0
      do 30 i=1,3
   30 syco=syco+sum(i)*10**(3-i)
      if (syco.eq.3972) return
      call cong5(syco,congr)
      return
      end
c-----------------------------------------------------------------------
      subroutine cong5(syco,congr)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      dimension cong1(13)
      integer alpha(10),syvet(2,63),congr(16),cong2(21)
      integer syco,pick1,pick2,blank,opar,cpar,comma
c
      data syvet/2092,0316,0692,0104,2572,0316,2570,0317,2090,0317,
     *           3970,0103,0690,0107,3890,0105,1770,0315,0770,0106,
     *           0772,0101,2892,0214,2890,0215,3892,0102,2052,0318,
     *           0972,0318,2610,0108,3690,0108,4050,0515,1170,0415,
     *           3490,0111,0610,0110,1172,0414,1772,0314,4052,0514,
     *           3492,0112,0612,0113,3692,0109,2612,0109,0970,0319,
     *           2050,0319,2595,1020,2757,1020,2267,1120,2075,1220,
     *           1937,1120,2387,1320,2705,1320,2395,1021,2737,1021,
     *           2587,1021,1925,1220,2725,1021,2275,1021,1957,1021,
     *           1905,1021,2067,1021,2287,0616,3925,0815,3937,0815,
     *           2455,0716,2407,0715,0745,0916,0717,0816,2487,0714,
     *           3945,0914,3917,0814,2255,0614,2207,0617,0725,0817,
     *           0737,0817,2175,0615,2375,0617/
      data cong1/5475760.0,5485760.0,5495760.0,6482576.0,6248576.0,
     *           5496750.0,5486750.0,5475960.0,5475860.0,5485860.0,
     *           5495860.0,5495960.0,5485960.0/
      data cong2/3200,3020,3002,3220,3022,3202,3222,
     *           3112,3110,3102,3012,3010,3100,2000,
     *           2020,2200,2220,2300,2320,1000,1200/
      data alpha/1h0,1h1,1h2,1h3,1hh,1hk,1hl,1h,,1h+,1h-/
      data blank,opar,cpar,comma/1h ,1h(,1h),1h,/
      ifin=63
      do 5 i=1,16
      congr(i)=blank
    5 continue
      do 10 i=1,ifin
      if (syco.eq.syvet(1,i)) go to 20
   10 continue
      write(lo,50) syco
      return
   20 continue
      ind=i
      pick1=syvet(2,ind)/100
      pick2=syvet(2,ind)-pick1*100
      comp=cong1(pick1)
      div=1000000.0
      congr(1)=opar
      ind4=1
      ind2=int(comp/div)
      comp=comp-(ind2)*div
      div=div/10.0
      do 30 i=1,ind2
      ind3=int(comp/div)+1
      rmen=(ind3-1)*div
      comp=comp-rmen
      div=div/10.0
      ind4=ind4+1
      congr(ind4)=alpha(ind3)
   30 continue
      ind4=ind4+1
      congr(ind4)=cpar
      ind4=10
      comp=cong2(pick2)
      div=1000.0
      ind2=int(comp/div)
      comp=comp-ind2*div
      div=div/10.0
      do 40 i=1,ind2
      ind3=int(comp/div)+1
      comp=comp-(ind3-1)*div
      div=div/10.0
      ind4=ind4+1
      congr(ind4)=alpha(ind3)
      ind4=ind4+1
      congr(ind4)=comma
   40 continue
      congr(ind4)=cpar
      return
   50 format(//,120('#'),/,1x,
     *'error in the subroutine cong5 - syco =',i8,/,120('#'),//)
      end
c----------------------------------------------------------------------
      subroutine diof(hmat,idiof,balfa,sign,alf,blv)
      common /dirg/ jss1,jopt,jss2
      common /dir1/ jboth,jrepr,jeli1,jenu1,jknum,soge1,sogk
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,dumy
      common /inv/  invma(96,3,3),idivv(48)
      common /cost/ pi2,jxa,jxb,jxx,nk1,lfl,nrif,mult,nsem,itype,ang(24)
      common /choi/ mm,iimax,jmax,nsj,jtable(8,16),invet(48)
      common /pro/  jvarma(3,3),kx(3),idoub,kkk,sump(2),icros,
     * jhkl(3),e,scr2(2),ns,sr2(2),jhimrn(3,3),nsemc,nsemg
      common/xdata/isr(100000),matse(350,3),little(350,24,3),limi(9001),
     1 idopp(1000),iel(350),phive(350),list1(1000,2),list2(1000,5),nlis,
     2 gq(8000),gv(8000),idummy(48),dummpc(84000)
      integer a(3,3),av(3,3),va(3,3)
      integer hmat(3,3),balfa(3)
      dimension y(3),blv(3),sign(3),coef(2),alf(3)
      integer v(3,3),b(3)
c
      data zero,rminus,bl,y,coef/1h0,1h-,1h ,1hh,1hk,1hl,1h2,1h3/
      idiof=0
      do 2 i=1,3
      b(i)=jhkl(i)
      alf(i)=bl
      balfa(i)=b(i)
      do 2 j=1,3
    2 a(i,j)=hmat(i,j)
c
c---- carica v, la (1-2) inversa di a ed  va = v * a
c
      do 3 i=1,3
      do 3 j=1,3
      va(i,j)=invma(kkk+48,i,j)
    3 v(i,j) =invma(kkk   ,i,j)
      idiv=idivv(kkk)
c
c---- calcola av = a * v
c
      do 7 i=1,3
      do 7 j=1,3
      av(i,j)=0
      do 7 l=1,3
    7 av(i,j)=av(i,j)+a(i,l)*v(l,j)
c
c---- controlla che  av * b  e' intero
c
      do 8 i=1,3
      kx(i)=0
      do 9 j=1,3
    9 kx(i)=kx(i)+av(i,j)*b(j)
      if (mod(kx(i),idiv)) 12,11,12
   11 kx(i)=kx(i)/idiv
      if (kx(i)-b(i)) 12,8,12
    8 continue
c
c---- divide  va  per il divisore
c
      do 10 i=1,3
      do 10 j=1,3
      if (mod(va(i,j),idiv)) 12,10,12
   10 va(i,j)=va(i,j)/idiv
c
c---- controlla che  v * b  e' intero
c
      do 20 i=1,3
      kx(i)=0
      do 21 j=1,3
   21 kx(i)=kx(i)+v(i,j)*b(j)
      if (mod(kx(i),idiv))12,22,12
   22 kx(i)=kx(i)/idiv
   20 continue
c
c---- calcola  va = ( i - va )
c
      do 25 i=1,3
      do 24 j=1,3
   24 va(i,j)=-1*va(i,j)
   25 va(i,i)=va(i,i)+1
c
c---- calcola la soluzione
c
      do 39 i=1,3
      ik=0
      isum=0
      do 37 j=1,3
      if (va(i,j).eq.0) go to 37
      isum=va(i,j)
      ik=j
   37 continue
      sign(i)=bl
      blv(i)=zero
      if (isum.eq.0) go to 39
      blv(i)=y(ik)
      if (isum.lt.0) sign(i)=rminus
      isum=iabs(isum)
      if (isum.eq.2) alf(i)=coef(1)
      if (isum.eq.3) alf(i)=coef(2)
   39 continue
      go to 40
   12 continue
      idiof=1
   40 continue
      do 50 i=1,3
      do 50 j=1,3
   50 jvarma(i,j)=va(i,j)
      return
      end
c-----------------------------------------------------------------------
      subroutine fill(hkl,e,itype,iphi,i,irec)
c---- fill work arrays
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
c
      common/xdata/isr(100000),matse(350,3),little(350,24,3),limi(9001),
     1 idopp(1000),iel(350),phive(350),list1(1000,2),list2(1000,5),nlis,
     2 gq(8000),gv(8000),idummy(48),dummpc(84000)
      integer hkl(3),jhkl(3),e1000
c
      e1000=e*1000
      iadd=0
      do 500 j=1,nsym
      call equiv(hkl,jhkl,j,ind)
      if(irec.ne.0) goto 450
c---- expands  reflections  into  'little'
      if (iadd.eq.0) go to 300
      do 200 jj=1,iadd
      do 100 j3=1,3
      if (little(i,jj,j3).ne.jhkl(j3)) go to 200
  100 continue
      go to 400
  200 continue
  300 continue
      iadd=iadd+1
      little(i,j,1)=jhkl(1)
      little(i,j,2)=jhkl(2)
      little(i,j,3)=jhkl(3)
      go to 450
  400 continue
c---- we add 1000 to the equivalent reflection
c---- if it is equal to the k-th. reflection  ( k=1,j-1 ) .
      iadd=iadd+1
      little(i,j,1)=jhkl(1)+1000
      little(i,j,2)=jhkl(2)+1000
      little(i,j,3)=jhkl(3)+1000
  450 continue
  500 continue
      if(irec.ne.0) return
      if (itype.ne.1.and.icent.eq.1) e1000=-e1000
      iel(i)=e1000
      phive(i)=itype*1000+iphi
      return
      end
c----------------------------------------------------------------------
      subroutine equiv(x,x1,k,ind)
c
c-- calcola il riflesso equivalente per la matrice  k-esima
c
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
c
      integer x(3),x1(3)
c
      do 10 i=1,3
      x1(i)=0
      do 10 j=1,3
   10 x1(i)=x1(i)+x(j)*ksmat(k,j,i)
      call indr(x1,ind)
      return
      end
c-----------------------------------------------------------------------
      subroutine indr(ihkl,ind)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,dumy
      common /cost/ pi2,jxa,jxb,jxx,nk1,lfl,nrif,mult,nsem,itype,ang(24)
      common/xdata/isr(100000),matse(350,3),little(350,24,3),limi(9001),
     1 idopp(1000),iel(350),phive(350),list1(1000,2),list2(1000,5),nlis,
     2 gq(8000),gv(8000),idummy(48),dummpc(84000)
      integer ihkl(3),ivet(3)
c
c----- make sure first non-zero index is positive
c
      do 200 i=1,3
      if (iabs(ihkl(i))-ihx(i)) 100,100,800
  100 continue
      ivet(i)=ihkl(i)
  200 continue
      do 300 i=1,3
      if (ivet(i)) 400,300,600
  300 continue
      go to 800
  400 continue
      do 500 i=1,3
      ivet(i)=-ivet(i)
  500 continue
  600 continue
      jklc=iabs(jxa*ivet(1)+jxb*ivet(2)+ivet(3))
      if (jklc.gt.jxx) go to 800
      ind=jklc
      return
  800 continue
      ind=-1
      return
      end
c-----------------------------------------------------------------------
      subroutine sigma2
c--calculate triplets
c
      common /dirg/ jss1,jopt,jss2
      common /dir1/ jboth,jrepr,jeli1,jenu1,jknum,soge1,sogk
      common /dir2/ jenu2,glim,soge2,eplim,nca(2)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),jjnt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,dumy
      common /cost/ pi2,jxa,jxb,jxx,nk1,lfl,nrif,mult,nsem,itype,ang(24)
      common/xdata/isr(100000),matse(350,3),little(350,24,3),limi(9001),
     1 idopp(1000),iel(350),phive(350),list1(1000,2),list2(1000,5),nlis,
     2 gq(8000),gv(8000),idummy(48),itab(8000),itab1(8000),isig(3,8000),
     3 lim0(9001),dummpc(34999)
      common /pross2/ nquar,e2,et(3),ishi,eq(10),epsi(10),iep231,iep132,
     1 jdelta,duen,ssin,scos,istamp,nb1,nb2,nb3,nb4,ns1,ns2,ns3,ns4,ikkk
     2 ,nsu(2),ess(4),jcb(3),sden
      common /sig2/ gs,n8
      dimension ill(3),ist(2,7),gt(7),iphit(7),ivet(48)
      integer jhkl3(3)
      common/tst/nt,ar(26),nn(11,26,3),pp(11,26,3)
      common /nctst/ ns,br(15),nb(11,15,3),fnb(11,15,3),bcm(11,15,3),
     *                        acm(11,15,3)
c--
c  description of some important settings
c
c  h1 = h2 + h3
c  i  h1 code
c  j  h2 code
c in  h3 code
c mh  h,k,l first  reflection
c mk  h,k,l second reflection
c ml  h,k,l third  reflection
c
c--
c--  prepara il buffer per il test centro- noncentro
c     if (knw.eq.1) then
c                    if (icent.le.1) then
c                                      call nclrt
c                                    else
c                                      call clrt
c                                    endif
c                   endif
      s3s2=1./sqrt(fnat)
c     if(knw.ne.0) write(lo,10) jenu1,soge1,nlis
c  10 format(///,' sigma2 relationships among the ',i4,'  strongest refl
c    1ections - (emin =',f5.2,' number of ss1 ',i5,')')
c--clear the areas
      do 1001 k=1,8000
      itab(k)=0
 1001 continue
      do 1004 i=1,jxx
      isr(i)=0
 1004 continue
c--create the list
      ipu=0
      do 1900 j=1,jenu1
      do 1100 i=1,nsym
      kcav=0
      if (little(j,i,1).ge.127) kcav=1
      do 1111 i1=1,3
 1111 ill(i1)=little(j,i,i1)-kcav*1000
      indr=ill(1)*jxa+ill(2)*jxb+ill(3)
      indrr=indr
      if (i.eq.1) go to 1113
      imen1=i-1
      do 1112 i1=1,imen1
      if (indr.eq.ivet(i1)) indrr=0
 1112 continue
 1113 ipu=ipu+1
      ivet(i)=indrr
      a=little(j,1,1)*tmat(i,1)+little(j,1,2)*tmat(i,2)
     ++little(j,1,3)*tmat(i,3)
      k=nint(a*24.)
      k=mod(k,24)
      if(k.lt.0) k=k+24
      itab(ipu)=indrr
      itab1(ipu)=((ill(2)+64)*128+ill(3)+64)*32+k
      isgn=isign(1,indr)
      indr=iabs(indr)
      if(isr(indr).eq.0)isr(indr)=(j*32+i)*isgn
 1100 continue
 1900 continue
      n8t=8000
      jsup =jenu1-1
c--calculate sigma 2
      jt=0
      n8=0
      n8e=0
      if(iprin.lt.2) go to 1530
      write(lo,1525)
1525  format(/,' set up sigma2 relationships')
1530  continue
c--azzeramento isig
c
      do 50 i=1,3
      do 50 j=1,8000
      isig(i,j)=0
 50   continue
      nsup=jenu1
      inn1=1-nsym
c--first loop
c
      do 2000 nl=1,nlis
      inn1=inn1+nsym
      i=list1(nl,1)/10
c
      llist=list2(nl,4)
      e1=float(llist)/1000.
      if(iprin.lt.2) go to 2005
      llist=list2(nl,5)
      ifi=mod(llist,1000)
      write(lo,2004) (list2(nl,n),n=1,3),i,e1,ifi
2004  format(/,' reflection ',3i4,10x,
     1 'code = ',i4,10x,
     2 'e = ',f7.2,10x,
     3 'phase =',i7,/)
      js=0
 2005 jk1=list2(nl,2)
      jl1=list2(nl,3)
      i1=i
c
c--second loop
c
      do 2100 j=1,nsup
c-- se il secondo riflesso e' uguale al primo , via 
      if (j.eq.i) go to 2100
c
      i0=2*nsym
      do 2110 ii=1,i0
      ivet(ii)=0
 2110 continue
      i0=0
      jn=(j-1)*nsym
      do 2200 k=1,nsym
      jnk=jn+k
      if(little(j,k,1).ge.127) goto 2200
      it=itab1(jnk)/32
      jk2=little(j,k,2)
      jl2=little(j,k,3)
      do 2300 l=1,3,2
      l1=l-2
      do 2301 jjj=1,3
      jhkl3(jjj)=list2(nl,jjj)+little(j,k,jjj)*l1
      if (iabs(jhkl3(jjj)).gt.ihx(jjj)) goto 2300
 2301 continue
      ih3=jxa*jhkl3(1)+jxb*jhkl3(2)+jhkl3(3)
      l3=1
      if(ih3) 2010,2300,2020
 2010 l3=-1
      ih3=-ih3
 2020 if(ih3.gt.jxx) go to 2300
      if(isr(ih3).eq.0) go to 2300
      if(isr(ih3).lt.0) l3=-l3
      isra=isr(ih3)
      isra=iabs(isra)
      in=isra/32
c-- controlla che non ci siano riflessi ripetuti
c-- e/o doppioni
      if (in.eq.i.or.in.ge.j) go to 2300
      if(i0.eq.0)go to 2030
      do 2040  ii=1,i0
      if(in.eq.ivet(ii))go to 2300
 2040 continue
 2030 i0=i0+1
      ivet(i0)=in
      in3=isra-in*32
      ins=(in-1)*nsym+in3
      ns3=mod(itab1(ins),32)
      ns2=mod(itab1(jnk),32)
      is =-ns2*l1+ns3*l3+48
      is =mod(is ,24)
      iss=is*360/24
c  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c  phi(t)=phi(h1)-phi(h2)-phi(h3)+shift(fase)
c  i codici sono per  h1 = h2 + h3
c  cod(h2)= -l1 * j
c  cod(h3)=  l3 * in
c
      ifi=list2(nl,5)
      ifi=ifi-(ifi/1000)*1000
      if2=int(phive(j))
      if2=if2-(if2/1000)*1000
      if3=int(phive(in))
      if3=if3-(if3/1000)*1000
      iphi= ifi+if2*l1-if3*l3+iss
      if(iphi.lt.0)iphi=iphi+3600
      iphi=mod(iphi,360)
      e2=float(iabs(iel(j)))/1000.
      e3=float(iabs(iel(in)))/1000.
      g=s3s2*e1*e2*e3
      g=2.*g
      if (iprin.lt.2) go to 2025
      js=js+1
      jt=jt+1
      ist(1,jt)=-j*l1
      ist(2,jt)=in*l3
      gt(jt)=g
      iphit(jt)=iphi
      if(jt.ne.5) go to 2025
      write(lo,2026) ((ist(n,mm),n=1,2),gt(mm),iphit(mm),mm=1,5)
 2026 format(5(3x,2i5,f7.2,i5))
      jt=0
 2025 continue
      n8=n8+1
      if(g.gt.20.47) g=20.47
      gq(n8)=g
      jg=nint(g*100.)
c *******************************************************
c **  is   =  d-shift del tripletto
c **  i    =  code del primo riflesso
c **  j    =  code del secondo riflesso
c **  in   =  code del terzo riflesso
c **  k    =  operatore di simm. del secondo riflesso
c **  in3  =  operatore di simm. del terzo riflesso
c **  l1   =  segno del secondo riflesso
c **  l3   =  segno del terzo riflesso
c **  jg   =  int(g*100)
c **  iphi =  fase reale del tripletto
c ********************************************************
      isig(1,n8)=((i+2048)*4096+l1*j+2048)*32+k+1
      isig(2,n8)=((-l3*in+2048)*4096+in3+2048)*32+is+1
      isig(3,n8)=(((iphi/15)+2048)*4096+jg+2048)*32+mod(iphi,15)+1
      if(knw.eq.0) goto 2400
c*********************************************************
c    calcolo statistiche
c*********************************************************
      b=float(iphi)*pi/180.
      a=cos(b)
      an=a*g
      if (icent.le.1) go to 4000
      gg=g
c--  esegue test centro
c     call sctst(gg,an,1)
      goto 2400
 4000 g2=g
      call besse(g2,coat)
c--  esegue test noncentro
c     call nctet(g2,coat,a,1)
 2400 if(n8.ge.n8t) go to 2700
 2300 continue
 2200 continue
 2100 continue
      if(iprin.lt.2) go to 2000
      if(jt.eq.0) go to 2002
      write(lo,2026) ((ist(n,mm),n=1,2),gt(mm),iphit(mm),mm=1,jt)
      jt=0
 2002 continue
      write(lo,2101) js
 2101 format(' number of contributors =',i6)
      js=0
 2000 continue
 2700 continue
c     if(knw.eq.1) then
c                   if(icent.le.1)  then
c                                      call nstst(0)
c                                   else
c                                      call stst(0)
c                                   endif
c                  endif
c *********************************************************************
c    call of p10
c *********************************************************************
c     if(jopt.ne.0) call p10s
c     if(knw.ne.0) write(lo,3000) n8
c3000 format(1h ,i8,' triplet(s) calculated',/)
c -------  costruzione lim0
      do 3048 i=1,9001
 3048 lim0(i)=0
      nseq=0
      ncod=0
      do 3050  i=1,n8
      call unpak3(isig(1,i),ncod1,ncod2,iff)
      if(ncod1.eq.0) goto 3051
      lim0(ncod1+1)=lim0(ncod1+1) + 1
 3050 continue
 3051 nfin=nrif+1
      do 3052 i=2,nfin
 3052 lim0(i)=lim0(i)+lim0(i-1)
      return
      end
c----------------------------------------------------------------------
      subroutine sortgs(um,ndim)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      dimension  um(9001)
c
      if (ndim.gt.1) go to 100
      if (ndim.le.0) write(lo,110)
      iflag=1
      return
  100 continue
      k=1
    1 k=2*k
      if (k.lt.ndim) go to 1
      k=k/2
    7 l=ndim-k
      j=1
    6 if (j.gt.l) go to 2
      i=j
    5 ik=i+k
      m=i
    4 aix=um(m)
      mj=m+k
      aiy=um(mj)
      if (aix.ge.aiy) go to 3
      aicom=um(m)
      um(m)=um(mj)
      um(mj)=aicom
      m=m-k
      i=ik
      if (m.gt.0) go to 4
    3 i=i+k
      if (i.le.l) go to 5
      j=j+1
      if (j.le.k) go to 6
    2 k=k/2
      if (k.gt.0) go to 7
      return
  110 format(//,' **********  warning  **********',/
     1         ,'         no sigma2 exist        ',/
     2         ,'        program is killed       ',/
     3         ,'********************************',//)
      end
c----------------------------------------------------------
      subroutine fillr
c---- reading of normal file
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
c
      common /cost/ pi2,jxa,jxb,jxx,nk1,lfl,nrif,mult,nsem,itype,ang(24)
      common/xdata/isr(100000),matse(350,3),little(350,24,3),limi(9001),
     1 idopp(1000),iel(350),phive(350),list1(1000,2),list2(1000,5),nlis,
     2 gq(8000),gv(8000),idummy(48),dummpc(84000)
      integer hkl(3),jhkl(3)
      dimension vet(12),ivet(12)
      equivalence(ivet(1),vet(1))
c
      do 95 i=1,jxx
   95 isr(i)=-1000
c -----
c     call  sub.  preambolo     lista  7  :  riflessi ordinati
c -----
      call ysfl07(nrif,nstron,nweak,npseud,iy)
c -----
c     call  sub.  per  lettura  lista  7  :  riflessi ordinati
c -----
      do 1090 i=1,nrif
      call snr07(vet)
      hkl(1)=ivet(1)
      hkl(2)=ivet(2)
      hkl(3)=ivet(3)
      e=vet(4)
      if(e.eq.0.0) e=0.01
      if(e.eq.1.0) e=0.999
      iphi8=mod(ivet(8),2**15)
      iphi=iphi8/32
      itype=mod(iphi8,32)
c---- fill reciprocal-space-array
      e1000=e*1000
      do 500 l=1,nsym
      call equiv(hkl,jhkl,l,ind)
  500 isr(ind)=e1000
 1090 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine sorts(num,v,nmax,idim)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      dimension num(idim),v(idim)
c
      if (nmax.gt.1) go to 100
      if (nmax.le.0) write(lo,110)
      num(1)=1
      iflag=1
      return
  100 continue
      do 10 i=1,nmax
      num(i)=i
   10 continue
      k=1
    1 k=2*k
      if (k.lt.nmax) go to 1
      k=k/2
    7 l=nmax-k
      j=1
    6 if (j.gt.l) go to 2
      i=j
    5 ik=i+k
      m=i
    4 x=v(m)
      mj=m+k
      y=v(mj)
      if (x.ge.y) go to 3
      com=num(m)
      num(m)=num(mj)
      num(mj)=com
      com=v(m)
      v(m)=v(mj)
      v(mj)=com
      m=m-k
      i=ik
      if (m.gt.0) go to 4
    3 i=i+k
      if (i.le.l) go to 5
      j=j+1
      if (j.le.k) go to 6
    2 k=k/2
      if (k.gt.0) go to 7
      return
  110 format(//,' **********  warning  **********',/
     1         ,' *    no seminvariants exist   * ',/
     2         ,' *******************************',//)
      end
c-----------------------------------------------------------------------
      subroutine inse(dopma,value,ind,ij)
      dimension dopma(49,8)
      entry=value
      if (ij.eq.1) go to 20
      ij1m=ij-1
      do 10 ii=1,ij1m
      if (value.ne.dopma(ii,ind)) go to 10
      return
   10 continue
   20 continue
      dopma(ij,ind)=entry
      return
      end
c---------------------------------------------------------------------
      subroutine ksym(k1,hp,e4,eps4,h4,id1)
c ----------
c ----------   compute   h + k * r(i)
c ----------
      common/xdata/isr(100000),matse(350,3),little(350,24,3),limi(9001),
     1 idopp(1000),iel(350),phive(350),list1(1000,2),list2(1000,5),nlis,
     2 gq(8000),gv(8000),idummy(48),dummpc(84000)
      integer hp(3),h4(3),k1(3)
c
      h4(1)=hp(1)+k1(1)
      h4(2)=hp(2)+k1(2)
      h4(3)=hp(3)+k1(3)
      call indr(h4,id1)
      if (id1.lt.0) go to 10
      istabs=isr(id1)
      ist=iabs(istabs)
      e4=float(ist)/1000.0
      eps4=e4*e4-1.0
      return
   10 continue
      e4=0.0
      eps4=0.0
      return
      end
c----------------------------------------------------------------------
      subroutine mark(hkl,nord,idoub,jhkl)
c
c-- 'marca' nel reciproco un riflesso gia' utilizzato
c
      common /dirg/ jss1,jopt,jss2
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,dumy
      common /cost/ pi2,jxa,jxb,jxx,nk1,lfl,nrif,mult,nsem,itype,ang(24)
      common/xdata/isr(100000),matse(350,3),little(350,24,3),limi(9001),
     1 idopp(1000),iel(350),phive(350),list1(1000,2),list2(1000,5),nlis,
     2 gq(8000),gv(8000),idummy(48),dummpc(84000)
      integer hkl(3),hkle(3),jhkl(3)
c
c
c---- rende negativo il valore di  'e'  e di tutti gli  'e'
c---- equivalenti attraverso  'equi'  in modo che in seguito
c---- non venga piu' utilizzato il riflesso u. inoltre memorizza
c---- l'indirizzo in idopp in modo da resettare il reciproco una volta
c---- completati i calcoli per il s.s.i. in esame.
c
      iflag=0
      do 27 jj=1,nsym
      call equiv(hkl,hkle,jj,ind)
      if (ind.le.0) go to 27
      ist=isr(ind)
      if (ist.le.0) go to 27
      isr(ind)=-ist
      idoub=idoub+1
      if (idoub.le.1000) go to 26
      idoub=idoub-1
      iflag=1
      return
   26 continue
      idopp(idoub)=ind
   27 continue
      return
      end
c----------------------------------------------------------------------
      subroutine sors1(gvet,icont,suma)
c---- sort seminvariants stored in 'matse'
      common /dirg/ jss1,jopt,jss2
      common /dir1/ jboth,jrepr,jeli1,jenu1,jknum,soge1,sogk
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,dumy
      common /inv/  invma(96,3,3),idivv(48)
      common /cost/ pi2,jxa,jxb,jxx,nk1,lfl,nrif,mult,nsem,itype,ang(24)
      common /choi/ mm,iimax,jmax,nsj,jtable(8,16),invet(48)
      common /pro/  jvarma(3,3),kx(3),idoub,kkk,sump(2),icros,
     * jhkl(3),e,scr2(2),ns,sr2(2),jhimrn(3,3),nsemc,nsemg
      common/xdata/isr(100000),matse(350,3),little(350,24,3),limi(9001),
     1 idopp(1000),iel(350),phive(350),list1(1000,2),list2(1000,5),nlis,
     2 gq(8000),gv(8000),idummy(48),dummpc(84000)
      dimension suma(2)
      dimension gvet(350),ias(350),nord(350),ihkl(350,3),ee(350)
      dimension num(350),iphi(350),iast(350),iphit(350),igv(350)
      data iblan,istar,iggg/1h ,1h*,1hg/
c
      if (nsem.eq.0) then
                      write(lo,10)
   10 format(//,' **********  warning  **********',/
     1         ,' *    no seminvariants exist   * ',/
     2         ,' *******************************',//)
                      return
                     endif
      scale=1.0
      if (jrepr.eq.2) scale=suma(1)/suma(2)
      if (scale.gt.1.0) scale=1.0
      istron=0
      ig=0
      n11=0
      do 20 i=1,nsem
      if (gvet(i).eq.0.0) go to 20
      n11=n11+1
      ias(i)=iblan
      if (gvet(i).lt.0.0) ias(i)=istar
      gvet(i)=abs(gvet(i))*scale
   20 continue
      icont=0
      if (n11.eq.0) return
      call sorts(num,gvet,nsem,350)
      if(ipripe.gt.0) write(lo,110)
      if(ipripe.gt.0) write(lo,115)
      ari=0.0
      nari=0
      do 30 i=1,nsem
      if (gvet(i).eq.0.0) go to 35
      icont=icont+1
      if (gvet(i).ge.0.8) istron=istron+1
      j=num(i)
      iast(i)=ias(j)
      jpoint=matse(j,1)
      do 25 k=1,3
      ihkl(i,k)=little(jpoint,1,k)
   25 continue
      nord(i)=matse(j,1)
      e=float(iel(jpoint))/1000.0
      ee(i)=abs(e)
      itype  =matse(j,3)/1000
      iphi(i) =matse(j,3)   -itype*1000
      ncode=nord(i)
      if (itype.eq.1) ncode=-ncode
      iphit(i)=jpack1(ncode,gvet(i),iphi(i))
      igv(i)=iblan
      if (itype.ne.1) go to 28
      ig=1
      igv(i)=iggg
      go to 30
   28 if (knw.eq.0) go to 30
      prob=0.5+0.5*tanh(gvet(i))
      if (istar.eq.iast(i)) prob=1.0-prob
      ari=ari+(prob-0.5)*ee(i)/abs(ee(i))
      nari=nari+1
   30 continue
   35 iconts=min0(9,icont)
      if(ipripe.gt.0)  then
        write(lo,210) (nord(i),(ihkl(i,k),k=1,3),ee(i),gvet(i),
     1                 iphi(i),igv(i),iast(i),i=1,iconts)
                       if(icont.gt.iconts) write(lo,230)
                       write(lo,240)
                       endif
      if (ig.eq.1.and.iprin.ne.0) write(lo,250)
      if (knw.eq.0) go to 37
      if(ipripe.gt.0) write(lo,245)
      if (nari.eq.0) nari=1
      ari=2.0*ari/float(nari)
      if (iprin.ne.0) then
                        write(lo,36) ari
   36 format(60x,'ari = ',f8.4)
                      endif
c---- write seminvariants on disk
   37 continue
c ---
c     call sub. scrittura lista 22 : seminvarianti a una fase
c ---
      iprea=0
      call frmxx(iprea,22,icont,icont,istron,nxxe,iccd,iphit)
      return
  210 format(3(i6,1h),3i3,2x,f6.3,1x,f7.3,1x,i4,a1,a1,3x))
  230 format(/,5x,' .... and so on',/)
  240 format(1h ,/)
  245 format(20x,'reflections marked with  *  are wrongly estimated',/)
  250 format(20x,'for reflections with  "g"-phase  alpha is equal to 1/2
     1  the argument of  io bessel  function',//)
  110 format(//,35x,
     *          ' List of one-phase structure seminvariants estimated',
     *//,3x,3('code     H        E     alpha phase       '),
     3 /,1h ,2x,3('----------------------------------------'),/)
  115 format(1h )
      end
c-----------------------------------------------------------------------
      function jpack1(n1,g,ifaz)
      ifz=ifaz/15
      ifz=mod(ifz,24)
      ig100=int(g*100)
      if (ig100.gt.2047) ig100=2047
      jpack1=((n1+2048)*4096+ig100+2048)*32+ifz+1
      return
      end
c-----------------------------------------------------------------------
      subroutine jpack2(ind1,ind2,n1,ise,n2,g,ifaz)
      ig100=int(g*100)
      if (ig100.gt.2047) ig100=2047
      ind1=((n1+2048)*4096+n2*ise+2048)*32
      ind2=((1024+2048)*4096+ig100+2048)*32+(ifaz/15)+1
      return
      end
c-----------------------------------------------------------------------
      subroutine unpk1(ind,n1,g,ifaz)
c---- jpack1=((n1+2048)*4096+int(g*100)+2048)*32+(ifaz/15)+1
      ind=ind-1
      n1=ind/131072-2048
      ig100=ind/32-(n1+2048)*4096-2048
      g=float(ig100)/100.0
      ifaz=(ind-((n1+2048)*4096+ig100+2048)*32)*15
      return
      end
c-----------------------------------------------------------------------
      function h4(ee)
      e=ee
      if (e.eq.0.0) go to 10
      h4=e*e*e*e-6.0*e*e+3.0
      return
   10 continue
      h4=0.0
      return
      end
c----------------------------------------------------------------------
      function modulo_sir(hkl)
c-- verifies if a reflection is a seminvariant
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
c
      integer hkl(3),mat(3,3)
      equivalence (mat(1,1),jsvet(1))
c
      modulo_sir=1
      do 30 ic=1,3
      isum=0
      do 20 i=1,3
   20 isum=isum+mat(ic,i)*hkl(i)
      if (mod(isum,192).ne.0) return
   30 continue
      modulo_sir=0
      return
      end
c-----------------------------------------------------------------------
      subroutine wrcon
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /choi/ mm,iimax,jmax,nsj,jtable(8,16),invet(48)
      integer congr(16)
c--
      if(ipripe.gt.0) then
                         write(lo,1160)
                         write(lo,1110) isvet
                         write(lo,1160)
                         write(lo,1150)
                         write(lo,1160)
                      endif
      do 12 i=1,jmax
      k=jtable(1,i)
      call cong4(ksmat,msym,k,congr)
      if(ipripe.gt.0) write(lo,1100) congr,k
   12 continue
      if(ipripe.gt.0) write(lo,1160)
c--
 1100 format(20x,10a1,' congruent to 0 mod. (',6a1,
     *'  because of matrix n. ',i2)
 1110 format(20x,'Seminvariant condition : ',3a2,4x,5a2)
 1150 format(20x,'First rank seminvariant condition(s) :')
 1160 format(1h )
      return
      end
c----------------------------------------------------------------------
      subroutine ss1(result)
c
      common /dirg/ jss1,jopt,jss2
      common /dir1/ jboth,jrepr,jeli1,jenu1,jknum,soge1,sogk
      common /dir2/ jenu2,glim,soge2,eplim,nca(2)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,dumy
      common /inv/  invma(96,3,3),idivv(48)
      common /cost/ pi2,jxa,jxb,jxx,nk1,lfl,nrif,mult,nsem,itype,ang(24)
      common /choi/ mm,iimax,jmax,nsj,jtable(8,16),invet(48)
      common /pro/  jvarma(3,3),kx(3),idoub,kkk,sump(2),icros,
     * jhkl(3),e,scr2(2),ns,sr2(2),jhimrn(3,3),nsemc,nsemg
      common/xdata/isr(100000),matse(350,3),little(350,24,3),limi(9001),
     1 idopp(1000),iel(350),phive(350),list1(1000,2),list2(1000,5),nlis,
     2 gq(8000),gv(8000),idummy(48),dummpc(84000)
      common /pross2/ nquar,e2,et(3),ishi,eq(10),epsi(10),iep231,iep132,
     1 jdelta,duen,ssin,scos,istamp,nb1,nb2,nb3,nb4,ns1,ns2,ns3,ns4,ikkk
     2 ,nsu(2),ess(4),jcb(3),sden
      integer balfa(3)
      dimension blv(3),sign(3),alf(3),gvet(350),imat(5)
      integer h(3,3),congr(16),result(2,2)
      dimension prob(3),arg(3),ias(3),suma(2)
      data iblan,istar/1h ,1h*/
      data gvet,suma /350*0.0,2*0.0/
c
      if(ipripe.gt.0) write(lo,100)
  100 format(///,120('+'),//,
     1 39x,'***   one-phase seminvariants section   ***',//)
      if(ipripe.gt.0) then 
                        if (jrepr.eq.1) write(lo,110)
                        if (jrepr.eq.2) write(lo,120)
                      endif
  110 format(20x,'First representation formula will be used',/)
  120 format(20x,'Second representation formula will be used',/)
      if (jenu1.lt.200) soge1=abs(float(iel(jenu1)))/1000.0
      if(ipripe.gt.0) write(lo,130) jenu1,soge1
  130 format(20x,'n. of reflections to search s.s.i. = ',i5,
     *'  with  /E/ .ge.', f7.3,/)
      if (jrepr.eq.2.and.ipripe.gt.0) write(lo,131) jknum,sogk
  131 format(20x,'n. of free vectors used            = ',i5,
     *'  with  /E/ .ge.', f7.3,/)
      if (nsem.eq.0) return
      duen = 2. * fnat
      nsemc=0
      nsemg=0
      ilit=0
c---- estract reflections from matse
   40 continue
      ilit=ilit+1
      if (ilit.gt.nsem) go to 1500
      nord   =matse(ilit,1)
      do 50 k=1,3
   50 jhkl(k)=little(nord,1,k)
      e      =iel(nord)/1000.0
      e      =abs(e)
      if (e.lt.soge1) go to 1500
      itype  =phive(nord)/1000
      iphi   =phive(nord)-itype*1000
      phi=iphi
      phic=ang(itype)
      sump(1)=0.0
      sump(2)=0.0
      icros=0
      sr2(1)=0.0
      sr2(2)=0.0
      idoub=0
      j=list1(ilit,1)
      nmat=mod(j,10)
      ixxx=j/10
      j=list1(ilit,2)
      do 60 i=1,nmat
      imat(i)=mod(j,64)
   60 j=j/64
c---- if we have to use the second representation formula
c---- we compute  h +/- krj  (j=1,nsym)
      if (jrepr.eq.2) call ehk
c---- by means of the array imat consider only
c---- indipendent symmetry operators.
      do 70 i=1,nmat
      kkk=imat(i)
      if (kkk.eq.0) then
                      write(lo,*) '**** subroutine ss1 (kkk) ****'
                      write(lo,*) '****  programming  error  ****'
                      write(lo,*) ' sir ends in error'
                      stop 1234
                    endif
c---- compute the matrix  h = ( i - rs )
      do 65 i1=1,3
      do 62 j1=1,3
   62 h(i1,j1)=-ksmat(kkk,j1,i1)
   65 h(i1,i1)=h(i1,i1)+1
c---- compute the first rank seminvariant vector
c---- by means of 'cong4' (for print only).
      if (iprin.gt.2) call cong4(ksmat,msym,kkk,congr)
c---- compute the solutions of the diophantine system
c---- if idiof = 1  we do not get integer solutions.
      call diof(h,idiof,balfa,sign,alf,blv)
      if (idiof.ne.0) then
                      write(lo,*) '**** subroutine ss1 (idiof) ****'
                      write(lo,*) ' ****  programming  error  ****'
                      write(lo,*) ' sir ends in error'
                      stop 1234
                    endif
      if (iprin.gt.2) write(lo,68) nord,jhkl,kkk,congr
     *, balfa
     1, (kx(i1),i1=1,3)
     2, (sign(i1),alf(i1),blv(i1),i1=1,3)
   68 format(1h ,i3,1h),3i4,3h - ,
     *           'mat. ',i2,2x,10a1,' congruent to 0 mod. (',6a1,
     *  2x,'h = (',2(i3,1h,),i3,1h),
     1  2x,6h x = (,i3,2(1h,,i3),1h),
     2  2x,' + (',3a1,2(1h,,3a1),1h))
      nquar=1
      call find1(nord,phic,isbat)
   70 continue
c---- reset reciprocal space
      do 85 i=1,idoub
      ipik=idopp(i)
      ist=isr(ipik)
      if (ist.gt.0) go to 85
      isr(ipik)=-ist
   85 continue
c---- compute probability
      if (icros.eq.0) go to 40
      if (itype.ne.1) go to 91
      nsemg=nsemg+1
      arg(1)=(sqrt(sump(1)*sump(1)+sump(2)*sump(2)))/2.0
      arg(2)=(sqrt(sr2(1)*sr2(1)+sr2(2)*sr2(2)))/2.0
      do 87 i=1,2
   87 arg(i)=arg(i)*e/satm
      prob(1)=atan2(sump(2),sump(1))
      prob(2)=atan2(sr2(2),sr2(1))
      prob(1)=prob(1)*360.0/pi2
      prob(2)=prob(2)*360.0/pi2
      go to 92
   91 continue
      nsemc=nsemc+1
      arg(1)=0.5*e*sump(1)/satm
      arg(2)=0.5*e*sr2(1)/satm
      prob(1)=0.5+0.5*tanh(abs(arg(1)))
      prob(2)=0.5+0.5*tanh(abs(arg(2)))
   92 continue
      do 93 i=1,2
      phicv=phic
      if (itype.eq.1) phicv=prob(i)*pi2/360.0
      if (arg(i).lt.0.0) phicv=phicv+pi2/2.0
      arg(i)=abs(arg(i))
      suma(i)=suma(i)+arg(i)
      ias(i)=iblan
      phicv=phicv*360.0/pi2
      if (knw.eq.0) go to 93
      argj=phicv-phi
      argc=(phicv-phi)*pi2/360.0
      if (cos(argc).lt.0.0.and.itype.ne.1) ias(i)=istar
      if (jrepr.eq.1) go to 95
   93 continue
   95 continue
      i=jrepr
      if (arg(i).ge.0.2) go to 96
      if (itype.eq.1) nsemg=nsemg-1
      if (itype.ne.1) nsemc=nsemc-1
      gvet(ilit)=0.0
      go to 1450
   96 if (itype.eq.1) phicv=prob(i)
      if (phicv.lt.  0.0) phicv=phicv+360
      if (phicv.ge.360.0) phicv=phicv-360
      phic=phicv
      gvet(ilit)=arg(i)
      jphic=phic+0.5
      if (ias(i).eq.istar) gvet(ilit)=-gvet(ilit)
      matse(ilit,3)=itype*1000+jphic
      if (jboth.eq.0) go to 90
      if (itype.ne.1)  write(lo,89) nord,jhkl,e,phi,icros,
     2                 (arg(i),prob(i),ias(i),i=1,2),jphic,itype
      if (itype.eq.1) write(lo,94) nord,jhkl,e,phi,icros,
     2                 (arg(i),        ias(i),i=1,2),jphic,itype
   90 continue
   89 format(1x,i5,1h),3i4,f8.3,f6.1,i4,1x,2(f7.3,1x,f5.3,a1),
     *                  7x,i5,8x,i3,2x,2h  )
   94 format(1x,i5,1h),3i4,f8.3,f6.1,i4,1x,2(f7.3,1x,5x  ,a1),
     *                  7x,i5,8x,i3,'  ')
      if (jboth.eq.1) write(lo,500)
 1450 continue
c
      go to 40
 1500 continue
c---- sort seminvariants
      call sors1(gvet,nsemt,suma)
      if(nsemt.eq.0) then
                       nsem=0
                       return
                     endif
      result(1,1)=nsem
      result(1,2)=nsemt
      if(iprin.ne.0) then
c---- print the number of seminvariants
                       write(lo,2007)
                       write(lo,2008) nsemc
                       if (nsemg.ne.0) write(lo,2009) nsemg
                       write(lo,2011) nsemt
                     endif
      return
 2007 format(1h )
 2008 format(20x,'n. of first rank s.s.i   (restricted-phase)   =',i5)
 2009 format(20x,'n. of first rank s.s.i.    (general phase)    =',i5)
 2011 format(20x,'n. of s.s.i. stored      = ',i5)
  500 format(1x,104('-'))
      end
c---------------------------------------------------------------------
      subroutine ehk
c
      common /dirg/ jss1,jopt,jss2
      common /dir1/ jboth,jrepr,jeli1,jenu1,jknum,soge1,sogk
      common /dir2/ jenu2,glim,soge2,eplim,nca(2)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /cost/ pi2,jxa,jxb,jxx,nk1,lfl,nrif,mult,nsem,itype,ang(24)
      common /pro/  jvarma(3,3),kx(3),idoub,kkk,sump(2),icros,
     * jhkl(3),e,scr2(2),ns,sr2(2),jhimrn(3,3),nsemc,nsemg
      common/xdata/isr(100000),matse(350,3),little(350,24,3),limi(9001),
     1 idopp(1000),iel(350),phive(350),list1(1000,2),list2(1000,5),nlis,
     2 gq(8000),gv(8000),idummy(48),dummpc(84000)
      common /temp/ ifinv(100,2),hkrj(100,4,24)
c
      integer h3(3),hk(3)
c
      do 100 k=1,jknum
      e3=iel(k)
      ifin1=2
      ifin2=nsym2
      if (icent.eq.2) go to 10
      if (e3.gt.0.0)  go to 10
      ifin1=1
      ifin2=nsym
   10 continue
      ifinv(k,1)=ifin1
      ifinv(k,2)=ifin2
      isegn=-1
c---- loop over the symmetry
      do 30 isy=1,ifin1
      isegn=-isegn
      do 30 i=1,nsym
      do 20 j=1,3
   20 h3(j)=little(k,i,j)*isegn
      call ksym(h3,jhkl,ee,eps,hk,ind)
      hkrj(k,isy  ,i)=ee
      hkrj(k,isy+2,i)=eps
   30 continue
  100 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine secrep(codh,e1,e2,eps2,eps1,nord,coef)
c ----------
c ---------- evaluate the second representation probability
c ----------
      common /dirg/ jss1,jopt,jss2
      common /dir1/ jboth,jrepr,jeli1,jenu1,jknum,soge1,sogk
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,dumy
      common /inv/  invma(96,3,3),idivv(48)
      common /cost/ pi2,jxa,jxb,jxx,nk1,lfl,nrif,mult,nsem,itype,ang(24)
      common /choi/ mm,iimax,jmax,nsj,jtable(8,16),invet(48)
      common /pro/  jvarma(3,3),kx(3),idoub,kkk,sump(2),icros,
     * jhkl(3),e,scr2(2),ns,sr2(2),jhimrn(3,3),nsemc,nsemg
      common/xdata/isr(100000),matse(350,3),little(350,24,3),limi(9001),
     1 idopp(1000),iel(350),phive(350),list1(1000,2),list2(1000,5),nlis,
     2 gq(8000),gv(8000),idummy(48),dummpc(84000)
c
      common /temp/ ifinv(100,2),hkrj(100,4,24)
c
      integer h3(3),h3j(3),h4(3),h4j(3)
      dimension sum(2),sum1(2),codh(2),ahks(2),dopma(49,8)
c
      ipr2=iprin
      fatt=coef*(2.0*eps2+1)
      ahks(1)=0.
      ahks(2)=0.
      bhks=0.
      sum(1)=0.0
      sum(2)=0.0
      if (ipr2.ge.1) write(lo,10)jhkl,e1,eps1,kx,e2,eps2,kkk,nk1,sogk
   10 format(1x,'&&&&',2(3i4,2f9.3,5x),' &&&& nmat=',i2,' &&&&',i5,f9.3)
c
c---- sogk = valore di soglia per  ek
c---- jknum = number of free vectors
c
      do 100 ll=1,jknum
      if (nord.eq.ll) go to 100
      h3(1)=little(ll,1,1)
      h3(2)=little(ll,1,2)
      h3(3)=little(ll,1,3)
      e3=iel(ll)
      ifin =ifinv(ll,1)
      ifin2=ifinv(ll,2)
      e3=abs(e3)
      e3=e3*0.001
      if (e3.eq.e2) go to 100
      eps3=e3*e3-1.
      fat=fatt*eps3
      isegn=-1
c
c---- loop over the symmetry
c
      molt5=1
      do 70 isy=1,ifin
      isegn=-isegn
      do 70 i=1,nsym
      ij=i+(isy-1)*nsym
      dopma(ij,2)=1.
      dopma(ij,4)=1.
      dopma(ij,6)=1.
      dopma(ij,8)=1.
      dopma(ij,1)=0.
      dopma(ij,3)=0.
      dopma(ij,5)=0.
      dopma(ij,7)=0.
      if (little(ll,i,1).gt.127) go to 70
      do 20 kk=1,3
   20 h3(kk)=little(ll,i,kk)*isegn
c ----------
c     call ksym(h3,jhkl,e5,eps5,h5,ind51)
      e5  =hkrj(ll,isy  ,i)
      eps5=hkrj(ll,isy+2,i)
c ----------
      call ksym(h3,kx,e4,eps4,h4,ind41)
c ----------
      if (eps4.eq.0.0.and.eps5.eq.0.0) go to 70
      if (e5.le.sogk) go to 25
      if (e3.ge.e5) go to 25
      dopma(ij,4)=0.0
      dopma(ij,6)=0.0
   25 continue
      if (eps4.ne.eps5) go to 30
      if (eps4.eq.0.00) go to 30
      dopma(ij,2)=0.0
      dopma(ij,4)=0.0
      dopma(ij,6)=0.0
      dopma(ij,8)=0.0
      go to 70
   30 continue
      if (e4.le.sogk) go to 35
      if (e3.ge.e4) go to 35
      dopma(ij,2)=0.0
      dopma(ij,4)=0.0
      dopma(ij,6)=0.0
      dopma(ij,8)=0.0
      go to 70
   35 continue
      if (eps4.eq.0.0) go to 40
c=============================
      call inse(dopma,eps4,5,ij)
   40 continue
      if (eps5.eq.0.0) go to 45
c=============================
      call inse(dopma,eps5,1,ij)
   45 continue
      r45=eps4*eps5
      if (r45.eq.0.0) go to 50
c=============================
      call inse(dopma, r45,3,ij)
   50 continue
      j=irot(ij,kkk)
      iseg1=1
      if (j.gt.nsym) iseg1=-1
      if (j.gt.nsym) j=j-nsym
      h3j(1)=little(ll,j,1)
      h3j(2)=little(ll,j,2)
      h3j(3)=little(ll,j,3)
      if (h3j(1).le.127) go to 55
      h3j(1)=h3j(1)-1000
      h3j(2)=h3j(2)-1000
      h3j(3)=h3j(3)-1000
   55 continue
      h3j(1)=h3j(1)*iseg1
      h3j(2)=h3j(2)*iseg1
      h3j(3)=h3j(3)*iseg1
c ----------
      call ksym(h3j,kx,e4j,eps4j,h4j,indj1)
c ----------
      if (e4j.gt.e3) dopma(ij,8)=0.0
      r44=eps4*eps4j
      if (r44.eq.0.0) go to 60
c=============================
      call inse(dopma, r44,7,ij)
   60 continue
      if (e5.eq.e2.and.e5.ne.0.0) molt5=0
      if (e4.eq.e2.and.e4.ne.0.0) molt5=0
      if (e4.eq.e1) molt5=0
      if (molt5.eq.0) go to 100
      if (e5.ne.e3) go to 61
      go to 100
   61 if (e4.ne.e4j) go to 70
      if (e4.eq.0.0) go to 70
      dopma(ij,2)=0.0
      dopma(ij,4)=0.0
      dopma(ij,6)=0.0
      dopma(ij,8)=0.0
   70 continue
      do 78 i=1,7,2
      dopma(49,i)=0.0
      do 75 jj=1,ifin2
   75 dopma(49,i)=dopma(49,i)+dopma(jj,i)*dopma(jj,i+1)
   78 continue
      as=fat*(     dopma(49,3)+dopma(49,7))
     &  -0.5*(eps3*dopma(49,5)+dopma(49,3))
      ahks(1)=ahks(1)+as
      ahks(2)=ahks(2)+as
      qhk=eps1*(eps3*dopma(49,1)+dopma(49,7))
     &   +eps2*(eps3*dopma(49,5)+dopma(49,3))
      bhks=bhks+qhk
      qhk=qhk/(2.0*fnat)
      as=as/fnat
      if(qhk.lt.0.0) qhk=0.0
      sum1(1)=as*codh(1)/(1.0+qhk)
      sum1(2)=as*codh(2)/(1.0+qhk)
      sum(1)=sum(1)+sum1(1)
      sum(2)=sum(2)+sum1(2)
  100 continue
      sr2(1)=sr2(1)+(eps2*codh(1))+sum(1)
      sr2(2)=sr2(2)+(eps2*codh(2))+sum(2)
      if (ipr2.ge.1) write(lo,110)  eps2,coef,codh,sr2,sum
  110 format('  eps2,coef,codh,sr2,sum      ',9x,8f10.4)
      return
      end
c-----------------------------------------------------------
      subroutine ss2(dmat,result)
c
      common /dirg/ jss1,jopt,jss2
      common /dir1/ jboth,jrepr,jeli1,jenu1,jknum,soge1,sogk
      common /dir2/ jenu2,glim,soge2,eplim,nca(2)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /ss2c/ ip,ku(3),eu,kva(3),ev,kn,epsu,epsv,nsem2,nsem2g
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,dumy
      common /inv/  invma(96,3,3),idivv(48)
      common /cost/ pi2,jxa,jxb,jxx,nk1,lfl,nrif,mult,nsem,itype,ang(24)
      common /choi/ mm,iimax,jmax,nsj,jtable(8,16),invet(48)
      common /pro/  jvarma(3,3),kx(3),idoub,kkk,sump(2),icros,
     * jhkl(3),e,scr2(2),ns,sr2(2),hklt  (3,3),nsemc,nsemg
      common/xdata/isr(100000),matse(350,3),little(350,24,3),limi(9001),
     1 idopp(1000),iel(350),phive(350),list1(1000,2),list2(1000,5),nlis,
     2 gq(8000),gv(8000),idummy(48),itab(8000),itab1(8000),isig(3,8000),
     3 lim0(9001),dummpc(34999)
      common /pross2/ nquar,e2,et(3),ishi,eq(10),epsi(10),iep231,iep132,
     1 jdelta,duen,ssin,scos,istamp,nb1,nb2,nb3,nb4,ns1,ns2,ns3,ns4,ikkk
     2 ,nsu(2),ess(4),jcb(3),sden
      common /sig2/ gs,n8
      common/tst/nt8,ar(26),nn(11,26,3),pp(11,26,3)
      common /nctst/nt9,br(15),nb(11,15,3),fnb(11,15,3),bcm(11,15,3),
     *                        acm(11,15,3)
      integer hklt,sx(3),jx(3),imat(5)
c
      integer dmat(3,500),num(350),h(3,3),balfa(3),congr(16),result(2,2)
      dimension blv(3),asign(3),alf(3)
      istamp=0
      do 1 i=1,350
      do 1 ii=1,3
    1 matse(i,ii)=0
      do 2 i=1,9001
    2 limi(i)=0
      do 5 i=1,nk1
      iel(i)=iabs(iel(i))
    5 continue
      icent=icent-1
c ---
c     call sub. lettura   lista  22  per  seminvarianti  a  una  fase
c ---
      iprea=0
      call sflxx(iprea,22,nsem1g,nsem1g,nstron,nxxe,iccd,num)
      do 10 i=1,nsem1g
      is1=num(i)
      call unpk1(is1,is2,dum1,kp)
      np=iabs(is2)
      matse(i,1)=np
      matse(i,2)=nint(dum1*100.)
      matse(i,3)=kp
      if(matse(i,3).le.0) matse(i,3)=matse(i,3)+360
      itype=phive(np)/1000
      iphi=phive(np)-itype*1000
      if(itype.ne.1) iel(matse(i,1))=-iel(matse(i,1))
   10 continue
      nsem2=0
      nsem2t=0
      ari=0.0
      duen = 2. * fnat
      sqfnat=sqrt(fnat)
c---- estract reflections from list1 & list2
      do 40 nl=1,nlis
      nord=list1(nl,1)/10
      do 41 k=1,3
   41 jhkl(k)=list2(nl,k)
      e      =list2(nl,4)/1000.0
      itype  =list2(nl,5)/1000
      iphi   =list2(nl,5)-itype*1000
      phi=iphi
      phic=ang(itype)
      isem=0
c
c-------------- informazioni utili -----------------
c
c   n1,n2,n3            numeri d'ordine del tripletto
c   nop1,nop2,nop3      operatori del tripletto
c   l1,l2,l3            segni del tripletto
c   ishi                delta-shift del tripletto
c
c-----------------------------------------------------------
      lim1=lim0(nord)
      lim2=lim0(nord+1)
      if(lim1.eq.lim2) goto 40
      iniz=lim1+1
      do 201 jcc=iniz,lim2
      call unpak3(isig(1,jcc),n1,n2,nop2)
      call unpak3(isig(2,jcc),n3,nop3,ishi)
      nop1=1
      l1=1
      l2=-isign(1,n2)
      l3= isign(1,n3)
      na2=-n2
      na3=-n3
      n2=iabs(n2)
      n3=iabs(n3)
      itypu=phive(n2)
      itypu=itypu/1000
      itypv=phive(n3)
      itypv=itypv/1000
      itype=13
      if (itypu.eq.1. or.itypv.eq.1) itype=1
      et(1)=e
      ee=iabs(iel(n2))
      et(2)=ee/1000.0
      ee=iabs(iel(n3))
      et(3)=ee/1000.0
      do 120 i=1,3
  120 hklt(i,1)=jhkl(i)
      do 130 i=1,3
  130 hklt(i,2)=little(n2,nop2,i)*l2
      do 140 i=1,3
  140 hklt(i,3)=-little(n3,nop3,i)*l3
      istamp=0
      if (nca(1).eq.n2.and.nca(2).eq.n3) istamp=1
      if (istamp.ne.0)
     * write(lo,150)       n1,(hklt(i,1),i=1,3),et(1),
     *                    na2,(hklt(i,2),i=1,3),et(2),nop2,
     *                    na3,(hklt(i,3),i=1,3),et(3),nop3,ishi
  150 format(1h ,i5,1h),3i4,f8.3,8x,2(i5,1h),3i4,f8.3,i3,5x),i5)
c
      idoub=0
      ssin = 0.0
      scos = 0.0
c ---
c---- by means of the array imat consider only
c---- indipendent symmetry operators.
c ---
      j=list1(nl,1)
      nmat=mod(j,10)
      j=list1(nl,2)
      do 61 i=1,nmat
      imat(i)=mod(j,64)
   61 j=j/64
      do 70 i=1,nmat
      j=(i-1)*5+1
      kkk=imat(i)
c----
c---- controllo se l'ordine di kkk e' 2 opppure diverso da  2
c----
      ikkk=0
      call prod1(ksmat,kkk,kkk,h)
      do 152 jc8=1,3
      do 152 jc9=1,3
      if(h(jc8,jc9).eq.ksmat(1,jc8,jc9)) goto 152
      ikkk=1
      go to 153
  152 continue
  153 continue
c    controllo  su  u1 * i = - u1 * rm
c    controllo  su  u2 * i = - u2 * rm
c           iep231 = 1 non va calcolato epsi(23,1) = epsi(7)
c           iep132 = 1 non va calcolato epsi(13,2) = epsi(9)
      iep231=0
      iep132=0
      nb1=1
      nb2=1
      do 151 jc8=1,3
  151 sx(jc8)=hklt(jc8,2)
      call equiv(sx,jx,kkk,ind)
      isum=0
      do 53 jc8=1,3
      jcb(jc8)=jx(jc8)+hklt(jc8,2)
   53 isum=isum+jx(jc8)+hklt(jc8,2)
      if(isum.ne.0) go to 54
      iep231=1
      nb1=0
   54 continue
      do 57 jc8=1,3
   57 sx(jc8)=hklt(jc8,3)
      call equiv(sx,jx,kkk,ind)
      isum=0
      do 58 jc8=1,3
   58 isum=isum+jx(jc8)+hklt(jc8,3)
      if(isum.ne.0) go to 60
      iep132=1
      nb2=0
   60 continue
c---- compute the solution vector
      do 63 i1=1,3
      do 62 j1=1,3
   62 h(i1,j1)=-ksmat(kkk,j1,i1)
   63 h(i1,i1)=h(i1,i1)+1
c---- compute the first rank seminvariant vector
c---- by means of 'cong4' (for print only).
      if (istamp.ne.0) call cong4(ksmat,msym,kkk,congr)
c---- compute the solutions of the diophantine system
c---- if idiof = 1  we do not get integer solutions.
      call diof(h,idiof,balfa,asign,alf,blv)
      if (idiof.ne.0) then
                      write(lo,*) '**** subroutine ss1 (idiof) ****'
                      write(lo,*) ' ****  programming  error  ****'
                      write(lo,*) ' sir ends in error'
                      stop 1234
                    endif
      nquar=2
      call find1(nord,phic,isbat)
      if (nquar.lt.0) go to 105
   70 continue
c---- reset reciprocal space
  105 do 110 i=1,idoub
      ipik=idopp(i)
      ist=isr(ipik)
      if (ist.gt.0) go to 110
      isr(ipik)=-ist
  110 continue
c
c--   zona riservata al calcolo della stima
c
      if(isbat.ne.0) goto 200
      sang = ssin * ssin
      cang = scos * scos
      alfa2 = sqrt(sang+cang)
c --------------------------------------------------------------
c   calcolo alfa per la seconda formula
c --------------------------------------------------------------
      alfa1 = abs(eq(1) * eq(2))
      alfa1 = alfa1/fnat
      alfa = alfa1 * alfa2
      if (itype.ne.1) alfa=alfa*2.
      if (scos.ne.0.0) goto 168
      if (ssin.gt.0.0) phicss=90.
      if (ssin.lt.0.0) phicss=270.
      if (ssin.eq.0.0) goto 200
      goto 169
  168 phicss=atan2(ssin,scos)*360./pi2
  169 iphics=phicss+sign(0.5,phicss)
      iphics=mod(iphics+3600,360)
      if (iphics.le.0) iphics=iphics+360
      if2=int(phive(n2))
      if2=if2-(if2/1000)*1000
      l2=isign(1,na2)
      if3=int(phive(n3))
      if3=if3-(if3/1000)*1000
      l3=isign(1,na3)
      iphivs=l2*if2+l3*if3
      iphivs = mod(iphivs,360)
      if (iphivs.le.0) iphivs = iphivs+360
c ------
c  controllo su alfa del seminvariante a fase ristretta
c ------
      if (itype.eq.1) go to 175
      phiu=(ang(itypu)*360.)/pi2
      iphiu=phiu+sign(0.5,phiu)
      iphiu=l2*iphiu
      phiv=(ang(itypv)*360.)/pi2
      iphiv=phiv+sign(0.5,phiv)
      iphiv=l3*iphiv
      iphic=iphiu+iphiv
      iphic=mod(iphic+3600,360)
      if (iphic.le.0) iphic=iphic+360
      idelta=iphics-iphic
      vcos=cos((idelta*pi2)/360.)
      alfar=alfa*vcos
      iphas=iphic
      if(alfar.lt.0.0) iphas=iphas+180
      iphas=mod(iphas,360)
      if(iphas.le.0) iphas=iphas+360
      alfa=abs(alfar)
      iphics=iphas
  175 continue
      jphic=iphics
      idm1=(na2+500)*1000000+(na3+500)*1000+jphic
      alpha=abs(alfa)
      if (itype.eq.1) alpha=-alpha
      if (alfa.le.0.4) go to 200
      nsem2=nsem2+1
      if(istamp.ne.0)
     *write(lo,180) nsem2,na2,(hklt(j,2),j=1,3),et(2),if2,
     1 na3,(hklt(j,3),j=1,3),et(3),if3,alfa,iphics,iphivs
  180 format(/,' *** code *** ',i4,2(i4,'* (',3i3,')',f6.2,i5),
     1 '  alfa ',e12.5,' phic = ',i5,' phiv = ',i5)
c---- store two_phase ss's in dmat
      if (nsem2.le.500) go to 847
      nsem2=nsem2-1
      call sort3s(dmat,nsem2)
      nsem2=401
  847 dmat(1,nsem2)=idm1
      dmat(2,nsem2)=alpha*1000
      dmat(3,nsem2)=iphivs
      nsem2t=nsem2t+1
      limi(nord+1)=limi(nord+1)+1
      itab(nsem2t)=idm1
      itab1(nsem2t)=alpha*1000
  200 if(istamp.ne.0) istamp=0
  201 continue
   40 continue
      do 1970 nl=2,1001
 1970 limi(nl)=limi(nl)+limi(nl-1)
      call sort3s(dmat,nsem2)
      if(nsem2.gt.400) nsem2=400
c---- riscalamento argomenti seminvarianti
      gsom2=0.
      nscal=min0(400,nsem2)
      do 2040 i=1,nscal
      jg=iabs(dmat(2,i))
      g=float(jg)/1000.
      gsom2=gsom2+g
 2040 continue
      if(jopt.ne.0) go to 2046
      do 2045 i=1,n8
      call unpak3(isig(3,i),jg,jg1,is)
      gv(i)=float(jg1)/100.
 2045 continue
 2046 continue
      call sortgs(gv,n8)
      gs=0.
      do 2047 i=1,nscal
      gs=gs+gv(i)
 2047 continue
      gk= gsom2/gs
      if(gk.lt.1.) gk=1.
      gk=gk*2.
      ii=0
      do 2060 i=1,nsem2
      alpha=float(dmat(2,i))/1000.
      alpha=alpha/gk
      if(icent.eq.0)alpha=alpha*0.8
      if(icent.eq.1)alpha=alpha*0.6
      if(abs(alpha).gt.6.00) alpha=6.00
      if(abs(alpha).lt.0.4) goto 2060
      ii=ii+1
      dmat(1,ii)=dmat(1,i)
      dmat(2,ii)=alpha*1000.
      dmat(3,ii)=dmat(3,i)
 2060 continue
      nsem2=ii
c      inserire  blocco  istruzioni  da  opts.f
      if(ipripe.gt.0) write(lo,16)
   16 format(///,120('+'),//,
     1 39x,'***   two-phase seminvariants section   ***',//)
      if(ipripe.gt.0) write(lo,2215)
 2215 format(20x,'first representation formula will be used',/)
      if(ipripe.gt.0) write(lo,2217) jenu1,soge1
 2217 format(20x,'n. of reflections to search s.s.i. = ',i5,
     *'  with  /E/ .ge.', f7.3,/)
      call sors2(dmat,ari,nari,numrp,foms2,nusba)
      istor=numrp+nsem2g
      if(istor.eq.0) return
      result(2,1)=nsem2t
      result(2,2)=istor
      if (knw.eq.0.or.nari.eq.0.or.iprin.eq.0) go to 1510
      ari=ari/float(nari)
      write(lo,2222) ari
 2222 format(60x,'ari = ',f8.4,/)
      write(lo,2223) foms2
 2223 format(60x,'foms2 = ',f8.4,/)
c---- prints the number of seminvariants
 1510 if(iprin.ne.0) then
                       write(lo,333) numrp
                       if (nsem2g.ne.0) write(lo,334) nsem2g
                       if(knw.eq.0) goto 4500
c----
c   stampa statistiche
c----
                       write(lo,5500) nusba
 5500 format(//,1x,'serial number of the first wrong ',
     * 'relationship =',i5,//)
                       if(icent-1)4300,4400,4400
c--  stampa il test (non centro)
 4300 call nstst(0)
      go to 4500
c--  stampa il test (centro)
 4400 call stst(0)
 4500 continue
                   endif
  333 format(20x,'n. of first rank s.s.i   (restricted-phase)   =',i6)
  334 format(20x,'n. of first rank s.s.i.    (general phase)    =',i6)
      return
      end
c----------------------------------------------------------------------
      subroutine find1(nord,phic,isbat)
      common /dirg/ jss1,jopt,jss2
      common /dir1/ jboth,jrepr,jeli1,jenu1,jknum,soge1,sogk
      common /dir2/ jenu2,glim,soge2,eplim,nca(2)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,dumy
      common /inv/  invma(96,3,3),idivv(48)
      common /cost/ pi2,jxa,jxb,jxx,nk1,lfl,nrif,mult,nsem,itype,ang(24)
      common /choi/ mm,iimax,jmax,nsj,jtable(8,16),invet(48)
      common /pro/  jvarma(3,3),kx(3),idoub,kkk,sump(2),icros,
     * jhkl(3),e,scr2(2),ns,sr2(2),  hklt(3,3),nsemc,nsemg
      common /pross2/ nquar,e2,et(3),ishi,eq(10),epsi(10),iep231,iep132,
     1 jdelta,duen,ssin,scos,istamp,nb1,nb2,nb3,nb4,ns1,ns2,ns3,ns4,ikkk
     2 ,nsu(2),ess(4),jcb(3),sden
      common/xdata/isr(100000),matse(350,3),little(350,24,3),limi(9001),
     1 idopp(1000),iel(350),phive(350),list1(1000,2),list2(1000,5),nlis,
     2 gq(8000),gv(8000),idummy(48),dummpc(84000)
      integer var1(3),var2(3),stlh1,sx(3),jx(3),jxc(3)
      integer isegn(3),incr(3),inf(3),sup(3),hklt
      dimension esp(2)
c
      indt=kkk
      ehkl=e
      eps1=ehkl*ehkl-1.0
      stlh1=iabs(jhkl(1))+iabs(jhkl(2))+iabs(jhkl(3))
      ifla1=0
      ifla2=0
      ifla3=0
      if (nquar.eq.1) go to 7
      isbat=0
      e51=e
      do 4 i=1,3
    4 jx(i)=hklt(i,2)
      call equiv(jx,sx,kkk,ind)
      do 1 i=1,3
    1 jxc(i)=sx(i)
      do 3 i=1,3
    3 sx(i)=sx(i)+hklt(i,3)
      call indr(sx,ind)
      if (ind.le.0) go to 7
      e52=isr(ind)
      e52=e52/1000.0
      if (abs(e52).lt.e51) go to 7
      isbat=1
      return
    7 do 8 i=1,3
      isegn(i)=kx(i)
      var1(i)=i
      inf(i)=0
      sup(i)=0
    8 var2(i)=0
      do 10 j=1,3
      do 10 i=1,3
      if (jvarma(i,j).ne.0) var2(j)=j
   10 continue
      do 20 i=1,3
      if (var2(i).eq.0) go to 20
      max=ihx(i)
      ihxi=ihx(i)
      inf(i)=max0(-max-kx(i),-ihxi)
      sup(i)=min0(max+kx(i),ihxi)
   20 continue
      iinf1=inf(1)
      isup1=sup(1)
      do 50 i=iinf1,isup1
      iinf2=inf(2)
      isup2=sup(2)
      if (var2(1).ne.var2(2)) go to 21
      if (var2(1).eq.0) go to 21
      ifla1=1
      iinf2=0
      isup2=0
   21 continue
      do 40 j=iinf2,isup2
      jjj=j
      if (ifla1.eq.1) jjj=i
      iinf3=inf(3)
      isup3=sup(3)
      if (var2(1).ne.var2(3)) go to 22
      if (var2(1).eq.0) go to 22
      ifla2=1
      iinf3=0
      isup3=0
      go to 23
   22 continue
      if (var2(2).ne.var2(3)) go to 23
      if (var2(2).eq.0) go to 23
      ifla3=1
      iinf3=0
      isup3=0
   23 continue
      do 30 l=iinf3,isup3
      i1=i
      j1=jjj
      l1=l
      if (ifla2.eq.1) l1=i1
      if (ifla3.eq.1) l1=j1
      incr(1)=i1
      incr(2)=j1
      incr(3)=l1
      do 250 ii=1,3
      var1(ii)=0
      do 250 jj=1,3
  250 var1(ii)=var1(ii)+jvarma(ii,jj)*incr(jj)
      do 25 k=1,3
      kx(k)=var1(k)+isegn(k)
      if (iabs(kx(k)).gt.ihx(k)) go to 29
   25 continue
      e2=-999.99
      if (kx(1).eq.0.and.kx(2).eq.0.and.kx(3).eq.0) go to 29
      call indr(kx,ind2)
      if (ind2.le.0.0) go to 29
      ist=isr(ind2)
c
c---- if (e.lt.0.0) then we have considered the reflection yet
c----    (ist=e*1000)
c
      if (ist.lt.0) go to 29
c
c---- rende negativo il valore di  'e'  e di tutti gli  'e'
c---- equivalenti attraverso  'equi'  in modo che in seguito
c---- non venga piu' utilizzato. inoltre memorizza l'indirizzo
c---- in idopp in modo da resettare il reciproco una volta
c---- completati i calcoli per il s.s.i. in esame.
c
      e2=float(ist)/1000.0
      if (istamp.ne.0) write(lo,6999) kx,e2,kkk,ikkk
 6999 format(1h ,' kx',3i5,' e2',f7.2,' kkk',i5,' ikkk',i5)
      call mark(kx,nord,idoub,jhkl)
      if (iflag.eq.1) go to 80
      icros=icros+1
      eps2=e2*e2-1.0
      if (e2.eq.ehkl) eps2=(eps2-2.0)/3.0
c
c---- se nquar = 1 ( stima ss1 )
c---- se nquar = 2 ( stima ss2 )
c
      if(nquar.eq.1) goto 291
c---- marco -h1rm nel caso in cui rm e' di ordine 2
      do 283 jc8=1,2
  283 nsu(jc8)=0
      do 285 jc8=1,4
  285 ess(jc8)=0.0
      call quart (nord)
      go to 2828
  291 prod=0.0
      do 295 nn=1,3
  295 prod=prod+kx(nn)*tmat(indt,nn)
      prod=pi2*prod
      esp(1)=cos(phic-prod)
      esp(2)=sin(phic-prod)
      coef=1.0
      if (e2.gt.0.4.and.e2.lt.0.9) go to 28
c
c---- check over sin(theta)/lambda
c
      icodh=iabs(kx(1))+iabs(kx(2))+iabs(kx(3))
      icodh=icodh*stlh1
c
c---- if ( h2 = h/2 )   then   coef = 1/2
c----                   else   coef =  1
c
      if (jhkl(1)/2.eq.kx(1).and.
     *    jhkl(2)/2.eq.kx(2).and.
     *    jhkl(3)/2.eq.kx(3)) coef=0.5
      if (icodh.le.20) go to 28
      if (jrepr.eq.2) call secrep(esp,ehkl,e2,eps2,eps1,nord,coef)
      go to 290
   28 continue
      sr2(1) = sr2(1)+coef*eps2*esp(1)
      sr2(2) = sr2(2)+coef*eps2*esp(2)
  290 continue
      sump(1)=sump(1)+coef*eps2*esp(1)
      sump(2)=sump(2)+coef*eps2*esp(2)
      if (jrepr.eq.1) sr2(1)=sr2(1)+coef*eps2*esp(1)
      if (jrepr.eq.1) sr2(2)=sr2(2)+coef*eps2*esp(2)
 2828 continue
      if (nquar.eq.1) go to 29
c 
      a = epsi(3) + epsi(6)
      if(ikkk.eq.0) a = a+epsi(7)+epsi(9)
      b = epsi(3)*epsi(5)+epsi(6)*epsi(8)+2*epsi(3)*epsi(6)
      if(iep231.eq.0) b = b + 2*epsi(3)*epsi(7)
      if(iep132.eq.0) b = b + 2*epsi(6)*epsi(9)
      if(ikkk.eq.0) b = b + 2 * (epsi(7)*ess(1) + epsi(9)*ess(2) +
     * ess(2)*ess(3) + ess(1)*ess(4))
      h4e31= h4(eq(3))
      h4e32= 0.0
      if(epsi(6).ne.0.0) h4e32= h4(eq(6))
      c1 = epsi(3)*epsi(6) + epsi(3)*epsi(7) + epsi(6)*epsi(9)
      c2 = c1*epsi(1)
      c3 = c1*epsi(2)
      proe = epsi(1)*epsi(2)
      c4 = proe * epsi(5)
      c5 = proe * epsi(8)
      c = 0.25*h4e31*epsi(5) +0.25*h4e32*epsi(8) + c2 +
     * c3 + c4 + c5
      if(ikkk.ne.0) goto 65
      c1kkk=0.0
      if(epsi(9).ne.0.0) c1kkk=c1kkk+0.25*h4(eq(9))*epsi(5)
      if(epsi(7).ne.0.0) c1kkk=c1kkk+0.25*h4(eq(7))*epsi(8)
      c2kkk = epsi(1)*epsi(9)*ess(2) + epsi(1)*epsi(7)*ess(1)
     *      + epsi(2)*epsi(9)*ess(2) + epsi(2)*epsi(7)*ess(1)
      c3kkk = epsi(1)*ess(2)*ess(3)  + epsi(1)*ess(1)*ess(4)
     *      + epsi(2)*ess(2)*ess(3)  + epsi(2)*ess(1)*ess(4)
      c = c + c1kkk + c2kkk + c3kkk
   65 continue
      if (c.lt.0.0) c = 0.0
      qj =  a + b
      deltaj = jdelta * 15.0
      argj=deltaj*pi2/360.
      ssin = ssin + qj * sin(argj)
      scos = scos + qj * cos(argj)
      if(istamp.ne.0)write(lo,70)  qj,argj,ssin,scos
   70 format('0  qj, deltaj ',2f10.3,' ssin,scos ',2f10.3)
   29 continue
      if (ifla2.eq.1.and.ifla1.eq.1) go to 50
      if (ifla2.eq.1) go to 40
      if (ifla3.eq.1) go to 50
   30 continue
      if (ifla1.eq.1) go to 50
   40 continue
   50 continue
   80 continue
      if (iflag.eq.1) nquar=-nquar
      return
      end
c----------------------------------------------------------------------
      subroutine quart(nord)
c
      common /dir1/ jboth,jrepr,jeli1,jenu1,jknum,soge1,sogk
      common /dir2/ jenu2,glim,soge2,eplim,nca(2)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
c
      common /pro/  jvarma(3,3),kx(3),idoub,kkk,sump(2),icros,
     * jhkl(3),e,src2(2),ns,sr2(2),  hklt(3,3),nsemc,nsemg
      common /pross2/ nquar,e2,et(3),ishi,eq(10),epsi(10),iep231,iep132,
     1 jdelta,duen,ssin,scos,istamp,nb1,nb2,nb3,nb4,ns1,ns2,ns3,ns4,ikkk
     2 ,nsu(2),ess(4),jcb(3),sden
      common/xdata/isr(100000),matse(350,3),little(350,24,3),limi(9001),
     1 idopp(1000),iel(350),phive(350),list1(1000,2),list2(1000,5),nlis,
     2 gq(8000),gv(8000),idummy(48),dummpc(84000)
      integer hklt,sx(3),jx(3),jjx(3),hklq(10,3),hkls(4,3)
      dimension eqs(4)
c
c-------------- informazioni utili ------------------------------------
c
c   hklt(3,3)           h,k,l, della tripletta memorizzati per colonna
c   et(3)               e della tripletta
c
c----------------------------------------------------
c
      iq=0
      nin=1
      nfi=4
      call azzero(eqs,ess,nin,nfi)
      do 5 jc8=1,4
      do 5 jc9=1,3
    5 hkls(jc8,jc9)=0
c
c-- caricamento della matrice hklq relativamente ai base
c
      do 10 j=1,3
   10 hklq(1,j)=hklt(j,2)
      do 20 j=1,3
   20 hklq(2,j)=hklt(j,3)
      do 30 j=1,3
   30 hklq(3,j)=-kx(j)
c----
c-- calcolo di h1 * rm  ( quarto base del quartetto)
c----
      call equiv(kx,sx,kkk,ind)
      do 40 j=1,3
   40 hklq(4,j)=sx(j)
c
c ---
c    controllo  su  h1 * i = - h1 * rm
c           iep231 = 1 non va calcolato epsi(23,1) = epsi(7)
c           iep231 = 1 anche quando  u1 * i = - u1 * rm
c ---
      nb3=1
      if(istamp.ne.0)write(lo,62)
   62 format(/)
      if(iep231.ne.0) go to 66
      iep231=0
      isum=0
      do 63 j=1,3
   63 isum=isum-hklq(3,j)+hklq(4,j)
      if (istamp.ne.0) write(lo,65)(hklq(3,j),j=1,3),(hklq(4,j),j=1,3)
   65 format('  controllo su h1*i=-h1*rm ',3i5,10x,3i5)
      if(isum.ne.0) go to 64
      iep231=1
   64 continue
   66 if (iep231.ne.0) nb3=0
c
c-- calcolo del deltashift del quartetto
c   delh1 = h1 * tm
c
      delh1=0
      delh1=kx(1)*tmat(kkk,1)+kx(2)*tmat(kkk,2)+kx(3)*tmat(kkk,3)
      kdelh1=nint(delh1*24.)
      kdelh1=mod(kdelh1,24)
      if(kdelh1.lt.0) kdelh1=kdelh1+24
      jdelta=-ishi+kdelh1
c
c-- caricamento della matrice hklq relativamente ai cross
c
      do 70 j=1,3
   70 hklq(5,j)=hklq(1,j)+hklq(2,j)
c ---
c  calcolo di -h2 * rbeta e controllo esistenza del suo e
c ---
      do 80 j=1,3
   80 hklq(6,j)=hklq(1,j)+hklq(3,j)
      do 85 j=1,3
   85 sx(j)=hklq(6,j)
      call indr (sx,ind)
      if (ind.gt.0) go to 86
      iq=1
      go to 88
   86 if(isr(ind).ne.-1000) goto 87
      iq=1
      goto 88
c ----------------------------------------------------------
c    controllo  su  h2rbeta * i = - h2rbeta * rm
c           iep132 = 1 non va calcolato epsi(13,2) = epsi(9)
c           iep132 = 1 anche quando  u2 * i = - u2 * rm
c ----------------------------------------------------------
   87 nb4=1
      if(istamp.ne.0)write(lo,62)
      if(iep132.ne.0) go to 166
      iep132=0
      isum=0
      do 162 j=1,3
  162 jx(j)=-hklq(6,j)
      call equiv(jx,sx,kkk,ind)
      do 163 j=1,3
  163 isum=isum-hklq(6,j)+sx(j)
      if (istamp.ne.0) write(lo,165)(hklq(6,j),j=1,3),(sx(j),j=1,3)
  165 format('  controllo su h2rbeta*i=-h2rbeta*rm ',3i5,4x,3i5)
      if(isum.ne.0) go to 164
      iep132=1
  164 continue
  166 if(iep132.ne.0) nb4=0
c----
c----  calcolo  u(23,1)
c----
   88 do 89 j=1,3
      hklq(7,j)=hklq(2,j)+hklq(3,j)
   89 jx(j)=hklq(7,j)
c----
c---- marco  u(s,1)   nel  caso  che  rm  sia  di  ordine  2
c----
      if(istamp.ne.0) write(lo,2323)jcb
 2323 format('  u1(i+rm)  ',3i5)
      if(ikkk.ne.0)  goto 91
      call equiv(jx,sx,kkk,ind)
      if(ind.le.0) goto 91
c----
c---- h1 + u1(i+rm)
c----
      if( (nb1+nb3).ne.2)  goto 200
      nsu(1)=1
      do 196 jc8=1,3
  196 hkls(1,jc8)=kx(jc8)+jcb(jc8)
      do 198 jc8=1,3
  198 sx(jc8)=hkls(1,jc8)
      call indr(sx,ind)
      if(ind.le.0) goto 200
      e7=isr(ind)
      e7=e7/1000.
      eqs(1)=e7
      ess(1)=e7*e7-1.
  200 continue
      call mark(sx,nord,idoub,jhkl)
c----
c---- calcolo u(12,2)
c----
   91 do 92 j=1,3
   92 sx(j)=hklq(1,j)
      call equiv(sx,jx,kkk,ind)
      do 93 j=1,3
   93 hklq(8,j)=jx(j)+hklq(2,j)
c----
c---- calcolo u(13,2)
c----
      do 94 j=1,3
      hklq(9,j)=jx(j)+hklq(6,j)
   94 jx(j)=-hklq(9,j)
c----
c---- marco  -u(13,2)   nel  caso  che  rm  sia  di  ordine 2
c----
      if(ikkk.ne.0)  goto 96
      if(iq.eq.1) goto 96
      call mark(jx,nord,idoub,jhkl)
      if(istamp.ne.0)write(lo,2325) jx
2325  format(' asterisco -u(13,2) ', 3i8)
c----
c---- -h2rbeta + u1(i+rm)
c----
      if( (nb1+nb4).ne.2)  goto 210
      nsu(2)=1
      do 202 jc8=1,3
  202 hkls(2,jc8)=hklq(6,jc8)+jcb(jc8)
      do 204 jc8=1,3
  204 sx(jc8)=hkls(2,jc8)
      call indr(sx,ind)
      if(ind.le.0) goto 210
      e7=isr(ind)
      e7=e7/1000.
      eqs(2)=e7
      ess(2)=e7*e7-1.
  210 continue
c----
c---- marco   u(13,2)rm    nel  caso  che  rm  sia  di  ordine 2
c----
      do 95 jc8=1,3
   95 jx(jc8)=+hklq(9,jc8)
c----
c---- calcolo u(23,2)
c----
   96 do 97 j=1,3
   97 hklq(10,j)=hklq(2,j)+hklq(6,j)
c
      nin=5
      nfi=10
      call azzero (eq,epsi,nin,nfi)
      eq(1)=et(2)
      eq(2)=et(3)
      eq(3)=e2
      eq(4)=e2
      do 98 i=1,4
   98 epsi(i)=eq(i)*eq(i)-1.
      nin=5
      nfi=10
      if(iq.eq.1) nfi=7
      do 100 j=nin,nfi
c --------
c   iep231 = 1 implica epsi(23,1) = epsi(7) = 0.0
c   iep132 = 1 implica epsi(13,2) = epsi(9) = 0.0
c --------
      if (iep231.ne.0.and.j.eq.7) go to 100
      if (iep132.ne.0.and.j.eq.9) go to 100
      do 99 i=1,3
   99 sx(i)=hklq(j,i)
      call indr(sx,ind)
      if (ind.le.0) go to 100
      e7=isr(ind)
      eq(j)=e7/1000.0
      epsi(j)=eq(j)*eq(j)-1.
  100 continue
c----
c----  caso in cui  rm  risulta essere di ordine  2
c----
      if(ikkk.ne.0) goto 240
      if(nsu(2).eq.0) goto 230
      if(iq.eq.1) goto 230
c----
c----   u(13,2) + u1(i+rm)
c----
      do 212 jc8=1,3
  212 hkls(3,jc8)=hklq(9,jc8)+jcb(jc8)
      do 214 jc8=1,3
  214 sx(jc8)=hkls(3,jc8)
      call indr(sx,ind)
      if(ind.le.0) goto 230
      e7=isr(ind)
      e7=e7/1000.
      eqs(3)=e7
      ess(3)=e7*e7-1.
  230 continue
      if(nsu(1).eq.0) goto 240
c----
c----   u(23,1) - u1(i+rm)
c----
      do 242 jc8=1,3
  242 hkls(4,jc8)=hklq(7,jc8)-jcb(jc8)
      do 244 jc8=1,3
  244 sx(jc8)=hkls(4,jc8)
      call indr(sx,ind)
      if(ind.le.0) goto 240
      e7=isr(ind)
      e7=e7/1000.
      eqs(4)=e7
      ess(4)=e7*e7-1.
  240 continue
      if(abs(eqs(2)).eq.abs(eq(6)).and.
     *   abs(eqs(3)).eq.abs(eq(3)) )    goto 247
      if(abs(eqs(1)).eq.abs(eq(3)).and.
     *   abs(eqs(4)).eq.abs(eq(6)) )    goto 248
      goto 245
  247 eqs(2)=-1.0
      ess(2)=0.0
      eqs(3)=-1.0
      ess(3)=0.0
      goto 245
  248 eqs(1)=-1.0
      ess(1)=0.0
      eqs(4)=-1.0
      ess(4)=0.0
  245 if(istamp.ne.0)
     *write(lo,250) ((hklq(i,j),j=1,3),eq(i),i=1,7),jdelta,kdelh1
      do 112 i=1,3
  112 sx(i)=+hklq(1,i)
      call equiv(sx,jx,kkk,ind)
      if (iq.eq.1) go to 300
      do 114 i=1,3
  114 sx(i)=-hklq(6,i)
      call equiv(sx,jjx,kkk,ind)
      if(istamp.ne.0)
     * write(lo,252)jx,(hklq(2,j),j=1,3),(hklq(6,j),j=1,3),jjx,
     * ((hklq(i,j),j=1,3),eq(i),i=8,10)
      if(istamp.ne.0)write(lo,251)
     * ((hkls(i,j),j=1,3),eqs(i),i=1,4)
  250 format(1h ,7(3i3,f7.2,1h*),i4,i4)
  251 format(1h ,51x,4(3i3,f7.2,1h*))
  252 format(1h ,4(3i3,7x,1h*),3(3i3,f7.2,1h*),i4)
  300 return
      end
c----------------------------------------------------------------------
      subroutine azzero  (eq,epsi,nin,nfi)
      dimension eq(10),epsi(10)
      do 90 i=nin,nfi
      eq(i)=-1.0
   90 epsi(i)=0.0
      return
      end
c--------------------------------------------------------------------
      subroutine sort3s(dmat,nsem2)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      integer dmat(3,500)
c
      if (nsem2.gt.1) go to 100
      if (nsem2.le.0) write(lo,110)
      iflag=1
      return
  100 continue
      k=1
    1 k=2*k
      if (k.lt.nsem2) go to 1
      k=k/2
    7 l=nsem2-k
      j=1
    6 if (j.gt.l) go to 2
      i=j
    5 ik=i+k
      m=i
    4 ix=iabs(dmat(2,m))
      mj=m+k
      iy=iabs(dmat(2,mj))
      if (ix.ge.iy) go to 3
      icom=dmat(1,m)
      dmat(1,m)=dmat(1,mj)
      dmat(1,mj)=icom
      icom=dmat(2,m)
      dmat(2,m)=dmat(2,mj)
      dmat(2,mj)=icom
      icom=dmat(3,m)
      dmat(3,m)=dmat(3,mj)
      dmat(3,mj)=icom
      m=m-k
      i=ik
      if (m.gt.0) go to 4
    3 i=i+k
      if (i.le.l) go to 5
      j=j+1
      if (j.le.k) go to 6
    2 k=k/2
      if (k.gt.0) go to 7
      return
  110 format(//,' **********  warning  **********',/
     1         ,'     no seminvariants exist     ',/
     2         ,'        program is killed       ',/
     3         ,'********************************',//)
      end
c-----------------------------------------------------------------------
      subroutine sors2(dmat,ari,nari,numrp,foms2,nusba)
c---- sort seminvariants stored in 'dmat'
      common /dirg/ jss1,jopt,jss2
      common /dir1/ jboth,jrepr,jeli1,jenu1,jknum,soge1,sogk
      common /dir2/ jenu2,glim,soge2,eplim,nca(2)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /ss2c/ ip,ku(3),eu,kva(3),ev,kn,epsu,epsv,nsem2,nsem2g
      common /inp/  natom,fnat,satm,dumy
      common /inv/  invma(96,3,3),idivv(48)
      common /cost/ pi2,jxa,jxb,jxx,nk1,lfl,nrif,mult,nsem,itype,ang(24)
      common /choi/ mm,iimax,jmax,nsj,jtable(8,16),invet(48)
      common /pro/  jvarma(3,3),kx(3),idoub,kkk,sump(2),icros,
     * jhkl(3),e,scr2(2),ns,sr2(2),jhimrn(3,3),nsemc,nsemg
      common/xdata/isr(100000),matse(350,3),little(350,24,3),limi(9001),
     1 idopp(1000),iel(350),phive(350),list1(1000,2),list2(1000,5),nlis,
     2 gq(8000),gv(8000),idummy(48),dummpc(84000)
      common/tst/nt8,ar(26),nn(11,26,3),pp(11,26,3)
      common /nctst/nt9,br(15),nb(11,15,3),fnb(11,15,3),bcm(11,15,3),
     *                        acm(11,15,3)
      character rescha(13)*9,linex(2)*9
      integer num(400),hklu(3),hklv(3),jtype(400)
      dimension nrif1(400),nrif2(400),iphi(400),alpha(400)
      integer dmat(3,500)
      data iplus,iblan,istar/1h+,1h ,1h*/
      data ibla2,iccc,ibbn/2h  ,2hrp,2h n/
      data rescha/'   any   ','         ','  30,210 ','  45,225 ',
     *'  60,240 ','         ','  90,270 ','         ',' 120,300 ',
     *' 135,315 ',' 150,330 ','         ','   0,180 '/
c
      vec(x) = amin1((x+0.4807)*x/((x+0.8636)*x +
     *  1.3943),1.0)
c
      if (nsem2.eq.0) then
                      write(lo,10)
   10 format(//,' **********  warning  **********',/
     1         ,' *    no seminvariants exist   * ',/
     2         ,' *******************************',//)
                      return
                     endif
c--  prepara il buffer per il test non centro
      if(icent.eq.0) call nclrt
c--  prepara il buffer per il test centro
      if(icent.eq.1) call clrt
      nusba=0
      nari=0
      ns2f=0
      igg=0
      do 20 i=1,nsem2
      ia=1
      ipk=dmat(2,i)
      if (ipk) 18,19,19
   18 ia=-1
      ipk=iabs(ipk)
   19 alpha(i)=float(ipk)/1000.0
      jtype(i)=ia
      iak=dmat(1,i)
      ia=1
      if (iak.lt.0) ia=-1
      iak=iabs(iak)
      nr1=iak/1000000
      nrif1(i)=nr1-500
      jj=nr1*1000000
      nr2=(iak-jj)/1000
      nrif2(i)=nr2-500
      iphi(i)=iak-jj-nr2*1000
      nrif2(i)=nrif2(i)*ia
   20 continue
      call sorts(num,alpha,nsem2,400)
      if(ipripe.gt.0) write(lo,110)
      if (knw.eq.0) then
                      if(ipripe.gt.0) write(lo,115)
                    else
                      if(ipripe.gt.0) write(lo,118)
                    endif
      conv=pi2/360.0
      test=conv*90
      ctest=cos(test)
      nsem2g=0
      numrp=0
      iconts=min0(10,nsem2)
c ++++++++++++++++++++++++++++++++++++++++++++++++++++
      foms2=0.0
      sg2=0.0
c ++++++++++++++++++++++++++++++++++++++++++++++++++++
      do 30 i=1,nsem2
      j=num(i)
      jpont1=iabs(nrif1(j))
      jpont2=iabs(nrif2(j))
      i1=nrif1(j)
      itypu=phive(jpont1)
      itypu=itypu/1000
      write(linex(1),4056)rescha(itypu)
 4056 format(a9)
      iphiu=phive(jpont1)-itypu*1000
      eu=iel(jpont1)
      eu=eu/1000.0
      isegn=iplus
      ise=1
      i2=nrif2(j)
      itypv=phive(jpont2)
      itypv=itypv/1000
      write(linex(2),4056)rescha(itypv)
      iphiv=phive(jpont2)-itypv*1000
      ev=iel(jpont2)
      ev=ev/1000.0
      do 25 k=1,3
      hklu(k)=little(jpont1,1,k)
      hklv(k)=little(jpont2,1,k)
   25 continue
      ig2=iccc
      prob=0.5
      ll=jtype(j)
      if (ll.lt.0) go to 26
      numrp=numrp+1
      ig1=ibla2
      prob=0.5+0.5*tanh(alpha(i))
      go to 27
   26 continue
      nsem2g=nsem2g+1
      igg=1
      ig1=ibbn
   27 iphit=dmat(3,j)
      iphic=iphi(j)
      dphi=iphit-iphic
      if (dphi.lt.0.0) dphi=iphic-iphit
      dphi=dphi*conv
      cdphi=cos(dphi)
      ias=iblan
      itest=1
      if (cdphi.gt.ctest) go to 28
      itest=-1
      ias=istar
   28 ari=ari+(prob-0.5)*itest
      nari=nari+1
c +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c   calcolo  foms2  come  da foms
c +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      delta=iphit-iphic
      delta=amod(delta+36000,360.)
      foms2=foms2+alpha(i)*cos(delta*conv)
      sg2=sg2+alpha(i)*vec(alpha(i))
c +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      eu=abs(eu)
      ev=abs(ev)
      if(i.le.iconts) then
                       if(ipripe.gt.0) then
                       if(knw.eq.0) then
                                 write(lo,210)i1,(hklu(k),k=1,3),eu,
     1                               linex(1),i2,(hklv(k),k=1,3),ev,
     2                               linex(2),iphic,alpha(i)
                                    else
                                 write(lo,212)i1,(hklu(k),k=1,3),eu,
     1                                 iphiu,i2,(hklv(k),k=1,3),ev,
     2                                 iphiv,iphit,iphic,alpha(i),ias
                                    endif
                                       endif
                      endif
  210 format(9x,i4,1h),1x,3i3,f7.3,a9,
     1   1x,i4,1h),1x,3i3,f7.3,a9,4x,i4,3x,f9.3)
  212 format(9x,i4,1h),1x,3i3,f7.3,2x,i4,
     1 4x,i4,1h),1x,3i3,f7.3,2x,i3,6x,i4,5x,i4,2x,f9.3,a1)
c----
c      call of stat subroutine
c----
      if (knw.eq.1) call stats(alpha(i),iphit,iphic,ias,nusba,i)
      if (alpha(i).ge.glim) ns2f=ns2f+1
      ise=1
      call jpack2(dmat(1,i),dmat(2,i),i1,ise,i2,alpha(i),iphic)
   30 continue
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      if(sg2.ge.0.0001) foms2=foms2/sg2
      if(ipripe.gt.0) then
                        if(nsem2.gt.iconts) write(lo,230)
                        write(lo,240)
                      endif
      if (igg.eq.1.and.iprin.ne.0) write(lo,250)
      if (knw.eq.1.and.ipripe.gt.0) write(lo,245)
c ---
c     call sub. scrittura lista 23 : seminvarianti a due fasi
c ---
      iprea=0
      call frmxx(iprea,23,nsem2,nsem2,ns2f,nxxe,iccd,dmat)
      iprin=0
      return
  110 format(//,26x,' List of two-phase structure',
     2 ' seminvariants estimated',//)
  115 format(10x,'code     H(1)     E   ph.rest.',
     2        2x,'code     H(2)     E   ph.rest.',
     3 '    phase      alpha',/,8x,86(1h-))
  118 format(10x,'code     H(1)      E  ph.true',
     2        3x,'code     H(2)      E  ph.true',
     3 '  ph.true  ph.calc    alpha',/,8x,90(1h-))
  230 format(/,14x,' .... and so on',/)
  240 format(1h ,/)
  245 format(20x,'seminvariants marked with * are wrongly estimated',/)
  250 format(20x,'for nrp seminvariants alpha is equal to  1/2',
     1'  the argument of  io bessel  function',//)
      end
c----------------------------------------------------------------------
      subroutine stats(g,iphit,iphic,ias,nusba,i)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym2/msym,nsym2,nsym,icent,s3s2
c
      common/tst/nt8,ar(26),nn(11,26,3),pp(11,26,3)
      common /nctst/nt9,br(15),nb(11,15,3),fnb(11,15,3),bcm(11,15,3),
     *                        acm(11,15,3)
      common /cost/ pi2,jxa,jxb,jxx,nk1,lfl,nrif,mult,nsem,itype,ang(24)
      data ibl/1h /
      b=float(iphit)*pi2/360.
      a=cos(b)
      if (icent.gt.0) go to 4200
      g2=g
      call besse(g2,coat)
c--  esegue test non-centro
      call nctet(g2,coat,a,1)
      if(nusba.ne.0.or.ias.eq.ibl)go to 4001
      nusba=i
      go to 4001
 4200 gg=g
      an=a*g
      call sctst(gg,an,1)
      if(nusba.ne.0.or.ias.eq.ibl)go to 4001
      nusba=i
 4001 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine dirsem(ier)
      character line*80,dire*40,diret*80
      character blank,digit*12,card(100)*80,ffile*80
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /chara/ blank,digit,card,ffile
      common /dirg/ jss1,jopt,jss2
      common /dir1/ jboth,jrepr,jeli1,jenu1,jknum,soge1,sogk
      common /dir2/ jenu2,glim,soge2,eplim,nca(2)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      dimension vet(40),ivet(40)
c
c-- set default values
      iprin=0
      jss1=1
      jss2=1
      jopt=0
      jboth=0
      jenu1=0
      jenu2=0
      jeli1=0
      soge1=0.0
      soge2=1.4
      sogk=0.0
      jknum=0
      eplim=2.0
      glim=0.8
      jrepr=2
      istop=0
      nca(1)=0
      nca(2)=0
      ic=0
      icmax=icomq(icomat,2)
c
  100 continue
      ic=ic+1
      if (ic.gt.icmax) go to 9000
      ipdir=ipdir+1
      line=card(ipdir)
      diret=line
      call cutst(line,lenp,dire,lend)
      call lcase(dire)
c-- directives with numeric parameters
      iopt=0
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 8000
      if (dire(1:4).eq.'nss1') then
          if (iv.ne.0) go to 8000
          jss1=0
          go to 100
          endif
      if (dire(1:4).eq.'nss2') then
          if (iv.ne.0) go to 8000
          jss2=0
          go to 100
          endif
      if (dire(1:4).eq.'nopt') then
          if (iv.ne.0) go to 8000
          jopt=0
          go to 100
          endif
      if (dire(1:4).eq.'firs') then
          if (iv.ne.0) go to 8000
          jrepr=1
          go to 100
          endif
      if (dire(1:4).eq.'nrs1') then
          if (iv.ne.1) go to 8000
          jenu1=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'list') then
          if (iv.ne.0) go to 8000
          jeli1=1
          go to 100
          endif
      if (dire(1:4).eq.'both') then
          if (iv.ne.0) go to 8000
          jboth=1
          go to 100
          endif
      if (dire(1:4).eq.'prin') then
          if (iv.ne.1) go to 8000
          iprin=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'numk') then
          if (iv.ne.1) go to 8000
          numk=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'epli') then
          if (iv.ne.1) go to 8000
          eplim=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'glim') then
          if (iv.ne.1) go to 8000
          glim=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'nrs2') then
          if (iv.ne.1) go to 8000
          jenu2=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'code') then
          if (iv.eq.0) go to 8000
          ncris=min0(iv,2)
          do 150 i=1,ncris
  150     nca(i)=ivet(i)
          go to 100
          endif
      write(lo,6000) diret
 6000 format(' wrong directive on following line:',/a)
 8000 continue
      ier=-1
      return
 9000 continue
      if (iprin.gt.1) jboth=1
      if (jenu1.ne.0) soge1=1.4
      return
      end
