c     ----------------------------------------------------------------
c     generate complete hemisphere of reflexion data
      subroutine expand(powf,jpowd,numb2,ccfom,mode,istop,ier)
      character powf*80,cspace*16
      dimension cfom(2250),ep(3000),i1(3),i2(3),kind(24),tab(15)
      dimension ipos(302),lh(60),lk(60),ll(60),ew(60),ed(60)
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common /xdata/ ihkl(3000),e(3000),iphaz(3000),iphb(3000)
     *              ,wt(3000),duma(25000),dum12(80000),dummpc(124000)
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common /refl/ ih(100),g(2,100)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /kuse/ kuser1,kuser2,kuser3
      common /tran/ scale,mh(3),level,it4,xlim(3)
      common /tape/ cell(6),neqv,icent,lat,natm,ts(3,24),is(2,3,24),nsym
     *             ,dumb(3)
      common /misc/ t(3,3),dxmax(3),mcon,iwt,fom(11),pts
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /emap1/ fwhm,npor(3),npror,nngr11,npar11
      common /neutro/ neutro,bmat(2,98),neuwei,vetint(200)
      common /setequ/ jpatt,jpunt(501),ksacc,jseteq,jumpp
      dimension vet(12),ivet(12)
      equivalence (vet(1),ivet(1))
      equivalence (iphaz(1),ep(1),cfom(1))
      equivalence (ih(1),lh(1)),(ih(61),lk(1)),(g(1,11),ll(1)),
     1  (g(1,41),ew(1)),(g(1,71),ed(1))
c
      nexp=0
      call inptf(npseud,numb)
c
c     temporary call to prepare common area
c     to manage atoms in special position
c
      call xspinb
      if(jpatt.eq.0) then
      if (mode.eq.1) then
c
c-- standard Fourier
c
      if (jpowd.eq.1) then
                        call getpow(powf,numb,ier)
                        if (ier.lt.0) return
                        jmpsie=1
                        go to 180
                      endif
c
c     examine sets of phases in order of combined figure of merit unless
c     set is specified by the user
c
      call srlin (16,lsn,lfw,llw,lpb,ll16)
      if(lfw.gt.0) then
                     call ysfl16(cfom,ipos,nset)
                   else
                     ier=-1
                     return
                   endif
      if(numset.gt.0.and.numset.le.nset) goto 160
      if(numset.gt.0.and.numset.gt.nset) then
                                           write(lo,150) numset,nset
                                           ier=-1
                                           return
                                         endif
  150 format(/,' *** error ***  set ',i3,' has been required',/,
     *         '                but only ',i3,' sets are available')
c   select set
  160 if (numset.gt.0) then
                         no=numset
                         nono=ipos(numset)
                       else
                         npos = 1
                         do 170 j=1,nset
                         if (cfom(j) .gt. cfom(npos)) npos = j
  170                    continue
c     mark selected set
                         nono=ipos(npos)
                         cfom(npos) =  -cfom(npos)
                         call ysup16(cfom,ipos,nset)
                         no=npos
                       endif
      numset = no
      if (abs(cfom(no)).gt.1.0) then
                                      npe=abs(cfom(no))
                                      npe=1000-npe
                                      npe=npe+1
                                      call getrefs(numba,npe)
                                   else
                                      npe=1
                                      call getrefs(numba,npe)
                                   endif
c--
      call snr16(nono,fom,ep,iphb)
      numb=numba
c
c-- end of standard Fourier
c
                     else
c
c-- Fourier recycling
c
      call getref(numb,ngroup,ier)
      if (ier.lt.0) return
c
  436 format(//,1h ,79('+'),//,23x,
     1 '***   Fourier recycling section A ***',//, 9x,20a4,//,
     2 10x,i5,' ( over ',i5,' ) reflections used with Fo .gt. ',f8.2,/,
     3 18x,i5,' groups of overlapping reflections',//,
     4 8x,'Step      cycle         R(f)       Rw(f)      R(f**2)',/)
c
  437 format(//,1h ,79('+'),//,21x,
     1 '***   Fourier recycling restarted  ***',//, 9x,20a4,//,9x,
     3 '  In step B scale factor, atomic coordinates and isotropic',
     * /,13x,' thermal factors are refined via full matrix.',/)
c
      if (mode.eq.2) then
                       if (krecy.eq.1) errem=1.0
C                      if (bt.gt.0.0) then
C                                       biso=bt
C                                     else
C                                       biso=0.0
C                                     endif
                       if (jrest.eq.0)  then
                              if (krecy.eq.1) write(lo,436) 
     *                               itle,numb,nref,fosog,ngroup
                              if (krecy.eq.2) write(lo,437) itle
                                        endif
C                      do 438 i=1,nats
C 438                  bfac(i)=biso
                     endif
      if (jrest.eq.0) then
      if (krecy.eq.1) then
                        call sftra(mode,numb,ep)
                      else
                        call sftrb(mode,numb,ep)
                      endif
                       else
                        call sftrc(mode,numb,ep)
                        krecy=krecy+1
                      endif
      if (mode.lt.0) then
                       ier=-1
                       return
                     endif
      if (erre.lt.errem) then
                           errem=erre
                           interp=1
                           call frm15(nats,numset,interp)
                           lsx=(krecy-1)*10+mode-1
                           call cp1530 
                         endif
      if (istop.gt.0) return
c
c-- end of Fourier recycling
c
                     endif
  180 do 185 i=1,numb
      wt(i)    = ep(i)
      e(i)     = e(i)*ep(i)
      iphaz(i) = iphb(i)
  185 continue
c
c-- richiamo subr. gestione psi-e
CNEW----------------
      if (jmpsie.eq.0) then
                         if (mode.eq.1) then                  
                         write(lo,4490) npe
                         call gpsie(npe,numb,error,dalfa,nexp)
                         end if
                       endif
 4490 format(40x,'psi-e triplet(s) from serial list #',i6,/)
      numb2=numb
CNEW----------------
      if (jpowd.eq.0.and.mode.eq.1) then
      write(lo,187)
      write(lo,188)
      write(lo,189)
      write(lo,191)
      write(lo,193)
      write(lo,192)no,(fom(i),i=1,5)
      ccfom=fom(5)
      write(lo,187)
  187 format( 6x,'+------------',54('-'),'+')
  188 format( 6x,'i           i        F i g u r e s      o f     '
     1 ,' m e r i t         i')
  189 format( 6x,'i  Set no.  i',54('-'),'i')
  191 format( 6x,'i           i   mabs   i  alcomb  i  pscomb  i'
     1 ,'  cphase  i   cfom   i')
  192 format( 6x,'i ',i6,'    i',5(f8.4,'  i'))
  193 format( 6x,'i-----------i',5('          i'))
                     endif
                    endif
      if (numb.eq.0) then
                       write(lo,196)
                       ier=-1
                       return
                     endif
  196 format(/,' *** error *** no reflections supplied')
c-- psi-e informations
          if (mode.eq.1) then
          if (nexp.ne.0) then
              if (knw.eq.0) then
                              write(lo,4500) nexp
                            else
                              write(lo,4510) error,dalfa,nexp
                            endif
                         else 
                              write(lo,281)
                         endif
                         endif
 4500 format(/,19x,' number of added psi-e reflections  ',i6,/)
 4510 format(/,19x,'                  mean phase error  ',f9.2,/
     *         19x,'         weighted mean phase error  ',f9.2,/,
     *         19x,' number of added psi-e reflections  ',i6,/)
      if(jpatt.eq.0) then
                      do 199 i=1,numb
                      phase=dtor*float(iphaz(i))
                      ep(i)=e(i)*sin(phase)
                      e(i)=e(i)*cos(phase)
  199                 continue
                    endif
c
c--   set default values of program parameters unless specified by user
c
c
c--   calculate number of grid points for fourier map
c
      do 280 i=1,3
         np(i)=cell(i)/factr+0.5
         if(i.eq.3) np(i)=np(i)+mod(np(i),2)
  250    ntest=np(i)
         do 270 j=2,5
  260       if(ntest.ne.(ntest/j)*j) go to 270
            ntest=ntest/j
            if(ntest.eq.1) go to 280
            go to 260
  270    continue
         np(i)=np(i)+1
         if(i.eq.3) np(i)=np(i)+1
         go to 250
  280 continue
      if (mode.eq.1) then
      write(lo,292)
      write(cspace,'(16a1)') (nt(i),i=1,16)
      call ucase(cspace(1:1))
      write(lo,284) cspace,cell
  284 format( 6x,
     * 'i                           Space group symbol  i',
     * 2h  ,a16,1hi,/, 6x,
     1 'i                     Unit cell parameters   a  i',
     2 f10.3,8x,'i',/, 6x,'i',44x,'b  i',f10.3,8x,'i',/, 6x,'i',
     3 44x,'c  i',f10.3,8x,'i',/, 6x,'i',40x,'alpha  i',f10.3,8x,'i',/
     4 , 6x,'i',41x,'beta  i',f10.3,8x,'i',/, 6x,'i',40x,'gamma  i',
     5 f10.3,8x,'i',/, 6x,'i',47x,'i',18x,'i')
  281 format(///)
  292 format( 6x,'+',47('-'),'+------------------+')
      write(lo,294) factr,np,mh
  294 format( 6x,
     1 'i  Grid spacing (in angstrom) is approximately  i',
     2 f10.3,8x,1hi,/, 6x,'i',47x,'i',18x,'i',/, 6x,
     3 'i    Number of grid points in fourier map   nx  i',
     4 i6,12x,'i',/, 6x,'i',43x,'ny  i',i6,12x,'i',/, 6x,
     5 'i',43x,'nz  i',i6,12x,'i',/, 6x,'i',47x,'i',18x,'i',/, 6x,
     6 'i                   Maximum indices value    h  i',
     7 i6,12x,'i',/, 6x,'i',44x,'k  i',i6,12x,'i',/, 6x,
     5 'i',44x,'l  i',i6,12x,'i',/, 6x,'i',47x,'i',18x,'i')
                     endif
      if (np(1) .le. 150) go to 400
      write(lo,320)
  320 format (/,22x,'nx greater than 150. increase array inut in subro
     1utine outpuf of fft modul',/,
     2            22x,'or increase the grid value')
      ier=-1
      return
  400 continue
      if (mode.eq.1) write(lo,460) numb
      rewind jrel
  460 format ( 6x,
     1 'i      Number of independent reflections input  i',
     2 i6,12x,'i',/, 6x,'i',47x,'i',18x,'i')
c
c     generate one complete hemisphere of reflexions
c
      do 470 i=1,15
         tab(i)=sin(float(30*i)*dtor)
  470 continue
      nex = 0
      fsum=0.0
      ip5=256*(262144+512+1)
      nbatch=0
      if (jpatt.ne.0) then
                        if (npseud.eq.0) then
                                           jind=4
                                         else
                                           jind=6
                                         endif
                        if (jpatt.eq.2) jind=5
                      endif
c*********
      do 800 jn=1,numb
      if (jpatt.eq.0) then
                        i1(1)=ihkl(jn)/262144
                        j=ihkl(jn)-262144*i1(1)
                        i1(2)=j/512-256
                        i1(3)=j-512*(i1(2)+256)-256
                        eep=ep(jn)
                        ee =e (jn)
                      else
                        eep=0.0
                        call snr07(vet)
                        i1(1)=ivet(1)
                        i1(2)=ivet(2)
                        i1(3)=ivet(3)
                        if (jpatt.eq.3) then
                                          ee=vet(jind)*vet(jind+1)
                                        else
                                          ee=vet(jind)*vet(jind)
                                        endif
                      endif
      do 700 j=1,neqv
      do 540 i=1,3
  540 i2(i)=0
      do 560 i=1,3
      do 550 k=1,2
      m=iabs(is(k,i,j))
      if(m.ne.0) i2(m)=i2(m)+i1(i)*isign(1,is(k,i,j))
  550 continue
  560 continue
      b1=1.0
      js=1
      if(i2(3)) 590,570,600
  570 if(i2(1)) 590,580,600
  580 if(i2(2)) 590,600,600
  590 b1=-1.0
      js=-1
  600 kind(j)=ip5+js*(262144*i2(1)+512*i2(2)+i2(3))
      do 610 i=1,3
      if(iabs(i2(i)).ge.np(i)/2) go to 700
      if(i2(i).gt.mh(i)) mh(i)=i2(i)
  610 continue
      if(j.eq.1) go to 630
      nd=j-1
      do 620 i=1,nd
      if(kind(j).eq.kind(i)) go to 700
  620 continue
  630 nbatch=nbatch+1
      nex=nex+1
      nu=0
      do 640 i=1,3
  640 nu=nu-i1(i)*int(ts(i,j)*12.0+0.1)
      nu=mod(nu,12)
      if(nu.le.0) nu=nu+12
      xc=tab(nu+3)
      xs=tab(nu)
      gr=xc*ee-xs*eep
      gi=(xs*ee+xc*eep)*b1
      fsum=fsum+sqrt(gr*gr+gi*gi)
      g(1,nbatch)=gr
      g(2,nbatch)=gi
      ih(nbatch)=kind(j)
      if(nbatch.lt.100) go to 700
      write(jrel) ih,g
      nbatch=0
  700 continue
  800 continue
c*********
      if(nbatch.ne.0) write(jrel) ih,g
      scale=3000.0/fsum
      if (mode.ne.1) return
      write(lo,990) nex,scale
  990 format( 6x,
     1 'i      Number of reflections in one hemisphere  i',
     2 i6,12x,'i',/, 6x,'i',47x,'i',18x,'i',/, 6x,
     3 'i                                        Scale  i',
     4 f10.3,8x,'i',/, 6x,'+',47('-'),'+------------------+')
      if (it4 .gt. 0) write(lo,410) xlim,level
  410 format (///13x,43hfourier map to be printed from x =  0.0  to,
     1  f7.3, 15h,  y =  0.0  to, f7.3, 15h,  z =  0.0  to, f7.3/
     1 /,40x,33hpoints underlined if greater than,i5)
      write(lo,431)
  431 format(//,1h1, 79('+'),//,18x,
     1       '***   E-map interpretation  ***',//)
      return
      end
c-----------------------------------------------------------------------
      subroutine getref(numb,ngroup,ier)
c
c-- read reflections from "struct.fo0" file
c
      character fname(9)*80,ext(9)*4
      common/dotdat/ fname,ext
      common /impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/xdata/ ihkl(3000),e(3000),iphaz(3000),iphb(3000),
     *            wt(3000),nzsav(500),occsav(500),ffmin,ffmax,
     *            dum12(67998),IndHKL(3000,5),Mult(3000),SetFob(3000,4),
     *            TThet(3000),WHM(3000),dummpc(124000)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /emap1/ fwhm,npor(3),npror,nngr11,npar11
      common /ureq1/ ncycl,nroset,nundset,alambda,nsec,machkl,uvwt(4),
     *               pfwhm
      common /bbbb/ oscalef,gpror,fov(3000),fcv(3000),natso
      dimension sortv(3000)
      equivalence(sortv(1),ihkl(1))
c
      itype=2
      iform=1
      jop=jopen(kform,fname(7),nlen,itype,iform,ierr)
      if (jop.lt.0) then
                      write(lo,100) ierr,fname(7)
                      ier=-1
                      return
                    endif
  100 format(' *** error ***  open error, code =',i5,' file is ',a)
      nref=0
      zero=0.001
      do 200 i=1,100000
      read(kform,2500,end=250) ih,ik,il,novf,sigfsq,sintl,fq,fwh,twoth 
     *                         ,multt
CNEW -------------------
      if(fq.lt.zero)go to 200
      nref=nref+1
      IndHKL(nref,1) = ih
      IndHKL(nref,2) = ik
      IndHKL(nref,3) = il
      if(fwh.lt.0.0)then
           IndHKL(nref,4) = novf    ! overlapping
           else
           IndHKL(nref,4) = -1      ! overlapping
      end if
      IndHKL(nref,5) = 0 
      SetFob(nref,1) = 0       ! intensita' del gruppo
      SetFob(nref,2) = sigfsq * sc
      SetFob(nref,3) = 0       ! non usato
      SetFob(nref,4) = fq * sc ! fo**2 riscalato
      TThet(nref)    = twoth
      Mult(nref)     = multt
      WHM(nref)      = fwh
      wt(nref)       = sintl*sintl
  200 continue
  250 continue
c
c-- re-define overlapping
c
      pfwhm=fwhm
      call defovl
c
c-- reject weak reflections and compute number of groups
c
      do 269 i=1,3000
      sortv(i)=0.0
 269  continue
      zero=0.001
      ngr=0
      do 270 i=1,nref
      iovl=iabs(IndHKL(i,4))
      count=SetFob(i,1)
      if (iovl.gt.0.and.count.gt.zero) then
                                         ngr=ngr+1
                                         sortv(ngr)=count
                                       endif
  270 continue
      n1=1
      nj=ngr
      n11=1
      n111=-1
      call sortz(n1,nj,n11,n111)
      j=nint(ngr*0.7)
      ffmin=sortv(j)
      ffmax=sortv(1)
      fosog=sortv(j)
      ffmin=fosog
      ngroup=0
      if (ngroup.ne.0) then
c------------------------ PRIMA POSSIBILITA'
                         numb=nref
                         do 280 i=1,nref
                         IndHKL(i,4)=iabs(IndHKL(i,4))
                         if (IndHKL(i,4).gt.0) ngroup=ngroup+1
  280                    continue
                       else
c------------------------ SECONDA POSSIBILITA'
   
      j=0
      i=0
  300 i=i+1
      iovl=iabs(IndHKL(i,4))
      if (iovl.eq.0) SetFob(i,1)=0.0
      if (SetFob(i,1).le.fosog.and.iovl.gt.0) iovl=-iovl
      if (iovl.lt.0) then
                        jump=-iovl-1
                        i=i+jump
                     else
                       j=j+1
                       do 400 k=1,5
  400                  IndHKL(j,k)=IndHKL(i,k)
                       do 500 k=1,4
  500                  SetFob(j,k)=SetFob(i,k)
                       if (IndHKL(j,4).gt.0) ngroup=ngroup+1
                       TThet(j)= TThet(i)
                       Mult(j) = Mult(i)
                       WHM(j)  = WHM(i)
                       wt(j)   = wt(i)
                     endif
      if (i.lt.nref) go to 300
      numb=j
                       endif
      do 600 i=1,numb
      ihkl(i) = 262144*IndHKL(i,1) +512*IndHKL(i,2)+IndHKL(i,3) +131328
  600 continue
      close(kform)
 2500 format(4i4,15x,f15.3,f8.5,f15.3,2f15.5,i4)
      return
      end
c-----------------------------------------------------------------------
      subroutine stopr(host,izpk,mode)
c
c-- terminates the recycling procedure
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /emap1/ fwhm,npor(3),npror,nngr11,npar11
      common /neutro/ neutro,bmat(2,98),neuwei,vetint(200)
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common /atomo/ xyzo(5,200),nzo(200),dold(400)
      common/sf/al(4,8),bs(4,8),cl(8),nnw(8),nno(8),nk,nat,f(9),nalf(8)
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      dimension izpk(500)
      character*80 host
c
      if(iprin.gt.2) write(lo,*)  'STOPR lsx=',lsx
      call cp3015
      idisp=1
      call sfl15(nats,idisp,idumm,interp)
c     write(6,*)'erre,erreo,errem,maxcyc',erre,erreo,errem,maxcyc
      do 60 jj=1,nats
      vetint(jj)=x(4,jj)
      x(4,jj)=abs(vetint(jj))
      if(iprin.gt.2) then
      write(lo,'(i8,i5,f10.1,5f12.8)') nz(jj),jj,
     * vetint(jj),(x(jjj,jj),jjj=1,3),bfac(jj),x(5,jj)
                      endif
   60 continue
c
      write(lo,80) itle
   80 format(//,1h ,79('+'),//,25x,
     1       '***   Final interpretation  ***',//,
     2       //,2x,20a4,//)
c
      if (jrecyc.eq.20) then
                          lsxx=lsx
                        else
                          lsxx=jrecyc
                        endif
      if(jrest.ne.0) lsxx=11
      if (lsxx.le.10) then
                        kaction=2
                        call maincl(izpk,kaction,iprin)
                        do 100 i=1,nats
                        if(nz(i).eq.0) izpk(i)=-99999
  100                   continue 
c
c-- procedura A
c
                      else
c
c-- procedura B & C
c
                        kaction=4
                        call maincl(izpk,kaction,iprin)
                        do 500 i=1,nats
                        if (nz(i).ne.0) then
                                           kfrag=mod(nz(i),100)
                                           nzz=iabs(nz(i))/100
                                           nzz=nk-nzz+1
                                           izpk(i)=nzz*100+kfrag
                                         else
                                           kfrag=0
                                           izpk(i)=-99999
                                         endif
  500                   continue
                      endif
      iprsav=iprin
      krecy=1
      if (iprin.eq.0) iprin=2
      klast=1
      call outpea(host,izpk,klast)
      iprin=iprsav
c
      idisp=1
      call sfl15(nats,idisp,idumm,interp)
      maxcyc=jrecyc 
      jrest=0
      call frm15(nats,idumm,interp)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine sftra(mode,numb,ep)
c     structure factor and phases for fourier refinement 
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/xdata/ ihkl(3000),e(3000),iphaz(3000),iphb(3000),
     *            wt(3000),nzsav(500),occsav(500),ffmin,ffmax,
     *            dum12(67998),IndHKL(3000,5),Mult(3000),SetFob(3000,4),
     *            TThet(3000),WHM(3000),dummpc(124000)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /emap1/ fwhm,npor(3),npror,nngr11,npar11
      common /neutro/ neutro,bmat(2,98),neuwei,vetint(200)
      common /bbbb/ oscalef,gpror,fov(3000),fcv(3000),natso
c
      dimension ep(3000),fvar(200),q(200),qq(200),on(8)
c
      ncy=(krecy-1)*10+mode-1
      do 10 i=1,nk
      if (neutro.eq.0) then
                         on(i)=no(i)
                       else
                         on(i)=abs(bs(1,i))
                       endif
   10 continue
      idisp=1
      call sfl15(nats,idisp,idumm,interp)
      jlig=1
      if (no(1).eq.1.and.neutro.eq.0) jlig=2
      anatm=0.0
CNEW CNEW
      if (ncy.eq.1) then
                      errem=1.0
C                     if (bt.gt.0.0) then
C                                      biso=bt
C                                    else
C                                      biso=0.0
C                                    endif
C                     do 4 i=1,nats
C   4                 bfac(i)=biso
                    endif
c
      if(nz(1).eq.0)nz(1)=nk*100
C     write(6,*)'nz(1)=',nz(1)
CNEW CNEW
      do 12 i=jlig,nk
   12 anatm=anatm+float(nw(i))
      anat=anatm
c
c-- compute the numer of peaks to consider
c
      totop=(icent+1)*nsym*pts
      delta=1.0/12.0
      sum=0.0
      enne=0.0
      jnats=0
      do 99 i=1,nats
      nzsav(i)=nz(i)
      occsav(i)=x(5,i)
      x(4,i)=abs(x(4,i))
C     write(lo,'(i4,1h),i5,3f10.4,f9.1,f10.4)') 
C    * i,nz(i),(x(j,i),j=1,5)
cXXXXXX
      nz(i)=iabs(nz(i))
cXXXXXX
      if (nz(i).eq.0) then
                        jnats=jnats+1
                        else
                         occ=x(5,i)
                         sum=sum+occ*totop
                         if ((sum-anat).lt.delta) enne=enne+1.0
                        endif
  99  continue
      bnats=float(nats-jnats)
      nenne=nint(enne)
      if (nenne.lt.nk) nenne=nk
      jnats=0
      j=nats
      do 991 i=1,nats
      if (nz(i).eq.0) go to 991
      if (jnats.ge.nenne) go to 991
      j=i
      jnats=jnats+1
  991 continue
      jnats=j
      denom=x(4,jnats)
C     write(lo,*) 'nenne,jnats,denom,bnats',nenne,jnats,denom,bnats
      ii=0
      do 111 i=1,nats
      fvar(i)=1.0
      if (nz(i).eq.0) go to 111
      ii=ii+1
      b667=bnats-ii+1
      a667=b667/bnats
C     write(lo,*) i,ii,b667,bnats,a667
      a667=0.8*sqrt(a667)
      if (i.le.jnats) then
                        if (nz(i).lt.0) fvar(i)=a667
                      else
                        fvar(i)=0.667*x(4,i)/denom
                        if (nz(i).lt.0) fvar(i)=fvar(i)*a667
                      endif
  111 continue
      c=x(4,1) 
      jfirst=iabs(nz(   1)/100)
      jnats=nats+1
  115 jnats=jnats-1
      jlast =iabs(nz(jnats)/100)
      if (jlast.eq.0) go to 115
Corig sog=float(no(jlast))/float(no(jfirst))
      sog=      on(jlast) /      on(jfirst)
c-- NEW
      if (neutro.eq.1) sog=on(1)/on(nk)
****  if (neutro.eq.0) sog=on(jlast)/on(nk)
c-- NEW
      sog=sog*0.667
      kfrag=nemap(4)
      iflag=0
      rife=0.0
      do 102 i=1,nats
      if (nz(i).eq.0) go to 102
      if (iflag.eq.0) then
                        qq(i)=x(4,i)/c
                        if (qq(i).lt.sog) then
                                            rife=x(4,i)
                                            iflag=1
                                            qq(i)=sog
                                          endif
                      else
                        qq(i)=sqrt(x(4,i)/rife)*sog
                      endif
      q(i)=fvar(i)
      nz(i)=iabs(nz(i)/100)
      if (kfrag.ne.0.and.mode.eq.2) go to 102
      sogz=qq(i)*q(i)*on(nk)
      x(5,i)=x(5,i)*qq(i)*q(i)
      if (nz(i).gt.0) nz(i)=nk
c     sogz=x(5,i)*on(nk)
c-- NEW
      if (sogz.lt.1.0.and.neutro.eq.0) nz(i)=0
Cprovaif (sogz.lt.3.0.and.neutro.eq.0) nz(i)=0
c-- NEW
      if (sogz.lt.0.1.and.neutro.eq.1) nz(i)=0
Cprovaif (sogz.lt.0.15.and.neutro.eq.1) nz(i)=0
c-- NEW
  102 continue
      iref=0
      nlsm=1
      call sftryy(iref,mode,nlsm,numb,ep,scalan,ncy)
      if (iref.lt.0) then
                       mode=-1
                       return
                     endif
      do 300 i=1,nats
      if (nzsav(i).ne.0.and.nz(i).ne.0) nz(i)=nzsav(i)
      x(4,i)=vetint(i)
      x(5,i)=occsav(i)
  300 continue    
      maxcyc=ncy
      interp=1
      call frm15(nats,numset,interp)
c
c-- plot
c
      call scrf(numset,ncy,1)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine sftrb(mode,numb,ep)
c     structure factor and phases for fourier refinement 
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common /atomo/ xyzo(5,200),nzo(200),dold(400)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/xdata/ ihkl(3000),e(3000),iphaz(3000),iphb(3000),
     *            wt(3000),nzsav(500),occsav(500),ffmin,ffmax,
     *            dum12(67998),IndHKL(3000,5),Mult(3000),SetFob(3000,4),
     *            TThet(3000),WHM(3000),dummpc(124000)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /emap1/ fwhm,npor(3),npror,nngr11,npar11
      common /neutro/ neutro,bmat(2,98),neuwei,vetint(200)
      common /bbbb/ oscalef,gpror,fov(3000),fcv(3000),natso
c
      dimension ep(3000),on(8),izpk(500)
c
      ncy=(krecy-1)*10+mode-1
      coef=1.35
      coefr=1.0/3.0
c
      delta=1.0/12.0
c-- compute the numer of peaks to consider
      totop=(icent+1)*nsym*pts
      jlig=1
      if (no(1).eq.1.and.neutro.eq.0) jlig=2
      anat=0.0
      do 12 i=jlig,nk
   12 anat=anat+float(nw(i))
      idisp=1
      call sfl15(nats,idisp,idumm,interp)
      if (mode.eq.2.and.krecy.eq.2) then
                                      do 88 i=1,nats
                                      vetint(i)=x(4,i)
   88                                 continue
                                    endif
c
      sum=0.0
      nne=0.0
      do 99 i=1,nats
      if (neutro.eq.1) x(4,i)=abs(x(4,i))
      if (nz(i).eq.0) go to 99
      if (sum.le.anat) then
                         occ=x(5,i)
                         sum=sum+occ*totop
                         if ((sum-anat).lt.delta) nne=nne+1
                      endif
   99 continue
      if (nne.lt.nk) nne=nk
      jnats=0
      j=nats
      do 991 i=1,nats
      if (nz(i).eq.0) go to 991
      if (jnats.ge.nne) go to 991
      j=i
      jnats=jnats+1
  991 continue
      nne=j


      nats    =nne     +(nats-nne     )*erre**0.2


      call label(nne,on)
      sz=on(jlig)/4.0
      call assbt(ncy)
      hei=x(4,nne)
      kzo=iabs(nz(nne)/100)
      sum=1.0
      do 97 i=1,nne-1
      if(sum.gt.2.5) go to 992
      j=nne-i
      if (nz(j).eq.0) go to 97
      kz=iabs(nz(j)/100)
      if (kz.eq.kzo) then
                       hei=hei+x(4,j)
                       sum=sum+1.0
                     endif
   97 continue
  992 continue
      hei=sum/hei
      do 98 i=1,nats
      nzsav(i)=nz(i)
      occsav(i)=x(5,i)
      if (nz(i).eq.0) go to 98
      kz=iabs(nz(i))/100
      xleg=1.000
      if (i.le.nne) then
                      ww=1.00
                      wws=1.00
                      sogz=99.99     
                    else
                      ww=x(4,i)*hei*erre**coefr
                      wws=ww*xleg
                      sogz=wws*on(kz)
c-- NEW
                      if (sogz.lt.1.0.and.neutro.eq.0) nz(i)=0
                      if (sogz.lt.sz .and.neutro.eq.0) nz(i)=0
                      if (sogz.lt.0.1.and.neutro.eq.1) nz(i)=0
c-- NEW
                    endif
      x(5,i)=x(5,i)*xleg*ww
      nz(i)=iabs(nz(i)/100)
   98 continue
c
      nlsm=5
      iref=3
      call sftryy(iref,mode,nlsm,numb,ep,scalan,ncy)
      if (iref.lt.0) then
                       mode=-1
                       return
                     endif
      do 300 i=1,nats
      kfrag=mod(nzsav(i),100)
      if (nzsav(i).gt.0) then
                           isg=1
                         else
                           isg=-1
                         endif
      if (nz(i).ne.0) then
                        nzo(i)=isg*(nz(i)*100+kfrag)
                        nz(i) =     nz(i)*100+kfrag 
                      endif
      x(4,i)=abs(vetint(i))
      x(5,i)=occsav(i)
      nzo(i)=nz(i)
      do 300 j=1,5
      xyzo(j,i)=x(j,i)
  300 continue    
      natso=nats
c
      kaction=5
      call maincl(izpk,kaction,iprin)
c 
      do 310 i=1,nats
      izpki=izpk(i)
      if (izpk(i).lt.0) then
                          isg=-1
                          kfrag=0
                          izpki=iabs(izpki)
                          if (izpki/100.gt.nk) isg=1
                        else
                          isg=1
                          kfrag=mod(izpki,100)
                        endif
      kk=nz(i)/100
      nz(i)=isg*(kk*100+kfrag)
      x(4,i)=vetint(i)
  310 continue
c
      maxcyc=ncy
      interp=1
      call frm15(nats,numset,interp)
c
c-- plot
c
      call scrf(numset,ncy,2)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine label(nne,on)
c
c-- subroutine to re-label peaks according only to
c-- the relative peak height and to the cell content
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common /atoms/ x(5,200),nz(200),idumx(21)
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common /impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /emap1/ fwhm,npor(3),npror,nngr11,npar11
      common /neutro/ neutro,bmat(2,98),neuwei,vetint(200)
      common/xdata/ ihkl(3000),e(3000),iphaz(3000),iphb(3000),
     *            wt(3000),nzsav(500),occsav(500),ffmin,ffmax,
     *            dum12(67998),IndHKL(3000,5),Mult(3000),SetFob(3000,4),
     *            TThet(3000),WHM(3000),dummpc(124000)
      common /bbbb/ oscalef,gpror,fov(3000),fcv(3000),natso
c-- nw(i) = number of atoms of the i-th specie
c-- no(i) = Z of atom of the i-th specie
c-- on(i) = Z of atom of the i-th specie
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
c
      dimension number(8,2),on(8)
      dimension izpk(500)
C
      jlig=0
      if (no(1).eq.1.and.neutro.eq.0) jlig=1
c
      bpmin=999.9
      bnmin=-999.9
      jligp=0
      jlign=0
      do 10 i=1,nk
      if (neutro.eq.0) then
                         jligp=jlig+1 
                         on(i)=no(i)
                       else
                         on(i)=abs(bs(1,i))
                         if(bs(1,i).gt.0.) then
                             if(bs(1,i).lt.bpmin) then
                                              bpmin=bs(1,i)
                                              jligp=i
                                                  endif
                                            else
                             if(bs(1,i).gt.bnmin) then
                                              bnmin=bs(1,i)
                                              jlign=i
                                                  endif
                                             endif
                       endif
   10 continue
      do 50 i=1,nats
      if(nz(i).ne.0) then
                        if(vetint(i).lt.0.0) then
                                            nz(i)=jlign*100
                                              else
                                            nz(i)=jligp*100
                                             endif
                       endif
   50 continue
      do 100 i=1,nne 
      if (nz(i).eq.0) then
                        izpk(i)=0
                      else
                        izpki=nz(i)/100
                        izpk(i)=nk-izpki+1
                      endif
  100 continue
      t2=(icent+1)*nsym*pts
      nkl=nk-jlig
c     write(6,*) 'icent,nsym,pts,t2,jlig',icent,nsym,pts,t2,jlig
      j=nk+1
      do 1000 i=1,nk
      j=j-1
      number(i,1)=nw(j)
      kz=nint(on(j)*1000.0)
      if (neutro.eq.0) then
Corig                    if (kz.ge.11000) then
                         if (kz.gt.1000) then
                                            number(i,2)=kz
                                          else
                                            number(i,2)=0
                                          endif
                       else
                                            number(i,2)=kz
                       endif
 1000 continue
c
c     write(6,*) ' labdef number ',(number(i,1),i=1,nk)
c     write(6,*) ' labdef number ',(number(i,2),i=1,nk)
c
      k=1
      heig1=x(4,1)
      z1  =float(number(1,2))/1000.0
c
      do 1100 i=1,nne 
      if(izpk(i).eq.0) go to 1100
c
      do 1090 j=1,nkl
      if (number(j,1).eq.0) go to 1090
      k=j
      lasth=i-1
      numb=nint(x(5,i)*t2)
 1120 number(k,1)=number(k,1)-numb
      kz=number(k,2)/1000.0
      heign=x(4,i)
      zn  =float(number(k,2))/1000.0
      if (number(k,1).ge.0) then
         rap=heig1*zn/z1
         rap1=rap*0.6
         rap2=rap*1.4
C        write(6,1132) heig1,z1,zn,rap,rap1,heign,rap2
c1132 format('heig1,z1,zn,rap,rap1,heign,rap2',7f9.3)
         if ((heign.gt.rap1.and.heign.lt.rap2).or.kz.eq.0) then
Cnew     if ((heign.gt.rap1                  ).or.kz.eq.0) then
                                             izpk(i)=k
                                             if (number(k,1).eq.0) k=k+1
                                             go to 1100
                                              else
                                            number(k,1)=number(k,1)+numb
                                              endif
                            else
                              number(k,1)=number(k,1)+numb
                              k=k+1
                              if (k.le.nkl) then
                                             go to 1120
                                           else
                                             go to 1900
                                           endif
                            endif
 1090 continue
 1100 continue
 1900 continue
      do 2000 i=1,nne 
      if(izpk(i).eq.0) go to 2000
      izpki=izpk(i)
      izpki=nk-izpki+1
      nz(i)=izpki*100
 2000 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine sftryy(iref,mode,nlsm,numb,ep,scalan,ncy)
c----
c     structure factor least squares
c
c     iref = 0 only structure factor computation
c     iref = 1 only B has to be refined
c     iref = 2 only X's have to be refined
c     iref = 3 B and X's have to be refined
c
      character buffer*130
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common /atomo/ apd(4,200),bpd(4,200)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,lcent,
     *         kpol,lsys,lat,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      common/xdata/ ihkl(3000),e(3000),iphaz(3000),iphb(3000),
     *           wt(3000),nzsav(500),occsav(500),ffmin,ffmax,peso(3000),
     *           pesof(3000),dum12(61998),IndHKL(3000,5),Mult(3000),
     *           SetFob(3000,4),TThet(3000),WHM(3000),dummpc(124000)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /emap1/ fwhm,npor(3),npror,nngr11,npar11
      common /neutro/ neutro,bmat(2,98),neuwei,vetint(200)
      common /bbbb/ oscalef,gpror,fov(3000),fcv(3000),natso
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      dimension xo(11),xn(11),keyx(10),shift(4)
     *      ,deltaf(4,200),qvet(4,4,200),kcond(4,200),newvet(48,3)
      integer i1(3)
      dimension ep(3000),hkle(4,24)
      dimension dfp(4,200),phip(3000)
      dimension smin(30),smax(30),disnum(30),disden(30),res(30),num(30)
     *          ,nmax(30)
      character jstep
c
      irefs=iref
      if (npror.ne.0.and.irefs.gt.0) then
      if(ncy.eq.11)write(lo,8)(npor(i),i=1,3)
  8   format('   preferred orientation along  ',3i5)
      do 3 i=1,3
      abc(i)=cx(i)
      ang(i)=cx(i+3)
   3  continue
      call senti
      end if
      if (iref.ge.2) then
      iactn=3
      do 130 i=1,nats
         do 100 j=1,3
            xo(j)=x(j,i)
  100    continue
         k=kspecb(buffer,newvet,xo,xn,keyx,itype,iser,khead,iactn)
         do 105 j=1,3
            x(j,i)=xn(j)
  105    continue
         iflk=0
         do 110 j=1,3
            ke=keyx(j)
            if (ke.ne.0.and.ke.ne.j) iflk=1
            kcond(j,i)=keyx(j)
  110    continue
         if (iflk.eq.1) then
             do 120 j=1,3
                kcond(j,i)=0
  120        continue
             endif
  130 continue
      if (kpol.ne.0) then 
                       jpol=kpol
                       i100=100
                       do 140 i=1,3
                       k=jpol/i100
                       if (k.ne.0) kcond(i,1)=0
                       jpol=jpol-k*i100
                       i100=i100/10
  140                  continue
CCCC
                     endif
                   endif
                             if (iprin.gt.2) then
                             do 145 jj=1,nats
                if (nz(jj).ne.0)
     *          write(lo,'(a2,i5,17x,5f9.5,f9.1)') nalf(nz(jj)),jj,
     *             x(5,jj),(x(jjj,jj),jjj=1,3),bfac(jj),vetint(jj)
  145                        continue
                             end if
corig if (krecy.le.1.and.jrest.eq.0) then
      if (krecy.eq.1) then
                       if (jrest.eq.0.or.maxcyc.eq.0) then
                                       oscale=1.0
                                       oscalef=1.0
                                       gpror=0.0
                                                    endif
                       endif
c     write(6,*) 'KRECY,oscale,oscalef =',krecy,oscale ,oscalef
      uno=1
      gof=100.0
      gofold=gof
      gofsold=gof
CORIG gofmin=0.5
      gofmin=0.0
      if (biso.gt.0.01) then
                          bt3=10.0    
                        else
                          bt3=12.5
                        endif
      dump=0.25 
      xdump=0.25 
     
      jlig=1
      if (no(1).eq.1) jlig=2
           if (iref.eq.1) then
                            k1=4
                            k2=4
                            jstep='B'
      else if (iref.eq.2) then
                            k1=1
                            k2=3
                            jstep='C'
      else if (iref.eq.3) then
                            k1=1
                            k2=4
                            jstep='B'
                          else
                            jstep='A'
                          endif
      if (iref.eq.1.or.iref.eq.3) then
                                    do 150 i=1,nats
                                    kcond(4,i)=1
c                 write(6,'(i5,1h),i5,4i3)') i,nz(i),(kcond(j,i),j=1,4)
  150                               continue
                                  endif
c
      jstop=0
      erre=0.0
      erre2=0.0
      erre3=0.0
      erre4=0.0
      npar = 0
      do 3000 nls=1,nlsm
c
      ngr=0
      fmin=99999.0
      fmax=-99999.0
      do 159 i=1,numb
      pesof(i)=0.0
      if (nls.eq.1) fov(i)=sqrt(SetFob(i,4))
      fval=fov(i)
      if (fval.le.fmin)fmin=fval
      if (fval.ge.fmax)fmax=fval
 159  continue
      p1=2.0*fmin
      p2=2.0/fmax
      do 160 i=1,numb
      iovl=IndHKL(i,4)
      novl=iovl-1
c ----- peso unitario
      if (iovl.ge.1) then
                ngr=ngr+1
                peso(ngr)=0.0
                do 165 j=0,novl
                pesof(i+j)=1.0                
                peso(ngr)= peso(ngr)       
     *          +Mult(i+j)*fov(i+j)/sqrt(pesof(i+j))     
  165 continue
      peso(ngr)=1.0/(4.0*(peso(ngr)**2))
      endif
  160 continue
c
      if (nls.eq.nlsm) iref=0
      scale=1.0/oscale
      scalef=1.0/oscalef
      if (gof.lt.gofmin) jstop=1
      if (jstop.eq.1.and.nls.ne.nlsm) go to 3000
      gof =0.0
      agof=0.0
      gofs=0.0
      sumfc=0.0
      bison=0.0
      bisod=0.0
      if (iref.ge.1) then
                       df1=0.0
                       df2=0.0
                       dfg=0.0
                       bg=0.0
                       b1=0.0
                       b2=0.0
                       b11=0.0
                       b22=0.0
                       b12=0.0
                       do 200 jj=1,nats
                       do 200 k=k1,k2
                       do 200 l=k1,k2
                       deltaf(k,jj)=0.0
  200                  qvet(k,l,jj)=0.0
                       do 220 jj=1,nats
                       do 220 k=k1,k2
                       dfp(k,jj)=0.0
  220                  continue
                     endif
      xinte=0.0
      yinte=0.0
      iovls=0
      sumdfw5=0.0
      sumfow5=0.0
      nngr=0
      do 500 i=1,numb
      i1(1)=IndHKL(i,1)
      i1(2)=IndHKL(i,2)
      i1(3)=IndHKL(i,3)
      if (npror.ne.0.and.irefs.gt.0) then                                                  
      call angl(i1(1),i1(2),i1(3),npor(1),npor(2),npor(3),angg)
      phip(i)=angg
      end if
      SetFob(i,3)=0.0
      iovl=IndHKL(i,4)
      if (iovl.ne.0)nngr=nngr+1
      if (iovl.ge.1) then
                       iovls=iovl
                       yinte=SetFob(i,1)
                     endif
c-- compute H*R and H*T
      do 250 j=1,nsym
      t=1000.0
      do 230 l=1,3
      t=t+float(i1(l))*ts(l,j)
      hkle(l,j)=0
  230 continue
      do 240 l=1,3
      do 240 k=1,2
      m=iabs(is(k,l,j))
      if(m.gt.0) hkle(m,j)=hkle(m,j)+i1(l)*isign(1,is(k,l,j))
  240 continue
      hkle(4,j)=t
  250 continue
c     write(6,'(3i4,2f15.5,i4)') i1,SetFob(i,4),SetFob(i,1),Mult(i)
      rho=wt(i)
      act=0.0
      bct=0.0
      if (neutro.eq.0) then
                         do 300 ij=1,nk
                         f(ij)=cl(ij)
                         do 300 ii=1,4
                         f(ij)=f(ij)+al(ii,ij)*exp(-bs(ii,ij)*rho)
  300                    continue
                       else
                         do 320 ij=1,nk
                         f(ij)=bs(1,ij)
  320                    continue
                       endif
      if (iref.ge.1) then
                       do 350 jj=1,nats
                       do 350 k=k1,k2
                       apd(k,jj)=0.0
                       bpd(k,jj)=0.0
  350                  continue
                     endif
      do 400 jj=1,nats
      if (nz(jj).eq.0) go to 400
      kz=nz(jj)
      fkz=sign(f(kz),vetint(jj))
      arg=-bfac(jj)*rho
      effe=pts*fkz*exp(arg)
      tfocc=effe*x(5,jj)
      tfocp=tfocc*twopi
      call sfacyyy(hkle,jj,contc,conts,tfocp,iref,rho,kcond)
      contc=contc*tfocc
      conts=conts*tfocc
      act=act+contc
      bct=bct+conts
      if (kcond(4,jj).eq.1) then
                              apd(4,jj)=-rho*contc
                              bpd(4,jj)=-rho*conts
                            endif
  400 continue
      args=act*act+bct*bct
      if (args.gt.0.000001) then
                              fc=sqrt(args)
                              if(nls.eq.nlsm)
     *                        faze=rtod*atan2(bct,act)+360.0
                              ac=act/fc
                              bc=bct/fc
                            else
                              fc=0.0
                              faze=0.0
                              ac=0.0
                              bc=0.0
                            endif
      if(irefs.gt.0.and.npror.ne.0)fc=fc*
     *sqrt(exp(gpror*(pi/2.0-phip(i))**2))
      fcv(i)=fc
      if (iref.ge.1) then
c
c--  accumulation of l.s. normal equations
c
                       fcs=fc*scale
                       sw=-rho*fc
                       emme2=Mult(i)*2
                       b1=b1+Mult(i)*fc*fcs
Cirg                   if (npror.eq.0.and.irefs.gt.0) then
                       if (npror.eq.0) then
                          b2=b2+emme2*fc*sw
                                         else 
                          b2=b2+Mult(i)*fc*fc*((pi/2.0-phip(i))**2)
                                       endif
                       do 450 jj=1,nats
                       if (nz(jj).ne.0) then          
                       do 440 k=k1,k2
                       if (kcond(k,jj).eq.0)go to 440 
                       fm2=fc*Mult(i)*2.0
                       dfdb=fm2*(apd(k,jj)*ac+bpd(k,jj)*bc)
                       dfp(k,jj)=dfp(k,jj)+dfdb
  440                  continue
                       endif
  450                  continue
                       if (iovl.eq.1) then
                                      xinte=Mult(i)*fc*fc
                                    else
                                      xinte=xinte+Mult(i)*fc*fc
                                    endif
             dfg=dfg+(scalef*fov(i)-fc)*fc*scalef*pesof(i)
             bg=bg+pesof(i)*((fc*scalef)**2)
                       iovls=iovls-1
                       if (iovls.eq.0) then
                                         df =  yinte*scale - xinte
c
c-- df is multiplied for the weight
c
                                         df =  df * peso(nngr)
c
c--
                                         b11=b11+(b1*b1*peso(nngr))
                                         b22=b22+(b2*b2*peso(nngr))
                                         b12=b12+(b1*b2*peso(nngr))
                                         df1=df1+df*b1
                                         df2=df2+df*b2
                                         do 480 jj=1,nats
                                         if (nz(jj).ne.0) then     
                                         do 470 k=k1,k2
                                         if (kcond(k,jj).eq.0)go to 470
                                         deltaf(k,jj)=deltaf(k,jj)+
     *                                                df*dfp(k,jj)
                                         do 475 l=k1,k2
                                         if (kcond(l,jj).eq.0)go to 475
                                         qvet(k,l,jj)=qvet(k,l,jj)+
     *                                (dfp(k,jj)*dfp(l,jj)*peso(nngr))
  475                                    continue
  470                                    continue
                                         endif
  480                                    continue
                                         sumdfw5=sumdfw5+abs(df)
                                         sumfow5=sumfow5+yinte*scale
                                         do 490 jj=1,nats
                                         do 490 k=k1,k2
                                         dfp(k,jj)=0.0
  490                                    continue
                                         xinte=0.0
                                         b1=0.0
                                         b2=0.0
                                       endif
                     else
c
c-- compute stuff for fourier
c
                       iphap=mod(int(faze+0.5),360)
                       iphb(i)=mod(iphap,360)
c                      SetFob(i,3)=0.0
                     endif
  500 continue
c
c--  compute scale factors
c
      sumfc =0.0
      sumfo =0.0
      sumfo2=0.0
      sumfc2=0.0
      sumfo2w=0.0
      summfo2=0.0
CNEW 
      do 600 i=1,numb
      multot=0
      fc=fcv(i)
      iovl=IndHKL(i,4)
      ifin=iovl-1
           if (ifin.eq.0) then
                            arg= Mult(i) * fc * fc
                            SetFob(i,3) =  arg
                            sumfc2=sumfc2+SetFob(i,3)
                            arg=SetFob(i,1)/float(Mult(i))
                            fo=sqrt(arg)
                            fov(i)=fo
                            sumfc=sumfc+fc
                            sumfo=sumfo+fo
                            summfo2=summfo2+SetFob(i,1)
      else if (ifin.gt.0) then
                            do 550 j=0,ifin
                            arg= Mult(i+j) * fcv(i+j) * fcv(i+j)
                            multot=multot+Mult(i+j)
  550                       SetFob(i,3) = SetFob(i,3) + arg
                            sumfc2=sumfc2+SetFob(i,3)
                            summfo2=summfo2+SetFob(i,1)
                            do 580 j=0,ifin
                            fc=fcv(i+j)
                            if (SetFob(i,3).lt.0.001) then                     
                                arg=SetFob(i,1)/multot        
                              else
                                arg=SetFob(i,1)*fc*fc/SetFob(i,3)
                              end if
                            fo=sqrt(arg)
                            fov(i+j)=fo
                            sumfc=sumfc+fc
                            sumfo=sumfo+fo
  580                       continue
                          endif
  600 continue
c
      if(sumfc.lt.0.0001)then
      write(lo,655) fc
  655 format('  *** error in sftryy ***   Sum(Fc) =',f10.4,
     *'  Probably all peaks are ghosts')
      iref=-1
      return
      endif
      scala =sumfc /sumfo
      scala2=sumfc2/summfo2
      sumdf2=0.0
      sumdf2w=0.0
      sumfo2w=0.0
      sumfo=0.0
      sumdf =0.0
      sumdfw =0.0
      sumfow =0.0
      sumfo2=0.0
c--
c     epmax=-1.0
      ngr=0
      do 799 i=1,30
      smin(i)=0.0
      smax(i)=0.0
      nmax(i)=-99999.0
      num(i)=0.0
      disnum(i)=0.0
      disden(i)=0.0
 799  continue
      step=(ffmax-ffmin)/30.0
      fcmax=-9999.0
      nnnnn=0
      do 800 i=1,numb
      iovl=IndHKL(i,4)
Corig if (krecy.gt.1) then
      if (iref.gt.0) then
                       fc=fcv(i)/scalef
                    else
                       fc=fcv(i)/scala
                      endif
      sumdf2=sumdf2+abs( fov(i)**2-fc**2)                   
      sumdf2w=sumdf2w+abs( fov(i)**2-fc**2)*pesof(i)          
      sumfo2=sumfo2+fov(i)**2
      sumfo2w=sumfo2w+(fov(i)**2)*pesof(i)
      sumdf=sumdf+abs( fov(i)-fc)                   
      sumdfw=sumdfw+abs( fov(i)-fc)*(fov(i)**2)*pesof(i)                  
      sumfo=sumfo+ fov(i)                  
      sumfow=sumfow+ fov(i)*(fov(i)**2)*pesof(i)                  
      do 899 j=1,30
      smin(j)=ffmin+(j-1)*step
      smax(j)=ffmin+j*step
      if (iovl.ge.1) then
      if (SetFob(i,1).ge.smin(j).and.SetFob(i,1).le.smax(j)) then          
      if(iovl.ge.nmax(j))nmax(j)=iovl
      if (ncy.le.10) then
      disnum(j)=disnum(j)+abs( SetFob(i,1)-SetFob(i,3)/scala2)       
      else
      disnum(j)=disnum(j)+abs( SetFob(i,1)-SetFob(i,3)/scale)                   
      end if
      disden(j)=disden(j)+ SetFob(i,1)                                  
      num(j)=num(j)+1
      end if
      end if
899   continue
800   continue
      do 901 j=1,30
      if (num(j).eq.0) then        
      res(j)=0.0
      nmax(j)=0
      go to 903
      end if
      res(j)=100.0*(disnum(j)/disden(j))
  903 continue
CC904 write(6,902)smin(j),smax(j),res(j),num(j),nmax(j)
c 902 format('++++',3f15.5,2i5)
  901 continue
c
      erre=sumdf/sumfo
      rfac=100.0*erre
      erre2=sumdf2/sumfo2
      rfac2=100.0*erre2
c-- weighted R  erre3= R(f) secondo Michele
c               erre4=Rw(f) secondo Michele
      erre3=sumdfw/sumfow
      rfac3=100.0*erre3
      erre4=sumdf2w/sumfo2w
      rfac4=100.0*erre4
c--
      scalan=sumfc/sumfo
      inats=0
      do 908 jj=1,nats
      if (nz(jj).ne.0) inats=inats+1
  908 continue
Corig if (ncy.eq.11.and.npar.gt.0.and.nls.eq.nlsm) then
      if (npar11.eq.0.and.npar.gt.0.and.nls.eq.nlsm) then
                              nngr11=nngr
                              npar11=npar
                              ratio=float(nngr)/float(npar)
                              write(lo,2200) nngr,npar,ratio
                              if(ratio.lt.3.0) write(lo,2210)
                              write(lo,2212) 
                            endif
 2200 format(10x,'   Groups, Parameters and their Ratio ',2i5,f8.2,/)
 2210 format(18x,'   ***  Warning  ***   too small value of Ratio.',/,
     *       18x,'        Carefully consider the refinement',/)
 2212 format(//,8x,
     *       'Step      cycle         R(f)       Rw(f)      R(f**2)',/)
cnew
      if (jrest.eq.0) then
      if (krecy.eq.1) then
COLD                   write(lo,839) ncy,jstep,numb,rfac,rfac3,rfac2,
COLD *                               rfac4,inats
                       write(lo,842) jstep,ncy,rfac,rfac3,rfac2
                     else
COLD       if(nls.eq.nlsm)write(lo,840) ncy,jstep,numb,rfac,rfac3,rfac2,
COLD *                               rfac4,scale,scalef,inats,biso,gpror
           if(nls.eq.nlsm)write(lo,842) jstep,ncy,rfac,rfac3,rfac2
                     endif
                     else
COLD       if(nls.eq.nlsm)write(lo,840) ncy,jstep,numb,rfac,rfac3,rfac2,
COLD *                               rfac4,scale,scalef,inats,biso,gpror
           if(nls.eq.nlsm)write(lo,842) jstep,ncy,rfac,rfac3,rfac2
                     endif
CO839 format(' #',i3,a1,i6,4x,' R(f)=',f7.2,'% (',f7.2,' )',
COLD *                        ' R(f**2)=',f7.2,'% (',f7.2,' )',
COLD *                          i4)
CO840 format(' #',i3,a1,i6,   ' R(f)=',f7.2,'% (',f7.2,' )',
COLD *                        ' R(f**2)=',f7.2,'% (',f7.2,' )',
COLD *                    2f9.4,i4,2f9.4)
  842 format(10x,a1,i10,8x,4(f7.2,1h%,4x))
c
      if (iref.eq.0) go to 3000
c
c--  compute correction for scale factor
c
      denom =  b11 * b22 - b12 * b12        
      dbm=(b11*df2-b12*df1)/denom
      dbs=df2/b22
      dg =(b22*df1-b12*df2)/denom
      dg2=dfg/bg
      if (npror.ne.0.and.irefs.gt.0) then
      ggpror=gpror
      dgpror=dbm*0.75
      gpror=gpror+dgpror
      corr=0.0
      else
      dgpror=0.0
      corr= dbm- dbs
      end if
      dg=dg*0.75  
      dg2=dg2*0.75
c--  compute new scale-factor
c
      oscale=oscale+dg
      oscalef=oscalef+dg2
c
      nesub=nats-nemap(3)
      nrej=0
Corig if(nls.eq.1.and.ncy.eq.11) npar=2
      if (npror.eq.0) then
      if(nls.eq.1.and.npar11.eq.0) npar=2
                      else
      if(nls.eq.1.and.npar11.eq.0) npar=3
                      endif
      nel=0
      do 900 jj=1,nats
      if (nz(jj).eq.0) go to 900
      kz=nz(jj)
      call inv4(kcond,deltaf,qvet,jj,shift,ier)
      if(ier.lt.0) corr=0.0
      do 850 k=k1,k2
      if (kcond(k,jj).eq.0) go to 850
Corig if(nls.eq.1.and.ncy.eq.11) npar=npar+1
      if(nls.eq.1.and.npar11.eq.0) npar=npar+1
      if (k.le.3) then
                    sd=shift(k)*xdump
                    if (abs(sd).gt.0.20) then
                                           nz(jj)=0
                    if (iprin.gt.2) write(6,*) 'eliminato ',jj,sd
                                         endif
                    xnew=x(k,jj)+shift(k)*xdump
                    if (iprin.gt.2.and.nz(jj).ne.0) write(lo,2000) 
     *                  nalf(nz(jj)),jj,x(k,jj),shift(k),xnew
                    x(k,jj)=xnew
                  else
                    ashift=(shift(k)+corr)*dump
                    bnew=bfac(jj)+ashift
                    if (iprin.gt.2.and.nz(jj).ne.0) write(lo,2001) 
     *                  nalf(nz(jj)),jj,bfac(jj),shift(k),ashift,bnew
c
c-- reset thermal factor if strongly negative
c
c
c-- reject atom if thermal factor is too large
c
                    if (nls.gt.1) then
                        if (bnew.gt.bt3) then
                                   if (kz.eq.jlig.and.nesub.gt.0) then
                                                   nesub=nesub-1
                                                   nrej=nrej+1
         if (iprin.gt.2) write(6,*) 'eliminato ',jj,bnew,bt3,kz,jlig,
     *                               nesub,nz(jj)
                                                   nz(jj)=0
                                                 endif
                                         endif
                                  endif
                    if (bnew.lt. 0.0) bnew= 0.0
                    if(nz(jj).eq.0)nel=nel+1
                    if (nz(jj).ne.0) then
                                       bison=bison+bnew
                                       bisod=bisod+1.0
                                       gof=gof+abs(ashift)
                                       gofs=gofs+ashift
                                       agof=agof+1.0
                                     endif
                    bfac(jj)=bnew
                  endif
  850 continue
  900 continue
      if(nel.eq.nats)then
      write(lo,911) 
  911 format('  *** error in sftryy ***   All peaks have been rejected')
      iref=-1
      return
      end if
 2000 format(2x,a2,i3,3f10.5)
 2001 format(2x,a2,i3,4f10.5)
      if (iref.eq.2) go to 3000
      gof =gof /agof
      gofs=gofs/agof
      if (nls.eq.1) gof=10+gof
      biso=bison/bisod
      if (biso.lt.0.0) biso=0.0
      if (gof.gt.gofold) then
                           gofold=gof
                           gofsold=gofs
                           gof=0.0
                         else
                           gofold=gof
                           gofsold=gofs
                         endif
 3000 continue
                     if (iprin.gt.2) then
                     do 3010 jj=1,nats
                        write(6,'(i8,i5,f10.1,5f12.8,i10)') nz(jj),jj,
     *        vetint(jj),(x(jjj,jj),jjj=1,3),bfac(jj),x(5,jj)
 3010                continue
                     end if
c
c-- compute fourier coefficients and weights
c
      nondet=0
      do 3015 i=1,numb
      i1(1)=IndHKL(i,1)
      i1(2)=IndHKL(i,2)
      i1(3)=IndHKL(i,3)
      call cmult(i1,eps,multi)
      rho=wt(i)
      sumff=0
             do 700 ij=1,nk
             sumff=sumff+nw(ij)*(f(ij)**2) 
  700        continue
      den=sqrt(exp(-2.0*bt*wt(i))*sumff*pts*eps)
Corig if (krecy.gt.1) then
      if (iref.gt.0) then
          if (npror.ne.0) then
      fc=fcv(i)/scalef*(sqrt(exp(ggpror*(pi/2-phip(i))**2)))
                         else
      fc=fcv(i)/scalef
                         endif
                   else
                   fc=fcv(i)/scala
                 endif

c
c-- new: coeff.= 2 Fo - Fc
c--      weight= 1
c
      eov=fov(i)/den
      ec=fc/den
      sim=bes(1.35*eov*ec)
c     ep(i)=sim
      novl=IndHKL(i,4)
      iovl=novl-1
c
      e(i)= 2.0*fov(i) - fc
      ep(i)=1.0
 3015 continue
      return
      end
c-----------------------------------------------------------------------
c     structure factor calculation
c     subroutine sfacyy(hkle,jj,contc,conts)
      subroutine sfacyyy(hkle,jj,contc,conts,tfocp,iref,rho,kcond)
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common /atomo/ apd(4,200),bpd(4,200)
      dimension cost(360),hkle(4,24),kcond(4,200)
      equivalence (sint(91),cost(1))
c
      if (icent.eq.0) then
                        ent=1.0
                      else
                        ent=2.0
                      endif
      at=0.0
      bt=0.0
      do 1000 j=1,nsym
      arg=amod(hkle(1,j)*x(1,jj)
     *        +hkle(2,j)*x(2,jj)
     *        +hkle(3,j)*x(3,jj)
     *        +hkle(4,j),1.0)
      iarg=int(360.0*arg+0.5)+1
      if(iarg.eq.361) iarg=1
      at=at+cost(iarg)
      bt=bt+sint(iarg)
      if (iref.ge.2) then
                       do 900 k=1,3
                                 hkltf=hkle(k,j)*tfocp*ent
                                 apd(k,jj)=apd(k,jj)-hkltf*sint(iarg)
                                 if (icent.eq.0) 
     *                           bpd(k,jj)=bpd(k,jj)+hkltf*cost(iarg)
  900                  continue
                     endif
 1000 continue
      if (icent.eq.0) then
                        contc=at
                        conts=bt
                      else
                        contc=2.0*at
                        conts=0.0
                      endif
      return
      end
c--------------------------------------------------------------------------
      subroutine assbt(ncy)
c
c  assign to atoms the thermal factor list according to previous atom list
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/xdata/ ihkl(3000),e(3000),iphaz(3000),iphb(3000),
     *             wt(3000),nzsav(500),occsav(500),ffmin,ffmax,
     *             q(500),bnew(500),peso(3000),dum12(63998),
     *             IndHKL(3000,5),Mult(3000),SetFob(3000,4),
     *             TThet(3000),WHM(3000),dummpc(124000)
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common /atomo/ xyzo(5,200),nzo(200),dold(400)
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent
     *        ,kpol,jsys,latx,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /emap1/ fwhm,npor(3),npror,nngr11,npar11
      common /bbbb/ oscalef,gpror,fov(3000),fcv(3000),natso
      dimension xn(3),xo(3),xeq(3),vet(2),s(3)
c
      idisp=1
      if (ncy.eq.11) call sfl30(natso,idisp,idumm,interp)
      do 5 j=1,nats
      q(j)=0.0
   5  bnew(j)=biso
      vet(1)= 1.0
      vet(2)=-1.0
      ifin=icent+1
      do 100 i=1,natso
      if (nzo(i).eq.0) go to 100
      nzo(i)=iabs(nzo(i)/100)
cnew
      if (nzo(i).eq.0) go to 100
cnew
      do 10 j=1,3
   10 xo(j)=xyzo(j,i)
      distm=9999
      jpunt=0
      do 90 j=1,nats
      if (nz(j).eq.0) go to 90
      if (q(j).gt.0.5) go to 90
      do 20 k=1,3
   20 xn(k)=x(k,j)
      do 50 kt=1,ncentr
        do 50 ifi=1,ifin
          coef=vet(ifi)
          do 50 k=1,noper
            call xequi(xo,k,coef,xeq,kt)
            call xdist(xn,xeq,d,s)
            if (d.lt.distm.and.d.lt.ddmin) then
                                             distm=d
                                             jpunt=j
                                           endif
   50 continue
   90 continue
c
      if (jpunt.ne.0) then
                        q(jpunt)=i
                        nzn=iabs(nz(jpunt)/100)
c
c-- assign old coordinates to new peaks
c
                        do 95 jj=1,3
   95                   x(jj,jpunt)=xyzo(jj,i)
                        if (nzo(i).eq.nzn) then
                                             bnew(jpunt)=bfac(i)
                                           else
                                             z1=no(nzo(i))
                                             z2=no(nzn)
                                             bmod=bfac(i)*z1/z2
                                             bmod=(bmod+biso)/2.0
                                             bnew(jpunt)=bmod
c
c-- proviamo ad assegnare il b medio calcolato
c
                                             bnew(jpunt)=biso
C             if (iprin.gt.2)
C    *        write(lo,98) nalf(nzo(i)),i    ,z1,bfac(i),
C    *                     nalf(nzn)   ,jpunt,z2,bmod
c  98 format(' Modifica di ',a2,i4,f5.0,f8.4,' in ',
c    *                       a2,i4,f5.0,f8.4)        
                                           endif
                      endif
c
  100 continue
      if (iprin.gt.2) then
      do 110 j=1,nats
      if (nz(j).eq.0) go to 110
      nzn=iabs(nz(j)/100)
      i=nint(q(j))
      if (i.gt.0) then
C                   write(lo,92) nalf(nzn),j,(x(k,j),k=1,3),bnew(j),
C    *                          nalf(nzo(i)),i,(xyzo(k,i),k=1,3),bfac(i)
                       else
C                   write(lo,92) nalf(nzn),j,(x(k,j),k=1,3),bnew(j)
                       endif
  110 continue
                      endif
      do 120 j=1,nats
      bfac(j)=bnew(j)
  120 continue
c  92 format(2x,a2,i4,4f10.3,10x,a2,i4,4f10.3,10x)
      return
      end
c------------------------------------------
      subroutine inv4(kcond,deltaf,qvet,jj,shift,ier)
c
c-- solve the 4*4 system of normal equations for jj-th atom
c
      dimension shift(4),deltaf(4,200),qvet(4,4,200),qv(4,4),qvd(4,4),
     *          kcond(4,200),delf(4)
c
      ier=0
      ki=0
      do 15 i=1,4
      shift(i)=0.0
      kk=kcond(i,jj)
      if (kk.ne.0) then
                     ki=ki+1
                     delf(ki)=deltaf(i,jj)
                     do 10 j=1,4
                     qvd(ki,j)=qvet(i,j,jj)
   10                continue
                   endif
   15 continue
      kj=0
      do 25 j=1,4
      kk=kcond(j,jj)
      if (kk.ne.0) then
                     kj=kj+1
                     do 20 i=1,4
                     qvd(i,kj)=qvd(i,j)
   20                continue
                   endif
   25 continue
      do 28 i=1,ki
      do 28 j=1,ki
      qv(i,j)=qvd(i,j)
   28 continue
           if (kj.eq.1) then
                          deter=qv(1,1)
                          if (abs(deter).gt.0.001) then
                                            shift(1)=delf(1)/deter
                                                   else
                                                     ier=-1
                                                     return
                                                   endif
      else if (kj.eq.2) then
                          deter = qv(1,1)*qv(2,2) - qv(1,2)*qv(2,1)
                          if (abs(deter).lt.0.001) then
                                                     ier=-1
                                                     return
                                                   endif
                          detk = delf(1)*qv(2,2) - qv(1,2)*delf(2)
                          shift(1)=detk/deter
                          detk = qv(1,1)*delf(2) - delf(1)*qv(2,1)
                          shift(2)=detk/deter
      else if (kj.eq.3) then
                          call det3(qv,deter)
                          if (abs(deter).lt.0.001) then
                                                     ier=-1
                                                     return
                                                   endif
                          do 330 k=1,3
                          do 310 i=1,3
                          do 310 j=1,3
  310                     qv(i,j)=qvd(i,j)
                          do 320 i=1,4
  320                     qv(i,k)=delf(i)
                          call det3(qv,detk)
                          shift(k)=detk/deter
  330                     continue
      else if (kj.eq.4) then
                          call det4(qv,deter)
                          if (abs(deter).lt.0.001) then
                                                     ier=-1
                                                     return
                                                   endif
                          do 430 k=1,4
                          do 410 i=1,4
                          do 410 j=1,4
  410                     qv(i,j)=qvd(i,j)
                          do 420 i=1,4
  420                     qv(i,k)=delf(i)
                         call det4(qv,detk)
                          shift(k)=detk/deter
  430                     continue
                        endif
      do 500 i=1,4
      delf(i)=shift(i)
  500 shift(i)=0.0
      j=0
      do 510 i=1,4
      if (kcond(i,jj).ne.0) then
                              j=j+1
                              shift(i)=delf(j)
                            endif
  510 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine det3(qv,deter)
c
c-- compute the determinant of 3*3 matrix
c
      dimension qv(4,4)
c
      deter = qv(1,1) * ( qv(2,2)*qv(3,3) - qv(2,3)*qv(3,2) )
     1      - qv(1,2) * ( qv(2,1)*qv(3,3) - qv(2,3)*qv(3,1) )
     2      + qv(1,3) * ( qv(2,1)*qv(3,2) - qv(2,2)*qv(3,1) )
      return
      end
c-----------------------------------------------------------------------
      subroutine det4(qv,deter)
c
c-- compute the determinant of 4*4 matrix
c
      dimension qv(4,4)
c
      double precision qv3344,qv4334,qv3144,qv3244,qv4134,qv4234,qv3142,
     *                 qv3143,qv3243,qv4132,qv4133,qv4233,b1,b2,b3,b4,
     *                 deter8
c
      qv3344 = qv(3,3)*qv(4,4)
      qv4334 = qv(4,3)*qv(3,4)
      qv3144 = qv(3,1)*qv(4,4)
      qv3244 = qv(3,2)*qv(4,4)
      qv4134 = qv(4,1)*qv(3,4)
      qv4234 = qv(4,2)*qv(3,4)
      qv3142 = qv(3,1)*qv(4,2)
      qv3143 = qv(3,1)*qv(4,3)
      qv3243 = qv(3,2)*qv(4,3)
      qv4132 = qv(4,1)*qv(3,2)
      qv4133 = qv(4,1)*qv(3,3)
      qv4233 = qv(4,2)*qv(3,3)
      b1= qv(2,2) * ( qv3344 - qv4334 )
     1  - qv(2,3) * ( qv3244 - qv4234 )
     2  + qv(2,4) * ( qv3243 - qv4233 )
      b2= qv(2,1) * ( qv3344 - qv4334 )
     1  - qv(2,3) * ( qv3144 - qv4134 )
     2  + qv(2,4) * ( qv3143 - qv4133 )
      b3= qv(2,1) * ( qv3244 - qv4234 )
     1  - qv(2,2) * ( qv3144 - qv4134 )
     2  + qv(2,4) * ( qv3142 - qv4132 )
      b4= qv(2,1) * ( qv3243 - qv4233 )
     1  - qv(2,2) * ( qv3143 - qv4133 )
     2  + qv(2,3) * ( qv3142 - qv4132 )
      deter8 = qv(1,1) * b1
     2      - qv(1,2) * b2
     3      + qv(1,3) * b3
     4      - qv(1,4) * b4
      if(dabs(deter8).gt.0.1E+35) deter8=0.0
      deter=deter8
      return
      end
c----------------------------------------------
      subroutine angl(IH,IK,IL,IU,IV,IW,ANGG)
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      dimension rcell(6)
      rcell(1)=astar**2
      rcell(2)=bstar**2
      rcell(3)=cstar**2
      rcell(4)=astar*bstar*coscs
      rcell(5)=astar*cstar*cosbs
      rcell(6)=bstar*cstar*cosas
      QSP =
     &        IH*IU*RCELL(1)+(IK*IW+IL*IV)*RCELL(6)
     &       +IK*IV*RCELL(2)+(IL*IU+IH*IW)*RCELL(5)
     &       +IL*IW*RCELL(3)+(IH*IV+IK*IU)*RCELL(4)
      QPO = 
     &        IU*IU*RCELL(1)+(2.0*IV*IW)*RCELL(6)
     &       +IV*IV*RCELL(2)+(2.0*IW*IU)*RCELL(5)
     &       +IW*IW*RCELL(3)+(2.0*IU*IV)*RCELL(4)
      QPP = 
     &        IH*IH*RCELL(1)+(2.0*IK*IL)*RCELL(6)
     &       +IK*IK*RCELL(2)+(2.0*IL*IH)*RCELL(5)
     &       +IL*IL*RCELL(3)+(2.0*IH*IK)*RCELL(4)
      ARG = QSP/(SQRT(QPP)*SQRT(QPO))
      if(arg.gt.1.0)arg=1.0          
      arg=abs(arg)
      ANGG = ACOS(ARG)
      RETURN
      end
c-----------------------------------------------------------------------
c     output peak heights, peak coordinates and cluster numbers
c     and special positions information
      subroutine outpea(host,izpk,klast)
      character host*80,buffer*130,specie*2
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),nno(8),nk,nat,f(9),nalf(8)
      common /atoms/ x(5,200),nz(200),idumx(21)
      common /atomo/ xyzo(5,200),nzo(200),dold(400)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /sdir/ dm,npc,nproj,nojoin,jplt
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/xfour/ itype,iprint,numero,iw,il  ,im  ,iv  ,ix
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /emap1/ fwhm,npor(3),npror,nngr11,npar11
      common /neutro/ neutro,bmat(2,98),neuwei,vetint(200)
      common /mess/ Message,ifMess,lMess
      character *80 Message
      dimension xo(11),xn(11),keyx(10),newvet(48,3),izpk(500)
      dimension on(8)
c
c-- klast=1 ultima chiamata ad outpea
c
      if (klast.eq.0) then
                        do 100 i=1,nats
                        x(4,i)=abs(vetint(i))
                        nz(i)=1
  100                   izpk(i)=0
                        kaction=2
                        if (maxcyc.eq.0) then
                                           call label(nats,on)
                                           iprsav=iprin
                                           iprin=max0(3,iprin)
                                           kaction=5
                                         endif
                        call maincl(izpk,kaction,iprin)
c
c-- E-map plot
c
                   if (maxcyc.eq.0) then
                        do 110 i=1,nats
  110                   x(4,i)=vetint(i)
                        interp=1
                        call frm15(nats,numset,interp)
                        jab=1
                        call topl
                        call molplo(jab)
                        Message=' E-map plot '
                        ifMess=1    
                        lMess=12
                        call PrintMess
                              endif
                    endif
c
c-new
      if (iprin.le.1) go to 915
      khead=0
      iactn=2
      ifspec=0
      do 840 i=1,nats
      do 830 k=1,3
  830 xo(k)=x(k,i)
      iser=i
      k=kspecb(buffer,newvet,xo,xn,keyx,itype,iser,khead,iactn)
      if (keyx(10).gt.1) ifspec=1
  840 continue
c-endnew
  915 khead=0
      if (iprin.gt.1) then
                        iactn=3
                        write(lo,900) itle
                        rfac=errem*100.0
                        if (rfac.gt.0.0) then
                            if(jrest.eq.0) then
                                write(lo,905) nats,rfac,jrecyc,lsx
                                           else
                                write(lo,906) nats,rfac,jrecyc
                                           endif
                                         endif
                        call xwrifl
Corig                   write(lo,910)
                        if (ifspec.eq.0) then
                                           write(lo,910)
                                           lbuff=79
                                         else
                                           write(lo,912)
                                           lbuff=130
                                         endif
                      else
                        iactn=2
                      endif
  900 format(/,1h ,79('-'),//,2x,20a4,/)
  905 format(//,3x,'Final R value using',i4,' atoms is ',f7.2,'%',
     *      '  after ',i2,'  cycles ',/,
     *          3x,'( minimum in cycle ',i2,' ).'/)
  906 format(//,3x,'Final R value using',i4,' atoms is ',f7.2,'%',
     *      '  after ',i2,'  cycles.'/)
  910 format(/,
     1  6h type ,4hpeak,2x,6hheight,5x,1hx,6x,1hy,6x,1hz,2x,8hfragment,
     *        /)
  912 format(
     *  49x,1hi,18(1h-),'   special positions information   ',
     *  18(1h-),1hi,//,
     *  21x,'i--- found  in ---i',9x,'i--- moved  to ---i',
     4   9x,'i---------  restrictions  on  ---------i',/,
     1  6h type ,4hpeak,2x,6hheight,5x,1hx,6x,1hy,6x,1hz,2x,8hfragment,
     3  2x,1hx,6x,1hy,6x,1hz,6x,'occ.',5x,
     4  'l.s.q. shifts & thermal parameters    site',/)
c
      do 951 i=1,nats
      izpki=izpk(i)
      is=1
      if (izpk(i).lt.0) then
                          is=-1
                          kfrag=0
                          izpki=iabs(izpki)
                          if (izpki/100.gt.nk) then
                                                 izpki=0
                                                 is=0
                                               endif
                        else
                          kfrag=mod(izpki,100)
                        endif
      izpki=izpki/100
      kk=iabs(nk-izpki+1)
      if(jrecyc.eq.0) x(4,i)=vetint(i)
      nz(i)=is*(kk*100+kfrag)
Corig if (iprin.gt.1) then
             do 918 k=1,130
  918        buffer(k:k)=' '
             k=nint(vetint(i))
             if (kk.le.nk) then
c
c-- checks the agreement between the signs of the peak and 
c   the scattering amplitude of assigned chemical specie
c
                      sg=1.0
                      if(neutro.gt.0) sg=k*bs(1,kk)
                      if(sg.lt.0.0) then
                              write(specie,'(a2)') 'nl'    
                                     else
                              write(specie,'(a2)') nalf(kk)
                              call ucase(specie(1:1))
                                   endif
c   
                           else
                      write(specie,'(a2)') 'Q '    
                    endif
             write(buffer,920) specie,i,k,(x(j,i),j=1,3),kfrag
  920 format(2x,a2,i5,i8,2x,3f7.3,i5,i15)
             iser=i
             do 930 k=1,3
             xyzo(k,i)=x(k,i)
  930        xo(k)=x(k,i)
             do 940 k=4,11
  940        xo(k)=0.0
             k=kspecb(buffer,newvet,xo,xn,keyx,itype,iser,khead,iactn)
             x(5,i)=1.0
             occ=keyx(10)
             if (occ.gt.1.0) then
                        call site(buffer,newvet,keyx,1,k)
                        do 945 k=1,3
  945                   x(k,i)=xn(k)
                        x(5,i)=1.0/occ
                      endif
      if (iprin.gt.1) then
                        write(lo,'(a)') buffer(1:lbuff)
                      endif
  951 continue
c
      iprin=iprsav
      if(jrecyc.ne.0.and.maxcyc.eq.0) then
c
      do 975 i=1,nats
      x(4,i)=abs(vetint(i))
      do 975 k=1,3
      x(k,i)=xyzo(k,i)
  975 continue
      kaction=2
      call maincl(izpk,kaction,iprin)
      do 980 i=1,nats
      izpki=izpk(i)
      is=1
      if (izpk(i).lt.0) then
                          is=-1
                          kfrag=0
                          izpki=iabs(izpki)
                          if (izpki/100.gt.nk) then
                                                 izpki=0
                                                 is=0
                                               endif
                        else
                          kfrag=mod(izpki,100)
                        endif
      izpki=izpki/100
      kk=iabs(nk-izpki+1)
      x(4,i)=vetint(i)
      nz(i)=is*(kk*100+kfrag)
 980  continue
                             endif
      return
      end
c-----------------------------------------------------------------------
