c-- sirpow.92                                         Release 93.05
       subroutine invar(ier)
c
c-- invariant main routine
c
      character cff
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/rc/p(6),cx(9),dumc(9)
c
      common /inp/  natom,fnat,satm,atoms
      common /prin/ ipt,ip0,ip10,ipq
      common /proc/ iftr,ifp10,ifnq,ifps,ifcoc,ifweig
      common/param/ifat1,ifat2,ifatx,lreci,idx,icst1,icst2,icst3,duma(3)
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nref,nweak,sgg,nstr,nzro
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/numk,ntrs,ntr10,sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee(24,6)
      common/esti/ib(3),ih(3,2,24),ii(2,24)
      common/nq/nor1(6),nop1(6),iseg1(6),icodqn,sumc,sums,sume
      common/wrt/icv(4,7),ishf,ifas,eewrt(3),icodx(3),iqua(1000),
     1           itac(5,24,4),eee(3)
      common/lst13/l13,m13,md13,l13f,m13f,n13f
      common/zero/argq(26),ncal(26),nver(26),ntt,fm(26),gt(26)
      common /pseud/ kmat(48,3,3),emme,patom,qatom,npseud,lpseud(4,3)
     1         ,scale,jmme,prod,prod2,mjn(5,11),njn,coef,nw(8),no(8)
      common /xdata/ ish(3,800),itype(800)  
     1,itab(8000),itab1(8000),isr(100000),isig(3,5000),gq(5000),gv(5000)
     2,dummm(36600),dummpc(63200)
      common /neutro/ neutro,bmat(2,98),neuwei,vetint(200)
      character rescha(7)*32,line(2)*8
      integer result(7,2)
      data rescha/
     *            '     positive estimated triplets',
     *            '     negative estimated triplets',
     *            ' enantiomorph sensitive triplets',
     *            '               psi-zero triplets',
     *            '                  psi-e triplets',
     *            '     negative estimated quartets',
     *            ' enantiomorph sensitive quartets'/
c
      if (ipripe.gt.0) then
                         write(cff,'(i1)') kff
                         write(lo,10) cff,itle
                       endif
   10 format(///,a1 ,120('+'),//,
     1 39h SIRPOW.92 : Invariants routine        ,68x,14hRelease  93.05
     2 ,/,/,20x,20a4,/,1h ,120('+'),/)
c-- read directives
      call dirinv(ifpse,ier)
      if (ier.lt.0) goto 1000
      mode=0
      call inpt9(ier,coefs,mode,npse)
c-- if known structure the statistics are always performed
Corig if (knw.eq.1.and.ifp10.eq.0.and.ifcoc.eq.1) then
      if (ifp10.eq.0.and.ifcoc.eq.1) then
                                                    numk=-1
                                                    ifp10=2
                                                  endif
      if (ier.lt.0) goto 1000
      if (ifpse.lt.0) goto 1000
      do 100 i=1,7
      do 100 j=1,2
  100 result(i,j)=0
      if (npseud.eq.0) go to 5
      if (ipripe.eq.0) go to 5
      write(lo,1) npseud
    1 format(/,45x,i1,' pseudo-translation(s) provided',/)
      do 2 j=1,npseud
    2 write(lo,3) (lpseud(i,j),i=1,4)
    3 format(54x,i1,2hh+,i1,2hk+,i1,2hl=,i2,1hn)
      write(lo,4) patom,qatom,coef,coefs
    4 format(//,34x,
     *       ' < e**2 > computed through least squares straight line'
     *,//,50x,' slope =',f8.3,/,47x,'intercept =',f8.3,
     *  /,20x,'   applied coeff. for w-w-w triplets =',f8.3,
     *  /,20x,' subgested coeff. for w-w-w triplets =',f8.3,//)
c-----------------
    5 ipp=ip0+ipt+ip10+ipq
      ili0=0
      if(ipp.gt.0) call outp
      iprin=ip0
      if(ifps.gt.0) call strip9(1,mode,npse,result,ili0)
      iprin=ipq
      if (ifnq.gt.0) call negq(result)
      iprin=ipt
      ili0=0
      if (iftr.gt.0) then
          call strip9(0,mode,npse,result,ili0)
          iprin=ip10
          numcoc=result(1,2)
          if (ifp10.ge.1) call p10(result)
          if (ifcoc.eq.0.and.numk.gt.0) then
                                          if (ipripe.gt.0) 
     *                                    write(lo,1400) numcoc,numk
                                        else
                                          call cancella(10)
                                          call cancella(11)
                                          if (ipripe.gt.0) 
     *                                    write(lo,1450)
                                        endif
                           endif
 1400 format(/,i5,' triplets have been strengthned by ',i3,
     *         '  free vectors using p-10 formula')
 1450 format(/,' triplets have been estimated using p-3 formula')
      if (ifpse.gt.0) then
                        mode=1
                        call inpt9(ier,coefs,mode,npse)
                        if (ier.lt.0) goto 1000
                        if (mode.eq.1)
     *                  call strip9(1,mode,npse,result,ili0)
                      else
                        call cancella(24)
                      endif
c-- final print
      if (ipripe.eq.0) go to 2100
      write(lo,1500)
 1500 format(//,10x,31x,'number of relationships',//,
     *         10x,32x,' calculated   stored   ')
      do 2000 i=1,7
      do 1800 j=1,2
      line(j)='        '
      if (result(i,j).eq.0) then
                              write(line(j),1600)
                            else
                              write(line(j),1700) result(i,j)
                            endif
 1600 format('       -')
 1700 format(i8)
 1800 continue
      write(lo,1900) rescha(i),(line(j),j=1,2)
 1900 format(/, 9x,a32,a8,3x,a8)
 2000 continue
      if (result(1,2).eq.0) then
                              write(lo,2050)
 2050 format(//,
     * '  *** error *** no suitable positive triplets stored',/,
     * '                the program cannot procede')
                              ier=-1
                              return
                            endif
 2100 if (ifper.eq.0) call modg(ier)
 1000 return
      end
c----------------------------------------------------------
      subroutine dirinv(ifpse,ier)
      character line*80,dire*80,diret*80
      character blank,digit*12,card(100)*80,ffile*80
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /chara/ blank,digit,card,ffile
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ jhmax(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common/proc/ iftr,ifp10,ifnq,ifps,ifcoc,ifweig
      common/param/ifat1,ifat2,ifatx,lreci,idx,icst1,icst2,icst3,duma(3)
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nref,nweak,sgg,nstr,nzro
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/numk,ntrs,ntr10,sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1
      common /pseud/ kmat(48,3,3),emme,patom,qatom,npseud,lpseud(4,3)
     1         ,scale,jmme,prod,prod2,mjn(5,11),njn,coef,nw(8),no(8)
      dimension vet(40),ivet(40)
c
c-- set default values
      ifpse=0
      sogpo=0.6
      sogen=0.2
      sogne=-0.2
      iprin=0
      iftr=1
c-- the default formula used is p-10
      ifp10=1
      ifcoc=0
      call yfl02
      call ysfl07(nrefl,idum1,idum2,idum3,idum4)
      ifps=1
      ifnq=1
      nreft=0
      emin=0.0
      ntr10=0
      numk=0
      ntrt=0
      ntrs=0
      nrefp=0
      nrefpl=0
      emax=0.3
Corig ecros=0.75
Corig ecr1=0.75
Corig iecros=int(ecros*100)
Corig iecr1=int(ecr1*100)
      ecros=1.00
      ecr1=3.0 
      iecros=100
      iecr1=300
      nsog=40
      sqes=0.2
      ncode=7
      icody=0
      ier=0
      coef=99999.0
c -- set the size of  ish  matrix
      idx=1000
      ic=0
      icmax=icomq(icomat,2)
c
  100 continue
      ic=ic+1
      if (ic.gt.icmax) go to 9000
      ipdir=ipdir+1
      line=card(ipdir)
      diret=line
      call cutst(line,lenp,dire,lend)
      call lcase(dire)
c-- directives with numeric parameters
      iopt=0
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 8000
      if (dire(1:4).eq.'nsig') then
          if (iv.ne.0) go to 8000
          iftr=0
          go to 100
          endif
      if (dire(1:4).eq.'coch') then
          if (iv.ne.0) go to 8000
          ifcoc=1
          ifp10=0
          go to 100
          endif
      if (dire(1:4).eq.'nqua') then
          if (iv.ne.0) go to 8000
          ifnq=0
          go to 100
          endif
      if (dire(1:4).eq.'npsi') then
          if (iv.ne.0) go to 8000
          ifps=0
          go to 100
          endif
      if (dire(1:4).eq.'emin') then
          if (iv.ne.1) go to 8000
          emin=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'nrtr') then
          if (iv.ne.1) go to 8000
          nreft=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'corr') then
          if (iv.ne.1) go to 8000
          coef=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'gmin') then
          if (iv.ne.1) go to 8000
          sogpo=vet(1)
          if (sogpo.le.sogen) sogpo=sogen+0.0001
          go to 100
          endif
      if (dire(1:4).eq.'pten') then
          if (iv.gt.1) go to 8000
          if (iv.eq.1) ntr10=ivet(1)
          ifcoc=0
          ifp10=1
          go to 100
          endif
      if (dire(1:4).eq.'prin') then
          if (iv.ne.1) go to 8000
          iprin=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'numk') then
          if (iv.ne.1) go to 8000
          numk=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'emax') then
          if (iv.ne.1) go to 8000
          emax=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'nlar') then
          if (iv.ne.1) go to 8000
          nrefpl=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'nrps') then
          if (iv.ne.1) go to 8000
          nrefp=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'ypsi') then
          if (iv.ne.0) go to 8000
          ifpse=1
          go to 100
          endif
      write(lo,6000) diret
 6000 format(' wrong directive on following line:',/a)
      go to 100
 8000 continue
      ier=-1
      write(lo,'(22h error in directive : ,a80)') diret
      return
 9000 continue
corig if (emin.lt.1.2) emin=1.2
      if (emin.eq.0.0) emin=1.0
      if (nreft.gt.500) nreft=500
      if (nrefpl.eq.0) nrefpl=nreft
      if (nrefp.gt.300) nrefp=300
      if (ifps.eq.0) ifnq=0
c     if (ifpsie.eq.1) then
c                       ifnq=0
c                       iftr=0
c                       ifp10=0
c                     endif
      ipt=iprin
      ip0=iprin
      ip10=iprin
      ipq=iprin
      return
      end
c-----------------------------------------------------------------------
      subroutine inpt9(ier,coefs,mode,npse)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/rc/p(6),cx(9),dumc(9)
      common/sf/al(4,8),bs(4,8),cl(8),nz(8),ny(8),nk,nat,f(9),nalf(8)
c
      common /inp/  natom,fnat,satm,atoms
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      common/proc/ iftr,ifp10,ifnq,ifps,ifcoc,ifweig
      common/prin/ ipt,ip0,ip10,ipq
      common/param/ifat1,ifat2,ifatx,lreci,idx,icst1,icst2,icst3,duma(3)
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nref,nweak,sgg,nstr,nzro
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/numk,ntrs,ntr10,sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1
      common /xdata/ ish(3,800),itype(800)  
     1,itab(8000),itab1(8000),isr(100000),isig(3,5000),gq(5000),gv(5000)
     2,dummm(36600),dummpc(63200)
      common /pseud/ kmat(48,3,3),emme,patom,qatom,npseud,lpseud(4,3)
     1         ,scale,jmme,prod,prod2,mjn(5,11),njn,coef,nw(8),no(8)
      common /trre/ rho(3),eps(3),sq(3),sn(3),fn(3,8),ipcod(3),msym,
     *              naold(8),nanew(8)
c--
      integer hkl(3)
      dimension vet(12),ivet(12)
      equivalence(vet(1),ivet(1))
c
c-- esk = minimum value of e for free vectors in p10 formula
c
corig esk=1.4
c
      pi=4*atan(1.0)
      twopi=2.*pi
      dtor=pi/180.0
c     set up sin/cos table
      do 10 i=1,450
      sint(i)=sin(dtor*float(i-1))
   10 continue
c
c -----
c     call sub. per lettura lista 1 : parametri della cella
c -----
      call yfl01
      do 21 i=1,3
   21 abc(i)=cx(i)
      do 22 i=4,6
   22 ang(i-3)=cx(i)
c -----
c     call sub. per lettura lista 2 : simmetria
c -----
      call yfl02
c -----
c     call sub. per lettura lista 3 : contenuto cella
c -----
      call yfl03
      do 23 i=1,8
      nw(i)=nz(i)
   23 no(i)=ny(i)
c -----
c     call sub. per lettura preambolo lista 7
c -----
      call ysfl07(nrefl,nstr,nzro,npseud,iy)
c-- segue il blocco 1 frammento traslato
      fnat=s3s2
c---- compute the number of free vectors
      msym=nsym*(icent+1)
      atoms=(1.0/fnat)**2.0
      natom=int(atoms+0.05)
      if (numk.ne.0) go to 25
      numk=natom/msym+30
      numk=min0(numk,70)
   25 lreci=100000
      icst1=268435456
      icst2=134217728
      icst3=32768
      nupos=0
c -- set the max. numb. of enant. and neg. triplets to write onto jrel
      nmxte=500
      nmxtn=500
c -- set the numb. of neg. quartets to calculate and write onto jrel
      nquam=2000
      nquat=500
c -- set the numb.of enant. quart. to calculate and write onto jrel
      nqenm=500
      nqent=500
c
c
      ifat1=(2*ihx(3)+1)*(2*ihx(2)+1)
      ifat2=(2*ihx(3)+1)
      ifatx=ihx(1)*ifat1+ihx(2)*ifat2+ihx(3)
      if (ifatx.gt.lreci) go to 1100
      jmme=msym
      emme=float(jmme)
      do 30 m=1,nsym
      do 30 i=1,3
      do 30 j=1,3
      if (icent.ne.0) ksmat(m+nsym,i,j)=-ksmat(m,i,j)
   30 continue
c-- if there are pseudotranslation effects
c-- sigma-2 are calculated using p3 formula
      if (npseud.gt.0) then
                         emin=1.0
                         call sfl19(lpseud,patom,qatom)
                         nreft = nrefl - nzro
                         nreft = min0(499,nreft)
                         if (nreft.gt.nrefl) nreft=nrefl
                         if (nrefpl.eq.0) nrefpl=nreft
                         ifp10=0
                         if (knw.eq.1) ifp10=2
                         numk=-1
                         call prepa(coefs)
                       endif
      ic=0
      ict=0
      alfa=0.0
c ---      set some default values
      if(nreft.eq.0) nreft=nstr
      if(nrefpl.eq.0.or.nrefpl.gt.nreft) nrefpl=nreft
      if(nzro.gt.300) nzro=300
      if(nrefp.eq.0) nrefp=nzro
c
      if (numk.gt.nreft) numk=nreft
c
      nstr=max0(nreft,numk)
      if (nrefl-nrefp.gt.nstr) go to 480
      nrefp=nrefl-nstr
      if (mode.eq.0) go to 500
      if (ipripe.gt.0) write(lo,460)
  460 format(//,' *** warning *** : there are no psi-e reflections'/)
      mode=-1
      return
  480 if(mode.eq.0) goto 500
      npse=0.8*float(nreft)
      npse=min0(npse,300)
      if(nrefl-nrefp.le.nreft+npse) npse=nrefl-nrefp-nreft
      nrefp=npse
c
  500 do 700 i=1,nrefl
      call snr07(vet)
      e=vet(4)
corig if (e.gt.esk) jsk=i
      if (e.lt.emin.or.ict.eq.nreft) go to 750
      ict=ict+1
      em=e
  750 hkl(1)=ivet(1)
      hkl(2)=ivet(2)
      hkl(3)=ivet(3)
      iphi8=mod(ivet(8),2**15)
      iphi=iphi8/32
      jcode=mod(iphi8,32)
      ic=ic+1
      ish(1,ic)=((hkl(1)+64)*128+hkl(2)+64)*128+hkl(3)+64
      ish(2,ic)=int(e*100.+0.5)*512+iphi
      if (npseud.ne.0) call alfas(alfa,hkl)
      ish(3,ic)=int(alfa*1000.0)
      itype(ic)=jcode
      if(ic.eq.nstr) goto 850
  700 continue
  850 nreft=ict
c
c-- update numk value
c
      emin=em
      if(nrefpl.gt.nreft) nrefpl=nreft
      ic=0
      nsup=nrefp
      npsx=idx-nreft
      nstr=max0(nreft,numk)
      if(nsup.le.npsx) goto 860
      nsup=npsx
      nrefp=npsx
  860 if (mode.eq.1) then
                         ifin=nreft+npse
                         nccris=nreft+1
                         emax=999.9
                         ind=nreft
                         mdavi=1
                      else
                        ind=nreft+nsup+1
                        mdavi=-1
                        nccris=nrefl-nsup+1
                        ifin=nrefl
                      endif
      call ysfl07(nrefl,nstr,nzro,npseud,iy)
      do 1000 i=1,ifin
      call snr07(vet)
      if(i.lt.nccris) go to 1000
      ind=ind+mdavi
      e=vet(4)
      if (e.gt.emax) go to 1000
      ic=ic+1
      hkl(1)=ivet(1)
      hkl(2)=ivet(2)
      hkl(3)=ivet(3)
      iphi8=mod(ivet(8),2**15)
      iphi=iphi8/32
      jcode=mod(iphi8,32)
      ish(1,ind)=((hkl(1)+64)*128+hkl(2)+64)*128+hkl(3)+64
      ish(2,ind)=int(e*100.+0.5)*512+iphi
      if (npseud.ne.0) call alfas(alfa,hkl)
      ish(3,ind)=int(alfa*1000.0)
      itype(ind)=jcode
      if(ic.eq.nsup) return
 1000 continue
      nrefp=ic
      return
 1100 write(lo,1200) lreci,ifatx
 1200 format(//,'actual size of isr ( =',i5,' ) is less then maximum sup
     1er-index = ',i5)
      ier=-1
      return
      end
c-----------------------------------------------------------------------
      subroutine strip9(ipsi0,mode,npse,result,ili0)
c--calculate triplets
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common /ureq1/ ncycl,nroset,nundset,alambda,nsec,machkl,uvwt(4),
     *               pfwhm
c
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common/param/ifat1,ifat2,ifatx,lreci,idx,icst1,icst2,icst3,duma(3)
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nref,nweak,sgg,nstr,nzro
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/numk,ntrs,ntr10,sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1
      common /pseud/ kmat(48,3,3),emme,patom,qatom,npseud,lpseud(4,3)
     1         ,scale,jmme,prod,prod2,mjn(5,11),njn,coef,nw(8),no(8)
      common /xdata/ ish(3,800),itype(800)  
     1,itab(8000),itab1(8000),isr(100000),isig(3,5000),gq(5000),gv(5000)
     2,dummm(36600),dummpc(63200)
      common /cp10/ nor(3),dumd(156)
      common/sf/al(4,8),bs(4,8),cl(8),nwno(16)   ,nk,nat,f(9),nalf(8)
c--
      character rescha(13)*9,linex(3)*9
      dimension ill(3),jvet(3),mh(3),mk(3),ml(3),vet( 7),kvet(16)
      dimension ist(2,3),gt(3),iphit(3),ivet(48)
      integer result(7,2)
      data rescha/'   any   ','         ','  30,210 ','  45,225 ',
     *'  60,240 ','         ','  90,270 ','         ',' 120,300 ',
     *' 135,315 ',' 150,330 ','         ','   0,180 '/
c--
c
c
c--description of some important settings
c
c  h1 = h2 + h3
c  i  h1 code
c  j  h2 code
c in  h3 code
c mh  h,k,l first  reflection
c mk  h,k,l second reflection
c ml  h,k,l third  reflection
c     ipsi0 = 0   ->  sigma2
c     ipsi0 = 1   ->  psi-zero
c      mode = 0   ->  sigma2 or psi-zero
c      mode = 1   ->  psi-e
c
c*******************************************************************
      gdvmn=0.0
      anat=float(nat)/(pts*float((icent+1)*nsym))
      k=int(4.0*anat+100.5)
      if (icent.eq.1) k=k+50
      if (nsym.eq.1) k=k+50
      k=min0(k,499)
      k=k+min0(499-k,100)/2
      k=min0(k,nreft)
      do 100,i=1,1000
       e=float(ish(2,k)/512)/100.
Corig if(e.ge.1.2) then
      if(e.ge.1.0) then
       gr=e*e*e*fnat
       goto 101
      else
       k=k-1
      endif        
 100  continue
 101  continue
c--
      iloop=0
 9999 npsi0=0
      iconts=0
      sqp4=atan(1.)
      pi=4.*sqp4
      dtor=pi/180.
      rtod=1./dtor
c-- segue il blocco 2 frammento traslato
      if (ipripe.gt.0) then
         if (ipsi0.eq.0) write(lo,10) nreft,emin
         if (ipsi0.eq.1.and.mode.eq.0) write(lo,20) nrefpl,nrefp
         if (ipsi0.eq.1.and.mode.eq.1) write(lo,25) nrefpl,nrefp
       endif
   10 format(//,' Sigma2 relationships estimated among the ',
     *i4,' strongest reflections - (Emin =',f5.2,')')
   20 format(/,' Psizero relationships estimated among the ',
     *i4,' strongest and the ',i4,'  weakest reflections',/)
   25 format(//,' Psi-e relationships among the ',i4,
     1 '  strongest and the ',i4,'  following  reflections')
c--clear the areas
c
      if (npseud.gt.0.and.knw.ne.0) then
                                      do 1002 i=1,5
                                      do 1002 j=1,11
 1002                                 mjn(i,j)=0
                                      njn=0
                                      if (icent.eq.1) then
                                                        call clrt
                                                      else
                                                        call nclrt
                                                      endif
                                    endif
      do 1001 k=1,8000
      itab(k)=0
1001  continue
      do 1004 i=1,ifatx
      isr(i)=0
1004  continue
c--create the list
      ipu=0
      do 1900 j=1,nstr
      call schkl(j,jvet)
      do 1100 i=1,nsym
      do 1111 i1=1,3
      ill(i1)=0
      do 1111 j1=1,3
      ill(i1)=ill(i1)+jvet(j1)*ksmat(i,j1,i1)
 1111 continue
      indr=ill(1)*ifat1+ill(2)*ifat2+ill(3)
      indrr=indr
      if (i.eq.1) go to 1113
      imen1=i-1
      do 1112 i1=1,imen1
      if (indr.eq.ivet(i1)) indrr=0
 1112 continue
 1113 ipu=ipu+1
      ivet(i)=indrr
      a=jvet(1)*tmat(i,1)+jvet(2)*tmat(i,2)+jvet(3)*tmat(i,3)
      k=nint(a*24.)
      k=mod(k,24)
      if(k.lt.0) k=k+24
      itab(ipu)=indrr
      itab1(ipu)=((ill(2)+64)*128+ill(3)+64)*32+k
      isgn=isign(1,indr)
      indr=iabs(indr)
      if(isr(indr).eq.0)isr(indr)=(j*24+i)*isgn
 1100 continue
 1900 continue
      n8t=4000
      if (npseud.gt.0) n8t=n8t+1000
c--modif 8.5.85 mercedes
      if(ipsi0.gt.0)n8t=4000
      jsup =nreft-1
      if(ipsi0.ne.0) jsup=nrefpl-1
c     if(mode.ne.0) n8t=7000
c--calculate sigma 2
      jt=0
      n8=0
      n8e=0
      sgg=0.0
      if(iprin.eq.0) go to 1530
      if(ipsi0.eq.0)write(lo,1525)
      if(ipsi0.gt.0)write(lo,1535)
1525  format(/,' set up sigma2 relationships')
1535  format(/,' set up psizero relationships')
1530  continue
c--first loop
c
      do 50 i=1,3
      do 50 j=1,5000
      isig(i,j)=0
 50   continue
      ninf=1
      nsup=nreft-2
      if(ipsi0.eq.0)go to 1000
      ninf=nreft+1
      nsup=nreft+nrefp
             if(mode.eq.0) go to 1000
             if(icent.eq.0) then
             if (iloop.eq.0) then
                edv1=float(ish(2,1)/512)*0.01
                edv2=float(ish(2,nreft)/512)*0.01
                edv3=float(ish(2,ninf)/512)*0.01
                edv4=float(ish(2,nsup)/512)*0.01
                gdvmx=edv1*edv1*edv3
                gdvmn=edv2*edv2*edv4
                gdvmn=fnat*(gdvmn+0.40*(gdvmx-gdvmn))
                gdvmn=amax1(0.6,gdvmn)
                if (gdvmn.gt.1.0) gdvmn=1.0
                jgdv=nint(gdvmn*100.0)
                              endif
                if (iprin.gt.0)
     *          write(lo,455) edv1,edv2,edv3,edv4,gdvmn
  455        format(//5x,'efmx =',f8.3,'   efmn =',f8.3,'   eemx =',
     *       f8.3,'   eemn =',f8.3,5x,'g(min) for psi-e =',f8.3//)
                      else
                       gdvmn=0.6
                       if (iprin.gt.0)
     *                 write(lo,456) gdvmn
456      format(//5x, 'centrosymmetric, g(min) for psi-e =',f8.3//)
                endif
 1000 inn1=1-nsym
      do 2000 i=ninf,nsup
      e1=float(ish(2,i)/512)/100.
      ityp1=itype(i)
      if(n8.lt.n8t) goto 1580
      if(ipsi0.gt.0)go to 1580
      jg=nint(e1*e1*e1*fnat*100.0)
      jc=int(gq(n8)*100.)
      if(jg.lt.jc )go to 2400
 1580 if(iprin.lt.2) goto 2005
      call schkl(i,ill)
      ifi=mod(ish(2,i),512)
      write(lo,2004) (ill(n),n=1,3),i,e1,ifi
 2004 format(/,' reflection ',3i4,10x,
     1 'code = ',i4,10x,
     2 'e = ',f7.2,10x,
     3 'phase =',i7,/)
      js=0
 2005 if(ipsi0.gt.0)go to 2007
      inn1=inn1+nsym
      it=itab1(inn1)/32
      jk1=it/128-64
      jl1=it-(jk1+64)*128-64
      i1=i
      go to 2008
 2007 call schkl(i,jvet)
      jh1=jvet(1)
      jk1=jvet(2)
      jl1=jvet(3)
      i1=0
c
c--second loop
c
 2008 ins=(i-1)*nsym+1
      ih31=itab(ins)
      if(ipsi0.gt.0) ih31=jh1*ifat1+jk1*ifat2+jl1
      jinf=i1+1
      do 2100 j=jinf,jsup
      e2=float(ish(2,j)/512)/100.
      ityp2=itype(j)
      i0=2*nsym
      do 2110 ii=1,i0
      ivet(ii)=0
 2110 continue
      i0=0
      jn=(j-1)*nsym
      do 2200 k=1,nsym
      jnk=jn+k
      if(itab(jnk).eq.0) goto 2200
      it=itab1(jnk)/32
      jk2=it/128-64
      jl2=it-(jk2+64)*128-64
      do 2300 l=1,3,2
      l1=l-2
      ih32=itab(jnk)
      ih3=ih31+ih32*l1
      l3=1
      if(ih3) 2010,2300,2020
 2010 l3=-1
      ih3=-ih3
 2020 if(ih3.gt.ifatx) go to 2300
      if(isr(ih3).eq.0) go to 2300
      jk=iabs(jk1+jk2*l1)
      if(jk.gt.ihx(2)) go to 2300
      jl=iabs(jl1+jl2*l1)
      if(jl .gt.ihx(3)) go to 2300
      if(isr(ih3).lt.0) l3=-l3
      isra=isr(ih3)
      isra=iabs(isra)
      in=isra/24
      if(in.le.j) go to 2300
      if(in.gt.jsup+1) goto 2300
      if(i0.eq.0)go to 2030
      do 2040  ii=1,i0
      if(in.eq.ivet(ii))go to 2300
 2040 continue
 2030 i0=i0+1
      ivet(i0)=in
      in3=isra-in*24
      ins=(in-1)*nsym+in3
      ns3=mod(itab1(ins),32)
      ns2=mod(itab1(jnk),32)
      is =-ns2*l1+ns3*l3+48
      is =mod(is ,24)
      iss=is*360/24
c
c  phi(t)=phi(h1)-phi(h2)-phi(h3)+shift(fase)
c  i codici sono per  h1 = h2 + h3
c  cod(h2)= -l1 * j
c  cod(h3)=  l3 * in
c
      iphi= mod(ish(2,i),512)+mod(ish(2,j),512)*l1-mod(ish(2,in),512)*l3
     1  +iss
      if(iphi.lt.0)iphi=iphi+3600
      iphi=mod(iphi,360)
      e3=float(ish(2,in)/512)/100.
      ityp3=itype(in)
c --------------------------------------------------------------------
c
c   routine for triplets symmetry inconsistent
c
c --------------------------------------------------------------------
      if(icent.gt.0) goto 5000
      if(ityp1.eq.1.or.ityp2.eq.1.or.ityp3.eq.1) goto 5000
      isotyp=(ityp1-1) + l1*(ityp2-1) - l3*(ityp3-1)
      isopha=isotyp*15 + iss
      imo=mod(isopha,180)
      if(imo.eq.0) goto 5000
      iconts=iconts+1
      if(iconts.gt.10) goto 2300
      if(ipripe.eq. 0) goto 2300
      do 4475 ini1=1,3
 4475 linex(ini1)=' ??????? '
      write(linex(1),4485) rescha(ityp1)
      write(linex(2),4485) rescha(ityp2)
      write(linex(3),4485) rescha(ityp3)
 4485 format(a9)
      if(ili0.ne.0) goto 4600
      ili0=1
      write(lo,4500)
 4500 format(//, '  the following triplets are symmetry inconsistent',
     1 ': they have been excluded from the procedure',//,
     2 10x,3('code',2x,'ph.rest.',5x),/)
 4600 write(lo,4700) i,linex(1),j,linex(2),in,linex(3)
 4700 format(10x,3(1x,i3,1x,a9,5x))
      if(iconts.eq.10) write(lo,4710)
 4710 format(10x,' ..... and so on',/)
      goto 2300
 5000 continue
      g=fnat*e1*e2*e3
c****************************************************************
      if (g.lt.gr.and.ipsi0.eq.0) goto 2300
c****************************************************************
c-- segue il blocco 3 frammento traslato
      if (npseud.le.0) go to 2033
c
c--------------------------------------------------------------
c
      call pseudt(g,i,j,in,l1,l3,k,in3,mh,mk,ml,e1,e2,e3,vet,kvet)
c
c---- we reject the triplet if weak-weak-weak  (and psi-zero also)
      ireje=kvet(5)+kvet(10)+kvet(15)
      if (ireje.eq.0.and.ipsi0.eq.1) go to 2300
      if (abs(g).lt.0.001.and.ipsi0.eq.0) go to 2300
c
      kvet( 1)=i
      kvet( 6)=j
      kvet(11)=in
c
c--------------------------------------------------------------
c
      if (knw.eq.0) go to 2033
      ljn=kvet(5)+kvet(10)+kvet(15)+kvet(16)/1000
      gg=(2-icent)*g
      if (njn.eq.10) go to 2041
      if (njn.eq.0) go to 2032
      do 2031 jj=1,njn
      if (ljn.eq.mjn(1,jj)) go to 2039
 2031 continue
      go to 2032
 2041 jj=11
      go to 2039
 2032 njn=njn+1
      mjn(1,njn)=ljn
      mjn(2,njn)=kvet( 5)
      mjn(3,njn)=kvet(10)
      mjn(4,njn)=kvet(15)
      mjn(5,njn)=kvet(16)
      jj=njn
 2039 b=float(iphi)*pi/180.0
      a=cos(b)
      an=a*gg
      if (icent.eq.1) go to 2034
      bang=iphi
      if (iphi.gt.180) bang=360.0-bang
      call nctet(gg,a,bang,jj)
      go to 2033
 2034 continue
      call sctst(gg,an,jj)
c
c-----------------------------------------------------------
c
 2033 if(icent.eq.0) g=2.*g
c
c     we reject psi-zero if arg.gt.0.2 ( if pseudotranslation exists )
c
      if (npseud.gt.0.and.g.gt.0.2) npsi0=npsi0+1
      if (ipsi0.gt.0.and.npseud.gt.0.and.g.gt.0.2) go to 2300
c
c     reject psi-e if g.lt.gdvmin (mean g value)
      if(mode.gt.0.and.g.lt.gdvmn) go to 2300
      gb=g
      if(g.gt.20.47) gb=20.47
      jg=nint(gb*100.0)
      if(iprin.lt.2)go to 2027
      js=js+1
      jt=jt+1
      ist(1,jt)=-j*l1
      ist(2,jt)=in*l3
      gt(jt)=g
      iphit(jt)=iphi
      if(jt.ne.3) go to 2027
      write(lo,2026) ((ist(n,nn),n=1,2),gt(nn),iphit(nn),nn=1,3)
 2026 format(3(2x,2i4,2f7.2,3i4))
      jt=0
 2027 if(n8.eq.n8t) go to 2320
      n8=n8+1
      gq(n8)=g
      sgg=sgg+gq(n8)
c *******************************************************
c **  is   =  d-shift del tripletto
c **  i    =  code del primo riflesso
c **  j    =  code del secondo riflesso
c **  in   =  code del terzo riflesso
c **  k    =  operatore di simm. del secondo riflesso
c **  in3  =  operatore di simm. del terzo riflesso
c **  l1   =  segno del secondo riflesso
c **  l3   =  segno del terzo riflesso
c **  jg   =  int(g*100)
c **  iphi =  fase reale del tripletto
c ********************************************************
      isig(1,n8)=((i+2048)*4096+l1*j+2048)*32+iphi/15+1
      isig(2,n8)=((-l3*in+2048)*4096+jg+2048)*32+is+1
      isig(3,n8)=((k*32+in3)*4096+jg+2048)*32+mod(iphi,15)+1
      go to 2300
 2320 if(ipsi0.gt.0)go to 2400
      if(n8e.ne.0)go to 2330
      call sortg(n8)
      n8m=n8
      n8l=n8
      gm=gq(n8m)
 2330 n8e=n8e+1
      if(g.lt.gm)go to 2300
      sgg=sgg-gq(n8m)+g
      gq(n8m)=g
      isig(1,n8m)=((i+2048)*4096+l1*j+2048)*32+iphi/15+1
      isig(2,n8m)=((-l3*in+2048)*4096+jg+2048)*32+is+1
      isig(3,n8m)=((k*32+in3)*4096+jg+2048)*32+mod(iphi,15)+1
      gm=100.
      n8lm1=n8l-1
      if(n8lm1.lt.1) n8lm1=1
      do 2340 ii=n8lm1,n8
      ga=gq(ii)
      if(ga.gt.gm)go to 2340
      gm=ga
      n8m=ii
 2340 continue
      n8l=min0(n8l,n8m)
 2300 continue
 2200 continue
 2100 continue
      if(iprin.lt.2) go to 2000
      if(jt.eq.0) go to 2002
      write(lo,2026) ((ist(n,nn),n=1,2),gt(nn),iphit(nn),nn=1,jt)
      jt=0
2002  continue
      write(lo,2101) js
2101  format(' number of contributors =',i6)
      js=0
2000  continue
2400  continue
      n8e=n8e+n8
      if(ipsi0.gt.0) goto 2500
c-- segue il blocco 4 frammento traslato
      if (iprin.gt.0) write(lo,3000)n8e,n8
      result(1,1)=n8e
      result(1,2)=n8
      call sortg(n8)
      igm=gq(n8)*1000.
 3000 format(i8,' triplet(s) calculated and',i6,' stored')
 4000 format(i8,' psizero triplet(s) calculated and',i6,' stored',
     1 i6,' rejected')
      ntra=n8
      call wrtr9(1,igm,npse)
      if (npseud.le.0.or.knw.eq.0) return
      if(icent.eq.1) then
                       call stst
                     else
                       call nstst
                     endif
      return
 2500 if (mode.eq.1) go to 5550
      npsa=n8
      if (iprin.gt.0) write(lo,4000)n8e,n8,npsi0
      result(4,1)=n8e
      result(4,2)=n8
      call wrtr9(2,igm,npse)
      return
 5550 continue
      if (iloop.eq.0) then
                        nrap=n8/nrefp
                        if (nrap.le.10.and.jgdv.gt.60) then
                                                  gdvmn=gdvmn-0.15
                                                  gdvmn=amax1(0.6,gdvmn)
                                                  iloop=1
                                                  if (ipripe.gt.0)
     *                                                write(lo,5555)
 5555 format(' insufficient psi-e found - lower g value and try again')
                                                  go to 9999
                                                endif
                      endif
      ntra=n8
      result(5,1)=n8e
      result(5,2)=n8
      mcycl=ncycl+1
      if (ipripe.gt.0) write(lo,5200) n8e,n8,mcycl
 5200 format(/,i8,' psi-e triplet(s) calculated and',i6,
     *            ' stored (serial ',i2,')')
      call wrtr9(4,igm,npse)
      return
      end
c-----------------------------------------------------------------------
      subroutine prepa(coefs)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,atoms
      common /pseud/ kmat(48,3,3),emme,patom,qatom,npseud,lpseud(4,3)
     1         ,scale,jmme,prod,prod2,mjn(5,11),njn,coef,nw(8),no(8)
      common /xdata/ ish(3,800),itype(800)  
     1,itab(8000),itab1(8000),isr(100000),isig(3,5000),gq(5000),gv(5000)
     2,dummm(36600),dummpc(63200)
      prod=1.0
      do 20 i=1,npseud
   20 prod=prod*float(lpseud(4,i))
      prod2=prod*prod
      call senti
      nnn=prod*jmme
      i8=8
      do 25 i=1,i8
      isig(1,i)=nw(i)
      isig(2,i)=no(i)
   25 gq(i)=no(i)
      call sortg(i8)
      do 28 i=1,i8
      nw(i)=isig(1,i)
   28 no(i)=isig(2,i)
      nnc=0
      do 30 i=1,i8
      if (nw(i).eq.0) go to 40
      j=i
      nnc=nnc+nw(i)
      if (nnn.le.nnc) go to 40
   30 continue
   40 z1=no(1)
      z2=no(j)
      dz=(z1-z2)/z1
      coefs=-dz/2.0
      if (coef.gt.99000.0) coef=coefs
      return
      end
c----------------------------------------------------------------------
      subroutine senti
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,atoms
      common/param/ifat1,ifat2,ifatx,lreci,idx,icst1,icst2,icst3,duma(3)
c
      do 10 i=1,3
   10 ang(i)=ang(i)*pi/180.0
      a1=cos(ang(1))
      a2=cos(ang(2))
      a3=cos(ang(3))
      s1=sin(ang(1))
      s2=sin(ang(2))
      s3=sin(ang(3))
      arg=1.0-a1*a1
     1       -a2*a2
     2       -a3*a3
     3       +a1*a2*a3*2.0
      v=abc(1)*abc(2)*abc(3)*sqrt(arg)
      astar=abc(2)*abc(3)*s1         /v
      bstar=abc(1)*abc(3)*s2         /v
      cstar=abc(1)*abc(2)*s3         /v
      cosas=(a2*a3-a1)/(s2*s3                 )
      cosbs=(a1*a3-a2)/(s1*s3                 )
      coscs=(a1*a2-a3)/(s1*s2                 )
      return
      end
c----------------------------------------------------------------
      subroutine outp
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/proc/ iftr,ifp10,ifnq,ifps,ifcoc,ifweig
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nref,nweak,sgg,nstr,nzro
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      write(lo,10) nstr
   10 format('   list of the',i4,'  strongest reflections'/)
      call outp1 (1,nstr)
      if(iftr.eq.0.and.ifnq.eq.0) return
      iniz=nstr+1
      ifin=nstr+nrefp
      write(lo,40) nrefp
   40 format('0  list of the',i4,'  weakest reflections for psizero and/
     1or negative quartets cross-vectors'/)
      call outp1(iniz,ifin)
      return
      end
c -----------------------------------------------
      subroutine outp1(iniz,ifin)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/proc/ iftr,ifp10,ifnq,ifps,ifcoc,ifweig
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nref,nweak,sgg,nstr,nzro
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common /xdata/ ish(3,800),itype(800)  
     1,itab(8000),itab1(8000),isr(100000),isig(3,5000),gq(5000),gv(5000)
     2,dummm(36600),dummpc(63200)
      dimension icod(5),ihkl(3,5),e(5),iphi(5)
      nr=0
      do 30 i=iniz,ifin
      nr=nr+1
      call schkl(i,ihkl(1,nr))
      e(nr)=float(ish(2,i)/512)/100.
      icod(nr)=i
      iphi(nr)=mod(ish(2,i),512)
      if(nr.lt.5.and.i.lt.ifin) goto 30
      write(lo,20)(icod(j),(ihkl(k,j),k=1,3),e(j),iphi(j),j=1,nr)
   20 format(' ',5(i3,'*',3i3,f5.2,i4,2x))
      nr=0
   30 continue
      return
      end
c ------------------------------------------------------
      subroutine equit(x,k)
c
c-- calcola il riflesso equivalente per la matrice  k-esima
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common /pseud/ kmat(48,3,3),emme,patom,qatom,npseud,lpseud(4,3)
     1         ,scale,jmme,prod,prod2,mjn(5,11),njn,coef,nw(8),no(8)
      integer x(3),x1(3)
c
      do 10 i=1,3
      x1(i)=0
      do 10 j=1,3
   10 x1(i)=x1(i)+x(j)*ksmat(k,j,i)
      do 20 i=1,3
   20 x(i)=x1(i)
      return
      end
c----------------------------------------------------------------
c
      subroutine pseudt(gnew,nor1,nor2,nor3,is2,is3,nop2,nop3,hkl1,hkl2,
     *                  hkl3,e1,e2,e3,vet,kvet)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,atoms
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      common /pseud/ kmat(48,3,3),emme,patom,qatom,npseud,lpseud(4,3)
     1         ,scale,jmme,prod,prod2,mjn(5,11),njn,coef,nw(8),no(8)
      common /xdata/ ish(3,800),itype(800)  
     1,itab(8000),itab1(8000),isr(100000),isig(3,5000),gq(5000),gv(5000)
     2,dummm(36600),dummpc(63200)
      integer hkl1(3),hkl2(3),hkl3(3)
      dimension vet( 7),kvet(16)
c
      call schkl(nor1,hkl1)
      call schkl(nor2,hkl2)
      call schkl(nor3,hkl3)
      call equit(hkl2,nop2)
      call equit(hkl3,nop3)
      do 10 i=1,3
      hkl2(i) = hkl2(i)*is2
   10 hkl3(i) =-hkl3(i)*is3
      isum1=0
      do 15 i=1,3
   15 isum1=iabs(hkl1(i)+hkl2(i)+hkl3(i))+isum1
      if (isum1.ne.0) then
                        write(lo,*) nor1,nor2,nor3,nop2,nop3,hkl1,hkl2,
     *                  hkl3
                        write(lo,*) '****  programming  error  ****'
                        write(lo,*) ' sir ends in error'
                        stop 1234
                      endif
      if (npseud.eq.0) go to 20
cccc
c----------   se alfa1 opp. alfa2 opp. alfa3 = 0 allora beta=0
c----------   i valori di sin(theta)/lambda calcolati in testa
cccc
      call sent(hkl1,rho1)
      call sent(hkl2,rho2)
      call sent(hkl3,rho3)
      q1=patom*rho1+qatom
      q2=patom*rho2+qatom
      q3=patom*rho3+qatom
      if (q1.gt.0.99) q1=0.99
      if (q2.gt.0.99) q2=0.99
      if (q3.gt.0.99) q3=0.99
cccc  qfin=amax1(q1,q2,q3)
cccc
      qfin=(q1+q2+q3)/3.0
cccc
      alfa1=float(ish(3,nor1))/1000.0
      alfa2=float(ish(3,nor2))/1000.0
      alfa3=float(ish(3,nor3))/1000.0
      call betas(beta,hkl1,hkl2,hkl3)
      com=    (alfa1*(1.0-q1)+q1)
     1   *    (alfa2*(1.0-q2)+q2)
     2   *    (alfa3*(1.0-q3)+q3)
c
      satom=sqrt(atoms)
c
      s3pm =(1.0-qatom)/satom
      s3q  =(    qatom)/satom
      s3ppp=(prod -1.0)*(qfin-qatom)/(satom*prod )
      spp  = s3ppp
      g1=0.0
      g2=0.0
      ig=0
      zer=0.0001
      if (alfa1.lt.zer) ig=ig+1
      if (alfa2.lt.zer) ig=ig+1
      if (alfa3.lt.zer) ig=ig+1
      if (ig.eq.3) g1=1.0
      if (ig.eq.2) g2=1.0
      gn = s3pm*beta*prod2/emme + s3q * ( 1.0 + coef*g1 ) + g2*s3ppp
      gn = gn / sqrt(com)
      gnew=gn*e1*e2*e3
      enhk=gn*gn
      if (abs(enhk).gt.zer) enhk=1.0/enhk
      if (gnew.ge.0.0) go to 20
   20 do 30 i=1,3
      kvet( 1+i)=hkl1(i)
      kvet( 6+i)=hkl2(i)
   30 kvet(11+i)=hkl3(i)
      kvet( 5)=int(alfa1*1000.0)
      kvet(10)=int(alfa2*1000.0)
      kvet(15)=int(alfa3*1000.0)
      kvet(16)=int(beta*1000.0)
      vet(1)=e1
      vet(2)=e2
      vet(3)=e3
      vet(4)=com
      vet(5)=prod
      vet(6)=gnew
      vet(7)=enhk
      return
      end
c---------------------------------------------------------------
      subroutine sent(hh,rho)
      integer hh(3)
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
c
      q=hh(1)*hh(1)*astar*astar
     1 +hh(2)*hh(2)*bstar*bstar
     2 +hh(3)*hh(3)*cstar*cstar
     3 +2.0*hh(2)*hh(3)*bstar*cstar*cosas
     4 +2.0*hh(3)*hh(1)*cstar*astar*cosbs
     5 +2.0*hh(1)*hh(2)*astar*bstar*coscs
      rho=0.25*q
      return
      end
c----------------------------------------------------------------------
      subroutine betas(beta,hkl1,hkl2,hkl3)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,atoms
      common /pseud/ kmat(48,3,3),emme,patom,qatom,npseud,lpseud(4,3)
     1         ,scale,jmme,prod,prod2,mjn(5,11),njn,coef,nw(8),no(8)
      integer hkl(3,3),hkl1(3),hkl2(3),hkl3(3)
c
      beta=0.0
      do 10 i=1,3
      hkl(i,1)=hkl1(i)
      hkl(i,2)=hkl2(i)
      hkl(i,3)=hkl3(i)
   10 continue
      do 100 i=1,jmme
      do  80 j=1,npseud
      do 80 ll=1,3
      isum=0
      do  50 k=1,3
      isum1=0
      do  30 l=1,3
      isum1=isum1+hkl(l,ll)*ksmat(i,l,k)
   30 continue
      isum=isum+isum1*lpseud(k,j)
   50 continue
      if(mod(isum,lpseud(4,j)).ne.0)go to 100
   80 continue
      beta=beta+1.0
  100 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine alfas(alfa,hkl)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,atoms
      common /pseud/ kmat(48,3,3),emme,patom,qatom,npseud,lpseud(4,3)
     1         ,scale,jmme,prod,prod2,mjn(5,11),njn,coef,nw(8),no(8)
      integer hkl(3)
c
      gamma=0.0
      do 100 i=1,jmme
      do  80 j=1,npseud
      isum=0
      do  50 k=1,3
      isum1=0
      do  30 l=1,3
      isum1=isum1+hkl(l)*ksmat(i,l,k)
   30 continue
      isum=isum+isum1*lpseud(k,j)
   50 continue
      if(mod(isum,lpseud(4,j)).ne.0)go to 100
   80 continue
      gamma=gamma+1.0
  100 continue
      alfa=prod*gamma/emme
      return
      end
c----------------------------------------------------------------
      subroutine unpak3(index,kod1,kod2,ifaz)
      isave=index/32
      ifaz=index-isave*32 -1
      kod1=isave/4096
      kod2=isave-4096*kod1-2048
      kod1=kod1-2048
      return
      end
c-----------------------------------------------------
      subroutine besse(xx,vec)
c--bessel function
c
      x=abs(xx)
      vec=amin1((x+0.4807)*x/((x+0.8636)*x+1.3943),1.0)
      if (xx.lt.0.0) vec=-vec
      return
      end
c ----------------------------------------------------------------------
      function bes(x)
      is=1
      if(x.lt.0.0) is=-1
      x1=abs(x)
      if(x1.lt.0.000001)  go to 200
      if(x1.le.2.9) go to 180
      if(x1.le.7.5) go to 160
      if(x1.le.20.) go to 140
      if(x1.le.39.) go to 120
      if(x1.le.45.) go to 100
      if(x1.le.55.) go to  80
      if(x1.le.65.) go to  60
      if(x1.le.80.) go to  40
      if(x1.le.99.) go to  20
      bes=1.*is
      return
   20 bes=0.0000631*x1+.988652
      bes=abs(bes)*is
      return
   40 bes=0.0000933*x1+.9862355
      bes=abs(bes)*is
      return
   60 bes=0.00014*x1+.9832
      bes=abs(bes)*is
      return
   80 bes=0.00021*x1+.97935
      bes=abs(bes)*is
      return
  100 bes=0.0000666*x1+.9858026
      bes=abs(bes)*is
      return
  120 bes=0.9459 +0.00187*x1-0.00002*x1*x1
      bes=abs(bes)*is
      return
  140 bes=0.82227+0.02189*x1-0.00114*x1*x1+0.00002*x1*x1*x1
      bes=abs(bes)*is
      return
  160 bes=0.444+0.19096*x1-0.02697*x1*x1+0.00135*x1*x1*x1
      bes=abs(bes)*is
      return
  180 bes=-0.00718+0.5668*x1-0.12287*x1*x1 +0.008*x1*x1*x1
      bes=abs(bes)*is
      return
  200 bes=0.
      return
      end
c ----------------------------------------------------------------------
      function besinv(y)
      if (abs(y).lt.0.000001)  go to  200
      if (y.le.0.6989)  go to 180
      if (y.le.0.8666) go to 160
      if (y.le.0.9259)  go to 140
      if (y.le.0.9553)  go to 120
      if (y.le.0.9635)  go to 100
      if (y.le.0.9884) go to 90
      if (y.le.0.9888) go to 80
      if (y.le.0.9909) go to 70
      if (y.le.0.9923) go to 60
      if (y.le.0.9937) go to 50
      if (y.le.0.9949) go to 40
      besinv=100.
      return
   40 besinv=15833.333*y-15653.583
      return
   50 besinv=10714.285*y-10566.785
      return
   60 besinv=7142.8571*y-7022.8571
      return
   70 besinv=4761.9047*y-4663.5713
      return
   80 besinv=15000*y-14787
      return
   90 besinv=49773.46954-102737.23532*y+53033.83171*y*y
      return
  100 besinv=77576.4096-162332.52722*y+84935.62155*y*y
      return
  120 besinv=3117.15834-6767.58257*y+3681.64105*y*y
      return
  140 besinv=486.69735-1127.7574*y+658.80603*y*y
      return
  160 besinv=-82.06253+344.25645*y-478.71058*y*y+226.35886*y*y*y
      return
  180 besinv=-0.00252+2.1065*y-1.12674*y*y+3.09414*y*y*y
      return
  200 besinv=0
      return
      end
c-----------------------------------------------------------------------
      subroutine decom(i,g,ggv,ishi,iphi)
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee(24,6)
      common /xdata/ ish(3,800),itype(800)  
     1,itab(8000),itab1(8000),isr(100000),isig(3,5000),gq(5000),gv(5000)
     2,dummm(36600),dummpc(63200)
      call unpak3(isig(1,i),nor(1),nor(2),if1)
      call unpak3(isig(2,i),nor(3),ign,ishi)
      call unpak3(isig(3,i),kod,igv,if2)
      g=float(ign)/100.
      ggv=float(igv)/100.
      iphi=if1*15+if2
      kod=kod+2048
      nop(1)=1
      nop(2)=kod/32
      nop(3)=mod(kod,32)
      do 10 j=1,3
      iseg(j)=isign(1,nor(j))
      nor(j)=iabs(nor(j))
      k=nor(j)
      e=float(ish(2,k)/512)/100.
      eeb(j)=e*e-1.
   10 continue
      return
      end
c----------------------------------------------------------
      subroutine schkl(j,hkl)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common/param/ifat1,ifat2,ifatx,lreci,idx,icst1,icst2,icst3,duma(3)
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nref,nweak,sgg,nstr,nzro
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/numk,ntrs,ntr10,sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1
      common /xdata/ ish(3,800),itype(800)  
     1,itab(8000),itab1(8000),isr(100000),isig(3,5000),gq(5000),gv(5000)
     2,dummm(36600),dummpc(63200)
      integer hkl(3)
c--decompatta gli indici
c
c--
      k=ish(1,j)
      hkl(1)=k/16384-64
      k=ish(1,j)-(hkl(1)+64)*16384
      hkl(2)=k/128-64
      hkl(3)=mod(k,128)-64
      return
      end
c-----------------------------------------------------------------------
code for cancella
      subroutine cancella(iln)
c
c--clear the entry for a list in the current index table
c--iln = the list type number
c
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4)
      common/xfili/lfirst,nwblo,lindex(240)
c
      lista=iln
      mln=lindex(2)
      il =lindex(5)
      if(lista) 2051,2051,2210
 2210 continue
      if(lista-mln) 2220,2220,2051
 2220 continue
      i=lista*il+1
      lindex(i)=0
      i=lindex(6)
      call xup(lindex(3),lindex,i)
      call xdump
 2051 return
      end
c--------------------------------------------------------------------
      subroutine negq(result)
c--calculate negative quartet
c  h1 + h2 + h3 + h4 = 0
c  i  h1 code
c  j  h2 code
c jj  h3 code
c in  h4 code
c
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common/param/ifat1,ifat2,ifatx,lreci,idx,icst1,icst2,icst3,duma(3)
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nref,nweak,sgg,nstr,nzro
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/numk,ntrs,ntr10,sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee2(24,6)
      common/dirqn/ecros,iecros,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1
      common/enant/ nqenex,n23m,n23l,gm,nqen
      common/esti/ib(3),ih(3,2,24),ii(2,24)
      common/nq/nor1(6),nop1(6),iseg1(6),icodqn,sumc,sums,sume
      common/wrt/icv(4,7),ishf,ifas,ee(3),icodx(3),iqua(1000),
     1           itac(5,24,4),eee(3)
      common/lst13/l13,m13,md13,l13f,m13f,n13f
c
      common /xdata/ ish(3,800),itype(800),itab(8000),itab1(8000)
     1,isr(100000),isig(3,5000),inq(7,1000),inq2(7,500),dmmx(29700)
     * ,dummpc(69600)
c
      common /neutro/ neutro,bmat(2,98),neuwei,vetint(200)
c--
      dimension ev(7)
      integer result(7,2)
c--
c
      call recip
c--new 12/6/92
      if(ipripe.gt.0) then
      if(knw.eq.1) then
                     if (icent.eq.1) then
                                       call clrt
                                     else
                                       call nclrt
                                     endif
                   endif
      if (icent.eq.1) then
                        call clrt1
                      else
                        call nclrt1
                      endif
                      endif
c--endnew 12/6/92
c
c--calculate negative quartet(s) from psi-zero relationships.
c
c--ncode:codice per definire il tipo di quart.(in funzione dei c.v.)
c        da valutare.
c  ncode=0   tutti
c  ncode=1   1deb+1ass.spec.+1ass.
c  ncode=2   1deb+est.+1ass.
c  ncode=3   2deb+1ass.
c  ncode=4   2deb+1ass.spec.
c  ncode=5   2deb+1est.
c  ncode=6   3deb
c  ncode=7   2deb+1non forte(casi 3,4,5 e 6 insieme)
c  icody=1   valuta solo i quart. con equiv.
      if(ipripe.gt.0) write(lo,1) npsa
    1 format(/,' Negative quartets relationships estimated using ',
     *i6,' psi-zero relationships ')
      iend=0
      niqua=0
      liqua=60
      liqu3=liqua*3
      nquar=0
      nquae=0
      fnatt=fnat*fnat
      atcel=1./fnatt
      if(atcel.lt.70) then
                      sgnq=0.35
                      endif
      if(atcel.ge.70.and.atcel.lt.700) then
                      sgnq=0.35*exp(-((atcel-70)/500.))
                          endif
      if(atcel.ge.700) then
                      sgnq=0.1
                      endif
      if (icent.eq.0) then
                        sqes=-9999.0
                      else
                        sqes=sgnq
                      endif
      l13=1
      m13=l13
      md13=3
      n13f=1000/md13
      nqen=0
      nqenex=0
      do 101 i=1,7
      do 101 j=1,750
      inq(i,j)=0
 101  continue
      do 102 i=1,7
      do 102 j=1,500
  102 inq2(i,j)=0
      zer=0.0001
      npsm1=npsa-1
      do 1000 i=1, npsm1
      is1=isig(1,i)/131072-2048
      call schkl(is1,nop)
      indr=nop(1)*ifat1+nop(2)*ifat2+nop(3)
      ispec=isr(indr)/icst2
      ispec=mod(ispec,2)
      isr1=isr(indr)
      call decom(i,g1,dum,ishi,iphi)
      do 1100 k=2,3
      k1=k-1
      call xbc9(nor(k),k1,nsym)
      do 1752 jc=1,4
      icv(jc,k1)=itac(jc,nop(k),k1)*iseg(k)
1752  continue
      nop1(k)=nop(k)
      nor1(k)=nor(k)
      iseg1(k)= iseg(k)
 1100 continue
      iplus1=i+1
      do 2000 j=iplus1, npsa
      is2=isig(1,j)/131072-2048
      if(is1.ne.is2) goto 1000
c--quartetto
      do 1290 k=1,3
      icodx(k)=0
 1290 continue
      iflag=0
      do 1291 k=1,4
      do 1291 k1=5,7
      icv(k,k1)=0
      eee(k1-4)=0
 1291 continue
c -- v.b.
      call decom(j,g2,dum,ishi,iphi)
c --
c --  controllo di diversita' dei v.b.
      do 1110  k=2,3
      do 1110  k1=2,3
      if(nor(k).eq.nor1(k1)) goto 2000
 1110 continue
      do 1200 k=2,3
      k1=k+1
      iseg(k)=-iseg(k)
      call xbc9(nor(k),k1,nsym)
      do 1754 jc=1,4
      icv(jc,k1)=itac(jc,nop(k),k1)*iseg(k)
1754  continue
 1200 continue
c-- first c.v.
      do 1250 k=1,4
      icv(k,5)= (icv(k,1)+icv(k,2))
 1250 continue
      eee(1)=float(ish(2,nor (1))/512)/100.
      ee(1)=eee(1)*eee(1)-1
      iqua(l13)=-nor(1)
      if(ispec.ne.0)iflag=iflag+1
c--c.v.
      m13=l13
      iqua(2)=0
      iqua(3)=0
      do 1301 k=2,3
      ied=iedeb(k,nor(1),0)
      if(ied.ne.0) go to 2000
 1301 continue
      do 1300 k1=1,2
      if(icodx(k1).ge.2) goto 2000
 1300 continue
      icont=6-icodx(1)*3-icodx(2)*2-icodx(3)
      if(icont.eq.0) then      
                        write(lo,*) '**** subroutine negq ****'
                        write(lo,*) '**** programming  error ****'
                        write(lo,*) ' sir ends in error'
                       stop   
                     endif
      if(icont.lt.3) go to  2000
c--ishf=fase quart. vero (ifass)-fase quart. stan.(iphi)
      is=itac(5,nop1(2),1)*iseg1(2)+itac(5,  nop1(3),2)*iseg1(3)
     ,  +itac(5,  nop (2),3)*iseg(2)+itac(5,  nop (3),4)*iseg(3)
      is=96-is
      is=mod(is,24)
      iss=is*15
      ishf=iss
c--
      sumep=ee(1)+ee(2)+ee(3)
      if(icodx(3).ne.0.or.iflag.ne.0) goto 2650
      if(sumep.gt.-1) goto 2000
 2650 shf=float(is)*twopi/24.
      cosx=cos(shf)
      sinx=sin(shf)
      sumc=sumep*cosx
      sums=sumep*sinx
      iph1=mod(ish(2,nor1(2)),512)*iseg1(2)
      iph2=mod(ish(2,nor1(3)),512)*iseg1(3)
      iph3=mod(ish(2,nor (2)),512)*iseg (2)
      iph4=mod(ish(2,nor (3)),512)*iseg (3)
      iphi=iph1+iph2+iph3+iph4
      if(iphi.lt.0)iphi=iphi+1800
      iphi=mod(iphi,360)
      ifas=iphi
      ifass=ifas+ishf
      if(ifass.lt.0)ifass=ifass+1800
      ifass=mod(ifass,360)
      fass=float(ifass)*pi/180.
      ev(1)=float(ish(2,nor1(2))/512)/100.
      ev(2)=float(ish(2,nor1(3))/512)/100.
      ev(3)=float(ish(2,nor (2))/512)/100.
      ev(4)=float(ish(2,nor (3))/512)/100.
      g=ev(1)*ev(2)*ev(3)*ev(4)
      g=g*fnat*fnat
      do 1764 k1=1,3
      ev(k1+4)=ee(k1)
 1764 continue
      if(iflag.ne.0) then     
                      do 1292 k=4,liqu3
                      iqua(k)=0
 1292                 continue
                      niqua=niqua+1
                      if(iequi(nor(1),liqu3).lt.0) goto 2000
                     endif
      m13=l13
      gb=g
      if(g.gt.20.47) gb=20.47
      jg=nint(gb*100.0)
c--calcolo del gcorr.
      if(icodx(3).eq.0) then     
                           sums=sums+sin(shf)
                           sumc=sumc+cos(shf)
                        endif
c-------
      if(abs(sumc).lt.zer) go to 2000
      sum=sumc*sumc+sums*sums
      sum=sqrt(sum)
      gc=(2-icent)*g*sum
      if(gc.gt.20.47)gc=20.47
      jgc=nint(gc*100.0)
      thet =-atan2(sums,sumc)
      if(thet.lt.0)thet=thet+twopi
      theta=thet *360./twopi
      thet=thet+shf
      cost=cos(thet)
      if(gc.gt.sqes.or.icent.eq.1) goto 1430
      if(iend.eq.1) goto 2000
      call enan(jg,jgc,gc,is,thet,ifass,nquae,iend)
      goto 2000
 1430 if(cost.ge.0.or.gc.lt.sgnq) goto 2000
      ith=nint(thet*100.0)
      if (icont.lt.5) then      
                        gc=gc*0.85
                        jgc=nint(gc*100)
                      endif
      if(nquar.ne.nquat) then     
                            nquar=nquar+1
                            inq(1,nquar)=iseg1(2)*(nor1(2)*32+nop1(2))
                            inq(2,nquar)=iseg1(3)*(nor1(3)*32+nop1(3))
                            inq(3,nquar)=iseg (2)*(nor (2)*32+nop (2))
                            inq(4,nquar)=iseg (3)*(nor (3)*32+nop (3))
                            inq(5,nquar)=jg*32+is
                            inq(6,nquar)=jgc*1000+ith
                            inq(7,nquar)=(ifass*10*8+icont)
                            goto 2000
                         endif
      if(nquae.eq.0) then     
                            call sortc(nquar,inq)
                            n13m=nquar
                            n13l=nquar
                            jjgm=inq(6,nquar)/1000
                            gm=float(jjgm)/100.
                     endif
      nquae=nquae+1
      if(nquae.eq.nquam) goto 4000
      if(gc.ge.gm) then      
                     inq(1,n13m)=iseg1(2)*(nor1(2)*32+nop1(2))
                     inq(2,n13m)=iseg1(3)*(nor1(3)*32+nop1(3))
                     inq(3,n13m)=iseg (2)*(nor (2)*32+nop (2))
                     inq(4,n13m)=iseg (3)*(nor (3)*32+nop (3))
                     inq(5,n13m)=jg*32+is
                     inq(6,n13m)=jgc*1000+ith
                     inq(7,n13m)=(ifass*10*8+icont)
                     gm=100.
                     i00=n13l-1
                     if(i00.lt.1) i00=1
                     do 1650 ij=i00,nquar
                     jjga=inq(6,ij)/1000
                     ga=float(jjga)/100.
                     if(ga.le.gm) then          
                                    gm=ga
                                    n13m=ij
                                  endif
 1650                continue
                     n13l=min0(n13l,n13m)
                   endif
 2000 continue
 1000 continue
 4000 call sortc(nquar,inq)
      do 8888 i=1,nquar
      n1=inq(1,i)/32
      n2=inq(2,i)/32
      n3=inq(3,i)/32
      n4=inq(4,i)/32
      jgc=inq(6,i)/1000
      is=mod(inq(5,i),32)
      inq(1,i)=((n1+2048)*4096+n2+2048)*32
      inq(2,i)=((n3+2048)*4096+n4+2048)*32
      inq(3,i)=((1024+2048)*4096+jgc+2048)*32+is+1
c--NEW 12/6/92 introduco statistica quartetti negativi
      if(ipripe.gt.0) then
           ifass=iabs(inq(7,i)/80)
           b=float(ifass)*pi/180.
           a=cos(b)
           gg=-float(jgc)/100
           an=a*gg
           if (icent.eq.1) then
c-- centrosymmetric test
                        if (knw.eq.1) call sctst(gg,an,1)
                        call sctst1(gg,an)
                      else
c-- noncentrosymmetric test
                        g2=jgc/100
                        call besse(g2,coat)
                        g2=gg
                        coat=-coat
                        bang=ifass
                        if (ifass.gt.180) bang=360.0-bang
                        if (knw.eq.1) call nctet(g2,a,bang,1)
                        call nctet1(g2,coat,a)
                      endif
                   endif
c--endNEW 12/6/92 introduco statistica quartetti negativi
 8888 continue
      do 8899 i=1,nqen
      n1=inq2(1,i)/32
      n2=inq2(2,i)/32
      n3=inq2(3,i)/32
      n4=inq2(4,i)/32
      jgc=inq2(6,i)/1000
      is=mod(inq2(5,i),32)
      inq2(1,i)=((n1+2048)*4096+n2+2048)*32
      inq2(2,i)=((n3+2048)*4096+n4+2048)*32
      inq2(3,i)=((1024+2048)*4096+jgc+2048)*32+is+1
 8899 continue
c -----
c     call  sub.  per  scrittura  quartetti  negativi  :  lista   20
c -----
      iprea=0
      if(nquar.ne.0) then
                     call frmxx(iprea,20,nquar,nquar,nxxd,nxxe,iccd,inq)
              if(ipripe.gt.0) then
                     write(lo,2998)
                     if(knw.eq.1) then
                                    if (icent.eq.1) then
                                                      call stst
                                                    else
                                                      call nstst
                                                    endif
                                  endif
                              if (icent.eq.1) then
                                                call stst1
                                              else
                                                call nstst1
                                              endif
                                   endif
                    endif
 2998 format(/,38x,'         Negative quartets statistic')
c -----
c     call  sub.  per  scrittura  quartetti  enantiom. :  lista   21
c -----
      if(icent.eq.0.and.nqen.ne.0)
     *call frmxx(iprea,21,nqen,nqen,nxxd,nxxe,iccd,inq2)
      nquae=nquae+nquar
      nqenex=nqenex+nqen
      if (iprin.gt.0) then
      write(lo,2999)
 2999 format(1h )
      write(lo,3001)nquae,nquar
 3001 format(i8,' negative quartet(s) calculated and',i6,' stored')
      write(lo,2999)
      if (icent.eq.0) write(lo,3002) nqenex,nqen
 3002 format(i8,' enant.sens. quartet(s) calculated and',i6,' stored')
                      endif
      result(6,1)=nquae
      result(6,2)=nquar
      result(7,1)=nqenex
      result(7,2)=nqen
      if(ipripe.gt.0) write(lo,2999)
      return
      end
c---------------------------------------------------------------------
      function iedeb(i,im,i10)
c
c--controlla esistenza,debolezza ed specialita del ii-esimo c.v.
c--(tabella ies)
c
c--iedeb=0 ok.
c--iedeb=1 rifl. forte
c--iedeb=-1 no. ord. c.v. le n.ord. primo c.v.
c
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,atoms
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee2(24,6)
      common/param/ifat1,ifat2,ifatx,lreci,idx,icst1,icst2,icst3,duma(3)
      common/dirqn/ecros,iecros,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1
      common/esti/ib(3),ih(3,2,24),ii(2,24)
      common/nq/nor1(6),nop1(6),iseg1(6),icodqn,sumc,sums,sume
      common/wrt/icv(4,7),ishf,ifas,ee(3),icodx(3),iqua(1000),
     1           itac(5,24,4),eee(3)
      common/lst13/l13,m13,md13,l13f,m13f,n13f
      common /xdata/ ish(3,800),itype(800),itab(8000),itab1(8000)
     1,isr(100000),isig(3,5000),inq(7,1000),inq2(7,500),dmmx(29700)
     * ,dummpc(69600)
Corig common /xdata/ ish(3,600),itab(8000),itab1(8000),isr(80000)
c    1,evet(20000),isig(3,4000),inq(7,1000),inq2(7,500),dmmx(29700)
c
      if (i10.eq.0) then
                     ecr=ecros
                     iecr=iecros
                    else
                     ecr=ecr1
                     iecr=iecr1
                    endif
      iedeb=0
      ia=0
      i4=i+4
      i2=i+1
      do 900 jj1=i,3
      eee(jj1)=0
  900 ee(jj1)=0
      do 1000 jj1=1,4
      do 1000 jj2=i4,7
 1000 icv(jj1,jj2)=0
      ihy=icv(1,1)+icv(1,i2)
      ihyx=iabs(ihy)
c
c-- controlla se esiste il riflesso
c
      if (ihyx.gt.ifatx.or.ihyx.le.0)  goto 1900
      jk=icv(3,1)+icv(3,i2)
      if(iabs(jk).gt.ihx(2))  goto 1900
      jl=icv(4,1)+icv(4,i2)
      if(iabs(jl).gt.ihx(3))  goto 1900
c--controllo di debolezza.
      ie=isr(ihyx)
      if(ie.eq.0) goto 1900
      if(ie.ge.0) then      
c--riflesso non speciale forte o debole
                    ia=mod(ie,icst3)
                    eee(i)=float(ie/icst3)/100.
                    ee(i)=eee(i)*eee(i)-1
                    if(eee(i).gt.ecr) iedeb=1-i10
                    goto 1800
                  endif
      if(ie.eq.-4*icst1) then     
c--rifl.estinto
                          icodx(3)=icodx(3)+1
                          eee(i)=0.
                          ee(i)=0
                          iflag=iflag+1
                          goto 1800
                         endif
      if(ie.eq.-5*icst1)  then     
c--riflesso assente ma speciale
                            iflag=iflag+1
                            icodx(2)=icodx(2)+1
                            eee(i)=1.0
                            ee(i)=0.0
                            goto 1800
                          endif
      it=-ie/icst1
      if(it.eq.1) then      
c--rifl. tra i 200 forte (lista 7)
                    ie=-ie
                    ie=mod(ie,icst3)
                    ia=-ie
                    iedeb=1-i10
                    eee(i)=float(ish(2,ie)/512)/100.
                    ee(i)=eee(i)*eee(i)-1
                    goto 1800
                  endif
      if(it.eq.2) then     
c--rifl. tra i 50 piu deboli.
                   ie=-ie
                   ispec=ie/icst2
                   ispec=mod(ie,2)
                   ie=mod(ie,icst3)
                   ia=-ie
                   if(ie.lt.im) then     
                                  iedeb=-1
                                else
                                  eee(i)=float(ish(2,ie)/512)/100.
                                  ee(i)=eee(i)*eee(i)-1
c--rifl. spec.
                                  if(ispec.ne.0) iflag=iflag+1
                                endif
                   goto 1800
                  endif
c--riflesso speciale
      if(it.ne.3)  then
                        write(lo,*) '**** function iedeb  ****'
                        write(lo,*) '**** programming  error ****'
                        write(lo,*) ' sir ends in error'
                        stop 1234
                      endif
      ie=mod(ie,icst2)
      ia=mod(ie,icst3)
      ie=ie/icst3
c--rifl.forte spec
      eee(i)=float(ie)/100.
      ee(i)=eee(i)*eee(i)-1
      if(ie.gt.iecr) iedeb=1-i10
      if(iedeb.eq.0) iflag=iflag+1
 1800 icv(2,i4)=icv(2,1)+icv(2,i2)
      icv(3,i4)=jk
      icv(4,i4)=jl
      icv(1,i4)=icv(2,i4)*ifat1+icv(3,i4)*ifat2+icv(4,i4)
      iqua(m13+i-1)=ia
      return
 1900 icodx(1)=icodx(1)+1
      ee(i)=0
      return
      end
c---------------------------------------------------------------------
      subroutine xbc9(i,k,nn)
      common/wrt/icv(4,7),ishf,ifas,ee(3),icodx(3),iqua(1000),
     1           itac(5,24,4),eee(3)
c
      common /xdata/ ish(3,800),itype(800),itab(8000),itab1(8000)
     1,isr(100000),isig(3,5000),inq(7,1000),inq2(7,500),dmmx(29700)
     * ,dummpc(69600)
c
      in=(i-1)*nn
      do 10 n=1,nn
         inn=in+n
         itac(1,n,k)=itab(inn)
         ita=itab1(inn)/32
         ih=ita/16384-64
         itac(2,n,k)=ih
         ita=ita-(ih+64)*16384
         itac(3,n,k)=ita/128-64
         itac(4,n,k)=mod(ita,128)-64
         itac(5,n,k)=mod(itab1(inn),32)
   10 continue
      return
      end
c-------------------------------------------------------------
      function iequi(im,liqu3)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common/param/ifat1,ifat2,ifatx,lreci,idx,icst1,icst2,icst3,duma(3)
      common/dirqn/ecros,iecros,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1
      common/esti/ib(3),ih(3,2,24),ii(2,24)
      common/nq/nor1(6),nop1(6),iseg1(6),icodqn,sumc,sums,sume
      common/wrt/icv(4,7),ishf,ifas,ee(3),icodx(3),iqua(1000),
     1           itac(5,24,4),eee(3)
      common/lst13/l13,m13,md13,l13f,m13f,n13f
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee2(24,6)
c
      common /xdata/ ish(3,800),itype(800),itab(8000),itab1(8000)
     1,isr(100000),isig(3,5000),inq(7,1000),inq2(7,500),dmmx(29700)
     * ,dummpc(69600)
      dimension icvv(4,7)
      character iast(3),iblan,istar
c--
c
      data istar,iblan/'*',' '/
      iequi=0
      iop1=nop1(2)
      do 50 i=1,4
      do 50 j=1,7
   50 icvv(i,j)=icv(i,j)
      do 100 i=1,4
      icv(i,1)=itac(i,iop1,1)*iseg1(2)
 100  continue
c--m13 indirizzo del quart. originale
      n13f=1
      if (icent.eq.0) then
c--  caso non centrosimmetrico
                        lf=1
c--  caso centrosimmetrico
                      else
                        lf=3
                      endif
      m13 =l13+md13
      do 3000 i=1,nsym
      if(itac(1,i,2).eq.0) goto 3000
      do 1800 l=1,lf,2
      do 2000 j=1,nsym
      if(itac(1,j,3).eq.0) goto 2000
      do 1900 ll=1,lf,2
      ll2=2-l
      ll3=2-ll
c -- ih4 = superindice del 4-to vettore base
      ih4=itac(1,iop1, 1)*iseg1(2)+itac(1,i, 2)*ll2*iseg1(3)+
     1    itac(1,j,3)*ll3*iseg(2)
      if(ih4.ne.0) then     
              ih4=-ih4*iseg(3)
              do 1700 k1=1,nsym
              if(ih4.eq.itac(1,k1,4)) then      
                                        ll4=1
                                        go to 1750
                                      else
                                        if(icent.eq.0) goto 1700
                                        ll4=-1
                                    if(ih4.eq.-itac(1,k1,4)) goto 1750
                                      endif
 1700         continue
              goto 1900
 1750         continue
              ishn=itac(5,i, 2)*iseg1(3)*ll2+itac(5,j, 3)*iseg(2)*ll3+
     1        itac(5,k1,4)*iseg(3)*ll4+itac(5,iop1,1)*iseg1(2)
              ishn=-ishn
              ishn=ishn*15+720
              ishn=mod(ishn,360)
              lll2=ll2*iseg1(3)
              lll3=ll3*iseg (2)
              lll4=ll4*iseg (3)
              do 1752 jc=1,4
              icv(jc,2)=itac(jc,i,2)*lll2
 1752         continue
              do 1754 jc=1,4
              icv(jc,3)=itac(jc,j,3)*lll3
 1754         continue
              do 1756 jc=1,4
              icv(jc,4)=itac(jc,k1,4)*lll4
 1756         continue
              do 1760 k=1,3
              ied=iedeb(k,im,1)
              if(ied.ne.0) then     
                            if (iprin.eq.2)     
     *                      write(lo,4)((icv(jj,kkc),jj=2,4),kkc=1,4),
     1                       ((icv(j1,k1),j1=2,4),ee(k1-4),k1=5,7),ied
    4 format(2x,4(3i3,5x),3x,3(3i3,f5.2),'quart. rejected  iedeb=',i3)
                                goto 9000    
                           endif
 1760         continue
              do 1790 k1=1,3
              iast(k1)=iblan
              isto=    (iqua(m13+k1-1))
              if(isto.ne.0) then     
              m13f=l13
              do 1785 k=1,n13f
              do 1780 k2=1,3
              isto1=    (iqua(m13f+k2-1))
              if(isto.eq.isto1) then     
                                  iast(k1)=istar
                                  ee(k1)=0.
                                  iqua(m13+k1-1)=0
                                  goto 1790
                                endif
 1780         continue
              m13f=m13f+md13
 1785         continue
                            endif
 1790         continue
              if(iprin.eq.2)
     1        write(lo,1)((icv(jj,k),jj=2,4),k=1,4)
     2,((icv(j1,k1),j1=2,4),ee(k1-4),iast(k1-4),k1=5,7),ishn 
  1   format(2x,4(3i3,5x),3x,3i3,f5.2,a1,2(3i3,f5.2,a1),i5)
c--quartetto equivalente o.k. con almeno un c.v.
c  in icv(4,7) ho indici
c  in ishn     ho lo shift
c  in ee(3)    ho gli epsilon
c
              shn=ishn*twopi/360.
              sumep=ee(1)+ee(2)+ee(3)
              sume=sumep+sume
              cosx=cos(shn)
              sinx=sin(shn)
              sumc=sumep*cosx+sumc
              sums=sumep*sinx+sums
              if(iprin.eq.2)
     1        write(lo,9)sume,sumep,sumc,sums,cosx,sinx,shn,ishn
 9    format(1x,'sume=',e10.2,'sumeps= ',e10.2,' sumcos= ',e10.2,
     ,' sumsin= ',e10.2,' cos=',e10.2,' sin=',e10.2,f10.2,i10)
              m13=m13+md13
              if(m13.ge.liqu3) then     
              write(lo,10)nor1(2),nor1(3),nor(2),nor(3),liqu3
  10  format(4i6,' quartet with more than ',i4,' equivalents')
                              goto 9000
                               endif
              n13f=n13f+1
              endif
 1900 continue
 2000 continue
 1800 continue
 3000 continue
      goto 9050
 9000 iequi=-1
 9050 do 9060 i=1,4
      do 9060 j=1,7
 9060 icv(i,j)=icvv(i,j)
      return
      end
c----------------------------------------------------------
      subroutine geest
c--genera gli estinti
c
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common/param/ifat1,ifat2,ifatx,lreci,idx,icst1,icst2,icst3,duma(3)
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nref,nweak,sgg,nstr,nzro
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/numk,ntrs,ntr10,sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1
      common/esti/ib(3),ih(3,2,24),ii(2,24)
c
      common /xdata/ ish(3,800),itype(800),itab(8000),itab1(8000)
     1,isr(100000),isig(3,5000),inq(7,1000),inq2(7,500),dmmx(29700)
     * ,dummpc(69600)
c--
      dimension ia(3,3),tras(3),jhk(2,24)
c--
c--definizione della matrice differenza.
c--
      do 1000 k=1,nsym
      icp1=icent+1
      do 1100 k1=1,icp1
      ii(k1,k)=0
      ll1=1
      if(k1.eq.2)ll1=-1
      do 1110 j=1,3
      do 1120 i=1,3
      ll2=0
      if(i.eq.j)ll2=1
      ia(j,i)=ll2-ll1*ksmat(k,j,i)
 1120 continue
 1110 continue
c--analisi della matrice somma e differenza.
c
      do 1200 j=1,3
      ih(j,k1,k)=-1
      if(ia(j,j).eq.0)ih(j,k1,k)=0
      do 1300 i=1,3
      if(i.eq.j) goto 1300
      if(ia(i,j).ne.0) goto 1250
      if(ia(j,i).ne.0) goto 1250
 1300 continue
      ih(j,k1,k)=ih(j,k1,k)+1
 1250 if(ih(j,k1,k).eq.-1)ih(j,k1,k)=3
      ii(k1,k)=ii(k1,k)+ih(j,k1,k)
 1200 continue
c--analiza se ci sono due componenti uguali e diverse da 0
      if(ii(k1,k).lt.6) goto 1150
      do 1400 i=1,2
      i1=i
      if(ih(i,k1,k).ne.3) goto 1400
      iplus1=i+1
      do 1500 j=iplus1,3
      j1=j
      if(ih(i,k1,k).eq.ih(j,k1,k)) goto 1600
 1500 continue
 1400 continue
c--analiza se il determinante e' diverso da 0
 1600 in=ia(i1,i1)*ia(j1,j1)-ia(i1,j1)*ia(j1,i1)
      jhk(k1,k)=1
      im=isign(1,ia(i1,i1))+isign(1,ia(j1,j1))
     1  +isign(1,ia(i1,j1))+isign(1,ia(j1,i1))
      if(im.ne.0)jhk(k1,k)=-1
      if(in.eq.0) goto 1100
      ii(k1,k)=ii(k1,k)-6
      ih(j1,k1,k)=0
      ih(i1,k1,k)=0
c--analiza se c'e' un unica componente uguale a 3
 1150 if(ii(k1,k).ne.4.and.ii(k1,k).ne.3) goto 1100
      do 1160 j=1,3
      j1=j
      if(ih(j,k1,k).eq.3) goto 1161
 1160 continue
      goto 1100
 1161 ih(j1,k1,k)=0
      ii(k1,k)=ii(k1,k)-3
1100  continue
 1000 continue
c--genera gli estinti
      do 2000 k=1,nsym
      mark=0
      do 2200 i=1,3
      tras(i)=tmat(k,i)
      ib(i)=0
      if(tmat(k,i).lt.0.001) goto 2200
      mark=1
      b=1.0/tmat(k,i)
      do 2300 j=1,8
      b1=b*j+.0001
      ib(i)=int(b1)
      b2=float(ib(i))
      if((b1-b2).le..001) goto 2200
 2300 continue
 2200 continue
      icp1=icent+1
      do 2100 k1=1,icp1
      if(ii(k1,k).eq.0) goto 2100
      iik1k=ii(k1,k)
      goto(2500,2600,2100,2100,2100,2700,2700,2100,2100),iik1k
 2500 call screw(k1,k)
      goto 2100
 2600 call glide(k1,k)
      goto 2100
 2700 call tetra(k1,k,tras,jhk)
 2100 continue
 2000 continue
      return
      end
c-------------------------------------------------
      subroutine screw(k1,k)
      dimension ind(3)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common/param/ifat1,ifat2,ifatx,lreci,idx,icst1,icst2,icst3,duma(3)
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nref,nweak,sgg,nstr,nzro
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/numk,ntrs,ntr10,sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1
      common/esti/ib(3),ih(3,2,24),ii(2,24)
c
      common /xdata/ ish(3,800),itype(800),itab(8000),itab1(8000)
     1,isr(100000),isig(3,5000),inq(7,1000),inq2(7,500),dmmx(29700)
     * ,dummpc(69600)
c--
      do 100 j=1,3
      j1=j
      if(ih(j,k1,k).ne.0)  goto 200
 100  continue
  200 do 300  l=1,3
      ind(l)=0
 300  continue
      ibb=1
      if(ib(j1).ne.0)ibb=ib(j1)
      ihm=ihx(j1)
      do 400 l=1,ihm
      ind(j1)=l
      mad=mod(l,ibb)
      if(mad.eq.0) goto 350
      indr=iabs(ind(1)*ifat1+ind(2)*ifat2+ind(3) )
      isr(indr)=-4*icst1
      if(iprin.eq.3) write(lo,10)(ind(i),i=1,3)
   10 format(1x,'rifl. estinto  ',3i4)
      goto 400
  350 call specq(ind)
 400  continue
      return
      end
c------------------------------------------------
      subroutine glide(k1,k)
      dimension ind(3)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common/param/ifat1,ifat2,ifatx,lreci,idx,icst1,icst2,icst3,duma(3)
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nref,nweak,sgg,nstr,nzro
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/numk,ntrs,ntr10,sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1
      common/esti/ib(3),ih(3,2,24),ii(2,24)
c
      common /xdata/ ish(3,800),itype(800),itab(8000),itab1(8000)
     1,isr(100000),isig(3,5000),inq(7,1000),inq2(7,500),dmmx(29700)
     * ,dummpc(69600)
c
      mad=1
      m1=0
      m2=0
      jj=0
      mark=0
      ihm1=0
      ihm2=0
      do 100 j=1,3
      ind(j)=0
      if(ih(j,k1,k).eq.0) goto 100
      jj=jj+j
      if(ib(j).ne.0)mark=1+mark
 100  continue
      if(jj.eq.0)return
      goto(500,500,110,120,130),jj
  110 m1=1
      m2=2
      goto 200
  120 m1=1
      m2=3
      goto 200
  130 m1=2
      m2=3
  200 if(ib(m1).ne.0)mad=ib(m1)
      ihm1=ihx(m1)
      if(ib(m2).ne.0)mad=ib(m2)
      ihm2=ihx(m2)
      ih2=-ihm2
      ihm1p1=ihm1+1
      do 300 j=1,ihm1p1
      ind(m1)=j-1
      do 400 i=ih2,ihm2
      ind(m2)=i
      if(mark.eq.0) goto 450
      if(mark.ne.2) goto 410
      in=ind(m1)+ind(m2)
      goto 420
  410 if(ib(m1).ne.0)in=ind(m1)
      if(ib(m2).ne.0)in=ind(m2)
  420 if(mod(in,mad).eq.0) goto 450
      indr=iabs(ind(1)*ifat1+ind(2)*ifat2+ind(3) )
      isr(indr)=-4*icst1
      if(iprin.eq.3) write(lo,10) ind
   10 format(1x,'rifl. estinto  ',3i4)
      goto 400
  450 call specq(ind)
 400  continue
 300  continue
  500 return
      end
c-------------------------------------------------------
      subroutine specq(ind)
c
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common/param/ifat1,ifat2,ifatx,lreci,idx,icst1,icst2,icst3,duma(3)
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nref,nweak,sgg,nstr,nzro
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/numk,ntrs,ntr10,sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1
      common/esti/ib(3),ih(3,2,24),ii(2,24)
      common/nq/nor1(6),nop1(6),iseg1(6),icodqn,sumc,sums,sume
c
      common /xdata/ ish(3,800),itype(800),itab(8000),itab1(8000)
     1,isr(100000),isig(3,5000),inq(7,1000),inq2(7,500),dmmx(29700)
     * ,dummpc(69600)
      dimension ind(3)
c
      iecrx=max0(iecros,iecr1)
      indr=ind(1)*ifat1+ind(2)*ifat2+ind(3)
      indr=iabs(indr)
      if(indr.eq.0)return
      i=isr(indr)
      if(i.eq.0)  then    
                   isr(indr)=-5*icst1
                   if(iprin.eq.3) write(lo,30)(ind(i),i=1,3)
   30              format(20x,'rifl. assente speciale  ',3i4)
                    return
                  else
c-- e' tra i 50 piu deboli?
          if(i.lt.0) then     
                   if(i.le.-4*icst1)return
                   ie=i/icst1
                   if(ie.eq.-2) isr(indr)=i-icst2
                   if(iprin.eq.3) write(lo,10)(ind(i),i=1,3)
   10              format(20x,'rifl. spec. debolissimo  ',3i4 )
                   return
                 else
                   ie=i/icst3
                   if (ie.gt.iecrx) return
                   isr(indr)=-(isr(indr)+3*icst1+icst2)
                   if(iprin.eq.3) write(lo,20)(ind(i),i=1,3)
   20              format(20x,'rifl. spec. debole  ',3i4)
                   return
                 endif
                 endif
      end
c-----------------------------------------------------------------------
      subroutine enan(jg,jgc,gc,is,thet,ifass,nquae,iend)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common/param/ifat1,ifat2,ifatx,lreci,idx,icst1,icst2,icst3,duma(3)
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee2(24,6)
      common/dirqn/ecros,iecros,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1
      common/enant/ nqenex,n23m,n23l,gm,nqen
      common/nq/nor1(6),nop1(6),iseg1(6),icodqn,sumc,sums,sume
c
      common /xdata/ ish(3,800),itype(800),itab(8000),itab1(8000)
     1,isr(100000),isig(3,5000),inq(7,1000),inq2(7,500),dmmx(29700)
     * ,dummpc(69600)
c ----
      icont=0
      ico=1
      iend=0
      if(nqen.lt.nqenm) goto 1000
      iend=1
      return
 1000 ith=nint(thet*100.0)
      if(nqen.eq.nqent) goto 1500
      nqen=nqen+1
      inq2(1,nqen)=iseg1(2)*(nor1(2)*32+nop1(2))
      inq2(2,nqen)=iseg1(3)*(nor1(3)*32+nop1(3))
      inq2(3,nqen)=iseg(2)*(nor(2)*32+nop(2))
      inq2(4,nqen)=iseg(3)*(nor(3)*32+nop(3))
      inq2(5,nqen)=jg*32+is
      inq2(6,nqen)=jgc*1000.0+ith
      inq2(7,nqen)=(ifass*80+icont)*ico
      goto 1690
 1500 if(nqenex.ne.0) goto 1600
      call sortc(nqen,inq2)
      n23m=nqen
      n23l=nqen
      jgm=inq2(6,nqen)/1000
      gm=float(jgm)/100.
 1600 nqenex=nqenex+1
      if(gc.ge.gm) return
      inq2(1,n23m)=iseg1(2)*(nor1(2)*32+nop1(2))
      inq2(2,n23m)=iseg1(3)*(nor1(3)*32+nop1(3))
      inq2(3,n23m)=iseg(2)*(nor(2)*32+nop(2))
      inq2(4,n23m)=iseg(3)*(nor(3)*32+nop(3))
      inq2(5,n23m)=jg*32+is
      inq2(6,n23m)=jgc*1000+ith
      inq2(7,n23m)=(ifass*80+icont)*ico
      gm=100.
      i00=n23l-1
      if(i00.lt.1) i00=1
      do 1650 ij=i00,nqen
      jga=inq2(6,ij)/1000
      ga=float(jga)/100.
      if(ga.gt.gm) goto 1650
      gm=ga
      n23m=ij
 1650 continue
      n23l=min0(n23l,n23m)
 1690 if (iprin.lt.2) return
      theta=thet*360/twopi
      write(lo,3400) gc,theta
 3400 format(1x,'/g/=',f10.2,'  theta=',f10.2,'  --- enantiomorph sensit
     1ive quartet')
      return
      end
c-------------------------------------------------------
      subroutine tetra(k1,k ,tras,jhk)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common/param/ifat1,ifat2,ifatx,lreci,idx,icst1,icst2,icst3,duma(3)
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nref,nweak,sgg,nstr,nzro
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/numk,ntrs,ntr10,sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1
      common/esti/ib(3),ih(3,2,24),ii(2,24)
c
      common /xdata/ ish(3,800),itype(800),itab(8000),itab1(8000)
     1,isr(100000),isig(3,5000),inq(7,1000),inq2(7,500),dmmx(29700)
     * ,dummpc(69600)
      dimension ind(3),tras(3),ibi(3),ibc(3),jhk(2,24)
c--
      m1=0
      m2=0
      m3=0
      ihm1=0
      ihm2=0
      ihm3=1
      jj=0
      mark=0
      do 100 j=1,3
      ibc(j)=ib(j)
      ind(j)=0
      if(ih(j,k1,k).ne.3)m3=j
      jj=jj+j
 100  continue
      ih3=1
      ihm3=ihx(m3)
      idif=0
      if(ih(m3,k1,k).ne.0) goto 101
      irr=0
      ihm3=1
      idif=-1
  101 jj=jj-m3
      m1=1
      if(jj-4)110,120,130
  110 m2=2
      goto 150
  120 m2=3
      goto 150
  130 m1=2
      m2=3
  150 tra=tras(m1)+tras(m2)*jhk(k1,k)
      ttra=abs(tra-int(tra))
      if(ttra.le.0.001) goto 155
      if (abs(tras(m1)-tras(m2)).gt.0.001) goto 151
      ibc(m1)=ibc(m1)/2
      goto 160
  151 if(ib(m1).ne.ib(m2)) goto 152
      ibc(m1)=ib(m1)/2
      goto 160
  152 ibc(m1)=max0(ibc(m1),ibc(m2))
      goto 160
  155 if(ibc(m3).eq.0.or.idif.eq.-1) goto 156
      ibi(m1)=0
      ibi(m3)=1
      imm=ibc(m3)
      goto 300
  156 ibi(m1)=0
      ibi(m3)=0
      imm=1
      goto 300
  160 if(ibc(m3).ne.0.and.idif.ne.-1) goto 170
      ibi(m1)=1
      ibi(m3)=0
      imm=ibc(m1)
      goto 300
  170 imm=max0(ibc(m1),ibc(m3))
      im=min0(ibc(m1),ibc(m3))
      ibi(m1)=imm/ibc(m1)
      ibi(m3)=imm/ibc(m3)
  300 ihm1=ihx(m1)+1
      ihm2=ihx(m2)+1
      if(ihm2.gt.ihm1)ihm2=ihm1
      ihm1=ihm2
      do 1000 j=1,ihm1
      ind(m1)=j-1
      ind(m2)=(j-1)*jhk(k1,k)
      do 2000 i=ih3,ihm3
      ind(m3)=i+idif
      indi=ibi(m1)*ind(m1)+ibi(m3)*ind(m3)
      indm=mod(indi,imm)
      if(indm.eq.0) goto 2100
      if(iprin.eq.3) write(lo,2200) (ind(l),l=1,3)
      indr=iabs(ind(1)*ifat1+ind(2)*ifat2+ind(3))
      isr(indr)=-4*icst1
      goto 2000
 2100 call specq(ind)
 2000 continue
 1000 continue
 2200 format(1x,'rifl. estinto  ',3i4)
      return
      end
c--------------------------------------------------------------
      subroutine recip
c--carica il reciproco
c--
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common/param/ifat1,ifat2,ifatx,lreci,idx,icst1,icst2,icst3,duma(3)
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nref,nweak,sgg,nstr,nzro
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/numk,ntrs,ntr10,sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1
      common/enant/ nqenex,n23m,n23l,gm,nqen
      common/esti/ib(3),ih(3,2,24),ii(2,24)
      common/nq/nor1(6),nop1(6),iseg1(6),icodqn,sumc,sums,sume
      common/wrt/icv(4,7),ishf,ifas,ee(3),icodx(3),iqua(1000),
     1           itac(5,24,4),eee(3)
      common/lst13/l13,m13,md13,l13f,m13f,n13f
c
      common /xdata/ ish(3,800),itype(800),itab(8000),itab1(8000)
     1,isr(100000),isig(3,5000),inq(7,1000),inq2(7,500),dmmx(29700)
     * ,dummpc(69600)
c--
      dimension ill(3),jvet(3),ikln(60),ivet(12),vet(12)
      equivalence (ivet(1),vet(1))
c--
c--clear the areas
      do 1001 k=1,8000
      itab(k)=0
1001  continue
      do 1004 i=1,ifatx
      isr(i)=0
1004  continue
c--create the list
      ipu=0
      do 1900 j=1,nrefpl
      kk=ish(1,j)
      ihh=kk/16384-64
      kk=ish(1,j)-(ihh+64)*16384
      ik=kk/128-64
      il=mod(kk,128)-64
      do 1100 i=1,nsym
      if (i.eq.1) then
                    indr=ihh*ifat1+ik*ifat2+il
                    itab1c=((ihh+64)*128+ik+64)*128+il+64
                  else
      ill(1)=ihh*ksmat(i,1,1)+ik*ksmat(i,2,1)+il*ksmat(i,3,1)
      ill(2)=ihh*ksmat(i,1,2)+ik*ksmat(i,2,2)+il*ksmat(i,3,2)
      ill(3)=ihh*ksmat(i,1,3)+ik*ksmat(i,2,3)+il*ksmat(i,3,3)
      indr=ill(1)*ifat1+ill(2)*ifat2+ill(3)
      itab1c=((ill(1)+64)*128+ill(2)+64)*128+ill(3)+64
                  endif
      indrr=indr
      indra=iabs(indr)
      if (i.ne.1) then
c -----   elimina i doppioni
                    imen1=i-1
                    do 1106 i1=1,imen1
                    if (indra.eq.iabs(ikln(i1))) indrr=0
 1106               continue
                  endif
      ipu=ipu+1
      itab(ipu)=indrr
      itab1(ipu)=itab1c
      ikln(i)=indrr
      a=ihh*tmat(i,1)+ik*tmat(i,2)+il*tmat(i,3)
      ia=nint(a*24)+480
      ia=mod(ia,24)
      itab1(ipu)=itab1(ipu)*32+ia
      indr=iabs(indr)
      if(isr(indr).eq.0)isr(indr)=-(icst1+j)
 1100 continue
 1900 continue
c--carica i deboli
      j400a=nreft+1
      j400b=nreft+nrefp
      do 3000 j=j400a,j400b
      call schkl(j,jvet)
      kk=ish(1,j)
      ihh=kk/16384-64
      kk=ish(1,j)-(ihh+64)*16384
      ik=kk/128-64
      il=mod(kk,128)-64
      do 3100 i=1,nsym
      ill(1)=ihh*ksmat(i,1,1)+ik*ksmat(i,2,1)+il*ksmat(i,3,1)
      ill(2)=ihh*ksmat(i,1,2)+ik*ksmat(i,2,2)+il*ksmat(i,3,2)
      ill(3)=ihh*ksmat(i,1,3)+ik*ksmat(i,2,3)+il*ksmat(i,3,3)
      indr=ill( 1)*ifat1+ill( 2)*ifat2+ill( 3)
      isgn=isign(1,indr)
      indr=iabs(indr)
      if(isr(indr).eq.0) isr(indr)=-(2*icst1+j)
3100  continue
3000  continue
c
c--create the isr list
      jord=1
      call ysfl07(nrefl,nstr,nzro,npseud,iy)
      do 2900 i=1,nrefl
      call snr07(vet)
      jh=ivet(1)
      jk=ivet(2)
      jl=ivet(3)
      e=vet(4)
      do 2800 i1=1,nsym
      ill(1)=jh*ksmat(i1,1,1)+jk*ksmat(i1,2,1)+jl*ksmat(i1,3,1)
      ill(2)=jh*ksmat(i1,1,2)+jk*ksmat(i1,2,2)+jl*ksmat(i1,3,2)
      ill(3)=jh*ksmat(i1,1,3)+jk*ksmat(i1,2,3)+jl*ksmat(i1,3,3)
      indr=ill(1)*ifat1+ill(2)*ifat2+ill(3)
      indr=iabs(indr)
      if (e.le.0.0) e=0.01
      if(isr(indr).eq.0) then     
                           isr(indr)=int(e*100.+0.5)*icst3+jord
                         endif
 2800 continue
      jord=jord+1
      if(jord.gt.icst3) then     
                          write(lo,4)jh,jk,jl
    4 format(1x,'too much independent reflections, last reflec',
     ,'tion stored :',3i4)
                        endif
 2900 continue
      if (nsym.eq.1) return
      call geest
      return
      end
c----------------------------------------------------------
      subroutine sortc(numb,inq)
c--sort the negative/enantiomorph-sensitive quartet list
c
      dimension inq(7,numb)
c--
      if(numb.eq.1) return
      m=2
 2010 in=numb/m
      if(in.le.0) in=1
      ifin=numb-in
 2040 mark=0
      do 2060 i=1,ifin
      k=i+in
      jn1=inq(6,i)/1000.0
      jn2=inq(6,k)/1000.0
      if(jn1.ge.jn2) goto 2060
      do 2055 n=1,7
      jc=inq(n,i)
      inq (n,i)=inq (n,k)
      inq (n,k)=jc
2055  continue
      mark=1
2060  continue
      if(mark.gt.0) goto 2040
      if(in.le.1) goto 2080
      m=m*2
      goto 2010
 2080 return
      end
c----------------------------------------------------------
      subroutine p10(result)
c
c--p10 calculation
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common /proc/ iftr,ifp10,ifnq,ifps,ifcoc,ifweig
      common/param/ifat1,ifat2,ifatx,lreci,idx,icst1,icst2,icst3,duma(3)
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nref,nweak,sgg,nstr,nzro
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/numk,ntrs,ntr10,sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee(24,6)
c
      common/xdata/ ish(3,800),itype(800)  
     1,itab(8000),itab1(8000),isr(100000),isig(3,5000),gq(5000),gv(5000)
     2,dummm(36600),dummpc(63200)
c--
      dimension ill(3),jvet(3),iche(24),ikln(60)
      dimension vet(12),ivet(12)
      integer result(7,2)
      equivalence (ivet(1),vet(1))
c--
      if (numk.le.0) then
                        sogpo=0.0
                        sogen=-9999.9999
                        sogne=    0.0
                     else
                        if (icent.eq.1) then
                                     sogen=-9999.9999
                                     sogens=sogpo
                                       endif
                         sognes=abs(sogne)
                      endif
c     if (icent.eq.0) go to 5
c     sogen=-9999.9999
c     sogne=    0.0
      call retr9(2)
      if(ntr10.gt.ntra.or.ntr10.eq.0) ntr10=ntra
      if (numk.ge.0.and.iprin.gt.0) write(lo,20)ntr10,ntra,numk
   20 format('0   ',i5,'  ( over ',i5,')  triplet relationships strength
     1ned by means of ',i4,'  free vectors'/)
      if(ntr10.gt.0) ntrs=min0(ntrs,ntr10)
      sgg=0.0
      do 100 i=1,ntr10
      call unpak3(isig(3,i),id,ig,id1)
      gv(i)=float(ig)/100.
  100 sgg=gv(i)+sgg
      if(ntr10.eq.ntra) goto 110
      iniz=ntr10+1
      do 105 i=iniz,ntra
      call unpak3(isig(3,i),id,ig,id1)
  105 gv(i)=float(ig)/100.
  110 continue
c--clear the areas
      do 1001 k=1,8000
      itab(k)=0
 1001 continue
c--  ifatx:superindice massimo
      do 1004 i =1,ifatx
      isr(i)=0
 1004 continue
c--create the list
      ipu=0
      do 1090 j=1,nreft
c-- carica in jvet i valori di h,k,l dei riflessi forti
      call schkl(j,jvet)
      do 1080 i=1,nsym
      do 1085 i1=1,3
      ill(i1)=0
      do 1085 j1=1,3
 1085 ill(i1)=ill(i1)+jvet(j1)*ksmat(i,j1,i1)
      indr=ill(1)*ifat1+ill(2)*ifat2+ill(3)
      indrr=indr
      if (i.eq.1) go to 1087
c -----   elimina i doppioni
      imen1=i-1
      do 1086 i1=1,imen1
      if (iabs(indr).eq.iabs(ikln(i1))) indrr=0
 1086 continue
 1087 continue
      ipu=ipu+1
      ikln(i)=indrr
      itab(ipu)=indrr
      itab1(ipu)=(ill(2)+64)*128+ill(3)+64
      indr=iabs(indr)
c--  isr: semisfera di riflesione
      isr(indr)=-j
1080  continue
1090  continue
c
c--create the isr list
c
      call ysfl07(nrefl,nstr,nzro,npseud,iy)
      do 1220 i=1,nrefl
      call snr07(vet)
      ih=ivet(1)
      ik=ivet(2)
      il=ivet(3)
      do 1210 i1=1,nsym
      ill(1)=ih*ksmat(i1,1,1)+ik*ksmat(i1,2,1)+il*ksmat(i1,3,1)
      ill(2)=ih*ksmat(i1,1,2)+ik*ksmat(i1,2,2)+il*ksmat(i1,3,2)
      ill(3)=ih*ksmat(i1,1,3)+ik*ksmat(i1,2,3)+il*ksmat(i1,3,3)
      indr=ill(1)*ifat1+ill(2)*ifat2+ill(3)
      indr=iabs(indr)
      e=vet(4)
      if (e.lt.0.01) e=0.01
      j=int(e*100+.05)
      if(isr(indr).eq.0)isr(indr)=j
 1210 continue
 1220 continue
c
c--end of loop
c--calculate p10
      fna2=fnat*fnat
      somgc=0.
      do 2000 i=1,ntr10
c--  fornisce g e il no.d`ordine,gli operatori,
c     il segno e gli e dei riflessi per ogni tripl.
      call decom(i,dum,g,id1,id2)
      do 995 k=2,3
  995 iseg(k)=-iseg(k)
      do 1000 k=1,nsym
      iche(k)=0
      do 1100 j=1,3
c--  nor:no.d`ordine
      nord=nor(j)
      nork=(nord-1)*nsym+k
      if(itab(nork).ne.0)go to 1000
 1100 continue
      iche(k)=k
 1000 continue
      if (iprin.ne.2) go to 1999
      write(lo,4) (nor(ii),nop(ii),iseg(ii),ii=1,3),ntrt
 4    format(1x,9i4,i10)
 1999 terr=0.
      if(numk.le.0)go to 2110
c
c--  numk:no. di rifl.k-random adoperati.
      do 2100 j=1,numk
      do 2001 i2=1,nsym
      do 2002 i3=1,6
c--  ee:contiene gli epsylon dei cross-vector.
      ee(i2,i3)=0.
 2002 continue
 2001 continue
      e2=float(ish(2,j)/512)/100.
c--  contiene gli epsylon dei vett. base(tripl.e k-random)
      eeb(4)=e2*e2-1
c--elimina il quintetto e i suoi equivalenti se il vett.k coincide con
c--un elemento della tripletta.
      do 2101 l =1,3
      if(j.eq.nor(l))go to 2100
 2101 continue
      ta=0.
      tb=0.
      jn=(j-1)*nsym
      do 2200 k=1,nsym
c--  controlli sulla ripetizione dei quintetti
c--  elimina l' op. di simm. se tutti i rifl.della
c--  tripl. sono speciali
      if(iche(k).gt.0) goto 2200
c--  elimina il op.di simm. se il k e`speciale
      jnk=jn+k
      if(itab(jnk).eq.0) goto 2200
      jk2=itab1(jnk)/128-64
      jl2=mod(itab1(jnk),128)-64
c--
      do 3000 i1=1,3
      mm1=-1
      if(i1.eq.1)mm1=1
      nord=nor(i1)
c--  no. d`ordine  del op.di simm.
      nope=nop(i1)
      mms=mm1*iseg(i1)
      nopd=(nord-1)*nsym+nope
      jk1=(itab1(nopd)/128-64)*mms
Corig jl1=(mod(itab1(jnk),128)-64)*mms
      jl1=(mod(itab1(nopd),128)-64)*mms
      do 2300 l=1,3,2
      l1=l-2
      ihh1=itab(nopd)*mms
      ihh2=itab(jnk)*l1
c--  superindice del cross-vector
      ih3=ihh1+ihh2
      l3=1
      if(ih3) 2010,2300,2020
 2010 continue
      l3=-1
      ih3=-ih3
 2020 continue
c--  tre controlli sulla esistenza del vett.-cross
c--  primo controllo sul superindice.
      if(ih3.gt.ifatx) go to 2300
      jkk=(jk1+jk2*l1)
      jk=iabs(jkk)
c--  secondo controllo sull`indice k
      if(jk.gt.ihx(2))go to 2300
      jll= jl1+jl2*l1
      jl=iabs(jll)
c--  terzo controllo sull`indice l
      if(jl.gt.ihx(3))go to 2300
      a=float(ih3)/ifat1
      jhp=nint(a)
      ie=isr(ih3)
      if(ie)2030,2300,2040
 2030 continue
      il=-ie
c--  due controlli che il vett.-cross sia diverso dai vett. base.
c--  1` rispetto al vett. k
      if(il.ne.j)go to 2032
      goto 2200
 2032 do 2035 n=1,3
c--  2` rispetto ai vett. della trip.
      if(nor(n).ne.il)go to 2035
      goto 2200
 2035 continue
      ie=ish(2,il)/512
 2040 continue
      e=float(ie)/100.
      inde=2*i1-1+(1-l1)/2
      ee(k,inde)=e*e-1
c
c-- elimina il quintetto se e(cross)>e(k)
c
      if(ee(k,inde).le.eeb(4)) go to 2037
      goto 2200
 2037 ih3=ih3*l3
 2300 continue
 3000 continue
c--
      ta=ta+aterm9(k,fna2)
      tb=tb+bterm9(k,fna2)
 2200 continue
      tb=tb+eeb( 1)*eeb( 2)*eeb( 3)*fna2/2
      if(tb.lt.0)tb=0.
      ter=ta/(1+tb)
      terr=terr+ter
      if (iprin.eq.2) write(lo,2210) terr
 2210 format(' sum+( suma/(1+sumb) ) = ',f15.5)
 2100 continue
c
 2110 continue
      terr=terr+1
      gcor=g*terr
c ============
      gq(i)=gcor
c     write(lo,3)i,g,gcor
c3    format(1x,i5,1h),'g= ',e10.2,5x,'gq= ',e10.2)
      somgc=somgc+abs(gcor)
 2000 continue
canto
      sgg=sgg/somgc
      if(numk.le.0)sgg=1
c --   riscala g - corretto
      nneg=0
      do 4020 i=1,ntr10
      gq(i)=gq(i)*sgg
      if(gq(i).gt.20.47) gq(i)=20.47
      if (gq(i).lt.-20.47) gq(i)=-20.47
      ifa=(mod(isig(1,i),32)-1)*15
      ifa=ifa+mod(isig(3,i),32)-1
      ifffa=gq(i)*100.
      ii=1
      if(ifffa.ge.0) goto 4900
      ii=-1
      nneg=nneg+1
 4900 iffa=iabs(ifffa)
      iff1=mod(isig(2,i),32)
      iff2=isig(2,i)/131072
      isig(2,i)=(iff2*4096+iffa+2048)*32+iff1
 4020 continue
      call sortg(ntr10)
      indpo=1
      inden=0
      indne=0
      indens=0
      indnes=0
      nupos=0
      nuena=0
      nuneg=0
      nunegs=0
      do 5000 i=1,ntr10
      ggqq=abs(gq(i))
      if(inden.eq.0.and.ggqq.le.sogen) inden=i
      if(numk.gt.0.) then
                 if(icent.eq.1) then
                 if(gq(i).gt.0.0.and.gq(i).le.sogens) then
                                  sogens=gq(i)
                                  indens=i
                                                     else 
                 if(gq(i).lt.0.0.and.ggqq.le.sognes) then
                                  sognes=ggqq 
                                  indnes=i
                                                     endif
                                                     endif
                                 endif
                     endif
      if(indne.eq.0.and.gq(i).le.sogne) indne=i
      if(gq(i).ge.sogpo) nupos=nupos+1
      if(ggqq.le.sogen) nuena=nuena+1
      if(gq(i).le.sogne) nuneg=nuneg+1
 5000 continue
      nuposo=nupos
      nuenao=nuena
      nunego=nuneg
 6000 if(nuena.le.nmxte) goto 6020
      ifin=inden+nuena
c
c     ifin=inden+nuena-1
c
      iniz=inden
      inden=0
      nuena=0
      sogen=sogen-0.05
      do 6010 i=iniz,ifin
      ggqq=abs(gq(i))
      if(ggqq.gt.sogen) goto 6010
      if(inden.eq.0) inden=i
      nuena=nuena+1
 6010 continue
      goto 6000
 6020 if(nuneg.le.nmxtn) goto 6040
      iniz=indne
      indne=0
      nuneg=0
      sogne=sogne-0.05
      do 6030 i=iniz,ntr10
      if(gq(i).gt.sogne) goto 6030
      if(indne.eq.0) indne=i
      nuneg=nuneg+1
 6030 continue
      goto 6020
 6040 if (iprin.gt.0) then
          write(lo,6100)nuposo,nupos,nunego,nuneg
          if (icent.eq.0) write(lo,6110)nuenao,nuena
          write(lo,6090)
                      endif
      result(1,1)=nuposo
      result(1,2)=nupos
      result(2,1)=nunego
      result(2,2)=nuneg
      result(3,1)=nuenao
      result(3,2)=nuena
 6090 format(1h )
 6100 format(//,
     *i8,' positive estimated triplets     ',5x,'(',i5,' stored)',/,
     1i8,' negative estimated triplets     ',5x,'(',i5,' stored)')
 6110 format(i8,' enantiomorph sensitive triplets ',5x,'(',i5,' stored)'
     *)
      igm=gq(nupos)*1000.
      call wrtr9(3,igm,npse)
CNEW -------------------------
c     if (knw.eq.1) call test10
c indens = puntatore per le relaz. con g > 0.2 usato solo per 
c la statistica
      if(numk.gt.0.and.icent.eq.1) then
          if(indens.gt.nupos) inden=indens+1
          if(indnes.gt.0.and.indnes.lt.indne) then
                                 nunegs=indne-indnes
                                 indne=indnes
                                 nuneg=nuneg+nunegs
                              endif
                                  endif
      if(ipripe.gt.0) call test10
      return
      end
c---------------------------------------------------------
      subroutine test10
c
c--test on p10 results
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common/param/ifat1,ifat2,ifatx,lreci,idx,icst1,icst2,icst3,duma(3)
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nref,nweak,sgg,nstr,nzro
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/numk,ntrs,ntr10,sogpo,sogen,sogne,limit(6),dume(2)
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee(24,6)
      common /nctst/ ns,br(15),nb(11,15,3),fnb(11,15,3),bcm(11,15,3),
     *                        acm(11,15,3)
      common /pseud/ kmat(48,3,3),emme,patom,qatom,npseud,lpseud(4,3)
     1         ,scale,jmme,prod,prod2,mjn(5,11),njn,coef,nw(8),no(8)
      common/xdata/ ish(3,800),itype(800)  
     1,itab(8000),itab1(8000),isr(100000),isig(3,5000),gq(5000),gv(5000)
     2,dummm(36600),dummpc(63200)
c--
      dimension nor1(3),sdc(3),sdca(3)
c--
c--  prepara il buffer per il test non centro
c-- nusba = serial number of the first wrong and positive triplet
c--  prepara il buffer per il test centro
CNEW -------------------
      njn=1
      if(icent.eq.0) then
                   if(knw.eq.1) call nclrt
                   call nclrt1
                           else
                   if(knw.eq.1) call clrt
                   call clrt1
                     endif
CNEW -------------------
      if (ntrs.gt.0) write(lo,5050)
 5050 format(//,10x,'code',14x,
     1      'g(2r)',5x,'g(1r)',3x,'phi(calc)',
     2       4x,'phi(ver)',7x,'dphi',/)
c--loop per eseguire delle stampe utili
      nusba=0
      do 5001 ii=1,3
      if (ii.eq.2.and.icent.eq.1) go to 5001
c     if (ii.eq.2) go to 5001
      mark=0
      if (ii.eq.3) mark=1
      n8w=1
      iniz=limit(ii+3)
      ifin=limit(ii)+iniz-1
C     if(ii.eq.1.and.numk.gt.0.and.icent.eq.0) ifin=limit(5)-1
      if(ii.eq.1.and.numk.gt.0) ifin=limit(5)-1
c     write(6,*) ii,iniz,ifin       
      sdc(ii)=0.0
      sdca(ii)=0.0
      do 5000 i=iniz,ifin
      mark1=1
      if(ntrs.lt.n8w)mark1=0
      ia=int(gq(i)*100.)
      call decom(i,g,ggv,ishi,ib)
      b=float(ib)*pi/180.
      a=cos(b)
      an=a*gq(i)
      if (icent.eq.1) then      
c-- centrosymmetric test
                        gg=gq(i)
                        if(ii.ne.2) then
                        if (knw.eq.1) call sctst(gg,an,1)
                        call sctst1(gg,an)
                                  endif
                        coat=1.0
                        if (gg.lt.0.0) coat=-1.0
                      else
c-- noncentrosymmetric test
                        bb=sin(b)
                        g2=gq(i)
                        call besse(g2,coat)
                        if(ii.ne.2) then
                        bang=ib
                        if (ib.gt.180) bang=360.0-bang
                        if (knw.eq.1) call nctet(g2,a,bang,1)
                        call nctet1(g2,coat,a)
                        an=coat*a
                                   endif
                      endif
      if (ii.ne.1) go to 4001
      if(nusba.ne.0.or.an.ge.0)go to 4001
      nusba=i
 4001 continue
      aa=b
      cc=acos(coat)
      dc=cc-aa
      adc=abs(dc)
      if(adc-pi) 4030,4030,4020
4020  continue
      dc=twopi-adc
      dc=-dc
4030  continue
      sdc(ii) =sdc(ii) +    dc
      sdca(ii)=sdca(ii)+abs(dc)
      do 5080 k=1,3
      nor1(k)=nor(k)*iseg(k)
 5080 continue
      cc=cc*180./pi
      aa=aa*180./pi
      dc=dc*180./pi
      if((mark+mark1).ne.0.and.iprin.ge.1)
     *write(lo,5100)(nor1(k),k=1,3),gq(i),ggv,cc,aa,dc
      n8w=n8w+1
 5000 continue
      if (limit(ii).eq.0) go to 5001
      xxx=180.0/(pi*float(limit(ii)))
      sdc(ii) = sdc(ii) * xxx
      sdca(ii)=sdca(ii) * xxx
 5001 continue
      if (knw.eq.1) write(lo,5500) nusba
 5500 format(//,1x,'serial number of the first wrong triplet =',i5)
 5100 format(4x,3i5,4x,2f10.2,3f12.2)
 5200 format(//,49x,6h<dphi>,5x,8h</dphi/>,
     1 /,2x,i6,' positive relationships ',12x,2f10.3,
     2 /,2x,i6,' enantiomorph sensitive rel. ', 7x,2f10.3,
     3 /,2x,i6,' negative relationships ',12x,2f10.3,//)
      if(ipripe.eq.0) go to 4500
      write(lo,2998)
 2998 format(/,38x,'            Triplets statistic')
      if(icent)4300,4300,4400
 4300 continue
      if (knw.eq.1) write(lo,5200)(limit(ii),sdc(ii),sdca(ii),ii=1,3)
c--  stampa il test (non centro)
      if (knw.eq.1) call nstst
      call nstst1
      go to 4500
 4400 continue
c--  stampa il test (centro)
      if (knw.eq.1) call stst
      call stst1
 4500 continue
      return
      end
c----------------------------------------------------------------------
      subroutine wrtr9(jump1,igm,npse)
c     input/output units, title, flags
      common /ureq1/ ncycl,nroset,nundset,alambda,nsec,machkl,uvwt(4),
     *               pfwhm
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common /pseud/ kmat(48,3,3),emme,patom,qatom,npseud,lpseud(4,3)
     1         ,scale,jmme,prod,prod2,mjn(5,11),njn,coef,nw(8),no(8)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/prin/ ipt,ip0,ip10,ipq
      common/proc/ iftr,ifp10,ifnq,ifps,ifcoc,ifweig
      common/param/ifat1,ifat2,ifatx,lreci,idx,icst1,icst2,icst3,duma(3)
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nref,nweak,sgg,nstr,nzro
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/numk,ntrs,ntr10,sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee(24,6)
      common/xdata/ ish(3,800),itype(800)  
     1,itab(8000),itab1(8000),isr(100000),isig(3,5000),gq(5000),gv(5000)
     2,dummm(36600),dummpc(63200)
      dimension ipu(6)
c--
c-- scrive le triplette su file
c ---  jump1=1   scrive le triplette
c ---  jump1=2   scrive le psi0
c ---  jump1=3 scrive le p10
c ---  jump1=4 scrive le psi-e
c ---
      i230=2**30
      npss=nrefp+nreft
      iz=0
      goto(100,1000,2000,3000),jump1
  100 continue
c -----
c     call sub. scrittura relazioni tripletti positivi : lista  8
c -----
      iprea=0
      call frmxx (iprea,8,ntra,ntra,nreft,ifp10,igm,isig)
      return
c ---  scrive le psi0
 1000 npsfm=0
      n1=0
c     ipbu=0
      do 50 i=1,npsa
      call unpak3(isig(1,i),nor1,nor2,if1)
      itab(i)=isig(1,i)
      if(nor1.gt.npss) goto 50
      call unpak3(isig(2,i),nor3,id,ishi)
      isig(1,i)=((nor2+2048)*4096+nor3+2048)*32+ishi+1
      if(nor1.eq.n1) goto 40
      n1=nor1
      isig(1,i)=isig(1,i)+i230
   40 npsfm=npsfm+1
   50 continue
c -----
c     call  sub.  scrittura  relazioni  psizero  :  lista  9
c -----
      iprea=0
      call frmxx (iprea,9,npsfm,npsfm,nrefp,nxxe,iccd,isig)
      do 60 i=1,npsa
   60 isig(1,i)=itab(i)
      return
c ---  scrive le p10
 2000 ipu(1)=indpo
      ipu(2)=nupos
      ipu(3)=inden
      ipu(4)=inden+nuena-1
      ipu(5)=indne
      ipu(6)=indne+nuneg-1
c -----
c     call  sub.  scrittura  tripletti positivi  :  lista  8
c -----
      iprea=0
      if (nupos.ne.0)
     *call frmxx (iprea,8,ntra,nupos,nreft,ifp10,igm,isig(1,indpo))
c -----
c     call  sub.  scrittura  tripletti negativi  :  lista 10
c -----
      if (nuneg.ne.0)
     *call frmxx(iprea,10,nuneg,nuneg,nreft,ifp10,igm,isig(1,indne))
c -----
c     call sub. scrittura tripletti enantiomorfi :  lista 11
c -----
      if(icent.eq.0.and.nuena.ne.0)
     *call frmxx(iprea,11,nuena,nuena,nreft,ifp10,igm,isig(1,inden))
      return
 3000 continue
c -----
c     call sub. scrittura relazioni psi-e              : lista  24
c -----
      iprea=0
      iln=24+ncycl
      if (iln.le.33) then
                if (ntra.ne.0) then
                    call frmxx (iprea,iln,ntra,ntra,npse,ifp10,igm,isig)
                  else
                    if (ipripe.gt.0) write(lo,3010)
                  endif
               else
                 if (ipripe.gt.0) write(lo,3020)
               endif
 3010 format(' *** Warning *** : no psi-e found')
 3020 format(' *** Warning *** : no psi-e stored - too many permutations
     *')
      return
      end
c-----------------------------------------------------------
c
      function aterm9(j,fna2)
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee(24,6)
c
      aterm9=eeb( 4)*(ee(j,1)*(ee(j,4)+ee(j, 6))+
     1                ee(j,3)*(ee(j,2)+ee(j, 6))+
     2                ee(j,5)*(ee(j,2)+ee(j, 4)))
      aterm9=aterm9*fna2
      return
      end
c---------------------------------------------------
      function bterm9(j,fna2)
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee(24,6)
c--
      bterm9=eeb( 1)*(eeb( 4)*(ee(j,1)+ee(j,2))+ee(j,3)*ee(j, 6)+
     1      ee(j,4)*ee(j,5))+
     2      eeb( 2)*(eeb( 4)*(ee(j,3)+ee(j,4))+ee(j,1)*ee(j, 6)+
     3      ee(j,2)*ee(j,5))+
     4      eeb( 3)*(eeb( 4)*(ee(j,5)+ee(j, 6))+ee(j,1)*ee(j,4)+
     5      ee(j,2)*ee(j,3))
      bterm9=bterm9*fna2/2
      return
      end
c--------------------------------------------------------------
      subroutine sortg(numb)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common/param/ifat1,ifat2,ifatx,lreci,idx,icst1,icst2,icst3,duma(3)
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nref,nweak,sgg,nstr,nzro
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/numk,ntrs,ntr10,sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1
      common/xdata/ ish(3,800),itype(800)  
     1,itab(8000),itab1(8000),isr(100000),isig(3,5000),gq(5000),gv(5000)
     2,dummm(36600),dummpc(63200)
c--sort the sigma 2 and the g-correct list
c
c--
      if(numb.eq.1) return
      m=2
2010  continue
      in=numb/m
      if(in) 2020,2020,2030
2020  continue
      in=1
2030  continue
      ifin=numb-in
2040  continue
      mark=0
      do 2060 i=1,ifin
      k=i+in
      if(gq(i)-gq(k)) 2050,2060,2060
2050  continue
      do 2055 n=1,3
      jc=isig(n,i)
      isig(n,i)=isig(n,k)
      isig(n,k)=jc
2055  continue
      gg=gq(i)
      gq(i)=gq(k)
      gq(k)=gg
      vg=gv(i)
      gv(i)=gv(k)
      gv(k)=vg
      mark=1
2060  continue
      if(mark) 2065,2065,2040
2065  continue
      if(in-1) 2080,2080,2070
2070  continue
      m=m*2
      go to 2010
2080  continue
      return
      end
c----------------------------------------------------------
      subroutine retr9(jump)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common/param/ifat1,ifat2,ifatx,lreci,idx,icst1,icst2,icst3,duma(3)
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nref,nweak,sgg,nstr,nzro
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/numk,ntrs,ntr10,sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee(24,6)
      common/xdata/ ish(3,800),itype(800)  
     1,itab(8000),itab1(8000),isr(100000),isig(3,5000),gq(5000),gv(5000)
     2,dummm(36600),dummpc(63200)
c--
c--  jump = 2  reads triplets
c--  jump = 1  reads psi-zero
c--
      if(jump.ne.1) goto 2000
      return
c -----------   lettura delle sigma2 per p10
 2000 continue
c -----
c     call sub. lettura lista 8 : tripletti positivi
c -----
      iprea=0
      call sflxx(iprea,8,ntra,ntra,nreft,nxxe,iccd,isig)
      return
      end
c-----------------------------------------------------
      subroutine stst
c--print the test (centro)
      common/tst/nt,ar(26),nn(11,26,3),pp(11,26,3)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common /pseud/ kmat(48,3,3),emme,patom,qatom,npseud,lpseud(4,3)
     1         ,scale,jmme,prod,prod2,mjn(5,11),njn,coef,nw(8),no(8)
      dimension pa(11,26,3)
c
      write(lo,1000)
 1000 format(/,' number of relations(nr),number of correct rel.',
     2'(nc) and percentage(%) of correct relationship ',/)
      write(lo,1010)
 1010 format(14x,'rel.posit.',20x,'rel.negat.',//,
     2 1x,5h arg.,2(9x,3hnr.,4x,3hnc.,4x,1h%,2x),/)
      do 1030 l=1,2
      do 1020 i=1,nt
      if (nn(1,i,l).gt.0) then
                            fn=float(nn(1,i,l))
                            pa(1,i,l)=pp(1,i,l)*100.0/fn
                          else
                            pa(1,i,l)=0.0
                          endif
 1020 continue
 1030 continue
      do 1050 i=1,nt
      if (nn(1,i,1).eq.0.and.nn(1,i,2).eq.0) go to 1050
      write(lo,1040)ar(i),(nn(1,i,l),pp(1,i,l),pa(1,i,l),l=1,2)
 1040 format(f5.1,2(5x,i7,2f7.1))
 1050 continue
      return
      end
c--------------------------------------------------
      subroutine nstst
c--print the test (non-centro)
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common /pseud/ kmat(48,3,3),emme,patom,qatom,npseud,lpseud(4,3)
     1         ,scale,jmme,prod,prod2,mjn(5,11),njn,coef,nw(8),no(8)
      common /nctst/ ns,br(15),nb(11,15,3),fnb(11,15,3),bcm(11,15,3),
     *                        acm(11,15,3)
c
      write(lo,1000)
1000  format(' number of relationships(nr), percentages(%) of correct si
     *gns',/,' average errors in relationships',/)
      en=float(mjn(1,1))/10.0
      write(lo,1010)
 1010 format(20x, 'positive rel.',25x,'negative rel.')
      write(lo,1020)
 1020 format(3x,2hg ,1x,2(8x,'nr.    %     <|phi|>         '),//)
      do 1100 j=1,3
      do 1090 i=1,ns
      if(nb(1,i,j)) 1090,1090,1030
 1030 continue
      fn=1.0/float(nb(1,i,j))
      fnb(1,i,j)=fnb(1,i,j)*fn*100.0
      bcm(1,i,j)=bcm(1,i,j)*fn
 1090 continue
 1100 continue
      do 1110 i=1,ns
      write(lo,1120) br(i),(nb(1,i,j),fnb(1,i,j),bcm(1,i,j),j=1,2)
 1120 format(f5.1,3(5x,i7,f7.1,f9.3,9x))
 1110 continue
      return
      end
c------------------------------------------------------
      subroutine nclrt
c--prepare the test buffer (non-centro)
c
      common /nctst/ ns,br(15),nb(11,15,3),fnb(11,15,3),bcm(11,15,3),
     *                        acm(11,15,3)
c
      ns=15
      br(1)=0.2
      do 1100 i=2,6
      br(i)=br(i-1)+0.2
1100  continue
      do 1110 i=7,8
      br(i)=br(i-1)+0.4
1110  continue
      do 1120 i=9,10
      br(i)=br(i-1)+0.6
1120  continue
      br(11)=4.0
      br(12)=5.5
      br(13)=8.0
      br(14)=15.0
      br(15)=20.0
      do 1140 k=1,11
      do 1140 j=1,3
      do 1150 i=1,ns
      nb (k,i,j)=0
      fnb(k,i,j)=0.0
      bcm(k,i,j)=0.0
      acm(k,i,j)=0.0
1150  continue
1140  continue
      return
      end
c------------------------------------------------------
      subroutine nctet(aa,cc,ang,j)
c--test for the correct coincidence (non-centro)
c
      common /nctst/ ns,br(15),nb(11,15,3),fnb(11,15,3),bcm(11,15,3),
     *                        acm(11,15,3)
c
      if (aa.lt.0.0) then
                       kk=2
                     else
                       kk=1
                     endif
      bb=abs(aa)
      do 1100 i=1,ns
      ii=i
      if(br(i)-bb) 1020,1020,1200
1020  continue
       nb(j,ii,kk)= nb(j,ii,kk)+1
      bcm(j,ii,kk)=bcm(j,ii,kk)+ang
      a=aa*cc
      if(a) 1100,1030,1030
1030  continue
      fnb(j,ii,kk)=fnb(j,ii,kk)+1.0
1100  continue
1200  continue
      return
      end
c--------------------------------------------------------
      subroutine clrt
c--prepare the test buffer (centro)
      common/tst/nt,ar(26),nn(11,26,3),pp(11,26,3)
      ar( 1)=.0
      ar( 2)=.2
      ar( 3)=.4
      ar( 4)=.6
      ar( 5)=.8
      ar( 6)=1.
      ar( 7)=1.2
      ar( 8)=1.4
      ar( 9)=1.6
      ar(10)=2.
      ar(11)=2.4
      ar(12)=2.8
      ar(13)=3.2
      ar(14)=3.4
      ar(15)=3.8
      ar(16)=4.2
      ar(17)=4.6
      ar(18)=5.0
      ar(19)=5.5
      ar(20)=6.0
      ar(21)=6.5
      ar(22)=7.
      ar(23)=7.5
      ar(24)=8.0
      ar(25)=8.5
      ar(26)=9.0
      nt=26
      do 100 k=1,11
      do 100 l=1,3
      do 200 i=1,nt
      nn(k,i,l)=0
      pp(k,i,l)=0
 200  continue
 100  continue
      return
      end
c----------------------------------------------------------
      subroutine sctst(aa,cc,j)
c--test for the correct coincidence (centro)
      common/tst/nt,ar(26),nn(11,26,3),pp(11,26,3)
c
Corig if(aa.lt.0) then
c-new 10/12/93
      if(aa.le.0) then
                    k=2
                  else
                    k=1
                  endif
      bb=abs(aa)
      do 1100 i=1,nt
      if(ar(i)-bb)1020,1020,1200
 1020 continue
      nn(j,i,k)=nn(j,i,k)+1
      if(cc)1100,1030,1030
 1030 continue
      pp(j,i,k)=pp(j,i,k)+1.0
 1100 continue
 1200 continue
      return
      end
c----------------------------------------------------------
      subroutine clrt1
c--prepare the test buffer (centro)
      common/tst1/nt,ar(19),nn(19),pp(19)
      ar( 1)=.0
      ar( 2)=.2
      ar( 3)=.4
      ar( 4)=.6
      ar( 5)=.8
      ar( 6)=1.
      ar( 7)=1.2
      ar( 8)=1.4
      ar( 9)=1.6
      ar(10)=2.
      ar(11)=2.5
      ar(12)=3.0
      ar(13)=3.5
      ar(14)=4.0
      ar(15)=5.0
      ar(16)=6.0
      ar(17)=8.0
      ar(18)=10.0
      ar(19)=15.0
      nt=19
      do 200 i=1,nt
      nn(i)=0
      pp(i)=0.0
 200  continue
      return
      end
c----------------------------------------------------------
      subroutine sctst1(aa,cc)
c--test for the correct coincidence (centro)
      common/tst1/nt,ar(19),nn(19),pp(19)
      bb=abs(aa)
      do 1100 i=1,nt
      if(ar(i).le.bb) then
                        nn(i)=nn(i)+1
                        if(cc)1100,1030,1030
 1030                   continue
                        pp(i)=pp(i)+1.0
                       endif
 1100 continue
      return
      end
c--------------------------------------------------------
      subroutine nclrt1
c--prepare the test buffer (non-centro)
c
      common /nctst1/ ns,br(19),nb(19),fnb(19)
c
      br( 1)=.0
      br( 2)=.2
      br( 3)=.4
      br( 4)=.6
      br( 5)=.8
      br( 6)=1.
      br( 7)=1.2
      br( 8)=1.4
      br( 9)=1.6
      br(10)=2.
      br(11)=2.5
      br(12)=3.0
      br(13)=3.5
      br(14)=4.0
      br(15)=5.0
      br(16)=6.0
      br(17)=8.0
      br(18)=10.0
      br(19)=15.0
      ns=19
      do 1150 i=1,ns
      nb (i)=0
      fnb(i)=0.0
1150  continue
      return
      end
c------------------------------------------------------
      subroutine nctet1(aa,co,cc)
c--test for the correct coincidence (non-centro)
c
      common /nctst1/ ns,br(19),nb(19),fnb(19)
c
      bb=abs(aa)
      do 1060 i=1,ns
      if(br(i).le.bb)  then
                         nb(i)=nb(i)+1
                         a=cc*co
                         if(a) 1060,1050,1050
1050                     continue
                         fnb(i)=fnb(i)+1.0
                       endif
1060  continue
      return
      end
c-----------------------------------------------------
      subroutine stst1
c--print the test (centro)
      common/tst1/nt,ar(19),nn(19),pp(19)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      dimension pa(19)
      data pa /19*0./
c
      write(lo,520)
  520 format(38x,44hdistribution of g - number of g's .gt. limit)
      if (knw.eq.1)  write(lo,530)
  530 format(40x,41hand percentage(%) of correct relationship)
      write(lo,540)(ar(i),i=1,19),(nn(i),i=1,19)
  540 format(/,2x,3hg  ,19f6.1/1h ,1x,4hno. ,19i6)
      if (knw.eq.0) return
      do 1020 i=1,nt
      if(nn(i))1020,1020,1015
 1015 continue
      fn=float(nn(i))
      pa(i)=pp(i)*100.0/fn
 1020 continue
      write(lo,550)(pa(i),i=1,19)
  550 format(1h ,2x,3h%  ,19f6.1)
      return
      end
c--------------------------------------------------
      subroutine nstst1
c--print the test (non-centro)
c
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common /nctst1/ ns,br(19),nb(19),fnb(19)
c
      write(lo,520)
  520 format(38x,44hdistribution of g - number of g's .gt. limit)
c
      if (knw.eq.1)  write(lo,530)
  530 format(40x,41hand percentage(%) of correct relationship)
      write(lo,540)(br(i),i=1,ns),(nb(i),i=1,ns)
  540 format(/,2x,3hg  ,19f6.1/1h ,1x,4hno. ,19i6)
      if (knw.eq.0) return
      do 1020 i=1,ns
      if(nb(i))1020,1020,1015
 1015 continue
      fn=float(nb(i))
      fnb(i)=fnb(i)*100.0/fn
 1020 continue
      write(lo,550)(fnb(i),i=1,ns)
  550 format(1h ,2x,3h%  ,19f6.1)
      return
      end
