c-----------------------------------------------------------------------
      subroutine modify(ier)
c
c-- modify main routine
c
      character cff
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/cperm/icperm(40),nperm
      common /xdata/ lperm(40),kperm(40,40),alpha(500),dummy(117860),
     *               dummpc(124000)
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
c
      ipcom=0
      ifper=1
      write(cff,'(i1)') kff
      write(lo,10) cff,itle
   10 format(///,a1 ,120('+'),//,
     1 39h SIRPOW.92 : Modify routine            ,68x,14hRelease  93.05
     2 ,/,/,20x,20a4,/,1h ,120('+'),/)
      call dirmod(ier)
      if (ier.lt.0) go to 130
      call rscard(ier)
      if (ier.lt.0) go to 130
      call mktabl(ier)
  130 return
      end
c-----------------------------------------------------------------------
      subroutine dirmod(ier)
c 
c -- this subroutine reads the directives of MODIFY 
c --             row n1 n2 ....np
c -- where n1,n2,..,np are the row(s) in the table
c--  printed after INVARIANTS routine
c-- these rows are store in kperm
c 
      character line*80,dire*80,diret*80
      character blank,digit*12,card(100)*80,ffile*80
      character fname(9)*80,ext(9)*4
      common/dotdat/ fname,ext
c
      common/cperm/icperm(40),nperm
c
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /chara/ blank,digit,card,ffile
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common /xdata/ lperm(40),kperm(40,40),alpha(500),idummy(117860),
     *               dummpc(124000)
c
      character wud1(64,6)
      character wud2(64,6)
      dimension vet(40),ivet(40)
c
c-- set default values
      ipripe=0
      jcran=0
      ifcoc=0
      do 10 i=1,40
   10 icperm(i)=0
      do 15 i=1,500
   15 alpha(i)=0.0
      lu=kform
      itype=0
      iform=1
      jop=jopen(lu,fname(5),nlen,itype,iform,ier)
      if (jop.lt.0) go to 6100
      irow=0
   20 continue
      irow=irow+1
      read(lu,'(i2,i3,f7.3,6i5)',end=30)
     1 nov1,kperm(irow,1),atmp,(kperm(irow,j),j=2,nov1)
      if(nov1.eq.0) go to 6100
      lperm(irow)=nov1
      icperm(irow)=irow
      alpha(kperm(irow,1))=atmp
      go to 20
   30 close(lu)
      irow=irow-1
      if(irow.eq.0) then
                      write(lo,35)
                      ier=-1
                      return
                    endif
   35 format(' no list of reflections to permute')
      nperm=irow
c
      ic=0
      icmax=icomq(icomat,2)
c
      nperx=0
c
c-- idef=0 if rows are choosen by the program
c-- idef=1 if rows are choosen by the user
      idef=0
      isemi=0
  100 continue
      ic=ic+1
      if (ic.gt.icmax) go to 220
      ipdir=ipdir+1
      line=card(ipdir)
      diret=line
      call cutst(line,lenp,dire,lend)
      call lcase(dire)
c--
      iopt=0
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 210
      if (dire(1:3).eq.'row') then
Corig     if (iv.eq.0.or.iv.gt.3) go to 210
          if (iv.eq.0.or.iv.gt.2) go to 210
          idef=1
          do 110 i=1,iv     
 110       icperm(i+nperx)=ivet(i)
          nperx=nperx+iv
          go to 100
          endif
      if (dire(1:3).eq.'pri') then
          if (iv.eq.0) go to 210
          ipripe=ivet(1)    
          go to 100
          endif
      if (dire(1:4).eq.'semi') then
          isemi=1    
          go to 100
          endif
      if (dire(1:4).eq.'coch') then
          ifcoc=1    
          go to 100
          endif
      if (dire(1:4).eq.'rand') then
          if (iv.gt.1) go to 210
          jcran=1
          kcran=0
          if (iv.eq.1.and.ivet(1).gt.0) kcran=ivet(1)
          go to 100
          endif
      write(lo,200) diret
  200 format(' wrong directive on following line:',/a)
      go to 100
  210 continue
      ier=-1
      write(lo,'(22h error in directive : ,a80)') diret
      return
  220 continue
c
c -- espansione della macroistruzione modify  
c
      if (nperx.gt.0) nperm=nperx
      call chkrow(irow,nperm,icperm,ier)
      if (ier.lt.0) return
      call svcard(ier)
      if (ier.lt.0) return
      call upcard('%permute',8,ier)
      nrig1=icperm(1)
      nov1=lperm(nrig1)
         call writeud(nrig1,nov1,wud1,np1)
         k=0
         do 550 i=1,np1
c ----------------------------------------------------------
c prima riga della prima permutazione
c salva il contenuto di wud
c ----------------------------------------------------------
         if (nperm.ge.2) then   
             nrig2=iabs(icperm(2))
             nov2=lperm(nrig2)
             call writeud(nrig2,nov2,wud2,np2)
             if (i.eq.1) then
                           in=2
                         else
                           in=1
                         endif
             do 540 j=in,np2
               do 404,kk=1,80
  404           line(kk:kk)=' '
               write(line,*) (wud1(i,kk),kk=1,nov1),' ',
     1                   (kperm(nrig1,kk),kk=1,nov1)
               call upcard(line,80,ier)
               do 405,kk=1,80
  405           line(kk:kk)=' '
               write(line(9:),420)(kperm(nrig1,kk),kk=1,nov1)
  420          format(6i4)
               write(line(1:6),410) (wud1(i,kk),kk=1,nov1)
  410          format(6a1)
               do 403,kk=1,80
  403           line(kk:kk)=' '
               write(line,*) (wud2(j,kk),kk=1,nov2),' ',
     1                    (kperm(nrig2,kk),kk=1,nov2)
               call upcard(line,80,ier)
               do 430 kk=1,80
  430           line(kk:kk)=' '
               write(line(9:),420)(kperm(nrig2,kk),kk=1,nov2)
               write(line(1:6),410) (wud2(j,kk),kk=1,nov2)
             if (j.lt.np2.or.i.lt.np1) then
               if (isemi.eq.1)
     *         call upcard('%seminv ',8,ier)
               call upcard('%invar  ',8,ier)
               if (ifcoc.eq.1)
     *         call upcard('cochran ',8,ier)
               call upcard('%phase  ',8,ier)
               if (jcran.eq.1) 
     *         call upcard('maxtr 10',8,ier)
               call upcard('%permute',8,ier)
             else               
               if (isemi.eq.1)
     *         call upcard('%seminv ',8,ier)
               call upcard('%invariants',11,ier)
               if (ifcoc.eq.1)
     *         call upcard('cochran ',8,ier)
               call upcard('%phase     ',11,ier)
               if (jcran.eq.1)
     *         call upcard('maxtr 10',8,ier)
             endif
  540      continue
          else
             if (i.gt.1) then
               do 402,kk=1,80
  402           line(kk:kk)=' '
             write(line,*) (wud1(i,kk),kk=1,nov1),' ',
     1                  (kperm(nrig1,kk),kk=1,nov1)
               call upcard(line,80,ier)
               do 541,kk=1,80
  541           line(kk:kk)=' '
               write(line(9:),420)(kperm(nrig1,kk),kk=1,nov1)
               write(line(1:6),410) (wud1(i,kk),kk=1,nov1)
          if (i.lt.np1) then
               if (isemi.eq.1)
     *         call upcard('%seminv ',8,ier)
               call upcard('%invar  ',8,ier)
               if (ifcoc.eq.1)
     *         call upcard('cochran ',8,ier)
               call upcard('%phase     ',11,ier)
               if (jcran.eq.1) 
     *         call upcard('maxtr 10',8,ier)
               call upcard('%permute',8,ier)
          else
               if (isemi.eq.1)
     *         call upcard('%seminv ',8,ier)
               call upcard('%invariants',11,ier)
               if (ifcoc.eq.1)
     *         call upcard('cochran ',8,ier)
               call upcard('%phase     ',11,ier)
               if (jcran.eq.1) 
     *         call upcard('maxtr 10',8,ier)
          endif
          endif
        endif
  550 continue
Corig call upcard('%fourier',8,ier)
      call upcard('%foms',5,ier)
      return
 6100 write(lo,6001)
 6001 format(//' *** error ***  Impossible to modify E values',/,
     *         '                No suitable reflections ',/)
      ier=-1
      return
      end
c-----------------------------------------------------------------------
      subroutine writeud(nriga,nov,wud,ncomb)
      common/cperm/icperm(40),nperm
      common /xdata/ lperm(40),kperm(40,40),alpha(500),idummy(117860),
     *               dummpc(124000)
      dimension icomb(64,6),icombp(64,6)
      equivalence (icomb (1,1),idummy  (1))
      equivalence (icombp(1,1),idummy(385))
c
      character wud(64,6),ud(2),wudtmp(64,6)
c
      np=2**nov-2
      ud(1)='d'
      ud(2)='u'
      do 680 ii=1,64
      do 670 jj=1,6
      icomb(ii,jj)=0
      wud(ii,jj)=' '
  670 icombp(ii,jj)=0
  680 continue
c
      do 800 i=1,np
      ii=i
      do 700 jj=1,nov
      icomb(i,jj)=mod(ii,2)
      ii=ii/2    
  700 continue 
      do 710 jj=1,nov
      kk=nov+1-jj
      icombp(i,jj)=icomb(i,kk)
  710 wud(i+1,jj)=ud(icombp(i,jj)+1)
      do 720 jj=1,nov
  720 wud(1,jj)='e'
  800 continue
c
c
c  vengono eliminate dalla permutazione corrente quei casi in cui
c  c'e' un riflesso con alpha piccolo il cui |E|**2 deve assumere
c  il valore S-t**2 ('u'=up) dove S=sum(|E|**2) e t=<|E|>
c
      alfsog=0.25*alpha(kperm(nriga,1))
      ncomb=1
      do 1000 ii=2,np+1
      do 900 jj=2,nov
      k=kperm(nriga,jj)
      if(wud(ii,jj).eq.'u'.and.alpha(k).le.alfsog) goto 910
 900  continue
c
      ncomb=ncomb+1
      do 905 jjj=1,nov
 905  wudtmp(ncomb,jjj)=wud(ii,jjj)
 910  continue
 1000 continue
      do 2000 ii=2,ncomb
      do 1905 jjj=1,nov
 1905 wud(ii,jjj)=wudtmp(ii,jjj)
 2000 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine chkrow(irow,nperm,icperm,ier)
c-- check the user input to eliminate doubled reflections
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /xdata/ lperm(40),kperm(40,40),alpha(500),idummy(117860),
     *               dummpc(124000)
      integer icperm(40)
c
      if (nperm.eq.1) return
      irow1=icperm(1)
      if (irow1.gt.irow) go to 200
      isum=lperm(1)
      do 10 j=1,isum
   10 idummy(j)=kperm(irow1,j)
      npe=nperm
      do 100 i=2,nperm
      irow1=icperm(i)
      if (irow1.gt.irow) go to 200
      nov2=lperm(2)
      jok=0
      do 30 j=1,nov2
      do 30 l=1,isum
      if (kperm(irow1,j).eq.idummy(l)) jok=1
   30 continue
      is2=isum+nov2
      if (jok.eq.0.and.is2.le.5) then
Corig                              isum=is2
Corig                              do 40 j=1,nov2
Cor40                              idummy(i+isum)=kperm(irow1,j)
                                   do 40 j=1,nov2
   40                              idummy(j+isum)=kperm(irow1,j)
                                   isum=is2
                                 else
                                   npe=npe-1
                                   icperm(i)=0
                                 endif
  100 continue
      ir=41
      do 140 i=1,nperm
      k=icperm(i)
      if (k.eq.0) go to 140
      ir=ir-1
      do 120 j=1,40
  120 kperm(ir,j)=kperm(k,j)
  140 continue
      nperm=npe
      do 160 i=1,nperm
      icperm(i)=i
      do 160 j=1,40
  160 kperm(i,j)=kperm(40-i+1,j)
      return
  200 continue
      write(lo,210) irow1
  210 format(//,' *** Error *** Required row ( ',i5,'  ) ',/,
     *          '               is out of range !!',/)
      return
      end
c-----------------------------------------------------------------------
      subroutine upcard(line,lung,ier)
c
c-- this subroutine update the command queue  (icomq)
c-- and the card reader (card) 
c
      character linc*80,line*80
      character blank,digit*12,card(100)*80,ffile*80
      character beg,commen,allcom(25)*14
      common /chara/ blank,digit,card,ffile
      common /charas/ beg,commen,allcom
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      call shift(line,lenp)
      nallc=25
      linc(1:lung)=line(1:lung)
      if (lung.lt.80) then
                        do 100 i=lung+1,80
  100                   linc(i:i)=blank
                      endif
      if (linc(1:1).eq.beg) then
                              icom=0
                              do 150 i=1,nallc
                              if (linc(2:4).eq.allcom(i)(1:3)) icom=i
  150                         continue
                              if (icom.eq.0) stop 7777
                              icomat=icomat+1
                              icomq(icomat,1)=icom
                              icomq(icomat,2)=0
                              ipcom=ipcom+1
                            else
                              ipdir=ipdir+1
                              if (ipdir.gt.100) go to 500
                              card(ipdir)=linc
                              icomq(icomat,2)=icomq(icomat,2)+1
                            endif
      return
  500 continue
      ier=-1
      ipdir=ipdir-1
      write(lo,510)
  510 format(' more than 100 directives generated ',/,
     *       ' reduce the number of reflections to modify')
      return
      end
c-----------------------------------------------------------------------
      subroutine svcard(ier)
c
c-- this subroutine save the command queue  (icomq)
c-- and the card reader (card) 
c-- in the scratch file jrel
c
      character*80 name
      character blank,digit*12,card(100)*80,ffile*80
      character beg,commen,allcom(25)*14
      common /chara/ blank,digit,card,ffile
      common /charas/ beg,commen,allcom
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      itype=1
      iform=2
      nlen=512
      jop=jopen(jrel ,name,nlen,itype,iform,ier)
      if (jop.lt.0) go to 9000
c
   10 continue
      icomat=icomat+1
      write(jrel) (icomq(icomat,j),j=1,2)
      icom =icomq(icomat,1)
      if (icom.eq.0) go to 30
      icmx=icomq(icomat,2)
      ic=0
   20 ic=ic+1
      if (ic.gt.icmx) go to 10
      ipdir=ipdir+1
      write(jrel) card(ipdir)
      go to 20
c
   30 continue
      icomat=0
      ipdir=0
      return
 9000 continue
      write(lo,9020) ier,jrel
 9020 format(' *** error ***  open error on scratch file jrel, code ='
     *,i5,',  channel =',i5)
      ier=-1
      return
      end
c-----------------------------------------------------------------------
      subroutine rscard(ier)
c
c-- this subroutine restore the command queue  (icomq)
c-- and the card reader (card) 
c-- reading informations from the scratch file jrel
c
      character blank,digit*12,card(100)*80,ffile*80
      character beg,commen,allcom(25)*14
      common /chara/ blank,digit,card,ffile
      common /charas/ beg,commen,allcom
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      rewind jrel
   10 continue
      icomat=icomat+1
      read(jrel) (icomq(icomat,j),j=1,2)
      icom =icomq(icomat,1)
      if (icom.eq.0) go to 30
      icmx=icomq(icomat,2)
      ipcom=ipcom+1
      ic=0
   20 ic=ic+1
      if (ic.gt.icmx) go to 10
      ipdir=ipdir+1
      read(jrel) card(ipdir)
      go to 20
c
   30 continue
      icomat=0
      ipdir=0
c
      close (jrel)
      return
      end
c-----------------------------------------------------------------------
      subroutine mktabl(ier)
c
c-- this subroutine reads the command queue  (icomq)
c-- and the card reader (card) 
c-- and prepares the table of E modifications
c
      character dir,line*80,diret*80,dire*80,ctype*3
      character blank,digit*12,card(100)*80,ffile*80
      character beg,commen,allcom(25)*14
      common /chara/ blank,digit,card,ffile
      common /charas/ beg,commen,allcom
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /xdata/ lperm(40),kperm(40,40),alpha(500),idummy(117860),
     *               dummpc(124000)
      dimension vet(40),ivet(40)
c
      ipdr=0
      ctype='-=+'
      icomt=0
      irow=0
      do 10 i=1,40
      lperm(i)=0
      do 10 j=1,40
   10 kperm(i,j)=0
   20 continue
      icomt=icomt+1
      icom=icomq(icomt,1)
      icmx=icomq(icomt,2)
      if (icom.eq.0) go to 250
      if (icom.ne.11) then
                        ipdr=ipdr+icmx
                        go to 20
                      endif
      ic=0
      irow=irow+1
c
      nperm=0
  100 continue
      ic=ic+1
      if (ic.gt.icmx) go to 200
      ipdr=ipdr+1
      line=card(ipdr)
      diret=line
      call cutst(line,lenp,dire,lend)
      call lcase(dire)
c-- directives with numeric parameters
      iopt=0
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 500
c******************************************************
      k=lperm(irow)
      lperm(irow)=lperm(irow)+iv
      do 120 i=1,iv
      j=k+i
       dir=dire(i:i)
            if (dir.eq.'d') then
                              kperm(irow,j)=1000+ivet(i)
       else if (dir.eq.'u') then
                              kperm(irow,j)=3000+ivet(i)
       else if (dir.eq.'e') then
                              kperm(irow,j)=2000+ivet(i)
                            endif
  120 continue
      goto 100
c******************************************************
  200 continue
      go to 20
  250 continue
c
c-- print the table of E modifications
      write(lo,260)
  260 format(//,
     *' The E-values of the following reflections will be modified',/,
     *' according to the table below. The modification number 0   ',/,
     *' corresponds to the first run of SIRPOW .                 ',//,
     *' Legenda:  =  E value unchanged',/,
     *'           -  E value decreased',/,
     *'           +  E value increased',//)
      do 280 j=1,lperm(1)
  280 idummy(j)=mod(kperm(1,j),1000)
      write(lo,290) (idummy(i),i=1,lperm(1))
  290 format('    Reflections      ',40i5,/)
      write(lo,300)
  300 format(/,'    Modification',/,'       number',/)
      line(1:5)='    ='
      write(lo,310) (line(1:5),j=1,lperm(1))
  310 format(8x,'  0',10x,40a5)
      do 350 i=1,irow
      ifin=lperm(i)
      do 320 j=1,80
  320 line(j:j)=blank
      k=0
      do 330 j=1,ifin
      itype=kperm(i,j)/1000
      k=k+5
  330 line(k:k)=ctype(itype:itype)
      write(lo,340) i,line(1:k)
  340 format(8x,i3,10x,a)
  350 continue
      return
  500 continue
      ier=-1
      write(lo,'(22h error in directive : ,a80)') diret
      return
      end
c--------------------------------------------------------------------
c-- sirpow.92 code for permute                         Release 93.05
       subroutine permut(ier)
c
c-- permute main routine
c
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common /xdata/ ix(3000),  ex(3000),   fx(3000),iphi(3000),
     *              ewx(3000), edx(3000),jpunt(3000),  nv(3000),
     *               we(3000),mulv(3000),dumx(90000),dummpc(124000)
      common/cperm/icperm(40),nperm
      common /ureq1/ ncycl,nroset,nundset,alambda,nsec,machkl,uvwt(4),
     *               pfwhm
c                                                            
      ncycl=ncycl+1
      if (ipripe.gt.0) write(lo,11) ncycl
   11 format(//,5x,' ++++ E-modification number',i3,' ++++',//)
      call list7p
      call pertra(npseud,iy,ier)
      if (ier.lt.0) goto 1000
      call dirper(ier)
      if (ier.lt.0) return
      call perend (npseud,iy,ier)
 1000 return
      end
c
c -----------------------------------------------------------
c -- questa subroutine legge le direttive di permute
c -- ud n1 n2 ....np
c -- du n1 n2 ....np
c -- con n1,n2,..,np sono le linee del file in uscita
c -- da modg sulle quali va realizzata la permutazione
c -----------------------------------------------------------
      subroutine dirper(ier)
      character line*80,dire*80,diret*80
      character blank,digit*12,card(100)*80,ffile*80
c
      common/cperm/icperm(40),nperm
c
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /chara/ blank,digit,card,ffile
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
      dimension vet(40),ivet(40)
c
c-- set default values
      do 20 i=1,40
   20 icperm(i)=0
      ic=0
      icmax=icomq(icomat,2)
c
      nperm=0
  100 continue
      ic=ic+1
      if (ic.gt.icmax) go to 9000
      ipdir=ipdir+1
      line=card(ipdir)
      diret=line
      call cutst(line,lenp,dire,lend)
c-- directives with numeric parameters
      iopt=0
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 8000
c******************************************************
      nperm=iv
      icont=0
      do 200,i=1,nperm
       if (dire(i:i).eq.'d') then
         icont=icont+1
         icperm(i)=-ivet(i)
       endif
       if (dire(i:i).eq.'u') then
         icont=icont+1
         icperm(i)=ivet(i)
       endif
       if (dire(i:i).eq.'e') then
         icperm(i)=ivet(i)
       endif
  200 continue
      if (icont.ge.1) then
       call emod
      else
       call nemod
      endif
      goto 100
c******************************************************
 8000 continue
      ier=-1
      write(lo,'(22h error in directive : ,a80)') diret
      return
 9000 continue
      return
      end
c
c--------------------------------------------------------------------
c---  procedura di trasferimento della lista 7 del file ad
c---  accesso diretto in memoria         
c--------------------------------------------------------------------
c     read reflexions from list 7 bis
      subroutine pertra(npseud,iy,ier)
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common /ureq1/ ncycl,nroset,nundset,alambda,nsec,machkl,uvwt(4),
     *               pfwhm
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,
     *          emme,s3s2p
      common /xdata/ ix(3000),  ex(3000),   fx(3000),iphi(3000),
     *              ewx(3000), edx(3000),jpunt(3000),  nv(3000),
     *               we(3000),mulv(3000),dumx(90000),dummpc(124000)
c
      dimension vat(12),ivat(12),i1(3),i2(3)
      equivalence (vat(1)  ,ivat(1)  )
c
      iln=6
      call srlin (iln,lsn,lixx,ljxx,lkxx,llxx)
      if(lixx.le.0) then
                      write(lo,7020)
 7020 format(' *** error ***   no reflections in direct access file')
                      ier=-1
                      return
                    endif
c
c-- caricamento lista 7 bis
c
      er=0.3
      en=1.0
      call ysfl06(nref,mm,mz,npseud,iy)
c
c-- get symmetry information from direct access file
c
      if (ncycl.eq.1) then
                        call yfl02
                        call musym(kmat,tmat,nsym,is,ts)
                      endif
c
c-- tasferimento in memoria
c
      sig=1.0
      nnn=0
      nrec=0
      do 7030 i=1,nref
         call snr06(vat)
         i1(1)=ivat(1)
         i1(2)=ivat(2)
         i1(3)=ivat(3)
         icobs=1
c     icobs  =  0 if reflexion is unobserved
c            =  1 if reflexion is observed
         inp=(icobs*128*128+(i1(1)+64)*128+(i1(2)+64))*128+i1(3)+64
         nov=ivat(9)/1024
         wei=float(mod(ivat(9),1024))/1000.0
         ix(i)=inp
         ex(i)=vat(4)
         fx(i)=vat(5)
         iphi(i)=mod(ivat(8),2**15)
         ewx(i)=vat(4)
         edx(i)=vat(4)
         nv(i)=nov
         we(i)=wei
c
c-- compute epsilon and multiplicity by generating equivalent
c-- reflexions
c-- epsylon = number of times same reflexion appears in list
c-- multiplicity = number different reflexions in list
c
      eps=1.0
      mult=1
c     in triclinic space groups eps = 1.0 and mult = 1
      if(nsym.eq.1) go to 600
      k1=65536*i1(1)+256*(i1(2)+128)+i1(3)+128
      ik1=65792-k1
      do 500 j=2,nsym
      do 100 l=1,3
  100 i2(l)=0
      do 400 l=1,3
      do 300 k=1,2
      m=iabs(is(k,l,j))
      if(m.gt.0) i2(m)=i2(m)+i1(l)*isign(1,is(k,l,j))
  300 continue
  400 continue
      k2=65536*i2(1)+256*(i2(2)+128)+i2(3)+128
      if(k2.eq.k1) eps=eps+1.0
      if(icent.ne.0.and.k2.eq.ik1) eps=eps+1.0
      if(k2.eq.k1.or.k2.eq.ik1) mult=mult+1
  500 continue
  600 continue
      mulv(i)=nsym/mult
 7030 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine perend(npseud,iy,ier)
c
c-- procedura di modifica dei moduli dei fattori di struttura
c-- normalizzati da permutare                        
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common /xdata/ ix(3000),  ex(3000),   fx(3000),iphi(3000),
     *              ewx(3000), edx(3000),jpunt(3000),  nv(3000),
     *               we(3000),mulv(3000),  nvn(90000),dummpc(124000)
c
c     output reflexions for sir
c
      nc=0
      nl=0
      ns=0
      do 575,i=1,nref 
       jpunt(i)=i
       e=ex(i)
       nl=nl+1
       if(e.gt.en) go to 100
       nl=nl-1
       if(e.gt.er) go to 100
       ns=ns+1
  100  nc=nc+1
  575 continue 
      call sort(ex,fx,iphi,ix,ewx,edx,jpunt,we,nc)
      do 580 i=1,nref
        nvn(i)=0
  580 continue
      do 588,i=1,nref
c --------------------------------------------------------
       jp=nv(jpunt(i))
       if (nv(jpunt(i)).ne.0) then
          do 585,j=1,nref
            if (jpunt(j).eq.jp) then
              nvn(i)=j
              goto 588
            endif
  585     continue 
       else
          nvn(i)=0
       endif
c---------------------------------------------------------
  588 continue
      do 589,i=1,nref
  589     nv(i)=nvn(i)*1024+int(we(i)*1000)
      mr=nc
      mm=min0(mm,nl)
      mm=min0(mm,499)
      mz=min0(mz,ns)
      ms=mr-mz
      if (ipripe.gt.0) then
                         write(lo,590) mm
                         call output(0,mm)
                         write(lo,610) mz
                         if (mz.gt.0) call output(ms,mr)
                       endif
  590 format(///,1h ,i6,38h  largest e-values for (sem)invariants,/)
  610 format(/,i6,46h  smallest e-values for psi0 and neg. quartets,/)
      call ysfr07(nref,npseud,iy)
      call xdump
      return
      end
c---------------------------------------------------------------------
      subroutine emod
c
c-- procedura per variare  i valori di e dei riflessi in sovrapposizione
c
      common /xdata/ ix(3000),  ex(3000),   fx(3000),iphi(3000),
     *              ewx(3000), edx(3000),jpunt(3000),  nv(3000),
     *               we(3000),mulv(3000),dumx(90000),dummpc(124000)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/cperm/icperm(40),nperm
      integer hkl(3)
c
c--
c
      if (ipripe.gt.0) write(lo,800)
  800 format(//,5x,34hselected reflexions               ,//,
     * 30x,'code   h   k   l    e   mult   e new    '/)
c
c        t  = <|E|> according to Wilson's statistics .
c        t  = sqrt(2.0/pi) for centric reflexions ,
c        t  = sqrt(pi)/2.0 for non-centric reflexions .
c        t2 = t*t
c
c
      if (icent.eq.1) then
                        t=sqrt(2.0/pi)
                      else
                        t=sqrt(pi)/2.0
                      endif
      t2=t*t
      sumq=0
      tt=0.0
c
      sumult=0
      do 1000 kk=1,nperm
      ind=icperm(kk)
      if (ind.lt.0) then
                      tt=tt+t2*mulv(-ind)
                    else 
                      sumult=sumult+mulv(ind)
                    endif
Cor1000     sumq=sumq+(ex(abs(icperm(kk)))**2)
      ind  = iabs(ind)
      esq  = ex(ind)*ex(ind)
      tul  = mulv(ind)
 1000 sumq = sumq + tul * esq
Corig      val=sqrt((sumq-tt)/float(nup))
       
      do 1100 i=1,nperm
      mult = mulv(iabs(icperm(i)))
      if (icperm(i).lt.0) then
                            icperm(i)=iabs(icperm(i))
                            ind=ix(icperm(i))
                            call unind(ind,hkl)
                            ep=t
           if (ipripe.gt.0) write(lo,1200) icperm(i),(hkl(k),k=1,3),
     *                                     ex(icperm(i)),mult,ep 
                            ex(icperm(i))=ep 
                          else
                            ind=ix(icperm(i))
                            call unind(ind,hkl)
                            arg = (sumq-tt) / sumult
                            if (arg.lt.0.0) arg=0.0
                            ep = sqrt( arg )
           if (ipripe.gt.0) write(lo,1200) icperm(i),(hkl(k),k=1,3),
     *                                     ex(icperm(i)),mult,ep 
                            ex(icperm(i))=ep 
                          endif
 1100 continue
 1200 format(30x,4i4,f6.2,i5,2x,f6.2)
      return
      end
c
c
      subroutine nemod
      common /xdata/ ix(3000),  ex(3000),   fx(3000),iphi(3000),
     *              ewx(3000), edx(3000),jpunt(3000),  nv(3000),
     *               we(3000),mulv(3000),dumx(90000),dummpc(124000)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/cperm/icperm(40),nperm
      integer hkl(3)
c
      if (ipripe.gt.0) write(lo,800)
  800 format(//,5x,34hselected reflexions permutation   ,//,
     * 30x,'code   h   k   l    e   mult   e new    '/)
      do 1100 i=1,nperm
      ind  = iabs(icperm(i))
      mult = mulv(ind)
      ep   =   ex(ind)
      ind  =   ix(ind)
      call unind(ind,hkl)
      if (ipripe.gt.0) write(lo,1200) icperm(i),
     *                                (hkl(k),k=1,3),ep,mult,ep 
 1100 continue
 1200 format(30x,4i4,f6.2,i5,2x,f6.2)
      return
      end
c-----------------------------------------------------------------------
      subroutine list7p
c
c-- procedura di trasferimento della lista 7 del file ad
c-- accesso diretto in lista 7'        
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common /xdata/ ix(3000),  ex(3000),   fx(3000),iphi(3000),
     *              ewx(3000), edx(3000),jpunt(3000),  nv(3000),
     *               we(3000),mulv(3000),dumx(90000),dummpc(124000)
c
      dimension vat(12),ivat(12)
      equivalence (vat(1)  ,ivat(1)  )
c
      iln=6
      call srlin (iln,lsn,lixx,ljxx,lkxx,llxx)
      if(lixx.le.0) then
      iln=7
      call srlin (iln,lsn,lixx,ljxx,lkxx,llxx)
c
c caricamento lista 7
c
      call ysfl07(nref,mm,mz,npseud,iy)
c
c tasferimento in memoria
c
      sig=1.0
      nnn=0
      nrec=0
      do 7030 i=1,nref
         nnn=nnn+1
         call snr07(vat)
         lh=ivat(1)
         lk=ivat(2)
         ll=ivat(3)
         icobs=1
c     icobs  =  0 if reflexion is unobserved
c            =  1 if reflexion is observed
         inp=(icobs*128*128+(lh+64)*128+(lk+64))*128+ll+64
         nv(nnn)=ivat(9)
         ix(nnn)=inp
         ex(nnn)=vat(4)
         fx(nnn)=vat(5)
         iphi(nnn)=mod(ivat(8),2**15)
         ewx(nnn)=vat(4)
         edx(nnn)=vat(4)
 7030 continue
c caricamento su lista 7'
      call ysfr06(nref,npseud,iy)
      call xdump
      endif
      return
      end
c
code for ysfr06
      subroutine ysfr06(nrifl,npseud,iy)
c--form the  list 7
c
      common /xdata/ ix(3000),  ex(3000),   fx(3000),iphi(3000),
     *              ewx(3000), edx(3000),jpunt(3000),  nv(3000),
     *               we(3000),mulv(3000),dumx(90000),dummpc(124000)
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/lst07/l7,l7a,l7d,ld7p,m7,m7dk,n7dk,md7d,n7d,n7,n7p,
     2 l7rs,l7rk,l7in,l7p,kk1,kk2,kk3
c
      common/xlimi/nfl,lfl,nl,idummy(3),nfls
      common /xfile/ ifile,ilist,iend,infle,nwfle,icfle,lid(4)
      common /data/ store(5000)
      dimension istore(5000)
      equivalence(store,istore)
c
c
      kk3=128
      kk2=128*kk3
      kk1=128*kk2
      nfl=nfls
      in=6
      call xcln(in)
      l7p=nfl
      md7d=7
      n7dk=6
      nref=nrifl
      n7p=30
      lj=nfl+n7p-1
      do 1000 i=nfl+5,lj
1000  store(i)=0.0
      store(nfl+5)= md7d
      store(nfl+6)= n7dk
      store(nfl+7)= nrifl
      store(nfl+9)= n7p
      store(nfl+10)=ihx(1)
      store(nfl+11)=ihx(2)
      store(nfl+12)=ihx(3)
      store(nfl+15)=float(jpart)
      store(nfl+16)=float(knw)
      store(nfl+17)=bt
      store(nfl+18)=sc
      store(l7p+19)=mm
      store(l7p+20)=mz
      store(l7p+21)=s3s2
      store(l7p+22)=s3s2p
      store(l7p+23)=jtran
      store(l7p+24)=float(npseud)
      istore(l7p+25)=iy
      store(l7p+26)=fosog
      ln=n7p+(nref+1)*n7dk
      call sowl(ln,in,lsn,ld7p,lk,lm,lj)
      store(nfl+2)=lsn
      call xup(ld7p,istore(l7p),n7p)
      llw=ld7p+ln-1
      call swlin(6,lsn,ld7p,llw,n7p,ln)
      l7=ld7p+n7p
      n7=0
      m7dk=nfl+n7p
      nfl=m7dk+n7dk
      do 2000 i=1,nrifl
      dum=edx(i)*1000.0
      if(dum.gt.32767.0) dum=32767.0
      idum=int(dum)
      dum=ewx(i)*1000.0
      if(dum.gt.32767.0) dum=32767.0
      idum1=int(dum)
      in=in+1
      istore(m7dk  )=ix(i)
      store(m7dk+1)=ex(i)
      store(m7dk+2)=fx(i)
      store(m7dk+3)=idum1+idum*32768
      istore(m7dk+4)=iphi(i)
      istore(m7dk+5)=nv(i)
      call xup(l7,istore(m7dk),n7dk)
      l7=l7+n7dk
2000  continue
      istore(m7dk)=iend
      call xup(l7,istore(m7dk),n7dk)
      call xdump
      return
      end
code for ysfl06
      subroutine ysfl06(nrifl,mmm,mmmz,npseud,iy)
c--load list 7
c
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/lst07/l7,l7a,l7d,ld7p,m7,m7dk,n7dk,md7d,n7d,n7,n7p,
     2 l7rs,l7rk,l7in,l7p,kk1,kk2,kk3
      common/xlimi/ nfl,idummy(5),nfls
      common /data/ store(5000)
      dimension  istore(5000)
      equivalence(store,istore)
c--load the preamble of list 6
      nfl=nfls
      kk3=128
      kk2=128*kk3
      kk1=128*kk2
      inm=6
      call srlin(inm,li,ld7p,lk,ln,lm)
      n7p=ln
      l7p=nfl
      call srdls(inm,l,l7p,lj)
      md7d= store(l7p+5)
      n7dk= store(l7p+6)
      n7d = store(l7p+7)
      n7  = n7d
      nrifl=n7d
      ihx(1)=store(l7p+10)
      ihx(2)=store(l7p+11)
      ihx(3)=store(l7p+12)
      jpart =store(l7p+15)
      knw   =store(l7p+16)
      bt    =store(l7p+17)
      sc    =store(l7p+18)
      mm    =store(l7p+19)
      mz    =store(l7p+20)
      mmm=mm
      mmmz=mz
      s3s2  =store(l7p+21)
      s3s2p =store(l7p+22)
      jtran =int(store(l7p+23))
      npseud=int(store(l7p+24))
      iy    =istore(l7p+25)
      fosog =    store(l7p+26)
      l7d   =ld7p+n7p
      m7dk=l7p+n7p
      m7=m7dk+n7dk
      nfl=m7+md7d
      l7=l7d
      return
      end
c
code for snr06
      subroutine snr06(vett)
c--read the next reflections
c
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/lst07/l7,l7a,l7d,ld7p,m7,m7dk,n7dk,md7d,n7d,n7,n7p,
     2 l7rs,l7rk,l7in,l7p,kk1,kk2,kk3
      common/xlimi/ nfl,idummy(6)
      common /data/ store(5000)
      dimension  istore(5000)
      equivalence(store,istore)
      dimension vett(12),vet(9),ivet(9)
      equivalence (vet,ivet)
c--
      call xdwn(l7d,store(m7dk),n7dk)
      l7d=l7d+n7dk
c--unpack the values
      in=istore(m7dk  )/kk1
      ihkl=istore(m7dk  )-in*kk1
      in=in-1
      ih=ihkl/kk2
      ikl=ihkl-ih*kk2
      ik=ikl/kk3
      il=ikl-ik*kk3
      ivet(1   )=ih-64
      ivet(2   )=ik-64
      ivet(3   )=il-64
      vet(4)= store(m7dk+1)
      vet(5)= store(m7dk+2)
      vet(6)= int(store(m7dk+3)/32768)*0.001
      vet(7)= amod(store(m7dk+3),32768.)*0.001
      vet(8)= store(m7dk+4)
      ivet(9)=istore(m7dk+5)
      continue
      do 2100 i=1,9
2100  vett(i)=vet(i)
      return
      end
c--------------------------------------------------------------------
      subroutine reorg16(ier)          
      common /xdata/ dumli(88911),                               
     2 ep(3000),ep2(3000),cfom(302),ipos(302),
     3 fom2(11),dumxy(2057)
     * ,dum120(146417)
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /kuse/ kuser1,kuser2,kuser3
      common /tran/ scale,mh(3),level,it4,xlim(3)
      common /misc/ t(3,3),dxmax(3),mcon,iwt,fom(11),pts
      common /ureq1/ ncycl,nroset,nundset,alambda,nsec,machkl,uvwt(4),
     *               pfwhm
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
c
c
c
c     reorders the first three sets of phases in order of
c      combined figure of merit 
c
      call srlin (16,lsn,lfw,llw,lpb,ll16)
      if (lfw.gt.0) then
                      call ysfl16(cfom,ipos,nset)
                    else
                      write(lo,1000)
 1000                 format(//,' no sets of phases available')
                      ier=-1
                      return
                    endif
        do 5 i=1,nset
           call snr16b(i,fom,ep)
           if(fom(5).le.1.0) goto 6  
  5   continue
  6   continue
      nrset=min0(i+nroset-1,nset)
c     write(6,'(6h reorg,f10.3,4i8)') fom(5),i,nset,nrset,ncycl
      if(nrset.ge.i) then                             
      do 20,j=i,nrset
        do 10,ii=i,nset
          if(ipos(ii).eq.j) then
              if(ii.ne.j)then
               call snr16b(ipos(j),fom2,ep2)
               call snr16b(ipos(ii),fom,ep)
c              fom(5)=fom(5)+1000.
               call snw16b(ipos(j),fom,ep)
c              fom2(5)=fom2(5)+1000.
               call snw16b(ipos(ii),fom2,ep2)
               ipostmp=ipos(ii)
               ipos(ii)=ipos(j)
               ipos(j)=ipostmp
              endif
              goto 11
         endif
 10   continue
 11   continue
 20   continue
      endif
      if(nrset.ge.i) then
      do 200,j=i,nrset
        call snr16b(j,fom2,ep2)
        fom2(5)=fom2(5)+1000.-float(ncycl-1)
c       write(6,'(i5,11f10.3)') j,fom2
        call snw16b(j,fom2,ep2)
        cfom(j)=cfom(j)+1000.-float(ncycl-1)
  200 continue
c       write(6,'(13f10.3)') (cfom(j),j=1,nrset)
c       write(6,'(13i10)') (ipos(j),j=1,nrset)
      call ysup16(cfom,ipos,nrset)
      endif
      return
      end
c--------------------------------------------------------------------
c-- sirpow.92                                           Release 93.05
c
      subroutine modg(ier)
c
      character fname(9)*80,ext(9)*4
      common/dotdat/ fname,ext
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common/rc/p(6),cx(9),dumc(9)
c
      common /inp/  natom,fnat,satm,atoms
      common /prin/ ipt,ip0,ip10,ipq
      common /proc/ iftr,ifp10,ifnq,ifps,ifcoc,ifweig
      common/param/ifat1,ifat2,ifatx,lreci,idx,icst1,icst2,icst3,duma(3)
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nref,nweak,sgg,nstr,nzro
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/numk,ntrs,ntr10,sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee(24,6)
      common/esti/ib(3),ih(3,2,24),ii(2,24)
      common/nq/nor1(6),nop1(6),iseg1(6),icodqn,sumc,sums,sume
      common/wrt/icv(4,7),ishf,ifas,eewrt(3),icodx(3),iqua(1000),
     1           itac(5,24,4),eee(3)
      common/lst13/l13,m13,md13,l13f,m13f,n13f
      common/zero/argq(26),ncal(26),nver(26),ntt,fm(26),gt(26)
      common /pseud/ kmat(48,3,3),emme,patom,qatom,npseud,lpseud(4,3)
     1         ,scale,jmme,prod,prod2,mjn(5,11),njn,coef,nw(8),no(8)
      common /xdata/ ish(3,800),itype(800)
     1,alpha(5000),ewei(5000),alph(5000),dumm(1000),isr(100000),
     2 isig(3,5000),alphanw(5000),icod(5000),ntr(5000),dumm1(31600)
     3 ,dummpc(63200)
      dimension vat(12),ivat(12),nover(6)
      equivalence (vat(1),ivat(1))
c -----
c     call sub. lettura lista 8 : tripletti positivi
c -----
      iprea=0
      call srlin (8,lsn,lfw,llwxx,lpbxx,llxx)
      if(lfw) 1000,1000,1200
 1000 write(lo,1100)
 1100 format(//,' ****  warning : no triplets calculated  ****',//)
      ier=-1
      return
 1200 call sflxx(iprea,8,ntot,ntrd,nreft,nxxe,iccd,isig)
c     write(lo,1300) ntrd
c1300 format(/,i6,'  tripletti positivi su disco',/)
c-- reflections are in the direct access file
      iln=7
      call srlin (iln,lsn,lixx,ljxx,lkxx,llxx)
      if(lixx.le.0) then
        ier=-1
      else
        call ysfl07(nrifl,id2,id3,id4,id5)
        do 1400 i=1,nrifl
          call snr07(vat)
          jj=ivat(9)
          ip=jj/1024
          isr(i)=ip
          if (i.le.nreft) then
              w=float(mod(jj,1024))/1000.0
              ewei(i)=w            
              alpha(i)=0.0
              alphanw(i)=0.0
              ntr(i)=0
              alph(i)=0.0
          endif
 1400   continue
      do 1500 i=1,ntrd
         call unpak3(isig(1,i),kod1,kod2,ifaz1)
         call unpak3(isig(2,i),kod3,ig,ifaz2)
         call unpak3(isig(3,i),kod,igg,ifaz3)
         nor(1)=kod1
         nor(2)=iabs(kod2)
         nor(3)=iabs(kod3)
         ntr(nor(1))=ntr(nor(1))+1
         ntr(nor(2))=ntr(nor(2))+1
         ntr(nor(3))=ntr(nor(3))+1
         g=float(ig)/100.0
         w=ewei(nor(1))*ewei(nor(2))*ewei(nor(3))
         alpha(nor(1))=alpha(nor(1))+w*g*bes(g)
         alpha(nor(2))=alpha(nor(2))+w*g*bes(g)
         alpha(nor(3))=alpha(nor(3))+w*g*bes(g)
         alph(nor(1))=alph(nor(1))+g*bes(g)
         alph(nor(2))=alph(nor(2))+g*bes(g)
         alph(nor(3))=alph(nor(3))+g*bes(g)
         alphanw(nor(1))=alphanw(nor(1))+g
         alphanw(nor(2))=alphanw(nor(2))+g
         alphanw(nor(3))=alphanw(nor(3))+g
 1500 continue
      namb=0
      do 1700,j=1,nreft
        icod(j)=j
        if (ewei(j).gt.0.99) then
c         alph(j)=-alpha(j)
          alph(j)=-999.0    
        else
          namb=namb+1
          alph(j)=alpha(j)
        endif
 1700  continue
      do 1900,i=1,nreft-1
       do  1800 , j=i+1,nreft
         if (alph(i).lt.alph(j)) then
           a=alph(i)
           alph(i)=alph(j)
           alph(j)=a
           icd=icod(i)
           icod(i)=icod(j)
           icod(j)=icd
         endif
 1800  continue
 1900  continue
      np=min0(10,namb)
      lu=kform
      itypf=0
      iform=1
      jop=jopen(lu,fname(5),nlen,itypf,iform,ier)
      if (jop.lt.0) go to 9000
      if(np.eq.0) then
          write(lu,2250) np,np,alpha(1),np
                  else
      irow=0
      do 2300 i=1,np
      ic=icod(i)
      jp=isr(ic)
c     nv=nint(1.0/ewei(ic))
c  si ricostruisce il numero dei riflessi in overlapping
c  ricordando che weig=1.0/sqrt(over)  => over=1.0/(weig**2)
      nv=nint(1.0/(ewei(ic)**2))
      do 2100 j=1,nv
      nover(j)=jp
      jp=isr(jp)
 2100 continue
c
c  sul file di uscita vengono scritte solo le prime 10 
c  permutazioni
c
 2110 format(//,4x,90('-'),/,
     14x,'Table of overlapping reflections with largest',
     2' alpha values to be used in MODIFY Routine  ',/,
     34x,90('-'),//,
     44x,'row  refl.  nr. of tripl.   alpha  sum(G(j))',
     5'          refl. in overlapping     ',/)
c
      if (ntr(ic).gt.0) then
                          if (i.le.np) then
                                         irow=irow+1
                                         if (irow.eq.1) write(lo,2110)
                                         write(lo,2200) irow,ic,ntr(ic),
     *                                   alpha(ic),alphanw(ic),
     *                                   (nover(j),j=1,nv-1)
                                       endif
c  sul file lu vengono scritte tutte le permutazioni
                          write(lu,2250) nv,ic,alpha(ic),
     *                    (nover(j),j=1,nv-1)
                        endif
 2200 format(5x,i2,i5,1h),5x,i5,7x,f7.3,1x,f7.3,5x,2x,5x,6i5)
 2250 format(i2,i3,f7.3,6i5)
 2300 continue
      endif
         endif
      close(lu)
      return
 9000 write(lo,9010) ier,fname(5)
 9010 format(' *** error ***  open error, code =',i5,' file is ',a)
      ier=-1
      return
      end
c-----------------------------------------------------------------------
      subroutine setperm(ier)
c
c
c-- procedura per la scrittura dei  primi 
c-- tre sets di ogni permutazione 
c
      character star
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/kdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kkf
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/rc/p(6),cx(9),nreg,nb,rhomax,mm,en,mz,er,th,rhomin
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common /ureq1/ ncycl,nroset,nundset,alambda,nsec,machkl,uvwt(4),
     *               pfwhm
c
      common /cost/ pi2,jxa,jxb,jxx,nk1,lfl,nrif,mult,nsem,itype,ang(24)
c   direct access file commons
      common /xfile/ ifile,jjlist,jjend,infle,nwfle,icfle,lid(4)
      common /xfili/ lfirst,nwblo,lindex(240)
      common /xdisu/ jdir,ndfle,irecx
      common /xdata/ x(30000),dumm1(15000),dumm2(15000),dum12(60000)
     *              ,dummpc(124000)
c
      dimension ipos(302),ix(3000)
      dimension vet(12),ivet(12)
      dimension cfom(302),fom(11),ep(500),iphb(500)
      equivalence (vet(1),ivet(1))
      equivalence (x(1),ix(1))
c
      ncycl=ncycl+1
      call reorg16(ier)
      if(ier.lt.0) return
      call srlin (16,lsn,lfw,llw,lpb,ll16)
      if (lfw.le.0) then
                      write(lo,1000)
 1000                 format(//,' no sets of phases available')
                      ier=-1
                    else
      call ysfl16(cfom,ipos,noset)
      ind=1
      mdm=2
      icfo=-1
      nperm=0
      do 1010 i=1,noset
      cf=cfom(i)
      if (cf.lt.0.) cf=-cf
      icf=int(cf)
      if (icf.ne.icfo) then
                         nperm=nperm+1
                         icfo=icf
                       endif
      cf=cf-float(icf)
      ix(ind)=i
      x(ind+1)=cf
      ind=ind+mdm
 1010 continue
      ind=1
      mdm=2
      jump=-2
      call sortz(ind,noset,mdm,jump)
      ind=1
      do 1020 i=1,noset
      ipos(i)=ix(ind)
      ind=ind+mdm
 1020 continue
      write(lo,7010) noset,nperm
 7010 format(/,i5,' sets of phases available for',i4,'  E modification')
      if (knw.eq.0) write(lo,7020)
 7020 format(//,31x,'+++++++  figures  of  merit  +++++++'
     *      ,//,10x,' set  (trial)',8x,'mabs   alcomb  pscomb  cphase',
     * '   cfom',3x,'nundet',4x,/)
      if (knw.eq.1) write(lo,7030)
 7030 format(//,31x,'+++++++  figures  of  merit  +++++++'
     *      ,//,10x,' set  (trial)',8x,'mabs   alcomb  pscomb  cphase',
     * '   cfom',3x,'nundet     err.     w-err.  enan.',/)
c
      write(lo,7074)
 7074 format(' +++ E modification number   0',/)
      np=0      
      do 7080 i=1,noset
      do 7075 j=1,noset
      if (ipos(j).eq.i) ii=j
 7075 continue
      star=' '
      if (cfom(i).lt.0.0) star='*'
      call snr16(i,fom,ep,iphb)
      itrial=nint(fom(10))
      if (fom(5).ge.1.0) then
         npprec=np      
         np=fom(5)
         np=1000-np
         ntmp=fom(5)
         fom(5)=fom(5)-float(ntmp)
         call snw16(i,fom,ep,iphb)
         if(np.ne.npprec) write(lo,7090) np            
 7090 format(/,' +++ E modification number ',i3,/)
      endif  
      if(knw.eq.0) 
     *   write(lo,7060) ii,star,itrial,(fom(j),j=1,6)
      if(knw.eq.1) 
     *   write(lo,7070) ii,star,itrial,(fom(j),j=1,6),(fom(j),j=7,9)
 7060 format(10x,i4,a1,2h (,i5,5h)    ,5f8.3,f7.0)
 7070 format(10x,i4,a1,2h (,i5,5h)    ,5f8.3,f7.0,3x,f8.2,2x,f8.2,f7.2)
 7080 continue
      call ysup16(cfom,ipos,noset)
                 endif
      return
      end
